#!/usr/local/bin/perl
#┌─────────────────────────────────
#│ [ WebPatio ]
#│ admin.cgi - 2007/05/06
#│ Copyright (c) KentWeb
#│ webmaster@kent-web.com
#│ http://www.kent-web.com/
#└─────────────────────────────────
# きりしま式 K0.92相当
# 2009/04/01 FAQモード追加修正
# 2009/03/14 スレッド作成制限モードの追加
# 2008/03/16 分割処理のバグ修正
# 2008/02/27 スレッド分割機能を装備（厳密には指定レス以降をコピーして新規スレッド作成）
# 2008/01/09 過去ログ化<->復元の際に各スレッドのログに状態を記録するように変更
# 2007/11/14 過去ログ化<->復元
# 2007/06/23 ロックを管理者ロックに、ロック時にレスのタイトルを失わないように
# 2007/06/10 3.2相当に修正
$kver = '_3.22_k0.92';
$sver = 'v1.43';
# 2012/02/07 ユーザ定義ヘッダー対応のコラム背景画像クラスとユーザ定義フッターの印刷ルーチンを追加
# 2010/11/16 過去ログの構成をページ別ディレクトリに変更し、移行・最構成機能を追加
# 2009/10/15 如水さんのWebPatio+ (http://jyosui.xrea.jp/feed.html) 静的RSS機能を一部修正して追加インストール
# 2009/07/05 CGIスクリプトをUnicode記述に変更。HTML入出力とログファイルの文字コード(utf8,sjis,euc,jis)を設定可能
# 2009/05/12 スレッドテーマと新規投稿題名を別設定できるよう修正
# 2009/03/34 きりしま式K0.8に対応
# 2008/10/29 新規にv1.03として配布
# スガラボット v0991
# 2008/03/25 スレッド分割バグ修正、および分割した発言を旧スレッドに残すかどうの設定を追加
# きりしま式 のK0.71に対応してスレッド分割機能を追加 526-622,648/649,659行 (20080321 スガラボット)
# 文字色指定機能、ツリー表示機能追加 (20080220 スガラボット)

#use strict;
#use warnings;
#use Time::Local;
use utf8;

# 外部ファイル取り込み
require './init.cgi';

# SSIによる複数会議室対応かどうか (20090324 スガラボット修正)
if (!$patioshtml) { $patioshtml = $patiocgi; }
if (!$forumshtml) { $forumshtml = $forumcgi; }
if (!$readshtml) { $readshtml = $readcgi; }
if (!$bbsshtml) { $bbsshtml = $bbscgi; }

&parse_form;
if ($in{'pass'} eq "") { &enter; }
elsif ($in{'pass'} ne $pass) { &error("認証エラー"); }
# if ($in{'logfile'} || $in{'bakfile'}) { &file_mente; }
# 消去退避ログのメンテナンスを追加 （2009/03/27 スガラボット修正)
if ($in{'logfile'} || $in{'bakfile'} || $in{'delfile'}) { &file_mente; }
elsif ($in{'filesize'}) { &filesize; }
elsif ($in{'member'} && $authkey) { &member_mente; }
# RSSフィードファイルの作り直し機能を追加 （2009/11/11 スガラボット追加修正)
elsif ($in{'feed_create'}) { &feed_create; }
# 過去ログ・再構築機能を追加 （2010/11/16 スガラボット追加修正)
elsif ($in{'reconf_pastlog'}) { &reconf_pastlog(1); }
&menu_disp;

#-------------------------------------------------
#  ログメンテ
#-------------------------------------------------
sub file_mente {

	# $key 値の変更時に index.dat と $number.cgi の $key 値がテレコにならないように $newkey を定義 （2009/08/06 スガラボット修正)
#	our($subject,$log,$top,$itop,$sub,$res,$nam,$em,$com,$da,$ho,$pw,$re,
#		$sb,$na2,$key,$last_nam,$last_dat,$del,@new,@new2,@sort,@file,@del,@top);
	our($subject,$log,$top,$itop,$sub,$res,$nam,$em,$com,$da,$ho,$pw,$re,
		$sb,$na2,$key,@newkey,$last_nam,$last_dat,$del,@new,@new2,@sort,@file,@del,@top,@lock);

	our $printString;

	# メニューからの処理
	if ($in{'job'} eq "menu") {
		foreach ( keys(%in) ) {
			if (/^past(\d+)/) {
				$in{'past'} = $1;
				last;
			}
		}
	}

	# 汚染チェック
	$in{'no'} =~ s/[^0-9\0]//g;

	# index定義
	my ($mylog, $logdir_org, $upldir_org, $uplurl_org);
	if ($in{'bakfile'}) {
		$log = $pastfile;
		$subject = "過去ログ";
		$mylog = "bakfile";
	# 消去退避ログ・メンテナンスを追加 （2009/03/27 スガラボット修正)
	} elsif ($in{'delfile'}) {
		$logdir_org = $logdir;
		$logdir = "$delsave/log";
		$datadir = "$delsave/data";
		$upldir_org = $upldir;
		$upldir = "$delsave/upl";
		$uplurl_org = $uplurl;
		$uplurl = "$delsave_url/upl";
		$delview = '&delview=1';
		$log = "$datadir/index.log";
		$subject = "消去退避ログ";
		$mylog = "delfile";
	} else {
		$log = $nowfile;
		$subject = "現行ログ";
		$mylog = "logfile";
	}

	# スレッド一括削除
	if (($in{'action'} eq "del" && $in{'no'} ne "") || $in{'action'} eq "rmnew") {

		# 削除情報
		(@del) = split(/\0/, $in{'no'});

		# indexより削除情報抽出
		our($top, @new, @deldat);

		# 管理者によるスレッド削除時にスレッドを保存ディレクトリに退避する場合の初期処理追加 （2009/03/26 スガラボット修正)
		# 管理者モードの削除退避ログからの削除の場合はinit.cgiの設定如何に関わらず完全削除とする
		if ($in{'deletelog'}) {
			$logdelete = 0;
		}
		if ($logdelete) {
			if (!opendir(DIR, $delsave)) {
				mkdir($delsave, 0707);
				mkdir("$delsave/data", 0707);
				mkdir("$delsave/log", 0707);
				mkdir("$delsave/upl", 0707);
				unless (-e "$delsave/data/index.log") {
					open(DATA, ">$delsave/data/index.log");
					close(DATA);
				}
			}
		}

		open(DAT,"+< $log") || &error("Open Error: $log");
		eval "flock(DAT, 2);";
		$top = &lineDecode(DAT)  if ($in{'logfile'});

		# 最終スレ番号削除の時は最終スレッド番号(とあれば記事)を削除し次の新規投稿で使用できるようにする （2009/04/08 スガラボット修正)
		if ($in{'action'} eq "rmnew") {
			$logdelete = 0;
			($max, $ho, $tm) = split(/<>/, $top);
			if ($del == 1 && $del[0] == $max) { 
				$rmnew_ok = 1;
			} elsif ($del[0]) {
				&error("最終スレ番号削除を選択したとき最終スレッド以外のログは削除できません。"); 
			} else {
				$del[0] = $max;
			}
		}
		
		while ( $_ = &lineDecode(DAT) ) {
			$flg = 0;
			local($no) = split(/<>/);
			foreach $del (@del) {
				if ($del == $no) {
					# 以下23行は本家3.22に対応して添付ファィルの移動または削除処理を追加 （2009/03/26 スガラボット修正)
					# ログ展開
					if (open(DB,"$logdir/$del.cgi")) {
						if ($in{'action'} eq "rmnew" && !$rmnew_ok) { &error("最終スレ番号削除でスレッド選択にチェックがないためログが削除できません。"); }
					}
					while( $db =  &lineDecode(DB)  ) {
						local($no,$sub,$nam,$eml,$com,$dat,$ho,$pw,$url,$mvw,$myid,$tim,$upl{1},$upl{2},$upl{3}) = split(/<>/, $db);

						# 画像削除
						foreach $i (1 .. 3) {
							next if (!$upl{$i});

							local($ex) = split(/,/, $upl{$i});
							if (-e "$upldir/$tim-$i$ex") {
								# 削除の場合
								if (!$logdelete) {
									unlink("$upldir/$tim-$i$ex");
								}
								# 
								else {
									rename("$upldir/$tim-$i$ex", "$delsave/upl/$tim-$i$ex");
								}
							}
						}
					}
					close(DB);
					# スレッド移動の場合 以下5行と8行目の""は新規追加 （2009/03/26 スガラボット修正)
					if ($logdelete) {
						rename("$logdir/$del.cgi", "$delsave/log/$del.cgi");
						rename("$logdir/$del.dat", "$delsave/log/$del.dat");
					} else {
						unlink("$logdir/$del.cgi");
						unlink("$logdir/$del.dat");
					}
					$flg = 1;
					last;
				}
			}
			if (!$flg) { push(@new,$_); }
			# 以下の1行は新規追加 (2009/03/26 スガラボット修正)
			else { push(@deldat, $_); }
		}

		# index更新
		# 直近スレ番号削除のときは最大スレッド番号をデクリメントする
		if ($in{'action'} eq "rmnew") {
			$max--;
			$top = "$max<>$ho<>$tm<>\n";
		}
		
		unshift(@new,$top);
		seek(DAT, 0, 0);
		print DAT &arrayEncode(\@new, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# 削除ログ移動先のindex更新 （2009/03/26 スガラボット修正)
		if ($logdelete) {
			open(DATA, "+>$delsave/data/index.log");
			while ( $_ = &lineDecode(DATA) ) {
				push(@deldat, $_);
			}
			seek(DATA, 0, 0);
			print DATA &arrayEncode(\@deldat, $logchar);
			truncate(DATA, tell(DATA));
			close(DATA);
		}

		# RSS/Atom			# 2009/10/16 スガラボット追加修正
		if($feed >= 1) {
			require $feedpl;
			&feed("admin");
		}

		# 過去ログ書庫再構築 (2010/12/01 スガラボット追加修正)
		&reconf_pastlog;

	# スレッドのロック開閉
	} elsif ($in{'action'} eq "lock" && $in{'no'} ne "" && !$in{'past'}) {

		# ロック情報
		(@lock) = split(/\0/, $in{'no'});

		# スレッドヘッダ情報更新
		my $i =0;
		foreach (@lock) {

			local($top,@file);
			open(DAT,"+< $logdir/$_.cgi") || &error("Open Error: $_.cgi");
			eval "flock(DAT, 2);";
			@file = &arrayDecode(DAT);

			$top = shift(@file);

			# 先頭記事分解、キー開閉
			local($num,$sub,$res,$key) = split(/<>/, $top);

			# 0=ロック 1=標準 2=管理用
#			if ($key eq '0') { $key = 1; } else { $key = 0; }
			# 管理者ロック
			# インデックスとログファイルの $key 値がテレコにならない対策 （2009/08/06 スガラボット修正)
#			if ($key eq '4') { $key = 1; } else { $key = 4; }
			if ($key eq '4') { $newkey[$i] = 1; } else { $newkey[$i] = 4; }

			# スレッド更新
#			unshift(@file,"$num<>$sub<>$res<>$key<>\n");
			unshift(@file,"$num<>$sub<>$res<>$newkey[$i]<>\n");
			seek(DAT, 0, 0);
			print DAT &arrayEncode(\@file, $logchar);
			truncate(DAT, tell(DAT));
			close(DAT);
			$i++;
		}

		# index読み込み
		local($top,@new);
		open(DAT,"+< $log") || &error("Open Error: $log");
		eval "flock(DAT, 2);";
		$top =  &lineDecode(DAT) ;
		while ( $_ = &lineDecode(DAT) ) {
			s/\n//;
			local($no,$sub,$res,$nam,$da,$na2,$key,$upl,$ressub,$restime) = split(/<>/);
			chomp ($ressub);
			chomp ($restime);

			$i = 0;
			foreach $lock (@lock) {
				# 0=ロック 1=標準 2=管理用
				if ($lock == $no) {
				#  indexの状態に関係なく、個別ログのロック状態に合わせる
				
				open(IND,"+< $logdir/$lock.cgi") || &error("Open Error: $lock.cgi");
				eval "flock(IND, 2);";
				$top2 =  &lineDecode(IND) ;
				close(IND);

				# 先頭記事分解、キー開閉
				local(undef,undef,undef,$key2) = split(/<>/, $top2);

#					if ($key eq '0') { $key = 1; } else { $key = 0; }
#					$_ = "$no<>$sub<>$res<>$nam<>$da<>$na2<>$key2<>$upl<>$ressub<>$restime<>";
					$_ = "$no<>$sub<>$res<>$nam<>$da<>$na2<>$newkey[$i]<>$upl<>$ressub<>$restime<>";
					last;
				}
				$i++;
			}
			push(@new,"$_\n");
		}

		# index更新
		unshift(@new,$top);
		seek(DAT, 0, 0);
		print DAT &arrayEncode(\@new, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

	# スレッドの管理者コメントモード
	} elsif ($in{'action'} eq "lock2" && $in{'no'} ne "" && !$in{'past'}) {

		# ロック情報
		(@lock) = split(/\0/, $in{'no'});

		# スレッドヘッダ情報更新
		my $i = 0;
		foreach (@lock) {

			local($top, @file);
			open(DAT,"+< $logdir/$_.cgi") || &error("Open Error: $_.cgi");
			eval "flock(DAT, 2);";
			@file = &arrayDecode(DAT);

			$top = shift(@file);

			# 先頭記事分解、キー開閉
			local($num,$sub,$res,$key) = split(/<>/, $top);

			# 0=ロック 1=標準 2=管理用
#			if ($key < 2) { $key = 2; } else { $key = 1; }
			if ($key < 2) { $newkey[$i] = 2; } else { $newkey[$i] = 1; }

			# スレッド更新
#			unshift(@file,"$num<>$sub<>$res<>$key<>\n");
			unshift(@file,"$num<>$sub<>$res<>$newkey[$i]<>\n");
			seek(DAT, 0, 0);
			print DAT &arrayEncode(\@file, $logchar);
			truncate(DAT, tell(DAT));
			close(DAT);
			$i++;
		}

		# index読み込み
		local($top, $flg, @new, @top1, @top2, $faq);
		open(DAT,"+< $log") || &error("Open Error: $log");
		eval "flock(DAT, 2);";
		$top =  &lineDecode(DAT) ;
		while ( $_ = &lineDecode(DAT) ) {
			$flg = 0;
			s/\n//;
			local($no,$sub,$res,$nam,$da,$na2,$key,$upl,$ressub,$restime) = split(/<>/);
			chomp ($ressub);
			chomp ($restime);

			$i = 0;
			foreach $lock (@lock) {
				if ($lock == $no) {
					# 0=ロック 1=標準 2=管理用
#					if ($key == 2) {
#						$key = 1;
#						$_ = "$no<>$sub<>$res<>$nam<>$da<>$na2<>$key<>$upl<>$ressub<>$restime<>";
#					} else {
#						$key = 2;
#						push(@top1,"$no<>$sub<>$res<>$nam<>$da<>$na2<>$key<>$upl<>$ressub<>$restime<>\n");
#						$flg = 1;
#					}
					if ($newkey[$i] == 2) {
						$key = $newkey[$i];
						push(@top1,"$no<>$sub<>$res<>$nam<>$da<>$na2<>$newkey[$i]<>$upl<>$ressub<>$restime<>\n");
						$flg = 1;
					} else {
						$key = $newkey[$i];
						$_ = "$no<>$sub<>$res<>$nam<>$da<>$na2<>$newkey[$i]<>$upl<>$ressub<>$restime<>";
					}
					last;
				}
				$i++;
			}
			if (!$flg) {
				if ($key == 2) {
					push(@top2,"$_\n");
				} elsif ($key == 3){
					push(@faq,"$_\n");
				} else {
					push(@new,"$_\n");
				}
			}
		}

		# index更新
		unshift(@new,@faq) if (@faq > 0);
		unshift(@new,@top2) if (@top2 > 0);
		unshift(@new,@top1) if (@top1 > 0);
		unshift(@new,$top);
		seek(DAT, 0, 0);
		print DAT &arrayEncode(\@new, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

	# スレッドのFAQスレッド化をON/OFF (2009/03/27 スガラボット追加修正)
	} elsif ($in{'action'} eq "faq" && $in{'no'} ne "" && !$in{'past'}) {

		# ロック情報
		local(@faq) = split(/\0/, $in{'no'});

		# スレッドヘッダ情報更新
		my $i = 0;
		foreach (@faq) {

			local($top, @file);
			open(DAT,"+< $logdir/$_.cgi") || &error("Open Error: $_.cgi");
			eval "flock(DAT, 2);";
			@file = &arrayDecode(DAT);

			$top = shift(@file);

			# 先頭記事分解、キー開閉
			local($num,$sub,$res,$key) = split(/<>/, $top);

			# 0=ロック 1=標準 2=管理用 3=FAQ
#			if ($key == 3) { $key = 1; } else { $key = 3; }
			if ($key == 3) { $newkey[$i] = 1; } else { $newkey[$i] = 3; }

			# スレッド更新
#			unshift(@file,"$num<>$sub<>$res<>$key<>\n");
			unshift(@file,"$num<>$sub<>$res<>$newkey[$i]<>\n");
			seek(DAT, 0, 0);
			print DAT &arrayEncode(\@file, $logchar);
			truncate(DAT, tell(DAT));
			close(DAT);
			$i++;
		}

		# index読み込み
		local($top, $flg, @new, @top1, @top2, @faq2);
		open(DAT,"+< $log") || &error("Open Error: $log");
		eval "flock(DAT, 2);";
		$top =  &lineDecode(DAT) ;
		while ( $_ = &lineDecode(DAT) ) {
			$flg = 0;
			s/\n//;
			local($no,$sub,$res,$nam,$da,$na2,$key,$upl,$ressub,$restime) = split(/<>/);
			chomp ($ressub);
			chomp ($restime);

			$i = 0;
			foreach $faq (@faq) {
				if ($faq == $no) {
					# 0=ロック 1=標準 2=管理用 3=FAQ
					$flg = 0;
#					if ($key == 3) {
#						$key = 1;
#						$_ = "$no<>$sub<>$res<>$nam<>$da<>$na2<>$key<>$upl<>$ressub<>$restime<>";
#					} else {
#						$key = 3;
#						push(@faq2,"$no<>$sub<>$res<>$nam<>$da<>$na2<>$key<>$upl<>$ressub<>$restime<>\n");
#						$flg = 1;
#					}
					if ($newkey[$i] == 3) {
						$key = $newkey[$i];
						push(@faq2,"$no<>$sub<>$res<>$nam<>$da<>$na2<>$newkey[$i]<>$upl<>$ressub<>$restime<>\n");
						$flg = 1;
					} else {
						$key = $newkey[$i];
						$_ = "$no<>$sub<>$res<>$nam<>$da<>$na2<>$newkey[$i]<>$upl<>$ressub<>$restime<>";
					}
					last;
				}
				$i++;
			}
			if (!$flg) {
				if ($key == 2) {
					push(@top2,"$_\n");
				} elsif ($key == 3) {
					push(@faq2,"$_\n");
				} else {
					push(@new,"$_\n");
				}
			}
		}

		# index更新
		unshift(@new,@faq2) if (@faq2 > 0);
		unshift(@new,@top2) if (@top2 > 0);
		unshift(@new,@top1) if (@top1 > 0);
		unshift(@new,$top);
		seek(DAT, 0, 0);
		print DAT &arrayEncode(\@new, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

	# スレッドの過去ログ化 regist.cgi の新規書き込みルーチンをパクリ
	} elsif ($in{'action'} eq "archive" && $in{'no'} ne "" && ($in{'logfile'} || $in{'delfile'})) {

		# 選択スレッド情報展開
		(@lock) = split(/\0/, $in{'no'});

		# index読み込み
#		local($i, $flg, $top, @new, @tmp, @top);

		local($flg,$top,@now,@past);
#		open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
		open(DAT,"+< $log") || &error("Open Error: $log");
		eval "flock(DAT, 2);";
		$top = &lineDecode(DAT) unless($in{'delfile'});
		while ( $_ = &lineDecode(DAT) ) {
			$flg = 0;
#			s/\n//;
			local($num,$sub,$res,$nam,$date,$na2,$key,$upl,$ressub,$restime) = split(/<>/);

			foreach $lock (@lock) {
				if ($lock == $num) {
				$flg = 1;
				last;
				}
			}
			if ($flg) {
#				unshift(@past,$_);
#				push(@past,$_);
				$key = "-1";
				push(@past, "$num<>$sub<>$res<>$nam<>$date<>$na2<>$key<>$upl<>$ressub<>$restime<>\n");

				# 過去ログに落ちるスレッドのフラグを変更
				# スレッド読み込み
				open(DAT2,"+< $logdir/$num.cgi") || &error("Open Error: $logdir/$num.cgi at log archive process");
				eval "flock(DAT2, 2);";
				local(@file) = &arrayDecode(DAT2);

				# 先頭ファイルを抽出・分解
				$top2 = shift(@file);
				local($no,$sub2,$res2,$key2) = split(/<>/, $top2);
				# フラグ変更・スレッド更新
				unshift(@file,"$no<>$sub2<>$res2<>-1<>$key2<>\n");

				seek(DAT2, 0, 0);
				my @temp = @file;
				print DAT2 &arrayEncode(\@temp, $logchar);
				truncate(DAT2, tell(DAT2));
				close(DAT2);

				# 消去待避ログから過去ログ復帰の場合は、ログファイルと添付ファイルを移動
				if ($in{'delfile'}) {
					shift(@file);					
					foreach $db (@file) {
						local($no,$sub,$nam,$eml,$com,$dat,$ho,$pw,$url,$mvw,$myid,$tim,$upl{1},$upl{2},$upl{3}) = split(/<>/, $db);

						# 画像移動
						foreach $i (1 .. 3) {
							next if (!$upl{$i});

							local($ex) = split(/,/, $upl{$i});
							if (-e "$upldir/$tim-$i$ex") {
								rename("$upldir/$tim-$i$ex", "$upldir_org/$tim-$i$ex");
							}
						}
					}
					rename("$logdir/$num.cgi", "$logdir_org/$num.cgi") || &error("Move error: from $logdir/$num.cgi to $logdir_org/$num.cgi");
					rename("$logdir/$num.dat", "$logdir_org/$num.dat") || &error("Move error: from $logdir/$num.dat to $logdir_org/$num.dat");
				}
			} else {
			push(@now,$_);
			}
		}

		# index更新
		unshift(@now,$top) unless($in{'delfile'});
		seek(DAT, 0, 0);
		print DAT &arrayEncode(\@now, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# 過去index更新
		if (@past > 0) {
#			$i = @tmp;
			open(DAT,"+< $pastfile") || &error("Open Error: $pastfile");
			eval "flock(DAT, 2);";
			while ( $_ = &lineDecode(DAT) ) {
				push(@past,$_);
			}
			seek(DAT, 0, 0);
			print DAT &arrayEncode(\@past, $logchar);
			truncate(DAT, tell(DAT));
			close(DAT);
		}

		# 削除待避ログから復帰処理のあとは、フィード作成のためにログディレクトリを通常の値に戻しておく
		$logdir = $logdir_org;
		$upldir = $upldir_org;

		# RSS/Atom			# 2009/10/16 スガラボット追加修正
		if($feed >= 1) {
			require $feedpl;
			&feed("admin", "-1");
		}

		# 過去ログ書庫再構築 (2010/12/01 スガラボット追加修正)
		&reconf_pastlog;

	# 過去ログの復帰 regist.cgi の新規書き込みルーチンをパクリ
	} elsif ($in{'action'} eq "extract" && $in{'no'} ne "" && $in{'bakfile'}) {

		# 選択スレッド情報展開
		(@lock) = split(/\0/, $in{'no'});

		# index読み込み
#		local($i, $flg, $top, @new, @tmp, @top);

		local($flg,$top,@now,@now2,@past,@tmp,@faq);
#		open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
		open(DAT,"+< $pastfile") || &error("Open Error: $pastfile");
		eval "flock(DAT, 2);";
#		$top = <DAT>;
		while ( $_ = &lineDecode(DAT) ) {
			$flg = 0;
#			s/\n//;
			local($num,$sub,$res,$nam,$date,$na2,$key,$upl,$ressub,$restime) = split(/<>/);

			foreach $lock (@lock) {
				if ($lock == $num) {
				$flg = 1;
				last;
				}
			}
			if ($flg) {
#				unshift(@now,$_);
#				push(@now2,$_);
				$key = "1";
				push(@now2, "$num<>$sub<>$res<>$nam<>$date<>$na2<>$key<>$upl<>$ressub<>$restime<>\n");

				# 現行ログに戻るスレッドのフラグを変更

				# スレッド読み込み
				open(DAT2,"+< $logdir/$num.cgi") || &error("Open Error: $num.cgi");
				eval "flock(DAT2, 2);";
				local(@file) = &arrayDecode(DAT2);

				# 先頭ファイルを抽出・分解
				$top2 = shift(@file);
				local($no,$sub2,$res2,$key2,$old_key) = split(/<>/, $top2);

				# フラグ変更・スレッド更新
				if ($old_key > 0) { $key2 = $old_key; }
				else { $key2 = '1'; }
				unshift(@file,"$no<>$sub2<>$res2<>$key2<>\n");

				seek(DAT2, 0, 0);
				my @temp = @file;
				print DAT2 &arrayEncode(\@temp, $logchar);
				truncate(DAT2, tell(DAT2));
				close(DAT2);

			} else {
			push(@past,$_);
			}
		}

		# 過去index更新
#		unshift(@now,$top);
		seek(DAT, 0, 0);
		print DAT &arrayEncode(\@past, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# 現行index更新
		if (@now2 > 0) {
		local (@faq);
#			$i = @tmp;
#			open(DAT,"+< $pastfile") || &error("Open Error: $pastfile");
			open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
			eval "flock(DAT, 2);";
			$top = &lineDecode(DAT);
			while ( $_ = &lineDecode(DAT) ) {
				local($num,$sub,$res,$nam,$date,$na2,$key,$upl,$ressub,$restime) = split(/<>/);
					# 0=ロック 1=標準 2=管理用 3=FAQ
					if ($key == 2) {
					push(@tmp,$_);
					} elsif ($key == 3) {
					push(@faq,$_);
					} else {
					push(@now,$_);
					}
			}
			unshift(@tmp,$top);
			seek(DAT, 0, 0);
			print DAT &arrayEncode(\@tmp, $logchar);
			print DAT &arrayEncode(\@faq, $logchar);
			print DAT &arrayEncode(\@now, $logchar);
			print DAT &arrayEncode(\@now2, $logchar);
			truncate(DAT, tell(DAT));
			close(DAT);
		}

		# RSS/Atom			# 2009/10/16 スガラボット追加修正
		if($feed >= 1) {
			require $feedpl;
			&feed("admin", "1");
		}

		# 過去ログ書庫再構築 (2010/12/01 スガラボット追加修正)
		&reconf_pastlog;

	# スレッド内レス記事閲覧
	} elsif ($in{'action'} eq "view" && $in{'no'} ne "") {

		# レス記事個別削除
		if ($in{'job'} eq "del" && $in{'no2'} ne "") {

			our ($top,$num,$sub2,$res,$key,$flg,@del,@new);

			if ($in{'no2'} =~ /\b0\b/) {
				&error("親記事の削除はできません");
			}

			# 削除情報を配列化
			@del = split(/\0/, $in{'no2'});

			# スレッド内より削除記事を抽出
			local($top, @new);
			open(DAT,"+< $logdir/$in{'no'}.cgi");
			eval "flock(DAT, 2);";
			$top = &lineDecode(DAT);
			local($num,$sub2,$res,$key) = split(/<>/, $top);
			while ( $_ = &lineDecode(DAT) ) {
				$flg = 0;
				local($no,$sub,$nam,$em,$com,$da,$ho,$pw,$url,$mvw,$myid,$tim,$upl{1},$upl{2},$upl{3}) = split(/<>/);
				foreach $del (@del) {
					if ($no == $del) {
						$flg = 1;

						# 画像削除
						foreach $i (1 .. 3) {
							next if (!$upl{$i});

							local($ex) = split(/,/, $upl{$i});
							if (-e "$upldir/$tim-$i$ex") {
								unlink("$upldir/$tim-$i$ex");
							}
						}
						last;
					}
				}
				if (!$flg) {
					push(@new,$_);

					# 最終投稿者名と時間を覚えておく
					$last_nam = $nam;
					$last_dat = $da;
					# タイトルも
					$last_sub = $sub;
				}
			}

			# レス個数を調整
			$res -= @del;
			$top = "$num<>$sub2<>$res<>$key<>\n";

			# スレッド更新
			unshift(@new,$top);
			seek(DAT, 0, 0);
			print DAT &arrayEncode(\@new, $logchar);
			truncate(DAT, tell(DAT));
			close(DAT);

			# index内容差し替え
			@new2 = (); @sort = (); @top = (); @faq= ();
			open(DAT,"+< $log");
			eval "flock(DAT, 2);";
			$top2 = &lineDecode(DAT) if ($in{'past'} == 0);
			while ( $_ = &lineDecode(DAT) ) {
				s/\n//;
				local($no,$sb,$re,$na,$da,$na2,$key,$upl,$ressub,$restime) = split(/<>/);

				if ($key == 2) {
					push(@top,"$_\n");
					next;
				}
				if ($key == 3 && $in{'no'} != $no) {
					push(@faq,"$_\n");
					next;
				}
				if ($key == 3 && $in{'no'} == $no) {
					# レス個数と最終投稿者名を差替
					$na2 = $last_nam;
					$da  = $last_dat;
					$_ = "$no<>$sb<>$res<>$na<>$da<>$na2<>$key<>$upl<>$last_sub<>$last_dat<>";
					push(@faq,"$_\n");
					next;
				}
				if ($in{'no'} == $no) {
					# レス個数と最終投稿者名を差替
					$na2 = $last_nam;
					$da  = $last_dat;
					$_ = "$no<>$sb<>$res<>$na<>$da<>$na2<>$key<>$upl<>$last_sub<>$last_dat<>";
				}
				push(@new2,"$_\n");

				# ソート用配列
				$da =~ s/\D//g;
				push(@sort,$da);
			}

			# 投稿順にソート
			@new2 = @new2[sort {$sort[$b] <=> $sort[$a]} 0 .. $#sort];

			# index更新
			unshift(@new2,@faq) if (@faq > 0);
			unshift(@new2,@top) if (@top > 0);
			unshift(@new2,$top2) if ($in{'past'} == 0);
			seek(DAT, 0, 0);
			print DAT &arrayEncode(\@new2, $logchar);
			truncate(DAT, tell(DAT));
			close(DAT);

			# RSS/Atom			# 2009/10/16 スガラボット追加修正
			if($feed >= 1) {
				require $feedpl;
				&feed("del");
			}

		# レス記事個別修正
		} elsif ($in{'job'} eq "edit" && $in{'no2'} ne "") {

			# 複数選択の場合は先頭のみ
			($in{'no2'}) = split(/\0/, $in{'no2'});

			require $editlog;
			&edit_log("admin");

		# スレッド分割・連結とスレッド改番
		} elsif ($in{'logfile'} && ($in{'job'} eq "split" || $in{'job'} eq "renumber")) {

			# スレッド改番で番号の指定がなければ、指定したレス以降で最新のレッドを作る。
			# 連結先スレッドの指定があれば、指定したレス以降を指定のスレッド記事に連結する。
			# 削除するかどうかなど分割元スレッドの処理はinit.cgiの $split_del パラメータに従う。

			local($tops,$num,$sub2,$res,$key,$i_nam2,$i_tim,$i_da,$flg,);

			local @newt = ();
			
			# 連結先の記事番号を複数選択の場合は先頭のみ使用
			($in{'no2'}) = split(/\0/, $in{'no2'});

			if ($in{'job'} eq "split" && !$in{'no2'}) { $in{'no2'} = 0; }
			if ($in{'job'} eq "renumber") { $in{'no2'} = 0; }

			# スレッド内より分割記事を抽出
			open(DAT0,"+< $logdir/$in{'no'}.cgi");
			eval "flock(DAT0, 2);";

			$line = 0;
			local (@log, @article);
			local (@no,@sub,@nam,@eml,@com,@dat,@ho,@pw,@url,@mvw,@myid,@tim,@file1,@file2,@file3,@idcrypt,@color,@resto,@prnt);
			local $top0 = &lineDecode(DAT0);
			while ( $buf =  &lineDecode(DAT0) ) {
				chomp($buf);
				($no[$line],$sub[$line],$nam[$line],$eml[$line],$com[$line],$dat[$line],$ho[$line],$pw[$line],$url[$line],$mvw[$line],
						$myid[$line],$tim[$line],$file1[$line],$file2[$line],$file3[$line],$idcrypt[$line],$color[$line],$resto[$line]) = split(/<>/, $buf);
				$prnt[$line] = $resto[$line];

				# 記事にこのスレッドを参照しているリンクがあればリンクを[スレッド番号]-記事番号の形式に変換する
				$com[$line] =~ s/&gt;&gt;(\d*\-|\-?)(\d+)/&gt;&gt;[$in{'no'}]-$1$2/g;
			
				# 記事の部分はまとめて@article配列に入れておく
				$article[$line] = "<>$sub[$line]<>$nam[$line]<>$eml[$line]<>$com[$line]<>$dat[$line]<>$ho[$line]<>$pw[$line]<>$url[$line]<>$mvw[$line]<>";
				$article[$line] .= 	"$myid[$line]<>$tim[$line]<>$file1[$line]<>$file2[$line]<>$file3[$line]<>$idcrypt[$line]<>$color[$line]<>";

				$buf = $no[$line] . $article[$line] . $resto[$line] . "<>\n";
				push(@log, $buf);

				$line++;
			}
			$num = $line;

			# ツリー構造のインデックス・リストを作成
			local (@lineno,@chid,@next,@prev);
			for ($line = 0; $line < $num; $line++) {
				&lst_cre($line, $prnt[$line], $no[$line]);
			}
 	
######## デバッグ用にtree テーブルの表示
#			&header;
#			print &strEncode("line &nbsp;no,prnt,chid,next,prev<br>\n");
#			for ($line = 0; $line < $num; $line++) {
#				printf("% 4d,% 4d,% 4d,% 4d,% 4d,% 4d, %50s<br>\n", $line, $no[$line],
#				$prnt[$line], $chid[$line], $next[$line], $prev[$line], $sub[$line]);
#			}
#			print &strEncode("<br>\n");
#
#			# デバッグ用にtree 行番号逆引きテーブル表示
#			$ln = $no[-1] + 1;
#			for ($line = 0; $line < $ln; $line++) {
#			    printf("%4d,%4d<br>\n", $line, $lineno[$line]);
#			}
#			print &strEncode("<br>\n");
##			exit;

			local $from = $in{'no2'} ? $in{'no2'} : 0;
			# 分割後のスレッドの作成者名をキープ
			$i_nam2 = $nam[$lineno[$from]];
			$i_tim = $tim[$lineno[$from]];
			$sub2 = $sub[$lineno[$from]];
			$i_da = $dat[$lineno[$from]];

			# もし分割・連結なら連結先のスレッド記事をチェック
			our ($to_thread, $new_thread);
			local($new, $top2, @dat2, $topt);
			local($resnum, $rescnt, $chkflag, $no_max, $to_open);
			local (@newt0) = ();
			if ($in{'to_thread'}) {
				# indexファイル
				$chkflag = 0;
				open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
				eval "flock(DAT, 2);";
				@dat2 = &arrayDecode(DAT);
				$top2 = shift(@dat2);
				foreach (@dat2) {
					local($no,$sb,$re,$na,$da,$na2,$key,$upl,$ressub,$restime) = split(/<>/);
					if ($in{'to_thread'} == $no) {
						$rescnt = $re + 1;
						$chkflag = 1;
					}
				}
				if (!$chkflag) {
					$new_thread = 1;
					$resnum = 0;
					$in{'to_res'} = 0;
				} else { &error("指定されたスレッド番号は既に存在します。既存スレッドの番号に改番はできません!") if ($in{'job'} eq "renumber"); }

# デバッグプリント
#				&error("dat2=@dat2<br><br>");

				# 連結先のログを開いて最大記事番号を取得する
				if (-e "$logdir/$in{'to_thread'}.cgi") {
					if ($in{'job'} eq "renumber") { &error("指定されたスレッド番号のログがあります。削除するか過去ログ化するなどの処理をしてから再実行して下さい!"); }
					open(OUT, "+<$logdir/$in{'to_thread'}.cgi");
					eval "flock(OUT, 2);";
					@newt0 =  &arrayDecode(OUT) ;
					$topt = shift(@newt0);
					$to_open = 1;
					$line2 = 0;
					$no_max = 0;
					foreach $buf2 (@newt0) {
						($no2[$line2]) = split(/<>/, $buf2);
						$no_max = $no2[$line2] if ($no2[$line2] > $no_max);
						$line2++;
					} 
					$resnum = $no_max + 1;
				} else {
					$no_max = 0;
					$resnum = 0;
					$new_thread = 1;
				}
			}

			# 新しいスレッドの記事番号配列を初期化 (追加する記事の最初の番号はそれまでの最大返信番号+1とする
			local $newln = $in{'to_thread'} ? $resnum : 0;

			local $newresto = $in{'to_thread'} ? $in{'to_res'} : 0;

			# この記事を参照する子供の親記事番号を全て更新する必要がある
			local(@new_prnt);

			if ($chid[$lineno[$from]]) {
				for ($lineno[$from] .. $num) {
					if ($prnt[$_] ==  $lineno[$from]) { $new_prnt[$_] = $newln; }
				}
			}

			local $kiji = "$newln" . $article[$lineno[$from]] . $newresto . "<>\n";
			$rescnt++;
			push(@newt, $kiji);

			# 旧ログの記事を参照していたリンクを新しいスレッド番号と記事番号に修正する準備
			local ($index) = $lineno[$from];
			local ($newidx) = $index;
			local (@newline, @no0);
			$newline[$from] = $newln;

			# 旧ログファイルのデータから分割移動する元記事を処理
			if ($split_del == 1) { undef($log[$lineno[$from]]); }
			if ($split_del == 2) { $log[$lineno[$from]] = $from . $article[$lineno[$from]] . "0<>\n"; }

######## 以下3行はデバッグ用
#			&header;
#			print &strEncode("Debug: from=$from<br>\n");
#			print &strEncode("Denug: line number of from=$lineno[$from]<br>");
#			print &strEncode("Denug: start line=$chid[$lineno[$from]]");
#			print "<br><br>\n";
#			exit;

			# 最終投稿者名、時間とタイトルを覚えておくための準備
			local($last_nam, $last_dat, $last_tim, $last_sub) = ('', '', 0, '');

			# 次にその発言に参照があれば子孫の記事をコピーするからチェックするだけに変更 (2009/04/10 スガラボット修正)
			our (@copy);
			$copy[$index] = 0;
			if ($chid[$lineno[$from]] > 0) { &lst_tree($chid[$lineno[$from]]); }
			
			# $index行以降で要コピーのチェックのついた行を記事にコピーする
			for ($index .. $num) {
				$j = $_;
				if ($copy[$j]) {
					$newidx++;
					$newln++;
					$newresto = $new_prnt[$j];
		 			$newline[$j] = $newln;

					# この記事を参照する子供の親記事番号を全て更新する必要がある
					if ($chid[$j]) { 
						for ($j .. $num) {
							if ($prnt[$_] ==  $j) { $new_prnt[$_] = $newln; }
						}
					}

					$kiji = $newln . $article[$j] . $new_prnt[$j] . "<>\n";
					$rescnt++;
					push(@newt, $kiji);

					# 旧ログの記事を参照していたリンクを新しいスレッド番号と記事番号に修正する準備
					$newline[$no[$j]] = $newln;

					# 旧ログファイルのデータから分割移動する記事の処理
					if ($split_del == 1) { undef($log[$j]); }
					if ($split_del == 2) { $log[$j] = $no[$j] . $article[$j] . "0<>\n"; }

					# 最終投稿者名とタイムスタンプを覚えておく
					if ($tim[$i] > $last_tim) {
						$last_nam = $nam[$j];
						$last_dat = $dat[$j];
						$last_tim = $tim[$j];
						# タイトルも
						$last_sub = $sub[$j];
					}
				}
			}

# デバッグプリント
#			&error("resnum=$resnum, chkflag=$chkflag, from=$from, newidx=$newidx, newln=$newln<br>newt=@newt<br><br>\n");

######## デバッグ用にtree テーブルの表示
#			&header;
#			print &strEncode("<br><br>line &nbsp;no,prnt,chid,next,prev,newprnt<br>\n");
#			for ($line = 0; $line < $num; $line++) {
#				printf("% 4d,% 4d,% 4d,% 4d,% 4d,% 4d,% 4d, %50s<br>\n", $line, $no[$line],
#				$prnt[$line], $chid[$line], $next[$line], $prev[$line], $new_prnt[$line], $sub[$line]);
#			}
#			print &strEncode("<br>\n");
#			exit;

######## 以下5行はデバッグ用
#			&header;
#			print &strEncode("Debug: old log=<br>");
#			foreach $string (@log) {
#			    print &strEncode($string . "<br>\n");
#			} 
#			print &strEncode("<br>\n");
#			exit;

######## 以下14行はデバッグ用のin変数とサーバのENV変数確認処理
#			&header;
#			print &strEncode("Debug: new log=<br>");
#			foreach $string (@newt) {
#			    print &strEncode($string . "<br>");
#			} 
#			exit;

			# 旧ログ更新
			my ($no0,$sub0,$res0,$key0) = split(/<>/, $top0);

			# 最終投稿者名、時間とタイトルを覚えておくための準備
			local($last_nam0, $last_dat0, $last_tim0, $last_sub0) = ('', '', 0, '');

			$line = 0;
			$lflg = 0;
			$newlog = '';
			foreach $buf (@log) {
				if (!$buf) { next; }
				$newlog .= $buf;
				chomp($buf);
				($no[$line],$sub[$line],$nam[$line],$eml[$line],$com[$line],$dat[$line],$ho[$line],$pw[$line],$url[$line],$mvw[$line],
						$myid[$line],$tim[$line],$file1[$line],$file2[$line],$file3[$line],$idcrypt[$line],$color[$line],$resto[$line])  = split(/<>/, $buf);

				# 最終投稿の名前、日時とタイトルを抽出
				if ($tim[$line] > $last_tim0) {
					$last_nam0 = $nam[$line];
					$last_dat0 = $dat[$line];
					$last_tim0 = $tim[$line];
					$last_sub0 = $sub[$line];
				}
				$line++;
			}

# デバッグプリント
#			&error("line=$line, split_del=$split_del<br><br>log=@log");

			if ($line) {
				$lflg = 1;
				$line--;
				seek(DAT0, 0, 0);
				print DAT0 &strEncode("$no0<>$sub0<>$line<>$key0<>\n", $logchar);
				print DAT0 &strEncode($newlog);
				truncate(DAT0, tell(DAT0));
				close(DAT0);
			} 
			else {				 # スレッド全コピー時、前のログファイルの処理は設定値に従う
				close(DAT0);
				if ($split_del == 1) {
					unlink("$logdir/$in{'no'}.cgi");
					unlink("$logdir/$in{'no'}.dat") if ($in{'job'} ne "renumber" && $in{'no2'});
				}
			}
			
			# 指定されたスレッド番号が存在すれば既存のスレッドに連結
			if ($chkflag) {
				# indexファイル更新
				local(@new2) = ();
				local($datnew, $nline);
				
				# 新しいスレッド番号を定義
				$to_thread = $in{'to_thread'};

				foreach $datbuf (@dat2) {
					local ($no,$sb,$re,$na,$da,$na2,$key,$upl,$ressub,$restime) = split(/<>/, $datbuf);

# デバッグプリント
#					print &strEncode("datbuf=$datbuf<br>\n");

					if ($no eq $in{'no'}) {
						if (!$lflg) { next; }
						$datnew = "$no<>$sb<>$line<>$na<>$last_dat0<>$last_num0<>$key<>$upl<>$last_sub0<>$last_tim0<>\n";
					} elsif ($no eq $in{'to_thread'}) {
						$nline = $rescnt - 1;
						if ($last_tim > $restime) {
							$datnew = "$no<>$sb<>$nline<>$na<>$last_dat<>$last_nam<>$key<>$upl<>$last_sub<>$last_tim<>\n";
						} else {
							$datnew = "$no<>$sb<>$nline<>$na<>$last_dat<>$na2<>$key<>$upl<>$ressub<>$restime<>\n";
						}
					} else {
						$datnew = $datbuf;
					}
					push(@new2, $datnew);
				}
				unshift(@new2, $top2);
				seek(DAT, 0, 0);

# デバッグプリント
#				&error("topt=$topt, dat2=@dat2<br><br>new2=@new2<br><br>addlog=@newt<br><br>");
				
				print DAT &arrayEncode(\@new2, $logchar);
				truncate(DAT, tell(DAT));
				close(DAT);

				# スレッド更新
				if (!$to_open) {
					open(OUT,"+<$logdir/$in{'to_thread'}.cgi") || &error("Write Error: $in{'to_thread'}.cgi");
					eval "flock(OUT, 2);";
					@newt0 =  &arrayDecode(OUT) ;
					$topt = shift(@newt0);
				}
				local($no3, $sub3, $res, $key) = split(/<>/, $topt);
				unshift(@newt0, "$no3<>$sub3<>$nline<>$key<>\n");
				push(@newt0, @newt);

# デバッグプリント
#				&error("<pre>分割スレッド処理動作中！<br><br>new2=@new2<br><br>newidx=$newidx<br>newlog=@newt0<br><br></pre>");
				
				seek(OUT, 0, 0);
				print OUT &arrayEncode(\@newt0, $logchar);
				close(OUT);

				# 参照ファイル修正 (スレッド改番のときは前のno.datの値を新しいスレッド番号に加算する)
				if ($in{'job'} eq 'renumber' || !$in{'no2'}) {
					open(NUM, "$logdir/$in{'no'}.dat");
					my ($buf) = &lineDecode(NUM);
					my ($num0, $ip0) = split(/:/, $buf);
					close(NUM);
					open(NUM, "$logdir/$in{'to_thread'}.cgi");
					$buf = &lineDecode(NUM);
					my ($num, $ip) = split(/:/, $buf);
					$num += $num0;
					$ip = $ip0 if ($last_tim > $restime);
					seek(NUM, 0, 0);
					print NUM &strEncode("$num:$ip");
					truncate(NUM, tell(NUM));
					close(NUM);
				}
			}
			# 連結先のスレッド番号が空なら新規スレッド作成、改番の時は指定番号のスレッドを作成
			else {
				# 新規スレッドの時indexファイルを展開
				if (!$top2) {
					local(@new2, @top, @faq);
					@new2 = ();
					open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
					eval "flock(DAT, 2);";
					@dat2 = &arrayDecode(DAT);
					$top2 = shift(@dat2);
					local($no,$host2,$time2) = split(/<>/, $top2);
					$new = $no + 1;

					$n_max = $new;
				} else {
					$new = $in{'to_thread'};

					local($no,$host2,$time2) = split(/<>/, $top2);
					if ($in{'to_thread'} <= $no) {
						$n_max = $no;
					} else {
						$n_max = $new;
					}
				}

				# 新しいスレッド番号を定義
				$to_thread = $new;

				foreach (@dat2) {
				local($tno,$sb,$re,$nm,$d,$lnm,$key,$ft,$lsb,$tm) = (split(/<>/));

					if ($tno == $in{'no'}) {
						if (!$lflg) { next; }
						$line--;
						if ($key == 2) { push(@top, "$tno<>$sb<>$line<>$nm<>$last_dat0<>$last_num0<>$key<>$ft<>$last_sub0<>$last_tim0<>\n"); next; }
						elsif ($key == 3) { push(@faq, "$tno<>$sb<>$line<>$nm<>$last_dat0<>$last_num0<>$key<>$ft<>$last_sub0<>$last_tim0<>\n"); next; }
						else { push(@new2, "$tno<>$sb<>$line<>$nm<>$last_dat0<>$last_num0<>$key<>$ft<>$last_sub0<>$last_tim0<>\n"); next; }
					}
					if ($key == 2) { push(@top,$_); next; }
					if ($key == 3) { push(@faq,$_); next; }
    
# 					この作業時は過去ログに落とさない
					else { push(@new2,$_); }
				}

				unshift(@new2,"$new<>$sub2<>$newidx<>$i_nam2<>$i_da<>$last_nam<>1<><>$last_sub<>$last_tim<>\n");
				unshift(@new2,@faq) if (@faq > 0);
				unshift(@new2,@top) if (@top > 0);
				unshift(@new2,"$n_max<>$host2<>$time2<>\n");
				seek(DAT, 0, 0);
				print DAT &arrayEncode(\@new2, $logchar);
				truncate(DAT, tell(DAT));
				close(DAT);
    
				# 参照ファイル生成 (スレッド改番のときは前のno.datを新しいスレッド番号にリネームする)
				if ($in{'job'} eq 'renumber') {
					rename("$logdir/$in{'no'}.dat", "$logdir/$new.dat");
				} else {
					open(NO,">$logdir/$new.dat") || &error("Write Error: $new.dat");
					print NO &strEncode("0:");
					close(NO);
				}

				# 新規スレッドのログ作成
				if (!$to_open) {
					open(OUT,">$logdir/$new.cgi") || &error("Write Error: $new.cgi");
					eval "flock(OUT, 2);";
				} else {
					seek(OUT, 0,0);
				}
				print OUT &strEncode("$new<>$sub2<>$newidx<>1<>\n", $logchar);
				print OUT &arrayEncode(\@newt, $logchar);
				truncate(OUT, tell(OUT));
				close(OUT);

				# パーミッション変更
				chmod(0666, "$logdir/$new.cgi");
				chmod(0666, "$logdir/$new.dat");
			}

			# 他の記事から移動した記事を参照するリンクがあればそれを修正
			if (@newline) {

				# リンク変更ログを作成
				open(LG, ">$logdir/linklog.txt");

				print LG &strEncode("move from thread=$in{'no'} to thread=$in{'to_thread'}, moved article no=", $logchar);
				my $i = -1;
				foreach (@newline) {
					$i++;
					if (!$_) { next; }
					print LG &strEncode("$i→$_, ", $logchar);
				}
				print LG &strEncode("\n", $logchar);

				opendir(DIR, "$logdir");
				my (@file0) = readdir(DIR);
				closedir(DIR);
				
				# 分割元スレッドの処理を最後にするためログファイル処理順序を変更
				my @file = ();
				foreach (@file0) {
					local ($fb, $ext) = split(/\./, $_);
					if ($fb eq $in{'no'}) { next; }
					push (@file, $_);
				}
				push (@file, "$in{'no'}.cgi");
				
				# 各ログファイルの処理
				foreach (@file) {
    
					local $final = 0;
					print LG &strEncode("$_\n", $logchar);
					$chg = 0;
					local ($fb, $ext) = split(/\./, $_);
					if (substr($fb, 0, 8) eq 'linktest' || $ext ne 'cgi') { next; }
					open(DAT, "+<$logdir/$_");
					eval "flock(DAT, 2);";
					local 	@newdata = ();
					local @data = &arrayDecode(DAT);
#					if (!$no[$i]) { next; }
    
					local $l = 1 ;	# ログの行番号
					foreach (@data) {
    
						# 連結先のスレッドでリンクが"from"-"to"形式になっているとき、"from"または"to"が移動された記事番号であれば変更し、なければ空にする
						local @no2 = ();
						local $param0 = $_;
						$param0 =~ s/&gt;&gt;\[$in{'no'}\]\-(\d+)\-(\d+)/push(@no2, ($1, $2))/eg;
    
						while (@no2) {
							local $c = 0;
							local ($one, $two, $one2, $two2);
							local $one = shift(@no2);
							local $two = shift(@no2);
							if (defined $newline[$one]) { $one2 = $newline[$one]; $c++; }
							if (defined $newline[$two]) { $two2 = $newline[$two]; $c++; }

							print LG &strEncode("line=$l, one=$one two=$two, ", $logchar);
							if ($c) {
								if ($fb eq $in{'to_thread'}) {
									if ($one2 && $two2) {
										s/&gt;&gt;\[$in{'no'}\]\-(\d+)\-(\d+)/<done>$one2-$two2/;
									} elsif ($one2) {
										s/&gt;&gt;\[$in{'no'}\]\-(\d+)\-(\d+)/<done>$one2-<br>&gt;&gt;[$in{'no'}]--$two/;
									} elsif ($two2) {
										s/&gt;&gt;\[$in{'no'}\]\-(\d+)\-(\d+)/<done>-$two2<br>&gt;&gt;[$in{'no'}]-$one-/;
									}
									$chg++;
    
									print LG &strEncode("c=$c, changed to <done>$one2-$two2\n", $logchar);
								} else {
									if ($one2 && $two2) {
										s/&gt;&gt;\[$in{'no'}\]\-(\d+)\-(\d+)/<done>[$in{'to_thread'}]-$one2-$two2/;
									} elsif ($one2) {
										s/&gt;&gt;\[$in{'no'}\]\-(\d+)\-(\d+)/<done>[$in{'to_thread'}]-$one2-<br>&gt;&gt;[$in{'no'}]--$two/;
									} elsif ($two2) {
										s/&gt;&gt;\[$in{'no'}\]\-(\d+)\-(\d+)/<done>[$in{'to_thread'}]--$two2<br>&gt;&gt;[$in{'no'}]-$one-/;
									}
									$chg++;
    
									print LG &strEncode("c=$c, changed to <done>[$in{'to_thread'}]-$one2-$two2\n", $logchar);
								}
							} else {
								s/&gt;&gt;\[$in{'no'}\]\-(\d+)\-(\d+)/<done>[$in{'no'}]-$1-$2/;
								print LG &strEncode("c=$c, no change\n", $logchar);
							}
						}
    
						# 連結先のスレッドでリンクが単独記事参照の時、リンク先が移動された記事番号であれば変更する
						@no2 = ();
						$param0 = $_;
						$param0 =~ s/&gt;&gt;\[$in{'no'}\]\-(\-?)(\d+)(\-?)/push(@no2, $2)/eg;
						while (@no2) {
							local $c = 0;
							local ($two, $two2);
							local $two = shift(@no2);

							print LG &strEncode("line=$l, two=$two, ", $logchar);
							if (defined $newline[$two]) { $two2 = $newline[$two]; $c++; }
							if ($c) {
								if ($fb eq $in{'to_thread'}) {
									s/&gt;&gt;\[$in{'no'}\]\-(\-?)(\d+)(\-?)/<done>$1$two2$3/;
									$chg++;
    
									print LG &strEncode("c=$c, changed to <done>$two->$two2\n", $logchar);
								} else {
									s/&gt;&gt;\[$in{'no'}\]\-(\-?)(\d+)/<done>[$in{'to_thread'}]-$1$two2$3/;
									$chg++;
    
									print LG &strEncode("changed to <done>[$in{'to_thread'}]-$two->two2\n", $logchar);
								}
							} else {
								s/&gt;&gt;\[$in{'no'}\]\-(\-?)(\d+)(\-?)/<done>[$in{'no'}]-$1$2$3/;
								print LG &strEncode("c=$c, no change\n", $logchar);
							}
						}
    
						# 分割元のスレッドで移動されなかった記事リンクを自スレッド参照形式に変更
						if ($fb eq $in{'no'}) {
							local $c = 0;
							$param0 = $_;
							$param0 =~ s/(&gt;&gt;|<done>)\[$in{'no'}\]\-/$c++/eg;
    
							if ($c) {
								s/<done2>\[$in{'no'}\]\-/&gt;&gt;/;
								$c--;
								$chg++;
    
								print LG &strEncode("  line=$l, link thread No. changed to self\n", $logchar);
							}
						}
    
						s/<done>/&gt;&gt;/g;
						s/<done2>/&gt;&gt;/g;
						push(@newdata, $_);
    
						$l++;
					}
    
					print LG &strEncode("chg=$chg\n", $logchar);
					if ($chg) {
						seek(DAT, 0, 0);
						print DAT &arrayEncode(\@newdata, $logchar);
						truncate(DAT, tell(DAT));
					}
					close(DAT);
    
					print LG &strEncode("\n", $logchar);
				}
    
				# リンク変更ログクローズ
				close(LG);
			}

			# RSS/Atom			# 2009/10/26 スガラボット追加修正
			if($feed >= 1) {
				require $feedpl;
				&feed("renumber");
			}

			goto THREAD;			# メンテナンス画面のスレッド選択表示にジャンプ
		}

		# スレッド内個別閲覧
		&header;
		print "<div align=\"right\">\n";
		print "<form action=\"$admincgi\" method=\"post\">\n";
		print "<input type=\"hidden\" name=\"pass\" value=\"$in{'pass'}\">\n";
		print "<input type=\"hidden\" name=\"mode\" value=\"admin\">\n";
		print "<input type=\"hidden\" name=\"$mylog\" value=\"1\">\n";
		print &strEncode("<input type=\"submit\" value=\"&lt;&lt; 戻る\"></form></div>\n");
		print "<form action=\"$admincgi\" method=\"post\">\n";
		print "<input type=\"hidden\" name=\"pass\" value=\"$in{'pass'}\">\n";
		print "<input type=\"hidden\" name=\"mode\" value=\"admin\">\n";
		print "<input type=\"hidden\" name=\"$mylog\" value=\"1\">\n";
		print "<input type=\"hidden\" name=\"no\" value=\"$in{'no'}\">\n";
		print "<input type=\"hidden\" name=\"action\" value=\"view\">\n";

		open(IN,"$logdir/$in{'no'}.cgi");
		$top = &lineDecode(IN);
		($num,$sub,$res) = split(/<>/, $top);

		print &strEncode("スレッド名 ： <b>[$num] $sub</b> [ $subject ]<hr>\n");
		print &strEncode("<li>修正、削除、分割・連結またはスレッド改番を選択して、処理したい記事番号をチェックします。<br>\n");
		print &strEncode("<li>親記事や返信の付いた記事の削除はできません。返信記事を分割してからスレッド削除などをして下さい。<br>\n");
		print &strEncode("<li>分割・連結の場合は、連結後に親記事となる参照先のスレッド番号と記事番号を入力します。<br>\n");
		print &strEncode("<li>分割・連結で連結先のスレッド指定がないか、指定されたスレッドが存在しないときは新しいスレッドを作成します。<br>\n");
		print &strEncode("<li>スレッド改番の場合は変更後のスレッド番号を入力します。既に存在するスレッドに改番することは出来ません。<br>\n");
		print &strEncode("<li>スレッド改番でスレッド番号を入力しないときは新規のスレッド番号が作成されます。<br><br>\n");
		print &strEncode("処理 ： <select name=\"job\">\n");
		print &strEncode("<option value=\"edit\" selected>修正\n");
		print &strEncode("<option value=\"del\">削除\n");
		if ($in{'logfile'}) {
			print &strEncode("<option value=\"split\">分割・連結\n");
			print &strEncode("<option value=\"renumber\">スレッド改番</select>\n");
			print &strEncode("　(但し、連結・改番の場合: スレッド番号<input type=\"text\" name=\"to_thread\" size=\"4\" value=\"\">へ、\n");
			print &strEncode(" 連結の場合: 記事番号<input type=\"text\" name=\"to_res\" size=\"4\" value=\"\">の返信として)　 \n");
		}
		print &strEncode("<input type=\"submit\" value=\"送信する\">\n");
		print "<dl>\n";

		while ( $_ = &lineDecode(IN) ) {
			local($no,$sub,$nam,$em,$com,$da,$ho,$pw,$url,$mvw,$myid) = split(/<>/);

			if ($em) { $nam="<a href=\"mailto:$em\">$nam</a>"; }

			print "<dt><input type=\"checkbox\" name=\"no2\" value=\"$no\"> ";
			print &strEncode("[<b>$no</b>] $sub <b>$nam</b> - $da ");
			print &strEncode("【<font color=\"$al\">$ho</font>】\n");

			if ($authkey) { print "ID:$myid\n"; }

			print &strEncode("<dd>$com\n");
		}
		close(IN);

		print "</dl></form>\n";
		&pr_footer;
		print "</body></html>\n";
		exit;
	}

# スレッド操作メニュー
	THREAD:

	&header;
	$printString .= <<"EOM";
<form action="$bbscgi">
<input type="submit" value="&lt; 掲示板">
</form>
<form action="$admincgi" method="post">
<input type="hidden" name="pass" value="$in{'pass'}">
<input type="submit" value="&lt; 管理TOP">
</form>
<h3 style="font-size:16px">管理モード [ $subject ]</h3>
<form action="$admincgi" method="post">
<input type="hidden" name="pass" value="$in{'pass'}">
<input type="hidden" name="mode" value="admin">
<input type="hidden" name="$mylog" value="1">
EOM
print &strEncode($printString);

	# 削除退避ログからの削除機能を追加 （2009/03/27 スガラボット修正)
	if ($in{'delfile'}) {
		$viewmode = "&mode=past&delview=1";
		print &strEncode("<input type=\"hidden\" name=\"deletelog\" value=\"1\">\n");
	}
	
	print &strEncode("スレッド処理 <select name=\"action\">\n");
	
	if (!$in{'delfile'}) {
		print &strEncode("<option value=\"view\">個別メンテ\n");
	}

	print &strEncode("<option value=\"del\">スレ削除\n");

	if ($in{'logfile'}) {
		print &strEncode("<option value=\"rmnew\">最終スレ番号削除\n");
		print &strEncode("<option value=\"lock\">ロック開閉\n");
		print &strEncode("<option value=\"faq\">FAQスレッドON/OFF\n");
		print &strEncode("<option value=\"lock2\">管理者\n");
	}

	if ($in{'logfile'} || $in{'delfile'}) {
		print &strEncode("<option value=\"archive\">過去ログ化\n");
	} 

	if ($in{'bakfile'}) {
		print &strEncode("<option value=\"extract\">現行ログ化\n");
		$viewmode = "&mode=past";
	} 

	$printString = <<EOM;
</select>
<input type="submit" value="送信する">
<p>
<Table border="0" cellspacing="0" cellpadding="0" width="600">
<Tr><Td bgcolor="$col1">
<table border="0" cellspacing="1" cellpadding="4" width="100%">
<tr bgcolor="$col1">
  <td bgcolor="$col3" align="center" nowrap>選択</td>
  <td bgcolor="$col3" width="100%">&nbsp; スレッド</td>
  <td bgcolor="$col3" align="center" nowrap>レス数</td>
</tr>
EOM
print &strEncode($printString);

	# スレッド一覧
	local ($no_max);
	open(IN,"$log") || &error("Open Error: $log");
	if ($in{'logfile'}){
		$top = &lineDecode(IN);
		($no_max) = split(/<>/, $top);
	}
	while ( $_ = &lineDecode(IN) ) {
		local($no,$sub,$res,$nam,$da,$na2,$key,$upl,$ressub,$restime) = split(/<>/);

		print "<tr bgcolor=\"$col2\"><th bgcolor=\"$col2\">";
		print "<input type=checkbox name=\"no\" value=\"$no\"></th>";
		print "<td bgcolor=\"$col2\">";

		if ($key eq '0') {
			print &strEncode("[<font color=\"$al\">ロック中</font>] ");
		} elsif ($key == 2) {
			print &strEncode("[<font color=\"$al\">管理コメント</font>] ");
		} elsif ($key == 3) {
			print &strEncode("[<font color=\"$al\">FAQスレッド</font>] ");
		} elsif ($key == 4) {
			print &strEncode("[<font color=\"$al\">管理者ロック中</font>] ");
		}

		print &strEncode("<b><a href=\"$readcgi$viewmode&no=$no\">[$no] $sub</a></b></td>");
		print &strEncode("<td bgcolor=\"$col2\" align=\"center\">$res</td></tr>\n");
	}
	close(IN);

	if ($in{'logfile'}){
		$printString = <<EOM;
<tr bgcolor="$col2">
  <td bgcolor="$col2">
  <td bgcolor="$col2" colspan="2" align="left" nowrap>最終スレッド番号: <b>$no_max</b><br>
  (スレッド処理で「最終スレ番号削除」を選択したとき、その番号のログがあるときはスレ選択にチェックを入れないと削除されません)</td>
</tr>
EOM
print &strEncode($printString);
	}

	print <<EOM;
</table>
</Td></Tr></Table>
</form>
EOM

	&pr_footer;

	print <<EOM;
</body>
</html>
EOM

	exit;
}

#-------------------------------------------------
#  ファイルサイズ
#-------------------------------------------------
sub filesize {
	local($top,$tmp,$num,$all,$all2,$size1,$size2,$size3,$size4,$file,$file1,$file2);

	# 現行ログ
	$size1 = 0;
	$file1 = 0;
	open(IN,"$nowfile") || &error("Open Error: $nowfile");
	$top = &lineDecode(IN);
	while ( $_ = &lineDecode(IN) ) {
		($num) = split(/<>/);
		$tmp = -s "$logdir/$num.cgi";
		$size1 += $tmp;
		$file1++;

		$now{$num} = 1;
	}
	close(IN);

	# 過去ログ
	$size2 = 0;
	$file2 = 0;
	open(IN,"$pastfile") || &error("Open Error: $pastfile");
	while ( $_ = &lineDecode(IN) ) {
		($num) = split(/<>/);
		$tmp = -s "$logdir/$num.cgi";
		$size2 += $tmp;
		$file2++;

		$pst{$num} = 1;
	}
	close(IN);

	# 画像
	opendir(DIR,"$upldir");
	local(@dir) = readdir(DIR);
	closedir(DIR);

	local($img) = 0;
	foreach (@dir) {
		next unless (/^[\d\-]+\.(jpg|gif|png)$/);

		$img += -s "$upldir/$_";
	}

	$size1 = int ($size1 / 1024 + 0.5);
	$size2 = int ($size2 / 1024 + 0.5);
	$img   = int ($img / 1024 + 0.5);
	$all = $size1 + $size2;
	$file = $file1 + $file2;

	&header;
	$printString = <<"EOM";
<form action="$bbscgi">
<input type="submit" value="&lt; 掲示板">
</form>
<form action="$admincgi" method="post">
<input type="hidden" name="pass" value="$in{'pass'}">
<input type="submit" value="&lt; 管理TOP">
</form>
<h3 style="font-size:16px">ログ容量算出</h3>
<ul>
<li>以下は記録ファイルの容量（サイズ）で、小数点以下は四捨五入します。
<li>分類欄のフォームをクリックすると各管理画面に移動します。
<form action="$admincgi" method="post">
<input type="hidden" name="pass" value="$in{'pass'}">
<p>
<Table border="0" cellspacing="0" cellpadding="0" width="280">
<Tr><Td bgcolor="$col1">
<table border="0" cellspacing="1" cellpadding="5" width="100%">
<tr bgcolor="$col1">
  <td bgcolor="$col3" rowspan="2" align="center">分類</td>
  <td bgcolor="$col3" rowspan="2" width="70" align="center">ファイル数</td>
  <td bgcolor="$col3" colspan="2" align="center">サイズ</td>
</tr>
<tr bgcolor="$col1">
  <td bgcolor="$col3" align="center" width="50">ログ</td>
  <td bgcolor="$col3" align="center" width="50">画像</td>
</tr>
<tr>
  <th bgcolor="$col2">
   <form action="$admincgi" method="post">
   <input type="submit" name="logfile" value="現行ログ"></th>
  <td align="right" bgcolor="$col2">$file1</td>
  <td align="right" bgcolor="$col2">$size1 KB</td>
  <td align="right" bgcolor="$col2" rowspan="2">$img KB</td>
</tr>
<tr bgcolor="$col2">
  <th bgcolor="$col2">
   <input type="submit" name="bakfile" value="過去ログ"></th>
  </th>
  <td align="right" bgcolor="$col2">$file2</td>
  <td align="right" bgcolor="$col2">$size2 KB</td>
</tr>
<tr bgcolor="$col2">
  <th bgcolor="$col2">合計</th>
  <td align="right" bgcolor="$col2">$file</td>
  <td align="right" bgcolor="$col2">$all KB</td>
  <td align="right" bgcolor="$col2">$img KB</td>
</tr>
</table>
</Td></Tr></Table>
</form>
</ul>
EOM
print &strEncode($printString);

	&pr_footer;

	$printString = <<"EOM";
</body>
</html>
EOM
print &strEncode($printString);
	exit;
}

#-------------------------------------------------
#  会員管理
#-------------------------------------------------
sub member_mente {
	# 新規フォーム
	if ($in{'job'} eq "new") {

		&member_form();

	# 新規発行
	} elsif ($in{'job'} eq "new2") {

		local($err);
		if (!$in{'name'}) { $err .= "名前が未入力です<br>\n"; }
		if ($in{'myid'} =~ /\W/) { $err .= "IDは英数字のみです<br>\n"; }
		if (length($in{'myid'}) < 4 || length($in{'myid'}) > 8) {
			$err .= "IDは英数字で4～8文字です<br>\n";
		}
		if ($in{'mypw'} =~ /\W/) { $err .= "パスワードは英数字のみです<br>\n"; }
		if (length($in{'mypw'}) < 4 || length($in{'mypw'}) > 8) {
			$err .= "パスワードは英数字で4～8文字です<br>\n";
		}
		if (!$in{'rank'}) { $err .= "権限が未選択です<br>\n"; }
		if ($err) { &error($err); }

		local($flg,$crypt,$id,$pw,$rank,$nam,@data);

		# IDチェック
		$flg = 0;
		open(DAT,"+< $memfile") || &error("Open Error: $memfile");
		while ( $_ = &lineDecode(DAT) ) {
			local($id,$pw,$rank,$nam) = split(/<>/);

			if ($in{'myid'} eq $id) { $flg = 1; last; }
			push(@data,$_);
		}

		if ($flg) { &error("このIDは既に登録済です"); }

		# パス暗号化
		$crypt = &encrypt($in{'mypw'});

		# 更新
		seek(DAT, 0, 0);
		print DAT &strEncode("$in{'myid'}<>$crypt<>$in{'rank'}<>$in{'name'}<>\n", $logchar);
		print DAT &arrayEncode(\@data, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

	# 修正フォーム
	} elsif ($in{'job'} eq "edit" && $in{'myid'}) {

		if ($in{'myid'} =~ /\0/) { &error("修正選択は１つのみです"); }

		local($flg,$id,$pw,$rank,$nam);

		$flg = 0;
		open(IN,"$memfile") || &error("Open Error: $memfile");
		while ( $_ = &lineDecode(IN) ) {
			($id,$pw,$rank,$nam) = split(/<>/);

			if ($in{'myid'} eq $id) { $flg = 1; last; }
		}
		close(IN);

		&member_form($id,$pw,$rank,$nam);

	# 修正実行
	} elsif ($in{'job'} eq "edit2") {

		local($err,$crypt);
		if (!$in{'name'}) { $err .= "名前が未入力です<br>\n"; }
		if ($in{'myid'} =~ /\W/) { $err .= "IDは英数字のみです<br>\n"; }
		if (length($in{'myid'}) < 4 || length($in{'myid'}) > 8) {
			$err .= "IDは英数字で4～8文字です<br>\n";
		}
		if ($in{'chg'}) {
			if ($in{'mypw'} =~ /\W/) { $err .= "パスワードは英数字のみです<br>\n"; }
			if (length($in{'mypw'}) < 4 || length($in{'mypw'}) > 8) {
				$err .= "パスワードは英数字で4～8文字です<br>\n";
			}

			# パス暗号化
			$crypt = &encrypt($in{'mypw'});

		} elsif (!$in{'chg'} && $in{'mypw'} ne "") {
			$err .= "パスワードの強制変更はチェックボックスに選択してください<br>\n";
		}
		if (!$in{'rank'}) { $err .= "権限が未選択です<br>\n"; }
		if ($err) { &error($err); }

		local($flg,$id,$pw,$rank,$nam,@data);

		open(DAT,"+< $memfile") || &error("Open Error: $memfile");
		while ( $_ = &lineDecode(DAT) ) {
			local($id,$pw,$rank,$nam) = split(/<>/);

			if ($in{'myid'} eq $id) {
				if ($crypt) { $pw = $crypt; }
				$_ = "$id<>$pw<>$in{'rank'}<>$in{'name'}<>\n";
			}
			push(@data,$_);
		}

		# 更新
		seek(DAT, 0, 0);
		print DAT &arrayEncode(\@data, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

	# 削除
	} elsif ($in{'job'} eq "dele" && $in{'myid'}) {

		local($flg,@data,@del);

		# 削除情報
		@del = split(/\0/, $in{'myid'});

		open(DAT,"+< $memfile") || &error("Open Error: $memfile");
		while ( $_ = &lineDecode(DAT) ) {
			local($id,$pw,$rank,$nam) = split(/<>/);

			$flg = 0;
			foreach $del (@del) {
				if ($del eq $id) { $flg = 1; last; }
			}
			if (!$flg) { push(@data,$_); }
		}

		# 更新
		seek(DAT, 0, 0);
		print DAT &arrayEncode(\@data, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	&header;
	$printString = <<"EOM";
<form action="$admincgi" method="post">
<input type="hidden" name="pass" value="$in{'pass'}">
<input type="submit" value="&lt; 管理TOP">
</form>
<h3 style="font-size:16px">会員管理</h3>
<form action="$admincgi" method="post">
<input type="hidden" name="pass" value="$in{'pass'}">
<input type="hidden" name="member" value="1">
<input type="hidden" name="past" value="3">
処理 :
<select name="job">
<option value="new">新規
<option value="edit">修正
<option value="dele">削除
</select>
<input type="submit" value="送信する">
<p>
<Table border="0" cellspacing="0" cellpadding="0" width="280">
<Tr><Td bgcolor="$col1">
<table border="0" cellspacing="1" cellpadding="3" width="100%">
<tr bgcolor="$col1">
  <td bgcolor="$col3" align="center" nowrap width="30">選択</td>
  <td bgcolor="$col3" align="center" nowrap>ID</td>
  <td bgcolor="$col3" align="center" nowrap>名前</td>
  <td bgcolor="$col3" align="center" nowrap>ランク</td>
</tr>
EOM
print &strEncode($printString);

	open(IN,"$memfile") || &error("Open Error: $memfile");
	while ( $_ = &lineDecode(IN) ) {
		($id,$pw,$rank,$nam) = split(/<>/);

		print "<tr bgcolor=\"$col2\"><th bgcolor=\"$col2\">";
		print &strEncode("<input type=\"checkbox\" name=\"myid\" value=\"$id\"></th>");
		print &strEncode("<td bgcolor=\"$col2\" nowrap>$id</td>");
		print &strEncode("<td bgcolor=\"$col2\">$nam</td>");
		print "<td bgcolor=\"$col2\" align=\"center\">$rank</td>";
	}
	close(IN);

	print <<EOM;
</table>
</Td></Tr></Table>
</form>
EOM

	&pr_footer;

	print <<EOM;
</body>
</html>
EOM
	exit;
}

#-------------------------------------------------
#  会員フォーム
#-------------------------------------------------
sub member_form {
	local($id,$pw,$rank,$nam) = @_;
	local($job) = $in{'job'} . '2';

	&header();
	$printString = <<EOM;
<form action="$admincgi" method="post">
<input type="hidden" name="pass" value="$in{'pass'}">
<input type="hidden" name="member" value="1">
<input type="submit" value="&lt; 前画面">
</form>
<h3 style="font-size:16px">登録フォーム</h3>
<form action="$admincgi" method="post">
<input type="hidden" name="pass" value="$in{'pass'}">
<input type="hidden" name="member" value="1">
<input type="hidden" name="job" value="$job">
<Table border="0" cellspacing="0" cellpadding="0" width="350">
<Tr><Td bgcolor="$col1">
<table border="0" cellspacing="1" cellpadding="5" width="100%">
<tr bgcolor="$col1">
  <td bgcolor="$col2" align="center" nowrap>名前</td>
  <td bgcolor="$col2"><input type="text" name="name" size="25" value="$nam"></td>
</tr>
<tr bgcolor="$col1">
  <td bgcolor="$col2" align="center" nowrap>ログインID</td>
  <td bgcolor="$col2">
EOM
print &strEncode($printString);

	if ($in{'myid'}) {
		print $in{'myid'};
	} else {
		print "<input type=\"text\" name=\"myid\" size=\"10\" value=\"$id\">\n";
		print &strEncode("（英数字で4～8文字）\n");
	}

	$printString = <<"EOM";
  </td>
</tr>
<tr bgcolor="$col1">
  <td bgcolor="$col2" align="center" nowrap>パスワード</td>
  <td bgcolor="$col2">
	<input id="w115" type="password" name="mypw"> （英数字で4～8文字）
EOM
print &strEncode($printString);

	if ($in{'myid'}) {
		print "<br><input type=\"checkbox\" name=\"chg\" value=\"1\">\n";
		print &strEncode("パスワードを強制変更する場合にチェック\n");
		print "<input type=\"hidden\" name=\"myid\" value=\"$in{'myid'}\">\n";
	}

	$printString = <<"EOM";
  </td>
</tr>
<tr bgcolor="$col1">
  <td bgcolor="$col2" align="center" nowrap>権限</td>
  <td bgcolor="$col2">
EOM
print &strEncode($printString);

	local(%rank) = (1,"閲覧のみ", 2,"閲覧&amp;書込OK");
	foreach (1,2) {
		if ($rank == $_) {
			print &strEncode("<input type=radio name=rank value=\"$_\" checked>レベル$_ ($rank{$_})<br>\n");
		} else {
			print &strEncode("<input type=radio name=rank value=\"$_\">レベル$_ ($rank{$_})<br>\n");
		}
	}

	$printString = <<EOM;
  </td>
</tr>
</table>
</Td></Tr></Table>
<p>
<input type="submit" value="送信する">
</form>
EOM
print &strEncode($printString);

	&pr_footer;

	$printString = <<EOM;
</body>
</html>
EOM
print &strEncode($printString);
	exit;
}

#-------------------------------------------------
#  メニュー画面
#-------------------------------------------------
sub menu_disp {
	# セッションディレクトリ掃除
	if ($authkey && $in{'login'}) {
		&ses_clean;
	}

	&header;
	$printString = <<"EOM";
<form action="$bbscgi">
<input type="submit" value="&lt; 掲示板">
</form>
<div align="center">
<form action="$admincgi" method="post">
<input type="hidden" name="pass" value="$in{'pass'}">
<input type="hidden" name="job" value="menu">
処理内容を選択してください。
<p>
<Table border="0" cellspacing="0" cellpadding="0" width="320">
<Tr><Td bgcolor="$col1">
<table border="0" cellspacing="1" cellpadding="5" width="100%">
<tr bgcolor="$col1">
  <td bgcolor="$col3" align="center">
	選択
  </td>
  <td bgcolor="$col3" width="100%">
	&nbsp; 処理内容
  </td>
</tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2" align="center">
	<input type="submit" name="logfile" value="選択">
  </td>
  <td bgcolor="$col2" width="100%" align="left">
	&nbsp; 現行ログ・メンテナンス
  </td>
</tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2" align="center">
	<input type="submit" name="bakfile" value="選択">
  </td>
  <td bgcolor="$col2" width="100%" align="left">
	&nbsp; 過去ログ・メンテナンス
  </td>
</tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2" align="center">
	<input type="submit" name="reconf_pastlog" value="選択">
  </td>
  <td bgcolor="$col2" width="100%" align="left">
	&nbsp; 過去ログ・再構築
  </td>
</tr>
EOM
print &strEncode($printString);

	# 消去退避ログ・メンテナンス
	if ($logdelete) {
		print "<tr bgcolor=\"$col2\"><td bgcolor=\"$col2\" align=\"center\">\n";
		print &strEncode("<input type=\"submit\" name=\"delfile\" value=\"選択\"></td>");
		print &strEncode("<td bgcolor=\"$col2\" width=\"100%\" align=\"left\">&nbsp; 消去退避ログ・メンテナンス</td></tr>\n");
	}

	if ($authkey) {
		print "<tr bgcolor=\"$col2\"><td bgcolor=\"$col2\" align=\"center\">\n";
		print &strEncode("<input type=\"submit\" name=\"member\" value=\"選択\"></td>");
		print &strEncode("<td bgcolor=\"$col2\" width=\"100%\" align=\"left\">&nbsp; 会員認証の管理</td></tr>\n");
	}

	$printString = <<"EOM";
<tr bgcolor="$col2">
  <td bgcolor="$col2" align="center">
	<input type="submit" name="filesize" value="選択">
  </td>
  <td bgcolor="$col2" width="100%" align="left">
	&nbsp; ファイル容量の閲覧
  </td>
</tr>
EOM
print &strEncode($printString);

	# RSSフィード対応ならRSSファイルを作り直す機能を入れる
	if ($feed) {
	$printString = <<"EOM";
<tr bgcolor="$col2">
  <td bgcolor="$col2" align="center">
	<input type="submit" name="feed_create" value="選択">
  </td>
  <td bgcolor="$col2" width="100%" align="left">
	&nbsp; RSSフィードファイルを作り直し
  </td>
</tr>
EOM
print &strEncode($printString);
	}

	if ($createonlyadmin || !$thread_theme) {
		if ($createonlyadmin) {
			$disp = "新規スレッド作成（スレッド作成制限中）";
		} else {
			$disp = "新規投稿にスレッドテーマを表示";
			$para = "&tthem=1";
		}
		$printString = <<"EOM";
<tr bgcolor="$col2">
  <td bgcolor="$col2" align="center">
	&nbsp;
  </td>
  <td bgcolor="$col2" width="100%" align="left">
	&nbsp; 	<a href="$readshtml&mode=form$para">$disp</a>
  </td>
</tr>
EOM
print &strEncode($printString);
	}

	if ($logdelete) {
	$printString = <<"EOM";
<tr bgcolor="$col2">
  <td bgcolor="$col2" align="center">
	&nbsp;
  </td>
  <td bgcolor="$col2" width="100%" align="left">
	&nbsp; 	<a href="$readshtml&mode=past&delview=1">削除退避したスレッドログを閲覧</a>
  </td>
</tr>
EOM
print &strEncode($printString);
	}

	$printString = <<"EOM";
<tr bgcolor="$col2">
  <td bgcolor="$col2" align="center">
	&nbsp;
  </td>
  <td bgcolor="$col2" width="100%" align="left">
	&nbsp; 	<a href="$showcountcgi">ファイルのダウンロード状況を表示</a>
  </td>
</tr>
EOM
print &strEncode($printString);

	print <<EOM;
</table>
</Td></Tr></Table>
</form>
</div>
EOM

	&pr_footer;

	print <<EOM;
</body>
</html>
EOM
	exit;
}

#-------------------------------------------------
#  入室画面
#-------------------------------------------------
sub enter {
	&header;
	$printString = <<"EOM";
<blockquote>
<table border="0" cellspacing="0" cellpadding="26" width="400">
<tr><td align="center">
	<fieldset>
	<legend>
	▼管理パスワード入力
	</legend>
	<form action="$admincgi" method="post">
	<input type="hidden" name="login" value="1">
	<input id="w115" type="password" name="pass">
	<input type="submit" value=" 認証 "></form>
	</fieldset>
</td></tr>
</table>
</blockquote>
<script language="javascript">
<!--
self.document.forms[0].pass.focus();
//-->
</script>
EOM
print &strEncode($printString);

	&pr_footer;

	$printString = <<"EOM";
</body>
</html>
EOM
print &strEncode($printString);
	exit;
}

#-------------------------------------------------
#  セションディレクトリ掃除
#-------------------------------------------------
sub ses_clean {
	local($mtime,@dir);

	opendir(DIR,"$sesdir");
	@dir = readdir(DIR);
	closedir(DIR);

	foreach (@dir) {
		next unless (/^\w+\.cgi$/);

		$mtime = (stat("$sesdir/$_"))[9];
		if (time - $mtime > $authtime*60*2) {
			unlink("$sesdir/$_");
		}
	}
}

#-------------------------------------------------
#  ツリー構造を辿って子孫の記事をコピーするサブルーチン
#-------------------------------------------------
sub lst_tree {
    # 
    my ($idx) = @_;
    my ($i);

    $i = $idx;

	do {
		# コピーする記事の行番号にチェックを入れる (2009/04/10 スガラボット修正)
		$copy[$i] = 1;

        if ($chid[$i] != 0) {
            if ($next[$i] == $chid[$prnt[$i]]) {
                # 最後のノード
            } else {
                # 最後以外のノード
            }
            &lst_tree($chid[$i]);
        }

        $i = $next[$i];
    } until ($i == $idx);
}

#-------------------------------------------------
#  RSSフィード作り直し画面
#-------------------------------------------------
sub feed_create {

	# フィード作成ライブラリ呼出し
	require $feedpl;
	&feed('create');

	&header;

	$printString = <<"EOM";
<form action="$bbscgi">
<input type="submit" value="&lt; 掲示板">
</form>
<div align="center">
<p>
RSSフィードファイルを作り直しました!
</div>
EOM
print &strEncode($printString);

	&pr_footer;

	$printString = <<"EOM";
</body>
</html>
EOM
print &strEncode($printString);

	exit;

}

#-------------------------------------------------
#  過去ログ・再構築
#-------------------------------------------------
sub reconf_pastlog {

	my ($exit_flag) = @_;

	require $pastlog;

	my ($INDEX1, $INDEX2);
	my (@tp, @tp2, @past_tp, $top, $past_tp_ln, @new_tp, @new_tp2, @past_newtp);

	# 現行インデックスファイルオープン
	open($INDEX1,"+< $nowfile") || &error("Open Error: $nowfile");
	@tp = &arrayDecode($INDEX1);
	$top = shift(@tp);
	push(@new_tp, $top);

	# 現行ログのスレッド数カウント
	my $now_count = @tp;

	# 過去ログインデックスファイルオープン
	open($INDEX2,"+< $pastfile") || &error("Open Error: $pastfile");
	@tp2 = &arrayDecode($INDEX2);
	my $tp2_count = @tp2;

	# 現行ログのスレッド数が $i_max より大きいか、再構築時、過去ログから現行ログに自動復帰なら現行ログインデックスと過去ログインデックスを連結する
	my $nowfile_change;
	if (($move2plog && $now_count > $i_max) || ($plog_restore && $tp2_count && $now_count < $i_max)) {

		# 重要なログファイルは変更する前にバックアップをとっておく。
		use File::Copy;
		copy("$nowfile", "$nowfile.bak");	
		copy("$pastfile", "$pastfile.bak");	

		# 現行ログに過去ログを連結
		push(@tp, @tp2);
		$nowfile_change = 1;
	} else { 
		push(@new_tp, @tp);
		@tp = @tp2;
	}
	my $tp_count = @tp;

	# 過去ログ・現行ログをロックする
	eval "flock($INDEX1, 2);";
	eval "flock($INDEX2, 2);";

	local $n = "1";
	local $acount = 0;
	local $N;
	local ($INDEX_P, @past_index, @past_page_dir);

	if (($nowfile_change && $tp_count > $i_max) || (!$nowfile_change && $tp2_count)) { 

		# 過去ログ書庫ページディレクトリがあれば一旦全削除する
		if (-e $pastdir) {

			use File::Path;
			my @pathArray = ("$pastdir");

			# ディレクトリを再帰的に全削除
			rmtree(@pathArray);

			# すぐ復帰すると次のディレクトリ再作成を失敗するようなので一休み
			sleep(1);
		}

		# 過去ログ書庫ページディレクトリ作成
		mkdir($pastdir, '0707');

		# 過去ログ書庫インデックス・ファイル名の定義
		$N = sprintf("%04d", $n);
		$past_index[$n] = "$pastdir/P${N}.dat";
		open($INDEX_P, "+> $past_index[$n]");

		# 過去ログ書庫ファイルディレクトリの作成
		if ($copy_logfiles) {
			$past_page_dir[$n] = "$pastdir/plog${N}";
			unless (-e $past_page_dir[$n]) {
				mkdir($past_page_dir[$n], '0707');
				mkdir("$past_page_dir[$n]/upl", '0707');
				$acount++;
			}
		}

		# 過去ログ書庫ページのカウントファイルを作成
		my $COUNT;
		open($COUNT, "+> $pastno_file") || &error("Open Error: $pastno_file");
		print $COUNT "$N\n";
		truncate($COUNT, tell($COUNT));
		close($COUNT);
	}

	our $titlebb;
	# BBCode処理の変数関数を選択 (2009/01/14 スガラボット修正)
	if ($bbcode) { $titlebb ="bbtitle"; } 
	else { $titlebb = "titlebbrm"; }

	use File::Copy;

	my ($i, $k, $fcount, $tcount);
	local ($print_string, @upl_files);
	$k = $fcount = $tcount = 0;
	for ($i = 0; $i < $tp_count; $i++) { 

		# 現行ログに変化がある場合
		if ($nowfile_change && $i < $i_max) {

			# 新しい現行インデックス・ファイルに追加する
			push(@new_tp, $tp[$i]);

			# もし、過去ログから現行ログに繰り上がるスレッドがあればキーを変更する
			if ($i > $now_count) {
				my ($num) = split(/<>/, $tp[$i]);
				my $IN;
				open($IN, "+< $logdir/$num.cgi") || &error("Open Error: $num.cgi at reconf_pastlog.");
				my @log = &arrayDecode($IN, $logchar);
				my ($no, $lsub, $lres, $key, $old_key) = split(/<>/, $log[0]);
				if ($old_key > 0) { $key = $old_key; }
				else { $key = '1'; }
				$log[0] = "$no<>$lsub<>$lres<>$key<>\n";
				seek($IN, 0, 0);
				print $IN &arrayEncode(\@log, $logchar);
				truncate($IN, tell($IN));
				close($IN);
			}
		} else {

			# 過去ログ書庫ページがのスレッド数が一杯になったら次の書庫ページを作成する
			if ($k == $past_page_max_tno) {

				# 新しい過去ログインデックスファイルを作成する
				$n++;
				$N = sprintf("%04d", $n);
				$past_index[$n] = "$pastdir/P${N}.dat";
				open($INDEX_P, "+> $past_index[$n]");
#				@past_tp =&arrayDecode($INDEX_P);
    
				# 過去ログ書庫ディレクトリの作成
				if ($copy_logfiles) {
					$past_page_dir[$n] = "$pastdir/plog${N}";
					unless (-e $past_page_dir[$n]) {
						mkdir($past_page_dir[$n], '0707');
						mkdir("$past_page_dir[$n]/upl", '0707');
						$acount++;
					}
				}
    
				$k = 0;
			}

			# 新しい過去インデックス・ファイルに追加する
			push(@new_tp2, $tp[$i]);

			# 古いものから順にスレッドのツリー式インデックスを作成する
			$print_string = '';
			@upl_files = ();
			# Forum 表示リンクのパラメータセット
			$readshtml .= "&bbs=forum&mode=past";
			# ツリー形式インデックス作成
			my $num = &create_pindex($tp[$element_no - $tcount - 1]);
			# Patio 表示リンクのパラメータセット
			$readshtml .= "&bbs=patio&mode=past";
			unshift(@past_newtp, $tp[$tp_count - $tcount - 1].$print_string);
    
			# 過去ログに移動するスレッドのlog/datファイルとアップロードファイルをコピーする
			if ($copy_logfiles) {
				copy("$logdir/$num.cgi", "$past_page_dir[$n]/$num.cgi");	
				copy("$logdir/$num.dat", "$past_page_dir[$n]/$num.dat");	
#				print ("copy $logdir/$num.cgi $past_page_dir[$n]/<br>\n");
    
				while ( @upl_files ) {
					my $file = shift(@upl_files);
					copy("$upldir/$file",  "$past_page_dir[$n]/upl/$file");
#					print ("copy $upldir/$file $past_page_dir[$n]/upl/<br>\n");
    
					$fcount++;
				}
			}

			$tcount++;
			$k++;
			my $j = $i + 1;
			if ($k == $past_page_max_tno || $j == $tp_count) {

				# 新しい過去ログインデックスファイルを書き込む
				print $INDEX_P &arrayEncode(\@past_newtp, $logchar);
				truncate($INDEX_P, tell($INDEX_P));
				close($INDEX_P);
				@past_newtp = ();

				# 過去ログ書庫ページのカウントファイルを作成
				my $COUNT;
				open($COUNT, "+> $pastno_file") || &error("Open Error: $pastno_file");
				print $COUNT "$N<>$k<>\n";
				truncate($COUNT, tell($COUNT));
				close($COUNT);
			}
		}
	}

	# ログファイルに変更を加える場合は書き込み
	if ($nowfile_change) {
		# 現行ログ書込み
		seek($INDEX1, 0, 0);
		print $INDEX1 &arrayEncode(\@new_tp, $logchar);
		truncate($INDEX1, tell($INDEX1));
		close($INDEX1);

		# 過去ログ書込み
		seek($INDEX2, 0, 0);
		print $INDEX2 &arrayEncode(\@new_tp2, $logchar);
		truncate($INDEX2, tell($INDEX2));
	}

	# ログファイルをクローズ
	close($INDEX1);
	close($INDEX2);

	# 結果表示
	if ($exit_flag) {
		$printString .= <<"EOM";
<form action="$bbscgi">
<input type="submit" value="&lt; 掲示板">
</form>
EOM
	}

	$printString .= <<"EOM";
<div align="center">
<p>
過去ログ書庫・再構築処理が終了しました。<br>
作成した最終のページカウント:$N<>$k<>, 移動したスレッド数:$tcount, コピーしたファイル数:$fcount<br>
</p>
</div>
EOM

if ($exit_flag) {
	&header;
	print &strEncode($printString);
	&pr_footer;
	print "</body></html>";
	exit;
}

}

1;
