#!/usr/local/bin/perl
# patio.cgiを参考にしてforum.cgiを作成 (20081010)
# きりしま式 Web Patio v3.22 K0.82相当 2009/03/24
$sver = 'v1.51';
# 2012/11/15 patio/forum のインデックスページに指定した数の新着記事を表示する機能を追加(簡易掲示板向け)
# 2012/11/14 スレッド一覧の下に新着記事を$newArticleで設定した数だけ表示する機能を追加
# 2012/02/12 ユーザカスタムCSSによりページ表示幅に制限がある時、枠をはみ出さないようにツリーインデックスの「題名」切り詰め機能を追加
# 2012/02/07 ユーザ定義ヘッダー対応のコラム背景画像クラスとユーザ定義フッターの印刷ルーチンを追加
# 2010/12/19 ツリー逆順表示、スレッド降順表示のアイコンの場所変更。表示の文言変更
# 2010/12/17 ツリーインデックスでツリー逆順表示及びスレッド降順表示のアイコン位置を行の先頭に変更
# 2010/12/04 ユーザ独自定義のヘッダ及びフッタを挿入可能とした
# 2010/11/30 $bbsshtml のパラメータ変更、「Patio形式表示」の文言をinit.cgiで、フッター追加等
# 2009/11/04 如水さんのWebPatio+ (http://jyosui.xrea.jp/feed.html) 静的RSS機能を一部修正して追加インストール
# 2009/07/05 CGIスクリプトをUnicode記述に変更。HTML入出力とログファイルの文字コード(utf8,sjis,euc,jis)を設定可能
# 2009/05/12 スレッドテーマと新規投稿題名を別設定できるよう修正
# 2009/03/24 スレッド作成制限モードの追加
# 2009/01/14 名前とタイトルにBBCodeからHTMLに変換する文字修飾機能を追加
# 2008/12/28 トピックス数が複数ページになる時のviewcountファイルの書込み方法を修正
# 2008/12/14 携帯電話対応を含めて各種表示方法を追加
# 2008/12/09 携帯電話からのアクセスに対応
#			 内容:	①携帯電話からのアクセス時はtreeview表示しない
#					②<tabel>タグを入れ子にしない等々
# 2008/10/29 v1.03 閲覧数要約ファイルviewcouut.datの適用
# 2008/10/26 v1.03α 掲示板のforum形式スレッドページ表示のキャッシュファイル化
# 2008/10/14 Forum形式のメニュー表示でツリーの参照がおかしくなる不具合を修正
# 2008/03/03 Tree表示機能、トピックスと最新レスにリンク機能を追加
# 2007/05/19 掲示板の説明を追加
# 2007/01/22 着手

#use strict;
#use warnings;
#use Time::Local;
use utf8;

# 外部ファイル取り込み
require './init.cgi';
#require $jcode;

# SSIによる複数会議室対応かどうか (20080315 スガラボット修正)
if (!$patioshtml) { $patioshtml = $patiocgi; }
if (!$forumshtml) { $forumshtml = $forumcgi; }
if (!$readshtml) { $readshtml = $readcgi; }
if (!$bbsshtml) { $bbsshtml = $bbscgi; }

# BBCode処理の変数関数を選択 (2009/01/14 スガラボット修正)
our $titlebb;
if ($bbcode) {
	$titlebb ="bbtitle";
	$combb = "bbcode2html";
} else {
	$titlebb = "titlebbrm";
	$combb = "bbcoderm";
}

# 以前のバージョンのinit.cgiを使用したときにも暴走しないように修正 (20081025 スガラボット)
$fmenu1 = $fmenu1 ? $fmenu1 : $menu1;
$fmenu2 = $fmenu2 ? $fmenu2 : $menu2;

&parse_form;

# 携帯電話からのアクセス時パラメータセット
if ($ua) { $width = "width=\"100%\""; $tree = 0;}
else { $width = "width=\"95%\""; }

if ($mode eq "check") {
	require $checkpl;
	&check;
}
&axscheck;
if ($mode eq "find") {
	require $findpl;
	&find('forumview');
}
elsif ($mode eq "enter_disp") { &enter_disp; }
elsif ($mode eq "logoff") { &logoff; }
&indexview;

#-------------------------------------------------
#  メニュー部表示
#-------------------------------------------------
sub indexview {
	local($alarm,$i,$data,$top,$count);
	local($st1,$st2,$newdisp);

#	Salon da Musica の掲示板で処理がアップデートならクッキー送出処理を追加 (20080519 守田修正)

	&user_cookie;

# ツリー・フォーラム対応でないときは動作できない
	if (!$treeforum)
	{
		&error("Open Error: ツリー表示対応フォーラム以外では動作しません");
	}
	# アラーム数定義
	$alarm = int ( $m_max * 0.9 );

	if ( $user_hdft ) {
		&header('', 'js', 1);
	} else {
		&header('', 'js', 0);
	}

# 本文タイトルを新規に追加した処理 (20080210守田修正)
	if ($body_title eq '') { $body_title=$title; }

# 各会議室にWebホームページがあればリンクを張る処理を追加 (20081009 スガラボット修正)
	@hpstat = stat("$roomdir/index.html");
	if ($hpstat[7] > 0) 
	{
		$hplink1 = "<a href=\"$room_url/index.html\">";
		$hplink2 = "&nbsp;&nbsp;←&lt;この掲示板のホームページへ&gt;</a>";
	}

# デバッグプリント
#	&error("Debug: room=$room_url, hpstat[7]=$hpstat[7], hpstatus=@hpstat<br>\n");

	$printString = <<"EOM";
<div align="center">
<table $width border="0" cellspacing="0" cellpadding="0">
	<tr>
	<td align="left">$hplink1<b style="font-size:$t_size; color:$t_color">$body_title</b><b>$hplink2</b><br>
<small>$desc</small></td><td align="right">
EOM
print &strEncode($printString);

	print "<td>";
# Google AdSense
	&googleadsense;
	print "</td>";

	print <<"EOM";
</td>
EOM

	if ($authkey) {
		print &strEncode("<td align=\"right\">ようこそ、<b>${my_name}さん</b></td>\n");
	}

	print <<EOM;
	<td align="right">$countview<br><div style="margin-top: 4px;">
EOM

# FEED機能の追加 （2009/11/04 スガラボット修正)
if($feed && !$ua) {
	print &strEncode("\t<img src=\"$imgurl/feed.gif\" border=\"0\" alt=\"FEEDアイコン\">\n");
	if($rss1forumfile) { print "\t<a href=\"$rss1forumurl\"><img src=\"$imgurl/RSS10.gif\" border=\"0\" alt=\"RSS1.0\"></a>\n"; }
	if($rss2forumfile) { print "\t<a href=\"$rss2forumurl\"><img src=\"$imgurl/RSS20.gif\" border=\"0\" alt=\"RSS2.0\"></a>\n"; }
	if($atomforumfile) { print "\t<a href=\"$atomforumurl\"><img src=\"$imgurl/ATOM10.gif\" border=\"0\" alt=\"ATOM1.0\"></a>\n"; }
}

	print <<EOM;
	</div></td></tr>

	</table>
<table border="0" cellspacing="0" cellpadding="0" $width><tr>
  <td align="right" nowrap><div style="padding: 3px;">
EOM

	if (!$createonlyadmin) {
	$printString = <<EOM;
	 | <a href="$readshtml&mode=form">新規テーマで投稿</a>
EOM
print &strEncode($printString);
} else {
	$printString = <<EOM;
	 | スレッド作成制限中
EOM
print &strEncode($printString);
}

	my $menu = defined($use_patio_menu) ? $use_patio_menu : 'Patio形式で表示';
	$printString = <<EOM;
	 | <a href="$patioshtml">$menu</a>
	 | <a href="$home" target="_top">ホームに戻る</a>
	 | </font><a href="$notepage">留意事項</a>
	 | <a href="$bbsshtml&mode=find">ワード検索</a>
	 | <a href="$readshtml&mode=past">過去ログ</a> |
EOM
print &strEncode($printString);

	# 認証モードのとき
	if ($authkey) {
		print &strEncode(" <a href=\"$bbsshtml&mode=logoff\">ログオフ</a> |\n");
	}

	$printString = <<EOM;
 <a href="$admincgi">管理用</a> |</font></div></td>
</tr></table>
EOM
print &strEncode($printString);

#	ユーザ定義関数による表示があるときはここで実行する
	&user_func;
		
# 閲覧専用モード

if ( $ReadOnly ) {
	$printString = <<"EOM";
<table border="0" cellspacing="0" cellpadding="0" $width>
<tr><td>&nbsp;</td></tr>
<tr><td>
	<p align="left">$Oshirase</p>
</td></tr></table>
EOM
print &strEncode($printString);
}

# NEWの時間を設定変数で表示するよう修正 (20080308 スガラボット)
	$newhour = int($hot / 3600);
# ファイルアップロードが許可された掲示板なら「投稿に添付」を表示する
	$tenpu = ($image_upl == 2)? "&nbsp;&nbsp;<img src=\"$imgurl/clipsls.gif\" alt=\"投稿に添付\"> 投稿に添付": '';

# 携帯電話からのアクセスの場合はツリー表示の説明を入れない (2008/12/08 スガラボット修正)
	if (!$ua) {
		$note_msg = "<LI>スレッド先頭部の<img src=\"$imgurl/tree.gif\">または<img src=\"$imgurl/fold1.gif\">をクリックするとスレッド内の全記事を表示します。(<img src=\"$imgurl/tree.gif\">はツリー表示)" .
					"<LI>記事先頭の<font color=\"green\">▼ △</font>をクリックするとスレッド内の関連する発言をその発言から(<font color=\"green\">" .
					"▼</font>は下、<font color=\"green\">△</font>は上)へツリー表示します。<font size=\"+1\">　</font>" .
					"<LI>スレッド最終行の<img src=\"$imgurl/treerev2.gif\">または最新発言の<img src=\"$imgurl/upbutton1.gif\">をクリックするとスレッド全記事を降順に表示します。(<img src=\"$imgurl/treerev2.gif\">はツリー表示)";
	}
	else {
		$note_msg = "<LI>スレッド先頭部の <img src=\"$imgurl/fold1.gif\"> をクリックするとスレッド内の全記事を順に表示します。" . 
					"<LI>スレッド最新記事の <img src=\"$imgurl/upbutton1.gif\"> をクリックするとスレッド内の全記事を新しいものから降順に表示します。\n";
	}

	$printString = <<"EOM";
<form action="$script" method="POST">
<table border="0" cellspacing="0" cellpadding="0" $width>
<tr bgcolor="$col1">
<td align="left" bgcolor="$col1">
<div $bgclass style="padding: 3px; border: 1px solid $col1;">
<font color="$col6"><b>キーワード</b></font>
<input type=hidden name=mode value="find">
&nbsp;&nbsp;<input id="w220" type="text" name="word" value="">
<input type=submit value="検索実行">
<input type=hidden name=op value="AND">
<input type=hidden name=vw value="10">
<input type=hidden name=log value="0">
<input type=hidden name=s value="1">
<input type=hidden name=n value="1">
<input type=hidden name=c value="1">
</div>
</td>
</form>
</tr>
<tr><td bgcolor="$col2" align="center"><div style="padding: 3px; border: 1px solid $col1;">
<img src="$imgurl/fold1.gif" alt="通常書込み"> 標準スレッド &nbsp;&nbsp;
<img src="$imgurl/fold6.gif" alt="添付あり"> 添付有り &nbsp;&nbsp;
<img src="$imgurl/fold3.gif" alt="ロック中"> ロック中（書込不可）&nbsp;&nbsp;
<img src="$imgurl/fold4.gif" alt="FAQスレッド"> FAQ(優先)スレッド&nbsp;&nbsp;
<img src="$imgurl/fold5.gif" alt="アラーム"> アラーム（返信数$alarm件以上）&nbsp;&nbsp;
<img src="$imgurl/look.gif" alt="管理者メッセージ"> 管理者メッセージ 
$tenpu
</td></tr></table>
<Table border=\"0\" cellspacing=\"5\" cellpadding=\"0\" $width>
<tr>
<td align="left" nowrap>$note_msg \n</td>
<td align="right" nowrap valign="top"><LI>新着記事は $newmark<br></td>
</tr></table>\n
EOM
print &strEncode($printString);

		print "<P>";

# 新着記事一覧を表示する機能を追加に伴い、メニューインデックスのタイトルを表示 (2012/11/14 スガラボット修正)
	if ($newArticle) {
		# タイトル表示
		print "<P><table  border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width><tr><td nowrap>";
		print &strEncode("<tr><td align=\"left\" nowrap><b style=\"color:$t_color\">◆ トピックス(スレッド)別・投稿記事一覧 (タイトル･氏名の目次)</b></td></tr></table>\n");
		print "<p class=\"h4\"> </p>\n";
	}

# テーブル幅は携帯とPCで異なるのでキャッシュファイルには書き出さない
	print "<Table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width>\n";
	
# 最初の行セット
	$init = 1;

	# スレッド表示
	if ($p eq "") { $p = 0; }
	# 初期値リセット
	$i = 0;
	$lastres = 0;
	open(TP,"$nowfile") || &error("Open Error: $nowfile");
	@nowstat = stat(TP);
	$lastmod = $nowstat[9];
	
# まず一度掲示板スレッドのindexファイルを読み込んで最新レスの日時を確認する。
#	@tp = <TP>;
	@tp = &arrayDecode(TP);
	close(TP);
		
	$top = $tp[0];

	# 前回保存されたForumトップページ画面キャッシュファイルのステータスを取得
	# キャッシュファイルを携帯用とPC用を作成する
	if (!$ua) { $fcache = "$datadir/fcache_p" . "$p" . ".txt"; }
	else { $fcache = "$datadir/fcache_kp" . "$p" . ".txt"; }
	@status = stat($fcache);
	
	# 閲覧数要約ファイルを定義
	$countfile = "$datadir/viewcount.dat";
	
	# 画面キャッシュファイルが無いか、最新のアクセスより古いときは画面をキャッシュファイルに書き込む
	
	# $nodrawフラグをリセット
	$nodraw = 0;
	if (@status) 
	{
		$lastup = $status[9];
		
#		if ($lastup > $lastres) { $nodraw = 1; }
		if ($lastup > $lastmod) { $nodraw = 1; }
	}

# デバッグプリント
#	&error("Debug: lastres=$lastres, nodraw=$nodraw, status=@status<br>\n");
	
	if (!$nodraw)
	{
		open(CA, "+> $fcache") || &eroor("Cannot create: $fcache. Please confirm the environment settings.");
		# 一旦キャッシュファイルを巻き戻して、以前の内容を消去する (20081015 スガラボット修正)
#		seek(CA, 0, 0);
#		truncate (CA, 0);
	}
	else
	{
		open (CA, "< $fcache") || &eroor("Cannot oepn: $fcache. Please confirm the environment settings.");
	}
	eval "flock(CA, 2);";

	
	# 各スレッドの閲覧数を要約したviewcountファイルをオープンして閲覧数を更新
	$nocfile = 0;
	if(-e $countfile) {
		open(CNT, "+<$countfile") || &error("Open Error: $countfile.");
	} else {
		open(CNT, "+>$countfile") || &eroor("Cannot create: $countfile. Please confirm the environment settings.");
		$nocfile = 1;
	}
	eval "flock(CNT, 2);";

	# 総カウント数をクリア
	$total_count = 0;
	undef @countdata;
	# viewcountファイルがあるときは一度その内容を一括読み込み (2008/12/28 スガラボット修正)
	@countdata = <CNT>;
	
# デバッグプリント
#	print "Debug: countlint=$#countdata, @countdata <br>\n";

	if (!$countdata[0]) { $ctotal = 0; }
	else { 
		$ctotal = shift(@countdata);
		chomp($ctotal);
	}

	$i = 0;
	foreach $cln (@countdata) {
		($ctno[$i], $ccount[$i], undef) = split(/<>/, $cln);
		$ctcount{$ctno[$i]} = $ccount[$i];
		$ctline{$ctno[$i]} = $i;
		$i++;
	}

	if (!$nodraw || $nocfile) 
	{
		for ($i = 1; $tp[$i]; $i++)
		{
			# 新着記事を第1ページ目のスレッド一覧の下に表示する場合のページ数計算を導入 (2012/11/17 スガラボット修正)
			my $offset = $newArticle ? $fmenu3 : $fmenu1;
			my $offset1 = $p ? $offset : 0;
			my $multiple = $p ? ($p - 1) : 0;
			if ( $newArticle) {
				next if ($i < ($offset1 + $multiple * $fmenu1) + 1);
				next if ($i > ($offset + $p * $fmenu1));
			} else {
				next if ($i < $p * $fmenu1 + 1);
				next if ($i > $p * $fmenu1 + $fmenu1);
			}
		
			s/\n//;
			local($num,$sub,$res,$nam,$date,$na2,$key,$upl,$ressub,$restime) = split(/<>/, $tp[$i]);

			# スレッドタイトルとレス親の題名を分離する （2009/05/01 スガラボット修正)
			$tsub = $sub;

			# 参照カウンタ読み込み
			open(NO,"$logdir/$num.dat");
			$data = <NO>;
			close(NO);
			($count[$i], $ip[$i]) = split(/:/, $data);
			
			$tno[$i] = $num;
			$total_count += $count[$i];
			$cline = $tno[$i] . '<>' . $count[$i] . '<>' . $ip[$i] . "\n";

			# 既にあるviewcountファイルの行と一致すればその行を更新
			if ($ctline{$tno[$i]}) {
				$countdata[$ctline{$tno[$i]}] = $cline;
				$ctotal -= $ccount[$ctline{$tno[$i]}];
			} else {
				push(@countdata, $cline);
			}
		
			if (!$nodraw)
			{
				# スレッド読み込み
				open(IN, "$logdir/$num.cgi") || &error("Open Error: $num.cgi");
#				@log = <IN>;
				my @log = &arrayDecode(IN);
        		close(IN);
        	
				$top1 = $log[0];
				($no,$sub,$res,$key) = split(/<>/, $top1);
        	
				# ツリー構造のリンクリストを作成するためトピックスのログファイルを一度全部読み込む。
				$prnt[0] = 0;
				$chid[0] = 0;
        	
				$no[0] = 0;
				$j = 1;
				for ($line = 0; $log[$j]; $line++) {
					chomp($log[$j]);
					($no[$line],$sub[$line],$nam[$line],$eml[$line],$com[$line],$dat[$line],$ho[$line],$pw[$line],$url[$line],$mvw[$line],
							$myid[$line],$tim[$line],$upl[1][$line],$upl[2][$line],$upl[3][$line],$idcrypt[$line],$color[$line],$resto[$line])  = split(/<>/, $log[$j]);
					$prnt[$line] = $resto[$line];

					$j++;
				}
#				$num = $line;
				$nofline = $line;

# ツリー構造のインデックス・リストを作成
#	prnt: 親ノード (parent node)
#	chid: 子ノード (child node)
#	next: 次ノード (兄弟リンクのnext node)
#	prev: 前ノード (兄弟リンクのprevious node)

				# スレッドのツリー表示がずれるのを修正するため、ツリーリストを作成するときはその都度@lineno関数をクリアする (20081015 スガラボット修正)
				undef @lineno;
			
				for ($line = 0; $line < $nofline; $line++) {
					&lst_cre($line, $prnt[$line], $no[$line]);
				}

######### デバッグ用にtree テーブルの表示
#	print CA "line &nbsp;no,prnt,chid,next,prev<br>\n";
#	for ($line = 0; $line < $num; $line++) {
#	    print CA sprintf("% 4d,% 4d,% 4d,% 4d,% 4d,% 4d, %50s<br>\n", $line, $no[$line],
#	        $prnt[$line], $chid[$line], $next[$line], $prev[$line], $sub[$line]);
#	}
#	print CA "<br>\n";
#
#	# デバッグ用にtree 行番号逆引きテーブル表示
#	$ln = $no[-1] + 1;
#	for ($line = 0; $line < $ln; $line++) {
#	    print CA sprintf("%4d,%4d<br>\n", $line, $lineno[$line]);
#	}
#	print CA "\n";

#				print CA  "<p><Table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
				if (!$init) {
					print CA  "<tr><td>&nbsp;</td></tr>";
				}
				$init = 0;
				print CA  "<Tr><td id=\"treelist\" align=\"left\" nowrap>\n";

				# スレッドの状態を表示 (20081025 スガラボット修正)
				if ($key eq '0') {
					print CA "&nbsp;&nbsp;<img src=\"$imgurl/alarm.gif\"> ";
					print CA &strEncode("このスレッドは<b>ロック</b>されています。", $logchar);
					print CA &strEncode("記事の閲覧のみとなります。", $logchar);
					print CA "<br>\n";

				} elsif ($key == 2) {
					print CA "&nbsp;&nbsp;<img src=\"$imgurl/alarm.gif\"> ";
					print CA &strEncode("このスレッドは<b>管理者からのメッセージ</b>です。", $logchar);
					print CA &strEncode("記事の閲覧のみとなります。", $logchar);
					print CA "<br>\n";

				} elsif ($key eq '4') {
					print CA "&nbsp;&nbsp;<img src=\"$imgurl/alarm.gif\"> ";
					print CA &strEncode("このスレッドは<b>管理者によりロック</b>されています。", $logchar);
					print CA &strEncode("記事の閲覧のみとなります。", $logchar);
					print CA "<br>\n";

				} elsif ($alarm <= $res) {
					print CA &strEncode("&nbsp;&nbsp;<img src=\"$imgurl/alarm.gif\"> ", $logchar);
					print CA &strEncode("返信記事数が<b>$res</b>件あります。", $logchar);
					print CA &strEncode("<b>$m_max</b>件を超えると書き込みができなくなります。", $logchar);
					print CA "><br>\n";
				}
        	
				# アイコン定義
				if ($key eq '0' || $key eq '4') { $icon = 'fold3.gif'; }
				elsif ($key eq '3') { $icon = 'fold4.gif'; }
				elsif ($key eq '2') { $icon = 'look.gif'; }
				elsif ($res >= $alarm) { $icon = 'fold5.gif'; }
#				elsif ($upl) { $icon = 'fold6.gif'; }
				else { $icon = 'fold1.gif'; }

				# 添付ファイルのアイコン定義
				$res_icon = '';
				foreach $k (1 .. 3) 
				{
					local($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl[$k][0]);
					if ($ex) { $res_icon = "<img src=\"$imgurl/clipsls.gif\" border=\"0\"> "; last;}
				}

# スレッド一覧からトリップを消したい場合有効にする
#				$nam[0] =~ s/◆.+//g;
#				$na2[0] =~ s/◆.+//g;

				# 名前からトリップ表示を削除するかどうか (きりしまさんの掲示板を参考にして修正、2009/04/07 スガラボット)
				if ($patio_trip) {
					$nam[0] =~ s/[◆◇].+//g;
				}
		
				# タイトルと名前に文字修飾機能追加 （2009/01/12 スガラボット修正)
				$sub[0] = &$titlebb($sub[0]);	
				$nam[0] = &$titlebb($nam[0]);	
				$tsub = &$titlebb($tsub);

				#スレッドタイトルとレス親題名を分離したことに因る処理
				local ($sub1, $sub2);
				if ($sub[0] ne $tsub) {
					$sub_dif = 1;
					$sub1 = "&nbsp;&nbsp;<b>スレッド $tno[$i]: $tsub &nbsp;</b><br>\n";
					$sub2 = " No.0 &nbsp;";
				} else {
					$sub2 = "<b>スレッド $tno[$i]:</b>";
				}

				# スレッドのプリント順序カウンタを初期化
				our $pr_count = 0;

				# もし表示ページ幅の制限により「題名」を切り詰める必要か有る時
				if ( $max_chars ) {
					$sub[0] = &sub_chop( '', $sub[0], $nam[0], $tim[0], 1 );
				}

				# スレッドの親記事を表示
				print CA &strEncode($sub1, $logchar);
				# 携帯からのアクセスのときは全表示でツリー表示をしない （2008/12/08 スガラボット修正)
				if (!$ua) {
					print CA &strEncode("&nbsp;&nbsp;&nbsp;<a href=\"$readshtml&tree=1&no=$tno[$i]&l=all\"><img src=\"$imgurl/tree.gif\" border=\"0\" align=\"middle\"></a>\n", $logchar);
					print CA &strEncode(" <a href=\"$readshtml&no=$tno[$i]\"><img src=\"$imgurl/$icon\" border=\"0\" align=\"middle\"></a> $st1 $sub2 ［$res_icon<a href=\"$readshtml&tree=1&no=$tno[$i]&l=0\">$sub[0]</a>］&nbsp;<b>$nam[0]</b> &nbsp;$dat[0] $st2 \n", $logchar);
				} else {
					print CA &strEncode("&nbsp;&nbsp;&nbsp;<a href=\"$readshtml&no=$tno[$i]\"><img src=\"$imgurl/$icon\" border=\"0\"></a>\n", $logchar);
					print CA &strEncode(" $sub2 ［$res_icon<a href=\"$readshtml&tree=1&no=$tno[$i]&l=0\">$sub[0]</a>］&nbsp;<b>$nam[0]</b> &nbsp;$dat[0] $st2 \n", $logchar);
				}
				# New!を直接印刷するのではなく、それぞれの発言のタイムスタンプを記録する
				print CA "<>$tim[0]<>\n";
				print CA "<>count:$i:$tno[$i]:$count[$i]<>\n";
				
				$pre_c = '';
				$pre1a_c = '├';
				$pre1b_c = '└';
				$pre2a_c = '│';
				$pre2b_c = '　';
				
				$pre = "<img src=\"$imgurl/blank.gif\">";
				$pre1a = "<img src=\"$imgurl/branch.gif\">";
				$pre1b = "<img src=\"$imgurl/next.gif\">";
				$pre2a = "<img src=\"$imgurl/down.gif\">";
				$pre2b = "<img src=\"$imgurl/blank.gif\">";

				# スレッドを階層表示
				if ($chid[0]) {
					&lst_dsp2($chid[0], $pre, $pre_c);
				}
				print CA  "</td></tr>\n";
#				print CA  "</table><br>\n";
			}
		}
		# 元のトータルに今回のトータルを足して$countfileに参照数を一気に書込み
		$total_count += $ctotal;
		unshift(@countdata, "$total_count\n");
		seek(CNT, 0, 0);
		print CNT @countdata;
		truncate(CNT, tell(CNT));
	}

	# 一旦キャッシュファイルを巻き戻す
	seek(CA, 0, 0);
	seek(CNT, 0, 0);
	# 既に画面キャッシュファイルが最新の時はファイルを読み出しでオープン
	
#	@buf = <CA>;
	my @buf = &arrayDecode(CA);
	eval "flock(CA, 8);";
	close(CA);

	@cbuf = <CNT>;
	eval "flock(CNT, 8);";
	close(CNT);
	
# デバッグプリント 画面キャッシュファイルの内容を端末に書き出し。
#	foreach (@buf) 
#	{
#		print &strEncode($_);
#	}

# デバッグプリント カウントビューファイルの内容を端末に書き出し。
#	print "<pre>";
#	foreach (@cbuf) 
#	{
#		print $_;
#	}
#	print "</pre>";

	shift(@cbuf);
	$i = 1;
	foreach $cln (@cbuf) {
		chomp($cln);
		($tno[$i], $count[$i], undef) = split(/<>/, $cln);
		$tcount{$tno[$i]} = $count[$i];
		$i++;
	}

	foreach $ln (@buf) {
		# 発言が新しければ<>time<>形式のタイムスタンプをNew!マークに変換して書き出し
	    if ($ln =~ /^<>(\d{10})<>/)
	    {
	    	if (time < ($1 + $hot)) { $ln =~ s/<>\d{10}<>/$newmark/; }
	    	else { $ln =~ s/<>\d{10}<>//; }
	    }
		# 閲覧数は各リクエスト毎に最新値を表示する。
	    if ($ln =~ /^<>count:(\d{1,}):(\d{1,}):(\d{1,})<>/)
	    {
			$ln = " &nbsp;&nbsp;閲覧数: $tcount{$2} <br>\n";
	    }
	    
	    # 一行出力
	    print &strEncode($ln);
	}
	print "</table><br>\n";

	$j = $#tp;
	# ページ移動ボタン表示
	my $page0 = $newArticle ? $fmenu3 : $fmenu1;
	if ($page0 < $j) {
		local($x,$y) = (1,0);
		print "<hr $width><table $width><tr><td class=\"num\" align=\"left\"> Page: ";
# デバッグプリント
#		print "Debug: fmenu1=$fmenu1, j=$j <br>\n";
		my $loop = 0;
		while ($j > 0) {
			if ($p == $y) {
				print "<b style=\"color:$pglog_col\">$x</b> |\n";
			} else {
				print "<a href=\"$forumshtml&p=$y\">$x</a> |\n";
			}
			$x++;
			$y++;
			$decrement = $loop ? $fmenu1 : $page0;
			$j -= $decrement;
			$loop++;
		}
		print "</td></tr></table>\n";
	}

	print "<hr $width>";

# 新着記事一覧を表示する機能を追加 (2012/11/14 スガラボット修正)
	if ($newArticle && -e $feedlog && !$p ) {
		# feedlogを開いて上から順に新着記事表示数だけ抽出して記事を表示する
		my $FEED, @feed;
		open($FEED, "< $feedlog") || &error("Open Error: $feedlog");
		@feed = &arrayDecode($FEED);
		close($FEED);

		# タイトル表示
		print "<table  border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width><tr><td nowrap>";
		print &strEncode("<tr><td align=\"left\" nowrap><b style=\"color:$t_color\">◆ 新着の投稿記事を新しいものから5個表示</b></td></tr></table>\n");
		print "<p class=\"h4\"> </p>\n";

		my @thread, @num, $end;
		$end = ( $newArticle >= $#feed ) ? $#feed : $newArticle;
		foreach my $n (1 .. $end) {
			($thread[$n], $num[$n]) = split(/<>/, $feed[$n]);
			&printArticle($thread[$n], $num[$n]);
			print "<p class=\"h10\"> </p>\n";
		}

		print "<hr $width>";
	}

# 新規投稿フォームを表示するように修正 (20080926 スガラボット修正)
	if (!$createonlyadmin) {
	$printString = <<"EOM";
<table $width>
<tr>
  <td align="right">
	<a name="newform"><a href="$bbscgi?">トップページ</a> &gt; 新規スレッド作成</a>
  </td>
</tr></table>
EOM
print &strEncode($printString);

	&form2("new");
}

#	print "</Td></Tr></Table>";

	# 著作権表示（削除不可）
	$printString = <<"EOM";
<p>
<!-- 著作権表示部・削除禁止 ($ver) -->
<span class="s1">
- <a href="http://www.kent-web.com/" target="_top">Web Patio</a> -
 <a href="http://kirishima.it/patio/" target="_top">きりしま式</a> -
 <a href="http://vmorita.com/bbs/patio/" target="_top">スガラボット版</a> -
 <a href="http://www.futomi.com/library/revocount.html" target="_top">RevoCounter</a> -
</span><br><br>
</div>
EOM
print &strEncode($printString);

	&pr_footer;

	print "</body></html>\n";

	exit;
}

#-------------------------------------------------
#  ログオフ
#-------------------------------------------------
sub logoff {
	unlink("$sesdir/$my_ckid.cgi");
	print "Set-Cookie: patio_member=;\n";

	&enter_disp;
}

# list display
#----------------------------------------------------
# ツリー構造のポインターリストを印刷するサブルーチン
#----------------------------------------------------

#	$pre = '';
#	$pre1a = '├';
#	$pre1b = '└';
#	$pre2a = '│';
#	$pre2b = '　';

sub lst_dsp2 {
    my ($idx, $pre, $pre_c) = @_;			# 引数はデータの行番号とプレフィックス文字列
    my ($i, $link);

#printf("lst_dsp2(%d)\n", $idx);

	$i = $idx;
	do {
		# プリント順序カウンタをインクリメント
		$pr_count++;

		if ($next[$i] == $chid[$prnt[$i]]) {
			# 自分の次ノードが長男のポインタと同じなら最後のノード
			$pre1 = $pre.$pre1b;
			$pre2 = $pre.$pre2b;
			$pre1_c = $pre_c.$pre1b_c;
			$pre2_c = $pre_c.$pre2b_c;
		} else {
			# 最後以外のノード
			$pre1 = $pre.$pre1a;
			$pre2 = $pre.$pre2a;
			$pre1_c = $pre_c.$pre1a_c;
			$pre2_c = $pre_c.$pre2a_c;
		}
#		printf("%-20s %-11s %-10s\n",
#			$pre1.$data[$i], $date[$i], $user[$i]);

# もし特定のレスを指定したツリー表示ならそのレスを強調表示する
		if ($from > 0 && $from == $no[$i]) { $st1 = $strong1; $st2 = $strong2; }
		else { $st1 = ''; $st2 = ''; }

		# 名前からトリップ表示を削除するかどうか (きりしまさんの掲示板を参考にして修正、2009/04/07 スガラボット)
		if ($patio_trip) {
			$nam[$i] =~ s/[◆◇].+//g;
		}
		
# タイトルと名前に文字修飾機能追加 （2009/01/12 スガラボット修正)
		$sub[$i] = &$titlebb($sub[$i]);
		$nam[$i] = &$titlebb($nam[$i]);

		# 添付ファイルのアイコン定義
		$res_icon = '';
		foreach $k (1 .. 3) 
		{
			local($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl[$k][$i]);
			if ($ex) { $res_icon = "<img src=\"$imgurl/clipsls.gif\" border=\"0\"> "; last;}
		}
		
		# 最後の行番号ならツリー全体の降順表示リンクを追加
		undef $revdisp;
		undef $revtree;
#		if ($i == ($nofline - 1)) {
#			$revtree = "<a href=\"$readshtml&tree=1&no=$no&l=rev\"><img src=\"$imgurl/treerev2.gif\" border=\"0\"></a>";
#			$revdisp = "<a href=\"$readshtml&tree=1&no=$no&l=new\"><img src=\"$imgurl/upbutton1.gif\" border=\"0\"></a>";
#		}
		# 下向けツリー表示か逆順表示アイコンかを定義
		my $link_icon;
		if ($pr_count == ($nofline - 1)) {
			$link_icon .= "<a href=\"$readshtml&tree=1&no=$no&l=rev\"><img src=\"$imgurl/treerev2.gif\" border=\"0\" align=\"middle\"></a>";
			$revtree = "<a href=\"$readshtml&tree=1&no=$num&l=rev\"><img src=\"$imgurl/treerev2.gif\" border=\"0\"></a>";
		} 
		if ($i == ($nofline - 1)) {
			$link_icon .= "<a href=\"$readshtml&tree=1&no=$no&l=new\"><img src=\"$imgurl/upbutton1.gif\" border=\"0\" align=\"middle\"></a>";
			$revdisp = "<a href=\"$readshtml&tree=1&no=$num&l=new\"><img src=\"$imgurl/upbutton1.gif\" border=\"0\"></a>";
		} 
		if ($i != ($nofline - 1) && $pr_count != ($nofline - 1)) {
			$link_icon = "<a href=\"$readshtml&tree=1&no=$no&l=$no[$i]-\"><font color=\"green\">▼</font></a>";
		}

		# 表示枠の幅に制限がある場合、タイトルの尾部を省略して「…」で置き換え、ツリー表示の表示行野長さが制限を超えないように短くする処理
		if ( $max_chars ) {
			$sub[$i] = &sub_chop( $pre1_c, $sub[$i], $nam[$i], $tim[$i] );
		}

		# 携帯電話からのアクセスのときはサブツリーのリンクを表示しない (2008/12/08 スガラボット修正)
		if (!$ua) {
			print CA &strEncode("<SPAN STYLE=\"font-family:'monospace';\"><font size=\"+1\" color=\"#338B33\">$pre1</font></SPAN>$st1" . 
			"$link_icon" .
				"<a href=\"$readshtml&tree=1&no=$num&l=-$no[$i]\"><font color=\"green\">△</font></a>" .
				" No.$no[$i] &nbsp;［$res_icon<a href=\"$readshtml&tree=1&no=$num&l=$no[$i]\">$sub[$i]</a>］&nbsp;<b>$nam[$i]</b> &nbsp;$dat[$i] $st2\n", $logchar);
		} else {
			if (!$resto[$i]) { $head_mark = "●"; }
			else { $head_mark = "■"; }
			if ($revdisp) { $head_mark = $revdisp; }
			print CA &strEncode("<font size=\"+1\" color=\"#338B33\">$pre1</font><font color=\"green\" size=\"-2\"> $head_mark </font>$st1" .
				" No.$no[$i] &nbsp;［$res_icon<a href=\"$readshtml&tree=1&no=$num&l=$no[$i]\">$sub[$i]</a>］&nbsp;<b>$nam[$i]</b> &nbsp;$dat[$i] $st2\n", $logchar);
		}
# New!を直接印刷するのではなく、それぞれの発言のタイムスタンプを記録する
			print CA "<>$tim[$i]<><br>\n";
		
		if ($chid[$i] != 0) {
			# 自分に子供が有るとき
			if ($next[$i] == $chid[$prnt[$i]]) {
				# 最後のノード
			} else {
				# 最後以外のノード
			}
			&lst_dsp2($chid[$i], $pre2, $pre2_c);		# 1レベル字下がりして再帰的に子ノードを印刷する
		}
	
		$i = $next[$i];						# 子供がないときは次ノードを印刷する
    } until ($i == $idx);
}

