#┌─────────────────────────────────
#│ [ WebPatio ]
#│ edit_log.pl - 2007/06/06
#│ Copyright (c) KentWeb
#│ webmaster@kent-web.com
#│ http://www.kent-web.com/
#└─────────────────────────────────

$sver = 'v1.43';
# 2012/02/07 ユーザ定義ヘッダー対応のコラム背景画像クラスとユーザ定義ヘッダー対応のコラム背景画像クラスを追加
# 2010/12/22 記事修正時のパスワード更新方法を修正
# 2009/10/15 如水さんのWebPatio+ (http://jyosui.xrea.jp/feed.html) 静的RSS機能を一部修正して追加インストール
# 2009/07/21 CGI本体とログをUTF-8化
# 2009/05/12 スレッドテーマと新規投稿題名を別設定できるよう修正
# 2009/01/12 名前、タイトルと本文にBBCodeからHTMLに変換する機能を追加したことによるFormの名前枠の拡大
# 2008/10/29 新規に v1.03として配布
# 投稿時の最大容量チェックをinit.cgiのparse_form()から移動 (20081015 スガラボット修正)
# 2008/10/07 返信記事にもファイルアップロードが出来るように修正 (スガラボット)
# 2007/12/17 管理者による編集時に、パスワードを消すかどうかオプションで指定できるようにした。
# 2007/09/30 記事編集時、メールアドレス入力の制御をしているのに対応していなかった点を修正
# 2007/06/13 管理者による編集時には、書き込みのパスワードを消すように。編集内容を元に戻すユーザーがいたため。
# 2007/06/10 3.2相当に修正
# 2007/05/01 親記事を修正すると名前が消えるバグ修正
# 2007/05/01 3.13に対応
#            ログをエディターで直接編集することを想定して、記事編集時には、レスの数をカウントし直すように
# きりしまによる改造版 2007.04.06

use utf8;

#-------------------------------------------------
#  記事修正
#-------------------------------------------------
sub edit_log {
	local($myjob) = @_;

	if ($myjob eq "admin") {
		$in{'f'}  = $in{'no'};
		$in{'no'} = $in{'no2'};
	}
	local($mylog,$idxfile);
	if ($in{'bakfile'}) {
		$idxfile = $pastfile;
		$mylog = 'bakfile';
	} else {
		$idxfile = $nowfile;
		$mylog = 'logfile';
	}

	# 汚染チェック
	$in{'f'}  =~ s/\D//g;
	$in{'no'} =~ s/\D//g;

	# 修正処理
	if ($in{'job'} eq "edit2") {
		local($edit_upl);

		# 管理者オペ
		if ($in{'pass'} ne "") {
			$admin_flag = 1;
			if ($in{'pass'} ne $pass) { &error("パスワードが違います"); }
		# ユーザー画面から管理パスを入力
		} elsif ($in{'pwd'} eq $pass) {
			$admin_flag = 1;

		# ユーザオペ
		} elsif ($in{'pwd'} ne "") {
			$admin_flag = 0;

			# チェック
			if ($no_wd) { &no_wd; }
			if ($jp_wd) { &jp_wd; }
			if ($urlnum > 0) { &urlnum; }

		# オペ不明
		} else {
			&error("不正なアクセスです");
		}

		# 最大容量チェック ⇒ 会議室別の最大容量設定を可能とするため場所をinit.cgiから
		# regist.cgi,admin.cgiなどのアプリCGIに移動 (20081015 スガラボット修正)
		if ($ENV{'CONTENT_LENGTH'} > $maxdata) {
			local($maxd) = int( $maxdata / 1024 ) . "KB";
			&error("容量サイズオーバーです : $maxdまで");
		}

		# 投稿内容チェック
		if ($i_com eq "") { &error("コメントの内容がありません"); }
		if ($i_nam eq "") {
			if ($in_name) { &error("名前は記入必須です"); }
			else { $i_nam = '名無しのゴンベエ'; }
		}
#		if ($in_mail && $in{'email'} eq "") { &error("E-mailは記入必須です"); }
		if ($in_mail == 1 && $in{'email'} eq "") { &error("E-mailは記入必須です"); }
		if ($in_mail == 2 && $in{'email'} ne "") { &error("E-mailは入力禁止です"); }
		if ($in_mail == 3 && $in{'email'} ne "") { &error("E-mailは入力禁止です"); }
		if ($in{'email'} && $in{'email'} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,6}$/)
			{ &error("E-mailの入力内容が不正です"); }
		if ($i_sub eq "")
			{ &error("タイトルは記入必須です"); }
		if ($i_sub =~ /^(\x81\x40|\s)+$/)
			{ &error("タイトルは正しく記入してください"); }
		if ($i_nam =~ /^(\x81\x40|\s)+$/)
			{ &error("名前は正しく記入してください"); }
		if ($i_com =~ /^(\x81\x40|\s|<br>)+$/)
			{ &error("コメントは正しく記入してください"); }
		if ($in{'url'} eq "http://") { $in{'url'} = ""; }

		local ($top, @new, $dat, $tim, $nowtime, $date, $kiji_tim);
		open(DAT,"+< $logdir/$in{'f'}.cgi") || &error("Open Error: $in{'f'}.cgi");
		eval "flock(DAT, 2);";
#		$top = <DAT>;
		$top = &lineDecode(DAT)  if ($in{'logfile'});
#		while(<DAT>) {		#}
		while ( $_ = &lineDecode(DAT) ) {
			s/\n//;
			# 本文表示色指定機能とレス指定発言機能を追加 （20080218 守田修正)
			local($no,$sub,$nam,$eml,$com,$dat0,$ho,$pw,$url,$mvw,$myid,$tim0,$upl1,$upl2,$upl3,$idcrypt,$color,$resto) = split(/<>/);


			if ($in{'no'} == $no) {

# デバッグプリント
#&error("in{pwd}=$in{'pwd'}, pass=$pass, admin_flag=$admin_flag");

				# パスチェック
				if (!$admin_flag) {
					if (!&decrypt($in{'pwd'}, $pw)) {
						&error("パスワードが違います");
					}
				}

#				&error("Debug: \$no=$no, \$in{'resto'} = $in{'resto'}, \$resto=$resto<br>\n");
				# レス親でなければ参照記事番号チェック
				if (defined($in{'resto'}) && $in{'resto'} >= $no) {
					&error("no=$no, resto=$in{'resto'}<br>\n参照する記事番号は修正する記事番号より若番にして下さい");
				}

				# トリップ
				unless ($i_nam =~ /◆/ && $i_nam eq $nam) {
					$i_nam = &trip($i_nam);
				}

				# アップロードされたファイルを維持するため今の時刻を新しい変数に代入して維持する。(20080222 スガラボット修正)
				($nowtime, $date) = &get_time;

				# 編集記事の元のタイムスタンプを記憶
				$kiji_tim = $tim0;

				# 管理者の編集は日付・時刻・ID維持、それ以外は更新
				if ($admin_flag) {
#					$tim=$ptime;
					$tim = $tim0;
					$dat = $dat0;
				} else {
					$tim=$nowtime;
					$dat=$date;
					# IDを作成
					if($idkey) { &makeid; }
					else { $idcrypt = "";}
				}

				# 添付拡張子
				local($ex0{1},$w0{1},$h0{1},$filename0{1},$filetitle0{1}) = split(/,/, $upl1);
				local($ex0{2},$w0{2},$h0{2},$filename0{2},$filetitle0{2}) = split(/,/, $upl2);
				local($ex0{3},$w0{3},$h0{3},$filename0{3},$filetitle0{3}) = split(/,/, $upl3);

				# 親記事＆添付アップ

				if ($tim eq "") { &error("この記事はアップロードできません"); }

				require $upload;
#				local($ex{1},$w1,$h1,$ex{2},$w2,$h2,$ex{3},$w3,$h3) = &upload($tim);
#				# 新規に"txt,doc,xls,ppt,zip,lzh"をアップロード可能とする。(20080214 スガラボット修正)
				local($ex{1},$w{1},$h{1},$filename{1},$filetitle{1},$ex{2},$w{2},$h{2},$filename{2},$filetitle{2},$ex{3},$w{3},$h{3},$filename{3},$filetitle{3}) = &upload($nowtime);

# デバッグ メッセージ
#				&error ("debug: nowtime=$nowtime and $ex{1},$w{1},$h{1},$filename{1},$filetitle{1},$ex{2},$w{2},$h{2},$filename{2},$filetitle{2},$ex{3},$w{3},$h{3},$filename{3},$filetitle{3} <br>\n");

				# アップロードファイル・エディットフラグを処理
				$edit_upl = '';
				foreach my $j (1 .. 3) {
					$delete = "del" . $j;
					if ( $ex{$j} ) {
#						$upl1 = "$ex{1},$w1,$h1";
						$upl{$j} = "$ex{$j},$w{$j},$h{$j},$filename{$j},$filetitle{$j}";
						# 新しいファイルがアップされたときは旧を消して新を前のファイル識別名に変更 (20080222 スガラボット修正)
						unlink("$upldir/$tim0-$j$ex0{$j}");
						rename("$upldir/$nowtime-$j$ex{$j}", "$upldir/$tim-$j$ex{$j}");
						$edit_upl = $tim;
					}
					elsif ( $in{$delete} ) {
						$upl{$j} = ',,,,';
						unlink("$upldir/$tim0-$j$ex0{$j}");
					}
					else {
						# ファイルの標題だけ変更する
						$upl{$j} = "$ex0{$j},$w0{$j},$h0{$j},$filename0{$j},$ftitle{$j}";
						rename("$upldir/$tim0-$j$ex0{$j}", "$upldir/$tim-$j$ex0{$j}") if ($tim ne $tim0);
						if ($ex0{$j}) { $edit_upl = $tim; }
					}
				}

				# パスワードが更新されていれば暗号化 (2010/12/22 スガラボット追加修正
				my $pwd;
				if ($in{'newpwd'} eq "") { $pwd = $pw; }
				else { $pwd = &encrypt($in{'newpwd'}); }

# デバッグプリント
#				&error ("debug: upl1=$upl{1}, upl2=$upl{2}, upl3=$upl{3} <br>\n");
			
				if (!$admin_flag ) {
					$_ = "$no<>$in{'sub'}<>$i_nam<>$in{'email'}<>$in{'comment'}<>$dat<>$host<>$pwd<>$in{'url'}<>$in{'mvw'}<>$myid<>$tim<>$upl{1}<>$upl{2}<>$upl{3}<>$idcrypt<>$in{'color'}<>$in{'resto'}<>";
				} elsif ( $clearpass ) {
					$_ = "$no<>$in{'sub'}<>$i_nam<>$in{'email'}<>$in{'comment'}<>$dat<>$host<><>$in{'url'}<>$in{'mvw'}<>$myid<>$tim<>$upl{1}<>$upl{2}<>$upl{3}<>$idcrypt<>$in{'color'}<>$in{'resto'}<>";
				} else {
					if ($in{'adflg'}) { $pw = $pwd; }
					$_ = "$no<>$in{'sub'}<>$i_nam<>$in{'email'}<>$in{'comment'}<>$dat<>$host<>$pw<>$in{'url'}<>$in{'mvw'}<>$myid<>$tim<>$upl{1}<>$upl{2}<>$upl{3}<>$idcrypt<>$in{'color'}<>$in{'resto'}<>";
				}
			}
			push(@new,"$_\n");
#			$i++;
		}

		# ヘッダ
		($num,$sub2,$res2,$key) = split(/<>/, $top);

		local ($tsub, $ressub2);
		# 親記事の場合は題名を更新
		if (!$in{'no'}) {
			$sub2 = $in{'sub'};
			# スレッドタイトルとレス親の題名を分離したことに因る処理を追加 （2009/05/01 スガラボット修正)
			if ($in{'tsub'} && $sub2 ne $in{'tsub'}) { $tsub = $in{'tsub'}; }
			else { $tsub = $sub2; }
		} else {
			$tsub = $sub2;
		}

		# 更新
		unshift(@new,"$num<>$tsub<>$res2<>$key<>\n");
		seek(DAT, 0, 0);
#		print DAT @new;
		print DAT &arrayEncode(\@new, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# index展開
		local(@data);
		open(DAT,"+< $idxfile") || &error("Open Error: $idxfile");
		eval "flock(DAT, 2);";
#		$top = <DAT>;
		$top = &lineDecode(DAT)  if (!$in{'bakfile'});
#		while(<DAT>) {		#}
		while ( $_ = &lineDecode(DAT) ) {
			s/\n//;
			local($no,$sub,$res,$nam,$da,$na2,$key2,$upl,$ressub,$restime) = split(/<>/);
			chomp ($ressub);
			chomp ($restime);

			if ($in{'f'} == $no) {

				# ファイルアップロードを返信投稿にも適用したため以下の5行は親記事修正のIF文より移動 (20080926 スガラボット修正)
#				($tim,$upl1,$upl2,$upl3) = (split(/<>/, $new[1]))[11..14];
#				local($ex1) = split(/,/, $upl1);
#				local($ex2) = split(/,/, $upl2);
#				local($ex3) = split(/,/, $upl3);
#				if ($ex1 || $ex2 || $ex3) { $upl = $tim; } else { $upl = ''; }

				# 管理者の編集は日付維持、それ以外は更新
				if ($admin_flag) {
					$dat = $da;
				} else {
					$dat=$date;
				}

				# 親記事修正のとき
				if (!$in{'no'}) {

					# 修正記事が最終レスなら名前とレスタイトルを更新
					if ($kiji_tim eq $restime) {
						if ($tsub eq $in{'sub'}) { $ressub2 = $in{'sub'}; }
						$_ = "$no<>$tsub<>$res<>$i_nam<>$dat<>$i_nam<>$key<>$tim<>$ressub2<>$tim<>";
					} else {
						$_ = "$no<>$tsub<>$res<>$i_nam<>$dat<>$na2<>$key<>$upl<>$ressub<>$restime<>";
					}

				# レス記事修正のとき
				} else {
					# 修正記事が最終レスなら名前とレスタイトル及びタイムスタンプを更新 (2010/04/19 スガラボット修正)
					if ($kiji_tim eq $restime) {
						$_ = "$no<>$sub<>$res<>$nam<>$dat<>$i_nam<>$key<>$upl<>$in{'sub'}<>$tim<>";
					} else {
						$_ = "$no<>$sub<>$res<>$nam<>$dat<>$na2<>$key<>$upl<>$ressub<>$restime<>";
					}

				# RSS/Atom		# 2009/10/15 スガラボット修正
				$feed++;
#				if ($upl) { $edit_upl = $upl; }

				}
			}
			push(@data,"$_\n");
		}

		# index更新
		unshift(@data,$top) if (!$in{'bakfile'});
		seek(DAT, 0, 0);
#		print DAT @data;
		print DAT &arrayEncode(\@data, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# RSS/Atom		# 2009/10/15 スガラボット修正
		if($feed >= 2) {
			require $feedpl;
			&feed("edit");
		}

		# 完了メッセージ
		&header;
		print "<blockquote>\n";
		print &strEncode("<b>修正処理は正常に完了されました</b>\n");

		print "<table><tr><td align=\"left\" valign=\"top\">\n";

		# 管理モード
		if ($myjob eq "admin" || $in{'myjob'} eq "admin") {
			print "<form action=\"$admincgi\" method=\"post\">\n";
			print "<input type=\"hidden\" name=\"pass\" value=\"$in{'pass'}\">\n";
			print "<input type=\"hidden\" name=\"mode\" value=\"admin\">\n";
			print "<input type=\"hidden\" name=\"$mylog\" value=\"1\">\n";

		# 一般モード
		} else {
			print "<form action=\"$bbscgi\">\n";
		}
		print &strEncode("<input type=\"submit\" value=\"掲示板へ戻る\"></form>\n");

		# スレッドに戻る
		print "</td><td width=15></td>\n";
		print "<td valign=top>\n";

		# 管理モード
		if ($myjob eq "admin" || $in{'myjob'} eq "admin") {
			print "<form action=\"$admincgi\" method=\"post\">\n";
			print "<input type=\"hidden\" name=\"pass\" value=\"$in{'pass'}\">\n";
			print "<input type=\"hidden\" name=\"mode\" value=\"admin\">\n";
			print "<input type=\"hidden\" name=\"$mylog\" value=\"1\">\n";
			print "<input type=\"hidden\" name=\"action\" value=\"view\">\n";

		# 一般モード
		} else {
			print "<form action=\"$readcgi\">\n";
		}
		
			print "<input type=\"hidden\" name=\"no\" value=\"$in{'f'}\">\n";
		print &strEncode("<input type=\"submit\" value=\"スレッドへ戻る\"></form></td></tr></table>\n");

		print "</blockquote>\n";

		&pr_footer;

		print "</body></html>\n";
		exit;
	}

	# 該当ログチェック
	local($flg, $top);
	open(IN,"$logdir/$in{'f'}.cgi");
#	$top = <IN>;
	$top = &lineDecode(IN);
#	while(<IN>) {
	while ( $_ = &lineDecode(IN) ) {
		s/\n//;
#		($no,$sub,$nam,$eml,$com,$dat,$hos,$pw,$url,$mvw,$myid,$tim,$upl{1},$upl{2},$upl{3}) = split(/<>/);
		# 本文表示色指定機能とレス指定発言機能を追加 （20080218 守田修正)
		($no,$sub,$nam,$eml,$com,$dat,$hos,$pw,$url,$mvw,$myid,$tim,$upl{1},$upl{2},$upl{3},undef,$color,$resto) = split(/<>/);

		last if ($in{'no'} == $no);
	}
	close(IN);

	# 管理者ロック時はユーザーは編集不可
	local(undef,undef,undef,$key) = split(/<>/, $top);
	if ($in{'pwd'} ne $pass && $key == 4) {
			&error("管理者ロックされている記事は編集できません");
	}
	if ($myjob eq "user" && $in{'pwd'} ne $pass) {
		if ($pw eq "") {
			&error("該当記事はパスワードが設定されていません");
		}
		if (!&decrypt($in{'pwd'}, $pw)) { &error("パスワードが違います"); }
	} elsif ($myjob eq "user" && $in{'pwd'} eq $pass) {
		$admin_flag = 1;
	}

	# 親スレッドの編集の場合はインデックスファイルを読み込み
	local($top0,$no0, $sub0, $tsub);
	open(DAT,"< $idxfile") || &error("Open Error: $idxfile");
	eval "flock(DAT, 2);";
#	$top0 = <DAT> if (!$in{'bakfile'});
	$top0 = &lineDecode(DAT)  if (!$in{'bakfile'});

	# index展開
#	while(<DAT>) {
	while ( $_ = &lineDecode(DAT) ) {
		($no0, $sub0) = split(/<>/);
		
		if ($in{'f'} eq $no0) {
			$tsub = $sub0;
			last;
		}
	}
	close(DAT);

	if ($smile) { &header("", "js"); }
	else { &header(); }

	$printString = <<"EOM";
<div align="center">
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col3"><td $bgclass2 align="left" bgcolor="$col3" nowrap width="92%">
<img src="$imgurl/mente.gif" align="top">
&nbsp; <b>記事修正フォーム</b></td>
<td $bgclass2 align="right" bgcolor="$col3" nowrap>
<a href="javascript:history.back()">前画面に戻る</a></td>
</tr></table>
<p>
EOM
print &strEncode($printString);

	if ($image_upl && !$ua) {
		print qq|<form action="$registcgi&encode=$charset" method="post" name="myFORM" enctype="multipart/form-data">\n|;
	} else {
		print qq|<form action="$registcgi&encode=$charset" method="post" name="myFORM">\n|;
	}

	print <<EOM;
<input type="hidden" name="mode" value="edit_log">
<input type="hidden" name="job" value="edit2">
<input type="hidden" name="f" value="$in{'f'}">
<input type="hidden" name="no" value="$in{'no'}">
<input type="hidden" name="myjob" value="$myjob">
<input type="hidden" name="$mylog" value="1">
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
EOM

	# スレッドタイトルとすれ親の題名を分離したことにより処理 （2009/05/01 スガラボット修正)
	if (!$no && ($thread_theme || $admin_flag || $in{'mode'} eq 'admin')) {
		print &strEncode("<tr bgcolor=\"$col2\"><th bgcolor=\"$col2\" nowrap>スレッドテーマ</th>");
		print &strEncode("<td align=\"left\"><input id=\"w420\" type=\"text\" name=\"tsub\" value=\"$tsub\" maxlength=\"$sublength\">");
		print &strEncode("&nbsp; (空欄にすると次の題名と同じ内容になります)</td></tr>");
	}

	$printString = <<EOM;
<tr bgcolor="$col2">
  <th bgcolor="$col2" nowrap>題名</th>
  <td align="left"><input id="w540" type="text" name="sub" value="$sub" maxlength="$sublength"></td>
</tr>
EOM
print &strEncode($printString);

	# 特定レスへの返信機能を追加する (20080218 守田修正)
	if ($no && $in{'no'}) {
		$printString = <<"EOM";
<tr bgcolor="$col2">
  <th bgcolor="$col2" width="90">レス指定返信</th><td align="left">
EOM
print &strEncode($printString);

		print "<b>(No.";
		print &strEncode("<input id=\"w35\" type=\"text\" name=\"resto\" value=\"$resto\" maxlength=\"3\" style=\"ime-mode:inactive\" istyle=\"4\" mode=\"numeric\">");
		print &strEncode(")</b>の発言に対して返信する &nbsp;&nbsp;(空欄にするとスレッドの元テーマに対する発言になります)");
		print "</td></tr>";
	}

	$printString = <<"EOM";
<tr bgcolor="$col2">
  <th bgcolor="$col2" nowrap>名前</th>
  <td align="left"><input id="w330" type="text" name="name" value="$nam" maxlength="60"></td>
</tr>
EOM
print &strEncode($printString);

	if ($in_mail == 2) {
	} else {

	print <<"EOM";
<tr bgcolor="$col2">
  <th bgcolor="$col2" nowrap>E-Mail</th>
  <td align="left"><input id="#330" type="text" name="email" value="$eml" style="ime-mode:inactive" istyle="3" mode="alphabet">
EOM

	if ($show_mail) {
		print "  <select name=\"mvw\">\n";
		if ($cmvw eq "") { $cmvw = 0; }
		@mvw = ('非表示','表示');
		foreach (0,1) {
			if ($mvw == $_) {
				print &strEncode("<option value=\"$_\" selected>$mvw[$_]\n");
			} else {
				print &strEncode("<option value=\"$_\">$mvw[$_]\n");
			}
		}
		print "</select>\n";
	} else {
		print &strEncode("  <input type=\"hidden\" name=\"mvw\" value=\"0\"> 入力すると <img src=\"$imgurl/mail.gif\" alt=\"メールを送信する\" width=\"16\" height=\"13\" border=\"0\"> からメールを受け取れます（アドレス非表\示）\n");
	}
	if ($in_mail == 3) {
		print &strEncode(" 迷惑投稿防止のため何か入れると投稿できません\n");

	} elsif ($in_mail == 1) {
		print &strEncode(" （必須）\n");
	}
	print <<EOM;
</td>
</tr>
EOM

	}
	if ($url eq "") { $url = "http://"; }

	print <<"EOM";
<tr bgcolor="$col2">
  <th bgcolor="$col2">URL</th>
  <td align="left" bgcolor="$col2"><input id="w330" type="text" name="url" value="$url" style="ime-mode:inactive" istyle="3" mode="alphabet"></td>
</tr>
EOM

# デバッグプリント
#	print &strEncode("<tr><th>image_upl=</th><td>$image_upl</td></tr>");

	# 親記事は添付フォーム ⇒ 返信記事にもファイルアップロードを許可したためファイル修正条件を以下の3行に変更 (20080926 スガラボット修正)
	local ($file_ipl) = 0;
	if (($upl{1} ne ',,,,') || ($upl{2} ne ',,,,') || ($upl{3} ne ',,,,') && !$ua) {$file_upl = 1;}
	if (($image_upl && !$in{'no'}) || ($image_upl == 2) || $file_upl) {
		print &strEncode("<tr bgcolor=\"$col2\"><th bgcolor=\"$col2\" width=\"90\">添付ファイル</th>");
		print "<td align=\"left\" bgcolor=\"$col2\">\n";
		print &strEncode("(新しいファイルを指定すると前のファイルを上書きして更新。選択ファイルが空欄なら標題のみ修正)<br>\n");

print <<EOM;
<script type="text/javascript">
function sample(oId){
	var obj = document.getElementById(oId);
	var stO = obj.innerHTML;
	obj.innerHTML = stO;
}
</script>
EOM

		foreach my $i (1 .. 3) {
#			local($ex) = split(/,/, $upl{$i});
			# 添付ファイルの名前と標題を表示するように以下の3行を修正・追加 (20080215 守田修正)
			local($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl{$i});
#			print "<input id=\"w330\" type=\"file\" name=\"upfile$i\" value=\"$filename\" size=\"$f_size\">\n";
			print "<span id=\"FL$i\"><input id=\"w330\" type=\"file\" name=\"upfile$i\" size=\"$f_size\" istyle=\"3\" mode=\"alphabet\"></span>";
			print &strEncode("<input type=\"button\" value=\"←クリア\" onclick=\"sample(\'FL$i\')\">");
			print &strEncode(" &nbsp;&nbsp; 標題: <input id=\"w250\" type=\"text\" name=\"ftitle$i\" value=\"$filetitle\" maxlength=\"30\">\n");
			if ($ex) {
				print &strEncode("<br />&nbsp;[<a href=\"$uplurl/$tim-$i$ex\" target=\"_blank\">確認</a>]\n");
				print &strEncode("<input type=\"checkbox\" name=\"del$i\" value=\"1\">添付ファイル削除\n");
			}
			print "<br>\n";
		}

		print "</td></tr>\n";
	}

	# アドミンモードでなければ入力したパスワードをリターン
	my $pw_value;
	if (!$admin_flag) { $pw_value = $in{'pwd'}; }
	$printString = <<EOM;
<tr bgcolor="$col2">
  <th bgcolor="$col2">パスワード</th>
  <td align="left" bgcolor="$col2">
  <input id="w115" type="password" name="newpwd" value="$pw_value" value="$cpwd" maxlength="8" style="ime-mode:inactive" istyle="3" mode="alphabet">
   記事メンテ時に使用 (入力しておくと後から発言を修正・削除できます)
  </td>
</tr>
EOM
print &strEncode($printString);

	# 投稿できる最大文字数を表示 (スガラボット修正分)
	$printString = <<EOM;
<tr bgcolor="$col2">
  <td align="left" bgcolor="$col2" align=\"center\"><b>記事本文</b><br><span style=\"font-size:10px\"><br>(全角${max_msg}字まで)</span></td>
  <td align="left" bgcolor="$col2">
EOM
print &strEncode($printString);

	# アイコン
	if ($smile) {
		@s1 = split(/\s+/, $smile1);
		@s2 = split(/\s+/, $smile2);
		foreach (0 .. $#s1) {
			print "<a href=\"javascript:MyFace('$s2[$_]')\">";
			print "<img src=\"$imgurl/$s1[$_]\" border=0></a>\n";
		}
# コメント内にURLの記載を許可しないときは注意書きを表示する。
		if ($urlnum == 0) {
			print &strEncode("<font color='red'>　(ご注意: このパティオではスパム対策のため発言にURLの書き込みを禁止しています)</font>");
		}
		print "<br>\n";
	}

	if ($myjob eq "admin") {
		print "<input type=\"hidden\" name=\"pass\" value=\"$in{'pass'}\">\n";
	} else {
		print "<input type=\"hidden\" name=\"pwd\" value=\"$in{'pwd'}\">\n";
		print "<input type=\"hidden\" name=\"adflg\" value=\"$admin_flag\">\n";
	}

	$com =~ s/<br>/\n/g;

	# 本文印刷色の色指定機能追加 （20080210守田修正)
	if ($color) { print &strEncode("<font color=\"$color\">■■■元の記事本文はこの色で印刷されていました■</font><br>\n"); }
	else { $color = "#000000"; }

	$printString = <<"EOM";
<textarea id="w680" name="comment" cols="$cols" rows="$rows" wrap="soft">$com</textarea><br>
<b>文字色</b>
EOM
print &strEncode($printString);

	@colors = split(/,/, $char_color);
	foreach $c (@colors) {
		$checked = "";
		if ($c eq $color) { $checked = "checked"; }
		print &strEncode("<input type=\"radio\" name=\"color\" value=\"$c\" $checked><font color=\"$c\">■</font>\n");
	}

	$printString = <<"EOM";
</td></tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2"><br></td>
  <td align="left" bgcolor="$col2">
    <input type="submit" value="記事を修正する"></td>
</tr></table>
</form></div>
EOM
print &strEncode($printString);

	&pr_footer;

	$printString = <<"EOM";
</body>
</html>
EOM
print &strEncode($printString);
	exit;
}

1;

