# きりしま式 read.cgi を改造したスガラボット独自スクリプト
$sver = 'v1.53';
# 2013/02/14 v1.53 → UTF-8を連結した文字列 $print_str が一部 Wide_character されていたバグを修正 (2箇所)
# 2012/02/12 ユーザカスタムCSSによりページ表示幅に制限がある時、枠をはみ出さないようにツリーインデックスの「題名」切り詰め機能を追加
# 2012/02/07 ユーザ定義ヘッダー対応のコラム背景画像クラスとユーザ定義フッターの印刷ルーチンを追加
# 2011/10/15 特定記事への返信をラジオボタンをクリックして行う場合の参照先記事番号のバグ修正と題名の引用をJavaScriptで選択できるよう修正
# 2010/12/19 つり逆順表示とスレッド全体降順表示アイコンの表示場所変更
# 2010/11/12 タイトル・ツリー表示の場所(上/下)、アップロードファイル(画像)の表示位置(記事の上/下)等を設定可とした。
# 2010/11/12 スレッド・ツリー表示の方法を v1.15 当時の方法に戻した。
# 2009/07/16 単独記事指定、範囲指定したツリー表示のページ送りなどを見直し
# 2009/07/05 CGIスクリプトをUnicode記述に変更。HTML入出力とログファイルの文字コード(utf8,sjis,euc,jis)を設定可能
# 2009/05/12 スレッドテーマと新規投稿題名を別設定できるよう修正
# 			 $treeforum=0 (ツリー表示をしない) の時の表示方法を修正
# 2009/01/14 名前、タイトルと本文にBBCodeからHTMLに変換する機能を追加
# 2008/12/09 携帯電話からのアクセスモードを追加 
#			 内容: 	<table>タグを入れ子にしない。
#					画面表示幅をPCのとき95%、携帯のとき100%に設定
#					記事閲覧表示でトップにスレッドの親発言を表示しない
# 2008/10/31 各スレッドの閲覧数要約ファイルcountview.datファイルを導入
# 親スレッドの表示位置をトップから通常位置に変更 (20081004 スガラボット修正)
# 返信にもファイルアップロード表示機能追加 (20080930 スガラボット修正)
# スガラボットによる複数会議室対応 V0.98 (20080315)
# スガラボットによるツリー機能追加 V0.95
# 2008/03/01 read.cgiから分離独立したサブルーチンとして別ファイル化
# 

#-------------------------------------------------
#  ツリー表示で閲覧 （20080301 スガラボット追加)
#-------------------------------------------------

#use strict;
#use warnings;
use utf8;

sub treeview {

# ページ送りエラーのための暫定対策
#$t_max = 50;

	# SSIによる複数会議室対応かどうか (20080315 スガラボット修正)
	if (!$readshtml) { $readshtml = $readcgi; }
	if (!$bbsshtml) { $bbsshtml = $bbscgi; }
	$tree = 1;

	our($no,$sub,$res,$key,$no2,$nam,$eml,$com,$dat,$ho,$pw,$url,$resub,$pno);
	our($job) = @_;

	# アラームを定義
	local($alarm) = int ($m_max * 0.9);

	# スマイルアイコン定義
	if ($smile) {
		@s1 = split(/\s+/, $smile1);
		@s2 = split(/\s+/, $smile2);
	}

	# 汚染チェック
	$in{'no'} =~ s/\D//g;

	# 削除した退避ログを閲覧するモードを追加 （2009/03/27 スガラボット修正)
	if ($in{'delview'} == 1) {
		$logdir = "$delsave/log";
		$datadir = "$delsave/data";
		$upldir = "$delsave/upl";
		$uplurl = "$delsave_url/upl";
		$delview = '&delview=1';
		$job = "past";
	}

	# スレッド読み込み
	open(IN,"$logdir/$in{'no'}.cgi") || &error("Open Error: $in{'no'}.cgi");
#	$top1 = <IN>;
	$top1 = &lineDecode(IN);
	($no,$sub,$res,$key) = split(/<>/, $top1);

	if ($key eq '-1') {$job = "past";}

	# 過去ログ
	if ($job eq "past") {
		$bbsback = "mode=past";
		if (!$in{'delview'}) {
			$guid = " [<a href=\"$readshtml&mode=past&tree=1\">過去ログ一覧</a>] <b>過去ログ閲覧</b>";
		} else {
			$guid = " [<a href=\"$readshtml&mode=past&tree=1$delview\">消去退避ログ一覧</a>] <b>消去退避ログ閲覧</b>";
		}
		$readshtml = "$readshtml&mode=past";

	# 現行ログ
	} else {
		# 参照数カウント
		&viewcount;
		$bbsback = "";
		$guid = " [<a href=\"$readshtml&mode=past&tree=1\">過去ログ</a>] <b>記事閲覧</b>";
	}

#	$top2 = <IN>;
	$top2 = &lineDecode(IN);
	chop($top2);

	our(@no,@sub,@nam,@eml,@com,@dat,@ho,@pw,@url,@mvw,@myid,@tim,@upl,@idcrypt,@color,@resto,@hldone);

	# ツリー表示機能追加に伴い以下の3行を追加 (20080229 スガラボット修正)
	$line = 0;
	($no[0],$sub[0],$nam[0],$eml[0],$com[0],$dat[0],$ho[0],$pw[0],$url[0],$mvw[0],
		$myid[0],$tim[0],$upl[1][0],$upl[2][0],$upl[3][0],$idcrypt[0],$color[0],$resto[0])  = split(/<>/, $top2);

	$pno = $no;

	# スレッドタイトルとスレ親の題名を分離したことに因る処理追加→現行ログからスレッドタイトル読みだし （2009/05/02 スガラボット修正)
	our ($sub_dif, $sub0, $sub00);
	$sub0 = $sub;

	# スレッドタイトルとレス親の題名が異なる場合のフラグをセット
	if ($sub[0] ne $sub) {
		$sub_dif = 1;
	}

	# タイトルに文字修飾機能追加
	$sub = $sub00 = &$titlebb($sub);	

#	$sub="スレッド$in{'no'}: " . $sub;

	# アイコン定義
	if ($job ne "past" && $key eq '0') { $icon = 'fold3.gif'; }
	elsif ($job ne "past" && $key eq '4') { $icon = 'fold3.gif'; }
	elsif ($job ne "past" && $key eq '3') { $icon = 'fold4.gif'; }
	elsif ($job ne "past" && $key eq '2') { $icon = 'look.gif'; }
	elsif ($job ne "past" && $res >= $alarm) { $icon = 'fold5.gif'; }
	elsif (time < $tim[0] + $hot) { $icon = 'foldnew.gif'; }
	else { $icon = 'fold1.gif'; }

	$sub0 = &titlebbrm($sub0);
	if ($job eq "past") {
		if ( $user_hdft > 1 ) {
			&header($sub0, '', 1);
		} else {
			&header($sub0, '', 0);
		}
	} else {
		if ( $user_hdft > 1 ) {
			&header($sub0, 'js', 1);
		} else {
			&header($sub0, 'js', 0);
		}
	}

	$printString = <<"EOM";
<div align="center">
<table border="0" cellspacing="0" cellpadding="0" $width><Tr>
<td width="20%" align="left"><b style="font-size:$t_size; color:$t_color">$forum_title</b></Td>
<td align="right" width="80%" valign="buttom">
[<a href="$home">ホームに戻る</a>]
EOM
print &strEncode($printString);

	if ($in{'view'} eq 'thread') {
	$printString = <<"EOM";
[<a href="$bbsshtml&view=thread&no=$in{'no'}">記事タイトル一覧に戻る</a>]
EOM
print &strEncode($printString);
	}

	if ($in{'hexwd'}) {
	$printString = <<"EOM";
[<a href="$bbsshtml&mode=find">検索トップに戻る</a>]
EOM
print &strEncode($printString);
	}

	$printString = <<"EOM";
[<a href="$bbsshtml0">スレッド一覧</a>]
[<a href="$readshtml0&mode=form&tree=1">新規投稿</a>]
[<a href="$notepage">留意事項</a>]
[<a href="$bbsshtml&mode=find">ワード検索</a>]
EOM
print &strEncode($printString);

	# 認証モードのとき
	if ($authkey) {
		print &strEncode("[<a href=\"$bbsshtml&mode=logoff\">ログオフ</a>]\n");
	}

	$printString = <<EOM;
[<a href="$admincgi">管理用</a>]
$guid

</td></tr></table>
EOM
print &strEncode($printString);
	if ($key eq '0') {
		print "<table $width><tr><td align=\"left\">";
		print "<img src=\"$imgurl/alarm.gif\"> ";
		print &strEncode("このスレッドは<b>ロック</b>されています。");
		print &strEncode("記事の閲覧のみとなります。</td></tr></table>\n");

	} elsif ($key == 2) {
		print "<table $width><tr><td align=\"left\">";
		print "<img src=\"$imgurl/alarm.gif\"> ";
		print &strEncode("このスレッドは<b>管理者からのメッセージ</b>です。");
		print "</td></tr></table>\n";

	} elsif ($key eq '4') {
		print "<table $width><tr><td align=\"left\">";
		print "<img src=\"$imgurl/alarm.gif\"> ";
		print &strEncode("このスレッドは<b>管理者によりロック</b>されています。");
		print &strEncode("記事の閲覧のみとなります。</td></tr></table>\n");

	} elsif ($alarm <= $res) {
		print "<table $width><tr><td align=\"left\">";
		print "<img src=\"$imgurl/alarm.gif\"> ";
		print &strEncode("返信記事数が<b>$res</b>件あります。");
		print &strEncode("<b>$m_max</b>件を超えると書き込みができなくなります。");
		print "</td></tr></table>\n";
	}
#	print "<p>";
	print "<hr $width>\n";

	# この記事に返信のJavaScriptを埋込み
	print <<EOM;
<script type="text/javascript">
<!--
function resnum(parts){
	f = parts.form;
	number = parts.value;
	f.resto.value = number;
	window.location='#form';
}
function restitle(str) {
	document.myFORM.sub.value = str;
	window.location='#form';
}
// -->
</script>
EOM

	# ここから出力は一旦バッファメモリに蓄積する
	local $print_buf = '';

	# 逆順表示パラメータをURLより抽出
	our $rev = $in{'rev'};
	our $all = $in{'all'};

	# 記事No認識
	our ($ptn, $from, $to);
	if ($l =~ /^\d+$/) { $ptn = 1; $from = $l; }						# パターン1(l=n): 			単独記事指定
	elsif ($l =~ /^(\d+)\-$/) { $ptn = 2; $from = $1; }					# パターン2(l=n-): 			指定記事からあとのツリースレッド表示
	elsif ($l =~ /^(\d+)\-(\d+)$/) { $ptn = 3; $from = $1; $to = $2; }	# パターン3(l=n1-n2): 		指定記事の範囲(fromとto)指定
	elsif ($l =~ /^\-(\d+)$/) { $ptn = 4; $from = $1; }					# パターン4(l=-n): 			指定記事までのツリーを表示
	elsif ($l eq "all" || $l eq "rev" || $l eq "new") { $ptn = 5; }		# パターン5(l=all/rev/new): 全範囲指定
#	elsif ($l eq '') { $ptn = 6; $l = "all"; }							# パターン6(l=): 			指定がないとき、またはツリー表示のトップページはallにする
	elsif ($l eq '') { $ptn = 5; $l = "all"; }							# パターン6(l=): 			指定がないとき、またはツリー表示のトップページはallにする
	else { &error("l=$l, 記事Noが不正です"); }

	unless (-e "$logdir/$in{'no'}\.cgi") {
		 &error("スレッドが見当たりません");
	}

	if ($key == 2) { $all = 1; }
	# 1-はallではなく1番レスからの部分ツリー表示とする
#	if ($l eq "1-") { $l = "all"; $ptn = 5;}
	if ($l eq "0-") { $l = "all"; $ptn = 5;}

	# ツリー構造のリンクリストを作成するためトピックスのログファイルを一度全部読み込む。
	$prnt[0] = 0;
	$chid[0] = 0;

	$no[0] = 0;
#	for ($line = 1; $buf = <IN>; $line++) {
	for ($line = 1; $buf = &lineDecode(IN); $line++) {
		chomp($buf);
		# 返信記事にもファイルアップロードを表示するように修正 (20080924 スガラボット修正)
		($no[$line],$sub[$line],$nam[$line],$eml[$line],$com[$line],$dat[$line],$ho[$line],$pw[$line],$url[$line],$mvw[$line],
				$myid[$line],$tim[$line],$upl[1][$line],$upl[2][$line],$upl[3][$line],$idcrypt[$line],$color[$line],$resto[$line])  = split(/<>/, $buf);
		$prnt[$line] = $resto[$line];
	}
	$num = $line;
	$nofline = $line;

    close(IN);

# list edit: 双方向リスト編集処理
#   prnt: 親ノード (parent node)
#   chid: 子ノード (child node)
#   next: 次ノード (兄弟リンクのnext node)
#   prev: 前ノード (兄弟リンクのprevious node)

	# ツリー構造のインデックス・リストを作成
	for ($line = 0; $line < $num; $line++) {
		&lst_cre($line, $prnt[$line], $no[$line]);
	}
	if (!$from) { $from = 0; }
#	if (!$to) { $to = $num - 1; }

	our ($line_from, $line_to, $only, @l_order, @pr_order, $pglog, $pglogu);
	our $n = 0;

	# 各記事欄の「この発言に返信」にラジオボタンを付けたため、以下のform宣言文をform3から移動 （2009/07/17 スガラボット修正)
	if ($job ne "past" && ($key == 1 || $key == 3)) {
		if ($image_upl && !$ua) {
			$print_buf .= qq|<form action="$registcgi" method="post" name="myFORM" enctype="multipart/form-data">\n|;
		} else {
			$print_buf .= qq|<form action="$registcgi" method="post" name="myFORM">\n|;
		}
	}

	# トップに返信のラジオボタンをクリックした時、タイトルへの参照を JavaScript に渡す処理を追加 （2011/10/15 スガラボット修正)
	&res_dsp2(0, '', 1);

	if (!$res && ($ptn == 5 || $ptn == 6)) {
		$spacer_h4 = "<img src=\"$imgurl/spacer_h4.gif\">";
		$print_buf .= "<Table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width>";
		$print_buf .= "<Tr><td align=\"left\" nowrap>";
		$print_buf .= ("<font color=\"blue\"><b> ◆ このスレッドにまだ返信はありません</b></font></td></tr>\n");
		$print_buf .= "</table><p class=\"h4\"> </p>\n";
		$only = 1;
		$kijiCount = 1;
		&dsp_range(0,0);
		&res_dsp2(0, '');
	} 

######## デバッグ用にtree テーブルの表示
#	$print_buf .= "<div align=\"left\">line &nbsp;no,prnt,chid,next,prev<br>\n";
#	for (my $line = 0; $line < $num; $line++) {
#	    printf("% 4d,% 4d,% 4d,% 4d,% 4d,% 4d, %50s<br>\n", $line, $no[$line],
#	        $prnt[$line], $chid[$line], $next[$line], $prev[$line], $sub[$line]);
#	}
#	$print_buf .= "<br>\n";
#
#	# デバッグ用にtree 行番号逆引きテーブル表示
#	$ln = $no[-1] + 1;
#	for (my $line = 0; $line < $ln; $line++) {
#	    printf("%4d,%4d<br>\n", $line, $lineno[$line]);
#	}
#	$print_buf .= "<br></div>\n";

	# ここからスレッドの個別記事または記事全部をツリー順に表示する。

	$line_color = "#008040";
	$spacer = "<img src=\"$imgurl/spacer.gif\">";
	$spacer_w15 = "<img src=\"$imgurl/spacer_w15.gif\">";
	$spacer_w6 = "<img src=\"$imgurl/spacer_w6.gif\">";
	$spacer_w7 = "<img src=\"$imgurl/spacer_w7.gif\">";
	$spacer_w2 = "<img src=\"$imgurl/spacer_w2h4.gif\">";
	$spacer_h4 = "<img src=\"$imgurl/spacer_h4.gif\">";
	$green_w2 = "<img src=\"$imgurl/green_w2.gif\">";
	
	$tb_15 = "<td width=\"15\" align=\"right\" valign=\"top\">$spacer_w15</td>";
	$tb_pre15up = "<td width=\"15\" align=\"right\" valign=\"top\">";
	$tb_pre15down = "<td width=\"15\" align=\"right\" valign=\"bottom\">";
	$tb_7 = "<td width=\"7\" align=\"right\" valign=\"top\">$spacer_w7</td>";
	$tb_6 = "<td width=\"6\" align=\"right\" valign=\"top\">$spacer_w6</td>";
	$tb_pre7up = "<td width=\"7\" align=\"right\" valign=\"top\">";
	$tb_pre7down = "<td width=\"7\" align=\"right\" valign=\"bottom\">";
	$tb_line = "<td width=\"2\" bgcolor=\"$line_color\" valign=\"top\">$spacer_w2</td>";
	$tb_post = '</td>';

	# '└'は15x15pxの画像として"$imgurl/next.gif"
	$next_img = "<img src=\"$imgurl/next2.gif\">";
	# '┌'は画像として"$imgurl/rev_next.gif"
	$rev_next_img = "<img src=\"$imgurl/rev_next2.gif\">";
	# '├'はline表示テーブルで下への線を書き、横棒は画像として"$imgurl/branch_line.gif"
	$branch_line = "<img src=\"$imgurl/branch_line2.gif\">";
	# '├'はline表示テーブルで下への線を書き、横棒は画像として"$imgurl/branch_line.gif"
	$rev_branch_line = "<img src=\"$imgurl/rev_line2.gif\">";

# テーブル表示プレフィクスの定義は以下の通り
#	$pre1a = $tb_pre.'<b>├</b>'.$tb_post;
#	$pre1b = $tb_pre.'<b>└</b>'.$tb_post;
#	$pre2a = $tb_pre.'<b>│</b>'.$tb_post;
#	$pre2b = $tb_pre.'<b>　</b>'.$tb_post;

	# テーブル表示プレフィクスの新定義は上の意味を持つ表データ(線を2px幅の表として印刷)とする
	$pre = '';
	$pre1a = $tb_6 . $tb_line . $tb_pre7up . $branch_line .$tb_post;
	$pre1b = $tb_pre15up . $next_img . $tb_post;
	$pre2a = $tb_6 . $tb_line . $tb_7;
	$pre2b = $tb_15;

	# タイトルと下の枝をつなぐ線が必要なときのスペーサの役をするテーブル要素
#	$h_adjust = $tb_6 . $tb_line;

######## デバッグ用
#	&error ("Debug: from=$from, to=$to, ptn=$ptn, no=$in{'no'}, l=$l, only=$only, lineno[from]=$lineno[$from], lineno[to]=$lineno[$to]");
#	$print_buf .= ("Debug: from=$from, to=$to, ptn=$ptn, no=$in{'no'}, l=$l, only=$only, lineno[from]=$lineno[$from], lineno[to]=$lineno[$to]<br>\n");

	# スレッドテーマがレス親発言と異なるときの表示変更のための表示フラグリセット
	$done = 0;
	
	# スレッドのプリント順序をカウンタを初期化
	our $pr_count = 0;
	
	# 記事番号の存在をチェック
	if (($ptn == 1 || $ptn == 2 || $ptn == 3 || $ptn == 4) && !($lineno[$from] >= 0 && $lineno[$from] < $num)) { 
		&error("指定された番号の記事が見当たりません")
	}
	
	# 記事を指定されたとき
#	elsif ($ptn == 1) {
	if ($ptn == 1 || $ptn == 4) { 
		# 単独記事
		if ($ptn == 1) {
			$only = 1;
			$kjiCount = 1;

			$l_order[0] = $lineno[$from];
			&dsp_range(0,0);
			if (!$lineno[$from]) { 
				$print_buf .= "<table  border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width><tr><td align=\"left\" nowrap>";
				$print_buf .= ("<b style=\"color:$t_color\"> ◆ 指定された記事は本スレッドの元トピックスです</b></td></tr>\n");
				$print_buf .= "</table><p class=\"h4\"> </p>\n";
			} else {
				$print_buf .= "<table  border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width><tr><td nowrap>";
				$print_buf .= ("<tr><td align=\"left\" nowrap><b style=\"color:$t_color\">◆ 指定された発言を表示</b></td></tr>\n");
				$print_buf .= "</table><p class=\"h4\"> </p>\n";
			}
		}
		# $lが"-n"なら遡って先祖を表示する
		else {

			# 先祖リストの作成
			$pre = '';
			$pre1b = $tb_pre15down . $rev_next_img . $tb_post;
			$pre2b = $tb_15;
#			$pre1b = '└'; 			# Debug:
#			$pre2b = '■';			# Debug;

			$l_order[0] = 0;		# スレッドの元トピックスを初期値に入れておく
			$pr_order[0] = 0;
			$pre_info[0] = $pre;
			&rev_list($lineno[$from], $pre);

			# 範囲表示
			$link_rev = 1;
#			&dsp_range;
#			&dsp_range($pr_order[$lineno[$from]], $pr_order[$lineno[$to]]);
			&dsp_range($pr_order[0], $pr_order[$lineno[$from]]);
			
			# 表示個数をチェック
#			if ( @l_order > 1 ) { $only = 0; }
			if ( $#l_order > 0 ) { $only = 0; }
			else { $only = 1; }
			# 表示個数によってタイトルと表示内容を差し替え
			unless ( $only ) { $rev_title = "から参照リンクの元親まで遡って順次表\示"; }

			# タイトル表示
			$print_buf .= "<table  border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width><tr><td nowrap>";
			$print_buf .= ("<tr><td align=\"left\" nowrap><b style=\"color:$t_color\">◆ 選択された発言$rev_title</b></td></tr>\n");
			$print_buf .= "</table><p class=\"h4\"> </p>\n";
		}

		# ツリーを順に表示
		$dsp = 0;
		for (my $i = $#l_order; $i >= 0; $i--) {
			if ($i > $line_to) { next; }
			if ($i < $line_from) { last; }
			&res_dsp2($l_order[$i], $pre_info[$i]);
		}
	}
	# 指定された選択範囲(l=n-m)のスレッドの発言内容を印刷する (fromを親とする子をtoまで印刷、toが空ならその枝の最後まで)
	elsif ($ptn == 2 || $ptn == 3) { 
		our $order;
		if ($chid[$lineno[$from]]) {
			$only = 0;
			$done = 0;

			$pre = '';
			$pre2a = $tb_6 . $tb_line . $tb_7;
			$pre2b = $tb_15;
			if (!$rev) {
				$pre1a = $tb_6 . $tb_line . $tb_pre7up . $branch_line .$tb_post;
				$pre1b = $tb_pre15up . $next_img . $tb_post;
				$order = "順に";
			} else {
				$pre1a = $tb_6 . $tb_line . $tb_pre7down . $rev_branch_line . $tb_post;
				$pre1b = $tb_pre15down . $rev_next_img . $tb_post;
				$order = "$strong1逆順に$strong2";
			}

			# 表示終了の記事番号が不明なときの処理
			if (!$to) {
				$l_order[0] = $lineno[$from];
				$pr_order[0] = $lineno[$from];
				$pre_info[0] = $pre;
				&list_order($chid[$lineno[$from]], $pre);
				# 終了行番号は部分ツリーの最後に印刷する行番号
				$to = $no[$l_order[-1]];
			} else {
				$l_order[0] = 0;
				$pr_order[0] = 0;
				$pre_info[0] = $pre;
				&list_order($chid[$lineno[0]], $pre);
			}

			if ($rev == 1) {
				$link_rev = 1;
				$order = '逆順に';
			}
			&dsp_range($pr_order[$lineno[$from]], $pr_order[$lineno[$to]]);

		} else {
			$only = 1;
			$l_order[0] = $lineno[$from];
#			&dsp_range;
			&dsp_range($pr_order[$lineno[$from]], $pr_order[$lineno[$from]]);
		}

######## デバッグ用に \@pr_order テーブル表示
#		$print_buf .= "<br><div allign=\"left\">pr_order テーブル<br>\n";
#		$ln = $no[-1] + 1;
#		for (my $line = 0; $line < $ln; $line++) {
#		    printf("%4d,%4d$pre<br>\n", $line, $pr_order[$line]);
#		}
#		$print_buf .= "</div>\n";
#
#		$line_no = $#l_order;
#		$print_buf .= "Debug: l_order=$line_no, lines=@l_order,, p=$p, line_from= $line_from, 
#				line_to=$line_to, end=$end, rev=$rev, link_rev=$link_rev<br>\n";

		# スレッド表示の上にもページ選択を表示するように修正 （2009/07/16 スガラボット修正)
		$print_buf .= "<table  border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width>\n";
		$print_buf .= ("<tr><td align=\"left\" nowrap><b style=\"color:$t_color;\">◆ 選択されたスレッドの部分ツリーを${order}表示</b></td>\n");
		$print_buf .= ("<td nowrap align=\"right\">$pglogu</td>\n") if ($pglogu);
		$print_buf .= "</tr></table><p class=\"h4\"> </p>\n";

		# ツリーを順に表示
		if (!$rev) {
			for (my $i = $pr_order[$lineno[$from]]; $i <= $pr_order[$lineno[$to]]; $i++) {

# デバッグプリント
#				$print_buf .= "Debug: i=$i,  line_from=$line_from,  line_to=$line_to,  print_order=$pr_order[$lineno[$to]]<br>";

				if ($i < $line_from) { next; }
				if ($i > $line_to) { last; }
				&res_dsp2($l_order[$i], $pre_info[$i]);
#				if ($i && $l_order[$i] == $lineno[$to]) { last; }
			}
		} else {		# ツリーを逆順に表示
			for (my $i = $pr_order[$lineno[$to]]; $i >= $pr_order[$lineno[$from]]; $i--) {
# デバッグプリント
				if ($i > $line_to) { next; }
				if ($i < $line_from) { last; }
				&res_dsp2($l_order[$i], $pre_info[$i]);
#				if ($i && $l_order[$i] == $lineno[$to]) { last; }
			}
		}
	}
	elsif ($ptn != 1 && $ptn != 4 && $ptn != 5 && $ptn != 6) {
		&error("指定された番号の記事が見当たりません2");
	}

	# "all"が指定されていたら全発言をスレッドの並び順に印刷する。	
	elsif ($rev != 1 && $res && ($l eq "all" || $l eq "0-")) { 

		if ($rev) {
			$pre1a = $tb_6 . $tb_line . $tb_pre7down . $rev_branch_line . $tb_post;
			$pre1b = $tb_pre15down . $rev_next_img . $tb_post;
			$order = "$strong1逆順に$strong2";
		}
		# ツリーの枝部分とリストの表示順を作成
		$pre = $tb_15;
		$l_order[0] = 0;
		$pre_info[0] = '';

		&list_order($chid[0], '');

		# ページ送り制御
		&dsp_range;

		# タイトル印刷
		$print_buf .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width>\n";
		$print_buf .= ("<tr><td align=\"left\" nowrap><b style=\"color:$t_color\">◆ 全ての発言 (スレッドのツリー順に表示)</b></td>\n");
		$print_buf .= ("<td nowrap align=\"right\">$pglogu</td>\n") if ($pglogu);
		$print_buf .= "</tr></table><p class=\"h4\"> </p>\n";

		$only = 0;
		$done = 0;
#		$line_from--;

		# ツリーを順に表示
		for (my $i = 0; $i <= $#l_order; $i++) {
			if ($i < $line_from) { next; }
			if ($i > $line_to) { last; }
			&res_dsp2($l_order[$i], $pre_info[$i]);
		}

	}

	# "new"が指定されていたら全発言をスレッドを新しいものから順にに印刷する。	
	elsif ($l eq "new" && $res) { 

		# ページ送り制御
		$link_rev = 1;
		&dsp_range;

		$print_buf .= "<table  border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width><tr><td align=\"left\" nowrap>";
		$print_buf .= ("<b style=\"color:$t_color\"> ◆ 全ての発言 (新しいものから順に表示)</b></td>\n");
		$print_buf .= ("<td nowrap align=\"right\">$pglog</td>\n") if ($pglog);
		$print_buf .= "</tr></table><p class=\"h4\"> </p>\n";
#		&all_dsp($chid[0]); 

		$only = 0;

		# 正順なら最新日付順表示 (リストを逆から表示)
		if ($rev ne "1") {
			for (my $i = $num - 1; $i >= 0; $i--) {
				if ($i > $line_to) { next; }
				if ($i < $line_from) { last; }
				&res_dsp2($i);
			}
		} else {
			for (my $i = 0; $i < $num; $i++) {
				if ($i < $line_from) { next; }
				if ($i > $line_to) { last; }
				&res_dsp2($i);
			}
		}
	}

	# "rev"が指定されていたら全発言を新しいものから順にスレッド逆順に印刷する。	
	elsif ($l eq "rev" && $res || ($rev == 1 && ($l eq "all" || $l eq "1-"))) { 
		$rev = 1;
#		$all = 1;
		if ($l eq "rev") { $l = "all"; }

		# ツリーの枝部分とリストの表示順を作成
		$pre = '';
		$pre1a = $tb_6 . $tb_line . $tb_pre7down . $rev_branch_line . $tb_post;
		$pre1b = $tb_pre15down . $rev_next_img . $tb_post;
		$l_order[0] = 0;
		$pre_info[0] = $pre;
		&list_order($chid[0], $pre);

		# ページ送り制御
		$link_rev = 1;
		&dsp_range;

		# タイトル印刷
		$print_buf .= "<table  border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width>\n";
		$print_buf .= ("<tr><td align=\"left\" nowrap><b style=\"color:$t_color\">◆ 全発言を新しいものからスレッドを逆順に表示</b></td>\n");
		$print_buf .= ("<td nowrap align=\"right\">$pglogu</td>\n") if ($pglogu);
		$print_buf .= "</tr></table><p class=\"h4\"> </p>\n";

		$only = 0;

		# 新しいものからツリーを逆順に表示
		# スレッド元記事を表示するため以下の2行を追加修正 (20080301 スガラボット)
#		if ($line_from == 1) { $line_from--; }
#		for (my $i = ($#l_order -1); $i >= 0; $i--) {
		for (my $i = $#l_order; $i >= 0; $i--) {
			if ($i > $line_to) { next; }
			if ($i < $line_from) { last; }
			&res_dsp2($l_order[$i], $pre_info[$i]);
		}
	}
#	$print_buf .= "<p>\n";

	$print_buf .= "<table cellspacing=\"0\" cellpadding=\"0\" $width><tr hight=\"4\"><td>$spacer_h4</td></tr><tr><td class=\"num\" align=\"left\"nowrap>";
	$print_buf .= ($pglog);
	$print_buf .= "</td></tr></table><p> <p>\n";
	

	# スレッド・タイトルのツリー表示メニューを下に表示するときは記事を印刷する (2009/11/13 スガラボット追加)
	local $buf_print = 0;
#	if ($job eq "past" || $tree_menu == 1 || !$tree_menu && $only) {
	if ( $tree_menu == 1 || !$tree_menu && $only) {
		print &strEncode($print_buf);
		$buf_print = 1;
		print "<hr $width>\n";
	}

#	if ($job eq "past") { print "</div>\n</body></html>\n"; exit; }

	# NEWの時間を設定変数で表示するよう修正 (20080308 スガラボット)
	$newhour = int($hot / 3600);
	# ファイルアップロードが許可された掲示板なら「投稿に添付」を表示する
	$tenpu = ($image_upl > 0)? "<LI><img src=\"$imgurl/clipsls.gif\" alt=\"投稿に添付\">は添付ファイル付き　　&nbsp;": '';

	# 新着記事の定義
	my $new_comment;
	if ($job ne "past") { $new_comment = "<LI>新着記事は $newmark "; }

	# 携帯電話からのアクセスの場合はツリー表示の説明を入れない (2008/12/08 スガラボット修正)
	if (!$ua) {
		$note_msg = "<LI>スレッド先頭部の<img src=\"$imgurl/tree.gif\">または<img src=\"$imgurl/fold1.gif\">をクリックするとスレッド内の全記事を表示します。(<img src=\"$imgurl/tree.gif\">はツリー表示)\n" .
					"<LI>記事先頭の<font color=\"green\">▼ △</font>をクリックすると参照関係のある発言をその発言から(<font color=\"green\">\n" .
					"▼</font>は下、<font color=\"green\">△</font>は上) へツリー表示します。<font size=\"+1\">　</font>" .
					"<LI>スレッド最終行の<img src=\"$imgurl/treerev2.gif\">または最新発言の<img src=\"$imgurl/upbutton1.gif\">をクリックするとスレッドの全記事を降順に表示します。(<img src=\"$imgurl/treerev2.gif\">はツリー表示)</td>\n";
	}
	else {
		$note_msg = "<LI>スレッド先頭部の <img src=\"$imgurl/tree.gif\"> をクリックするとスレッド内の全記事を順に表示します。" . 
					"<LI>スレッド最新記事の <img src=\"$imgurl/upbutton1.gif\"> をクリックするとスレッド内の全記事を新しいものから降順に表示します。</td>\n";
	}

	$printString = <<EOM;
<Table border=\"0\" cellspacing=\"5\" cellpadding=\"0\" $width>
<tr>
<td align="left" nowrap>
$note_msg 
<td nowrap align="left" valign="top">
$tenpu
$new_comment
</td></tr></table>
<img src=\"$imgurl/spacer_h4.gif\">
EOM
print &strEncode($printString);

	print "<Table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width>";
	print "<Tr><td align=\"left\" width=\"100%\" nowrap>";

	# スレッドの親記事を表示
	# 添付ファイルのアイコン定義
	$res_icon = '';
	foreach $k (1 .. 3) 
	{
		local($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl[$k][0]);
		if ($ex) { $res_icon = "<img src=\"$imgurl/clipsls.gif\" border=\"0\"> "; last;}
	}

# スド一覧からトリップを消したい場合有効にする
#	$nam[0] =~ s/◆.+//g;
#	$na2[0] =~ s/◆.+//g;

	# もし特定のレスを指定したツリー表示ならそのレスを強調表示する
	my ($st1, $st2, $tsubst1, $tsubst2);
	if ($l == 0) { $st1 = $strong1; $st2 = $strong2; }
	else { $st1 = ''; $st2 = ''; }

	# タイトルと名前に文字修飾機能追加 （2009/01/12 スガラボット修正)
	$sub[0] = &$titlebb($sub[0]);	
	$nam[0] = &$titlebb($nam[0]);	

	# この記事に検索語が含まれるかをチェック
	if ($in{'word'}) {
		my $ktarget = '';
		$ktarget = $sub if ($in{'s'});
		$ktarget .= $nam if ($in{'n'});
		$ktarget .= $sub[0] if ($in{'s'}) ;
		$ktarget .= $nam[0] if ($in{'n'}) ;
		if ($in{'c'}) {
			$ktarget .= $com[0];
			$ktarget .= $up[l][0] . $upl[2][0] . $upl[3][0];
		}
		my $flg = 0;
		foreach $wd (@wd) {
#			if (index($ktarget,$wd) >= 0) {											#}
			if (&search($ktarget,$wd)) {
				$flg = 1;
				if ($in{'kijiop'} eq 'OR') { last; }
			} else {
				if ($in{'kijiop'} eq 'AND') { $flg = 0; last; }
			}
		}

		if ($flg) {
			# タイトルと名前に検索語のハイライト表示を追加 （2009/07/19 スガラボット修正)
			$sub = &highlight($sub, \@wd, 1) if ($in{'s'} && !$hldone[0]);
			$sub[0] = &highlight($sub[0], \@wd) if ($in{'s'} && !$hldone[0]);
			$nam[0] = &highlight($nam[0], \@wd) if ($in{'n'} && !$hldone[0]);

			$st1 .= $strong1b . $st1;
			$st2 .= $st2 . $strong2b;
		}
		$tsubst1 = $strong1b;
		$tsubst2 = $strong2b;
	}

	# 名前からトリップ表示を削除するかどうか (きりしまさんの掲示板を参考にして修正、2009/04/07 スガラボット)
	if ($patio_trip) {
		$nam[0] =~ s/[◆◇].+//g;
	}

	#スレッドタイトルとレス親題名を分離したことに因る処理
	local ($sub1, $sub2);
	if ($sub_dif) {
		$sub1 = "&nbsp;&nbsp;${tsubst1}<b>スレッド$in{'no'}: $sub &nbsp;</b>$tsubst2<br>";
#		$sub2 = " ${tsubst1}<b>No.0 &nbsp;$tsubst2</b>";
		$sub2 = " <b>No.0 &nbsp;</b>";
	} else {
		$sub2 = "$tsubst1<b>スレッド$in{'no'}:</b>$tsubst2";
	}

	# スレッドのプリント順序カウンタを初期化
	our $pr_count = 0;

	# もし表示ページ幅の制限により「題名」を切り詰める必要か有る時
	my $sub_bak = $sub[0];
	if ( $max_chars ) {
		$sub[0] = &sub_chop( '', $sub[0], $nam[0], $tim[0], 1 );
	}

	# スレッドの親記事を表示
	print &strEncode($sub1);

	if (!$ua) {
		print "$spacer_w15<a href=\"$readshtml&tree=1&no=$in{'no'}&l=all\"><img src=\"$imgurl/tree.gif\" border=\"0\" align=\"middle\"></a>\n";
		print &strEncode(" <a href=\"$readshtml&no=$in{'no'}&tree=0\"><img src=\"$imgurl/$icon\" border=\"0\" align=\"middle\"></a> $st1 $sub2 ［$res_icon<a href=\"$readshtml&tree=1&no=$in{'no'}&l=0\">$sub[0]</a>］&nbsp;<b>$nam[0]</b> &nbsp;$dat[0] $st2 \n");
	} else {
		print &strEncode("&nbsp;　<a href=\"$readshtml&no=$in{'no'}\"><img src=\"$imgurl/$icon\" border=\"0\"></a>\n");
		print &strEncode(" $sub2 ［$res_icon<a href=\"$readshtml&tree=1&no=$in{'no'}&l=0\">$sub[0]</a>］&nbsp;<b>$nam[0]</b> &nbsp;$dat[0] $st2 \n");
	}
	if ($job ne 'past' && time < $tim[0] + $hot) { print "$newmark"; }
	if ($job ne 'past') { print &strEncode(" &nbsp;&nbsp;閲覧数: $count <br>\n"); }
	else { print "<br>\n"; }

	# 題名を元の切り詰めない値に戻す
	$sub[0] = $sub_bak;

	$pre_c = '';
	$pre1a_c = '├';
	$pre1b_c = '└';
	$pre2a_c = '│';
	$pre2b_c = '　';

	$pre = "<img src=\"$imgurl/blank.gif\">";
	$pre1a = "<img src=\"$imgurl/branch.gif\">";
	$pre1b = "<img src=\"$imgurl/next.gif\">";
	$pre2a = "<img src=\"$imgurl/down.gif\">";
	$pre2b = "<img src=\"$imgurl/blank.gif\">";

	# スレッドを階層表示
	if ($res) {
#		&lst_dsp($chid[0], $pre, $lst_pre0, $lst_pre0);
		&lst_dsp($chid[0], $pre, $pre_c);
	}

	print "</td></tr>\n";
	print "</table><br>\n";

	# スレッド・タイトルのツリー表示メニューを上に表示するときはここで記事を印刷する (2009/11/13 スガラボット追加)
	if (!$buf_print) {
		print "<hr $width>\n";
		print &strEncode($print_buf);
	}

# スレッド発言のタイトルのツリー表示は終了

#	&form3 if ($job ne "past" && ($key == 1 || $key == 3));
	&form2 if ($job ne "past" && ($key == 1 || $key == 3));

	print "</div>\n";

	&pr_footer;

	print "</body></html>\n";

	exit;
}

# list display
#----------------------------------------------------
# ツリー構造のポインターリストを印刷するサブルーチン
#----------------------------------------------------

#	$pre_c = '';
#	$pre1a_c = '├';
#	$pre1b_c = '└';
#	$pre2a_c = '│';
#	$pre2b_c = '　';

sub lst_dsp {
    my ($idx, $pre, $pre_c) = @_;			# 引数はデータの行番号とプレフィックス文字列
    my ($i, $link);

#printf("lst_dsp(%d)\n", $idx);

	$i = $idx;
	do {
			# プリント順序カウンタをインクリメント
			$pr_count++;

		if ($next[$i] == $chid[$prnt[$i]]) {
			# 自分の次ノードが長男のポインタと同じなら最後のノード
			$pre1 = $pre.$pre1b;
			$pre2 = $pre.$pre2b;
			$pre1_c = $pre_c.$pre1b_c;
			$pre2_c = $pre_c.$pre2b_c;
		} else {
			# 最後以外のノード
			$pre1 = $pre.$pre1a;
			$pre2 = $pre.$pre2a;
			$pre1_c = $pre_c.$pre1a_c;
			$pre2_c = $pre_c.$pre2a_c;
		}
#		printf("%-20s %-11s %-10s\n",
#			$pre1.$data[$i], $date[$i], $user[$i]);

		# もし特定のレスを指定したツリー表示ならそのレスを強調表示する
		my ($st1, $st2);
		if ($from > 0 && $from == $no[$i]) { $st1 = $strong1; $st2 = $strong2; }
		else { $st1 = ''; $st2 = ''; }

		# 検索語ハイライト表示のとき、この記事に検索語が含まれるかをチェック
		my $flg = 0;
		if ($in{'word'}) {
			my $ktarget = '';
			$ktarget = $sub[$i] if ($in{'s'}) ;
			$ktarget .= $nam[$i] if ($in{'n'}) ;
			if ($in{'c'}) {
				$ktarget .= $com[$i];
				$ktarget .= $up[l][$i] . $upl[2][$i] . $upl[3][$i];
			}
			foreach my $wd (@wd) {
#				if (index($ktarget,$wd) >= 0) {
				if (&search($ktarget,$wd)) {
					$flg = 1;
					if ($in{'kijiop'} eq 'OR') { last; }
				} else {
					if ($in{'kijiop'} eq 'AND') { $flg = 0; last; }
				}
			}
		}

		# もしこのレスに検索語が含まれていたらそのレスを強調表示する
		if ($flg) {
			$hit++;

			$st1 = $strong1b . $st1;
			$st2 = $st2 . $strong2b;
		}

		# タイトルと名前に文字修飾機能追加 （2009/01/12 スガラボット修正)
		$sub[$i] = &$titlebb($sub[$i]);	
		$nam[$i] = &$titlebb($nam[$i]);	

		# タイトルと名前に検索語のハイライト表示を追加 （2009/07/19 スガラボット修正)
		$sub[$i] = &highlight($sub[$i], \@wd) if ($in{'s'} && !$hldone[$i]);
		$nam[$i] = &highlight($nam[$i], \@wd) if ($in{'n'} && !$hldone[$i]);

		# 名前からトリップ表示を削除するかどうか (きりしまさんの掲示板を参考にして修正、2009/04/07 スガラボット)
		if ($patio_trip) {
			$nam[$i] =~ s/[◆◇].+//g;
		}

		# 添付ファイルのアイコン定義
		$res_icon = '';
		foreach $k (1 .. 3) 
		{
			local($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl[$k][$i]);
			if ($ex) { $res_icon = "<img src=\"$imgurl/clipsls.gif\" border=\"0\"> "; last;}
		}

		# 最後の行番号ならツリー全体の降順表示リンクを追加
		$revdisp = '';
		$revtree = '';
#		if ($i == ($nofline - 1)) {
#			$revtree = "<a href=\"$readshtml&tree=1&no=$no&l=rev\"><img src=\"$imgurl/treerev2.gif\" border=\"0\"></a>";
#			$revdisp = "<a href=\"$readshtml&tree=1&no=$no&l=new\"><img src=\"$imgurl/upbutton1.gif\" border=\"0\"></a>";
#		}
		# 下向けツリー表示か逆順表示アイコンかを定義
		my $link_icon;
		if ($pr_count == ($nofline - 1)) {
			$link_icon .= "<a href=\"$readshtml&tree=1&no=$no&l=rev\"><img src=\"$imgurl/treerev2.gif\" border=\"0\" align=\"middle\"></a>";
			$revtree = "<a href=\"$readshtml&tree=1&no=$num&l=rev\"><img src=\"$imgurl/treerev2.gif\" border=\"0\"></a>";
		} 
		if ($i == ($nofline - 1)) {
			$link_icon .= "<a href=\"$readshtml&tree=1&no=$no&l=new\"><img src=\"$imgurl/upbutton1.gif\" border=\"0\" align=\"middle\"></a>";
			$revdisp = "<a href=\"$readshtml&tree=1&no=$num&l=new\"><img src=\"$imgurl/upbutton1.gif\" border=\"0\"></a>";
		} 
		if ($i != ($nofline - 1) && $pr_count != ($nofline - 1)) {
			$link_icon = "<a href=\"$readshtml&tree=1&no=$no&l=$no[$i]-\"><font color=\"green\">▼</font></a>";
		}

		# 表示枠の幅に制限がある場合、タイトルの尾部を省略して「…」で置き換え、ツリー表示の表示行野長さが制限を超えないように短くする処理
		my $sub_bak = $sub[$i];
		if ( $max_chars ) {
			$sub[$i] = &sub_chop( $pre1_c, $sub[$i], $nam[$i], $tim[$i] );
		}

		# 携帯電話からのアクセスのときはサブツリーのリンクを表示しない (2008/12/08 スガラボット修正)
		if (!$ua) {
			print &strEncode("<SPAN STYLE=\"font-family:'monospace';\"><font size=\"+1\" color=\"#338B33\">$pre1</font></SPAN>$link_icon
				<a href=\"$readshtml&tree=1&no=$no&l=-$no[$i]\"><font color=\"green\">△</font></a>
				 ${st1}No.$no[$i] &nbsp;［$res_icon<a href=\"$readshtml&tree=1&no=$no&l=$no[$i]\">$sub[$i]</a>］&nbsp;<b>$nam[$i]</b> &nbsp;$dat[$i] $st2\n");
		} else {
			if (!$resto[$i]) { $head_mark = "●"; }
			else { $head_mark = "■"; }
			if ($revdisp) { $head_mark = $revdisp; }
			print &strEncode("<font size=\"+1\" color=\"#338B33\">$pre1</font><font color=\"green\" size=\"-2\"> $head_mark </font>
				 ${st1}No.$no[$i] &nbsp;［$res_icon<a href=\"$readshtml&tree=1&no=$no&l=$no[$i]\">$sub[$i]</a>］&nbsp;<b>$nam[$i]</b> &nbsp;$dat[$i] $st2\n");
		}
		if (time < $tim[$i] + $hot) { print "$newmark"; }
		print "<br>\n";

		# 切り詰めた「題名」を元に戻す。
		$sub[$i] = $sub_bak;

		if ($chid[$i] != 0) {
			# 自分に子供が有るとき
			if ($next[$i] == $chid[$prnt[$i]]) {
				# 最後のノード
			} else {
				# 最後以外のノード
			}
			&lst_dsp($chid[$i], $pre2, $pre2_c);		# 1レベル字下がりして再帰的に子ノードを印刷する
		}
	
		$i = $next[$i];						# 子供がないときは次ノードを印刷する
    } until ($i == $idx);
}

# print order create
#----------------------------------------------------
# スレッドツリーの枝情報と表示順を作成するサブルーチン
#----------------------------------------------------

sub list_order {
    my ($idx, $pre) = @_;			# 引数は$fromの行番号から$toの行番号まで
    my ($i);

    if ($idx == 0) {
    	return;
    }
    
    $i = $idx;
    do {
		if ($next[$i] == $chid[$prnt[$i]]) {
			# 自分の次ノードが自分の長男なら最後のノード
			$pre1 = $pre.$pre1b;
			$pre2 = $pre.$pre2b;
		} else {
			# 最後以外のノード
			$pre1 = $pre.$pre1a;
			$pre2 = $pre.$pre2a;
		}

		push(@l_order, $i);
		push(@pre_info, $pre1);
		$n++;
		$pr_order[$i] = $n;

# デバッグプリント
#		$print_buf .= "Debug: i=$i, lines=$#l_order, n=$n<br>"; 

		if ($chid[$i] != 0) {
			&list_order($chid[$i],$pre2);	# 1レベル下がって再帰的に子ノードを印刷する
		}
		$i = $next[$i];						# 子供がないときは次ノードを印刷する
    } until ($i == $idx || $n == $num);
    
}

# print order create 2
#----------------------------------------------------
# スレッド記事の親を順次辿ってリストを作成するサブルーチン
#----------------------------------------------------

sub rev_list {
    my ($idx, $pre) = @_;			# 引数は選択された$fromの行番号
    my ($i, $pre0);

    $i = $idx;
	if ($prnt[$i] != 0) {			# 親がいるとき
		$pre0 = &rev_list($prnt[$i], $pre);	
									# 1レベル下がって再帰的に親ノードをリンクする
		$pre1 = $pre0;				# 終端ノード
		$pre2 = $pre2b.$pre0
	}
	else {							# 親がスレ主であるとき
		$pre1 = $pre1b;
		$pre2 = $pre2b.$pre1;
	}

	push(@l_order, $i);
	push(@pre_info, $pre1);
	$n++;
	$pr_order[$i] = $n;

	$pre2;

}

# dsp_range
#----------------------------------------------------
# 表示範囲を定義
#----------------------------------------------------

sub	dsp_range {

	my ($ln_from, $ln_to) = @_;

###### デバッグプリント
#	$print_buf .= "Debug: ln_from=$ln_from, ln_to=${ln_to}<br>\n";

	# 携帯からの閲覧時は、1ページの閲覧数を変更する （2009/11/13 スガラボット追加)
	if ( $ua ) { $t_max = $kt_max; }

	# ページ繰越ボタンの表示
	if ($ln_from eq '') { $ln_from = 0; }
#	if (!$ln_to || $ln_to < $ln_from) { $ln_to = $num - 1; }
	if ($ln_to eq '') { $ln_to = $num - 1; }

	$max_line = $ln_to - $ln_from + 1;

#	$l_order0 = $#l_order;
#	$l_order0 = $max_line;

	if ($p eq "") { $p = 1; }

#	$end = $max_line / $t_max + 1;
	$end = $max_line / $t_max;

	$pagecnt = ($end > 1) ? 1 : 0;

	if ($end > int($end)) { $end = int($end) + 1; } 
	else { $end=int($end); }


	$pglog = &pagelink2($end, $p);

#	$print_buf .= "<hr $width>\n";	

	# 携帯からの閲覧ではなく、allモードのときはページ制御をしない
	if (!$ua && $all == 1) {
		$line_from = 0;
		$line_to = $max_line;
		return;
	}
	
	# 表示範囲を定義
	if ( $t_max == 1 ) {			# 1ページあたりの表示数が1記事のとき
		if (!$link_rev) {
			$line_from = $ln_from + $p - 1;
			$line_to   = $line_from;
		} else {
			$line_from = $ln_to - $p + 1;
			$line_to   = $line_from;
		}
	} else {						# 1ページあたりの表示数が複数のとき
		# 記事番号と行番号を分離する
		# lineは0から数え、実際に印刷する記事の行番号-1とする
		if (!$link_rev) {
			if ($p == 1) {
				$line_from = $ln_from;
				$line_to   = $ln_from + $t_max - 1;
				if ($line_to > $ln_to) { $line_to = $ln_to; }
			} else {
				$line_from = $ln_from + $t_max * ($p - 1);
				$line_to   = $line_from + $t_max - 1;
				if ($line_to > $ln_to) { $line_to = $ln_to; }
			}
		} else {
			if ($p == 1) {
				$line_from = $ln_to - $t_max + 1;
				$line_to   = $ln_to;
				if ($line_from < $ln_from) { $line_from = $ln_from; }
			} else {
				$line_from = $ln_to - $t_max * $p + 1;
				$line_to   = $line_from + $t_max - 1;
				if ($line_from < $ln_from) { $line_from = $ln_from; }
			}
		}
	}

########
#	$print_buf .= "Debug: num=$num, to=$to, lineno[to]=$lineno[$to], max_line=$max_line, end=$end, line_from=$line_from, line_to=$line_to<br>\n";
	
}

#-------------------------------------------------
#  ページ繰越ボタン
#-------------------------------------------------
sub pagelink2 {
	local($end,$p) = @_;
	local($pglog);

#	$pglog .= "<table $width><tr><td class=\"num\">";
#	$pglog .= "<div style=\"max-width:95%;\">";

	my $msg1 = "（全部表示中）　\n";
	my $msg2 = "戻る";
	my $msg3 = "全部表示";
	my $msg4 = "逆順に表示 ";
	my $msg5 = "正順に表示 ";
	my $msg6 = "スレッド一覧";
	my $msg7 = "新規スレッド作成";
	my $msg8 = " 検索トップに戻る";
	my $msg9 = "次の記事";
	my $msg10 = " 前の記事";
	my $msg11 = " 記事タイトル一覧に戻る";

	# 携帯からの閲覧時は"次の記事"、"前の記事"を先に表示する
	if ( $ua ) {
		if ($pagecnt) {
			if ($p > 1) {
				my $prev_page = $p - 1;
				$pglog .= "<a href=\"$readshtml&mode=$mode&tree=$tree&no=$pno&p=$prev_page&l=$l&rev=$rev$delview\">$msg10</a>\n";
			}
			if ($p < $end) {
				my $next_page = $p + 1;
				$pglog .= "<a href=\"$readshtml&mode=$mode&tree=$tree&no=$pno&p=$next_page&l=$l&rev=$rev$delview\">$msg9</a>\n";
			}
		}
	}
	else {
	# 全部表示
		if ($all == 1 ) {
			$pglog = $msg1;
			$pglog .= " <a href=\"$readshtml&mode=$mode&tree=$tree&no=$pno&l=$l&p=$p&rev=$rev$delview\">$msg2</a>\n";
		} elsif ($pagecnt) {
			$pglog .= "Page: ";

			foreach (1 .. $end) {
				if ($end == 1) { last; }
				if ($p == $_) {
					$pglog .= " <b style=\"color:$pglog_col\">$_</b> | \n";
				} else {
					$pglog .= "<a href=\"$readshtml&mode=$mode&tree=$tree&no=$pno&p=$_&l=$l&rev=$rev$delview\">$_</a> |\n";
				}
			}

			if ($end > 1) {
			$pglog .= " &nbsp;<a href=\"$readshtml&mode=$mode&tree=$tree&no=$pno&l=$l&p=$p&rev=$rev&all=1$delview\">$msg3</a> \n";
			}
		}
	}

	if (!$rev && ($l eq 'all' || $ptn == 2 || $ptn == 3)) {
		$pglog .= " &nbsp;<a href=\"$readshtml&mode=$mode&tree=$tree&no=$pno&l=$l&p=$p&rev=1&all=$all$delview\">$msg4</a>\n";
	}
	if ($rev && ($l eq 'all' || $ptn == 2 || $ptn == 3)) {
		$pglog .= " &nbsp;<a href=\"$readshtml&mode=$mode&tree=$tree&no=$pno&l=$l&p=$p&all=$all$delview\">$msg5</a>\n";
	}

	if ($in{'view'} eq 'thread') {
		$pglog .= " &nbsp;<a href=\"$bbsshtml&view=thread&tree=$tree&no=$in{'no'}\">$msg11</a>\n";
	}
	
	$pglogu = $pglog;

	$pglog .= " &nbsp;<a href=\"$bbsshtml\">$msg6</a>\n";
	$pglog .= " &nbsp;<a href=\"$readshtml&mode=form&tree=1\">$msg7</a>\n";
	$pglog .= " &nbsp;<a href=\"$bbscgi1\">$msg8</a>\n" if (@wd);
	
####### デバッグプリント
#	$print_buf .= "Debug: rev=$rev, l=$l, pattern=$ptn<br>\n";
#	$pglog .= "</td></tr></table>\n";
#	$pglog .= "</div>\n";
	$pglog;
}

1;

