#┌─────────────────────────────────
#│ [ WebPatio ]
#│ upload.pl - 2007/06/30
#│ Copyright (c) KentWeb
#│ webmaster@kent-web.com
#│ http://www.kent-web.com/
#└─────────────────────────────────

use utf8;
use File::Copy;

$sver = "v1.42";
# 2011/10/15 parse_form() への CGI.pm 導入に伴ってアップロードファイルの処理をメモリライトからムーブに変更
# 2008/10/29 新規にv1.03として配布 (スガラボットファイルアップロード拡張バージョン)

#-------------------------------------------------
#  アップロード
#-------------------------------------------------
sub upload {
	local($no) = @_;
	local(@ret);
	local($type_error);
	local($i);

	foreach $i (1 .. 3) {

		if (!defined($uplno{$i})) {
#			push(@ret,("","",""));
# 記録する情報としてファイル名を追加修正 (20080215 守田修正)
			push(@ret,("","","","",""));
			next;
		}

#		local($w,$h);
# 記録する情報としてファイル名と標題を追加修正 (20080214 守田修正)
		local($w,$h,$pathname,$filename,$filetitle);

		local($ex);
		if ($ctype{$i} =~ m|image/gif|i) {
			$ex = '.gif';
		} elsif ($ctype{$i} =~ m|image/p?jpeg|i) {
			$ex = '.jpg';
		} elsif ($ctype{$i} =~ m|image/png|i) {
			$ex = '.png';
		}

# 許容するアップロードファイルの拡張子とアップロードファイルの拡張子を比較するのを以下のループ文に書き直し (20080216 守田修正)
		if (!$ex) {
			local(@ext) = split(/,/, $file_type);
#			local(@fext) = split(/\./, $fname{$i});
# 上の行を複数の.が付いても一回しか分割しないように修正 (20081029 スガラボット)
			local(@fext) = split(/\./, $fname{$i}, 2);
			foreach my $ky (@ext) {
				if ($fext[-1] eq $ky) { $ex = "." . $ky; last; }
			}
		}

		# ファイル認識できなかったときはエラーフラグをセット
		if (!$ex) { if ($fname{$i}) { $type_error = 1; last; } }
		# ファイル認識できたときは書き込む
		else {
			local($upfile) = $in{"upfile$i"};

			# マックバイナリ排除
			if ($macbin) {
				local($len) = substr($upfile, 83, 4);
				$len = unpack("%N", $len);
				$upfile = substr($upfile, 128, $len);
			}

			# アップファイル定義
			local($imgfile) = "$upldir/$no-$i$ex";
#			local($imgfile) = "$no-$i$ex";

#			# 書き込み
#			open(OUT,">$imgfile") || &error("$imgfileオープンエラー、画像アップ失敗");
#			binmode(OUT);
#			print OUT $upfile;
#			close(OUT);

# init.cgi で アップロード解析に CGI.pm を使用する変更に伴う修正
# アップロード･ディレクトリに保存されたアップロードファイルをムーブするだけに変更
#&error("upl_file=$in{"upfile$i"}, imgfiel=$imgfile<br>\n");
			move ($in{"upfile$i"}, $imgfile) or &error( "Failed to save uploaded file! <br>\n$!<br>" );		# File::Copy の moveメソッドで移動
			

			# パーミッション変更
			chmod(0666, $imgfile);

			# 画像サイズ取得
			if ($ex eq ".jpg") { ($w,$h) = &j_size($imgfile); }
			elsif ($ex eq ".gif") { ($w,$h) = &g_size($imgfile); }
			elsif ($ex eq ".png") { ($w,$h) = &p_size($imgfile); }

# 記録する情報としてファイル名を追加、以下の6行を追加修正 (20080215 守田修正)
			$pathname = $fname{$i};
			$pathname =~ s#\\#/#g;
			if( $pathname =~ m|.*/(.*)$| ) { $filename = $1; }
			else { $filename = $pathname; }
			$filetitle = $ftitle{$i};
		}
		# 処理結果
#		push(@ret,($ex,$w,$h));
# 記録する情報としてファイル名と標題を追加修正 (20080215 守田修正)
		push(@ret,($ex,$w,$h,$filename,$filetitle));
	}
	# 返り値
# 下の1行はデバッグ用
#	&error("デバッグ: @ret");
	if ($type_error) {
		$error_msg = "File_type Error: ret=@ret, <br>\n";
		$error_msg .= "i=$i, fname=$fname{$i}, ext=$fext[-1] でした。拡張子が @ext 以外のファイルはアップロード出来ません。<br>\n";
#		$error_msg .= "Debug Info: %in";
		&error("$error_msg"); 
		}
	return @ret;
}

#-------------------------------------------------
#  JPEGサイズ認識
#-------------------------------------------------
sub j_size {
	local($jpeg) = @_;
	local($t, $m, $c, $l, $W, $H);

	open(JPEG, "$jpeg") || return (0,0);
	binmode JPEG;
	read(JPEG, $t, 2);
	while (1) {
		read(JPEG, $t, 4);
		($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$W = $H = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(JPEG, $t, 5);
			($H, $W) = unpack("xnn", $t);
			last;
		} else {
			read(JPEG, $t, ($l - 2));
		}
	}
	close(JPEG);
	return ($W, $H);
}

#-------------------------------------------------
#  GIFサイズ認識
#-------------------------------------------------
sub g_size {
	local($gif) = @_;
	local($data);

	open(GIF,"$gif") || return (0,0);
	binmode(GIF);
	sysread(GIF,$data,10);
	close(GIF);

	if ($data =~ /^GIF/) { $data = substr($data,-4); }

	$W = unpack("v",substr($data,0,2));
	$H = unpack("v",substr($data,2,2));
	return ($W, $H);
}

#-------------------------------------------------
#  PNGサイズ認識
#-------------------------------------------------
sub p_size {
	local($png) = @_;
	local($data);

	open(PNG, "$png") || return (0,0);
	binmode(PNG);
	read(PNG, $data, 24);
	close(PNG);

	$W = unpack("N", substr($data, 16, 20));
	$H = unpack("N", substr($data, 20, 24));
	return ($W, $H);
}



1;

