#!/usr/local/bin/perl
#┌─────────────────────────────────
#│ [ WebPatio ]
#│ patio.cgi - 2006/10/09
#│ Copyright (c) KentWeb
#│ webmaster@kent-web.com
#│ http://www.kent-web.com/
#└─────────────────────────────────
#
# きりしま式 Web Patio v3.22 k0.8 相当 2009/3/14
$kver ="0.92";
# 2009/03/24 スレッド作成制限モードの追加
# 0.70 2008/02/27 スレッド分割機能を装備（厳密には指定レス以降をコピーして新規スレッド作成）
$sver = 'v1.51';
# 2012/11/15 patio/forum のインデックスページに指定した数の新着記事を表示する機能を追加(簡易掲示板向け)
# 2012/02/12 UTF-8を連結した文字列 $print_str が一部 Wide_character されていたバグを修正 (3箇所)
# 2012/02/12 ユーザカスタムCSSによりページ表示幅に制限がある時、枠をはみ出さないようにツリーインデックスの「題名」切り詰め機能を追加
# 2012/02/07 ユーザ定義ヘッダー対応のコラム背景画像クラスとユーザ定義フッターの印刷ルーチンを追加
# 2010/12/19 HTTPパラメータ名の変更 スレッドビューのパラメータ名を $in{'mode'} → $in{'view'} に変更、文言修正
# 2010/11/30 $bbsshtml のパラメータ変更、「Forum形式表示」の文言をinit.cgiで、フッター追加等
# 2010/02/01 スレッド一覧(目次)表示の説明書きの文字化け修正
# 2009/11/16 スレッド一覧(目次)表示ページを追加
# 2009/11/04 如水さんのWebPatio+ (http://jyosui.xrea.jp/feed.html) 静的RSS機能を一部修正して追加インストール
# 2009/07/05 CGIスクリプトをUnicode記述に変更。HTML入出力とログファイルの文字コード(utf8,sjis,euc,jis)を設定可能
# 2009/05/12 スレッドテーマと新規投稿題名を別設定できるよう修正
# 			 $treeforum=0 (ツリー表示をしない) の時の表示方法を修正
# 2009/03/24 きりしま式K0.8に対応
# 2009/01/14 名前とタイトルにBBCodeからHTMLに変換する文字修飾機能を追加
# 2008/12/28 トピックス数が複数ページになる時のviewcountファイルの書込み方法をforum.cgiに倣って修正
# v1.10 携帯電話からのアクセスを可能とするため表示内容を修正 （2008/12/05 スガラボット修正)
# v1.03 掲示板のスレッド一覧ページで閲覧数要約ファイルの適用
# スガラボット掲示板一覧タイトル表示方法一部修正 (20081026 スガラボット修正)
# スガラボット修正 (Forum形式表示に対応した修正 Forum Patio v1.00M 2008/10/07)
# スガラボット修正 (SSIによる複数会議室対応) Forum Patio v0.98 2008/03/15)
# スガラボット修正 Forum Patio v1.00M
# 2008/03/03 Tree表示機能、トピックスと最新レスにリンク機能を追加
# 2007/05/19 掲示板の説明を追加
# 2007/01/22 着手

#use strict;
#use warnings;
#use Time::Local;
use utf8;

# 外部ファイル取り込み
require './init.cgi';
#require $jcode;

# SSIによる複数会議室対応かどうか (20080315 スガラボット修正)
if (!$patioshtml) { $patioshtml = $patiocgi; }
if (!$forumshtml) { $forumshtml = $forumcgi; }
if (!$readshtml) { $readshtml = $readcgi; }
if (!$bbsshtml) { $bbsshtml = $bbscgi; }

# BBCode処理の変数関数を選択 (2009/01/14 スガラボット修正)
#our $titlebb;
if ($bbcode) {
	$titlebb ="bbtitle";
	$combb = "bbcode2html";
} else {
	$titlebb = "titlebbrm";
	$combb = "bbcoderm";
}

&parse_form;

our ($width, $colspan);
# 携帯からのアクセスかどうかを判定
	# PCからアクセスした時。($ua=0 はPC 1～6は携帯)
	if ($ua) {
		$tree = 0;
		$width = "width=\"100%\"";
		$colspan = "colspan=\"7\"";
	} elsif ($treeforum) {
		$tree = 1;
		$width = "width=\"95%\"";
		$colspan = "colspan=\"8\"";
	} else {
		$tree = 0;
		$width = "width=\"95%\"";
		$colspan = "colspan=\"7\"";
	}

if ($mode eq "check") {
	require $checkpl;
	&check;
}
&axscheck;
if ($mode eq "find") {
	require $findpl;
	&find;
}
if ($in{'view'} eq "thread") {
	&threadview;
}
#elsif ($mode eq "enter_disp") { &enter_disp; }
#elsif ($mode eq "logoff") { &logoff; }
&indexview;

#-------------------------------------------------
#  掲示板全体メニューを表示
#-------------------------------------------------
sub indexview {
	local($alarm,$i,$data,$top,$count);
	local($st1,$st2,$newdisp);

	# アラーム数定義
	$alarm = int ( $m_max * 0.9 );

#	Salon da Musica の掲示板で処理がアップデートならクッキー送出処理を追加 (20080519 守田修正)
	&user_cookie;

	if ( $user_hdft ) {
		&header('', 'js', 1);
	} else {
		&header('', 'js', 0);
	}

# 本文タイトルを新規に追加した処理 (20080210守田修正)
	if ($body_title eq '') { $body_title=$title; }

# 各会議室にWebホームページがあればリンクを張る処理を追加 (20081009 スガラボット修正)
	@hpstat = stat("$roomdir/index.html");
	if ($hpstat[7] > 0) 
	{
		$hplink1 = "<a href=\"$room_url/index.html\">";
		$hplink2 = "&nbsp;&nbsp;←&lt;この掲示板のホームページへ&gt;</a>";
	}

# デバッグプリント
#	&error("Debug: room=$room_url, hpstat[7]=$hpstat[7], hpstatus=@hpstat<br>\n");

	$printString = <<"EOM";
<div align="center">
<table $width border="0" cellspacing="0" cellpadding="0">
<tr>
	<td align="left">$hplink1<b style="font-size:$t_size; color:$t_color">$body_title</b><b>$hplink2</b><br>
<small>$desc</small></td><td align="right">
EOM
print &strEncode($printString);

	print "<td>";
# Google AdSense
	&googleadsense;
	print "</td>";

	print <<"EOM";
</td>
EOM

	if ($authkey) {
		print &strEncode("<td align=\"right\">ようこそ、<b>${my_name}さん</b></td>\n");
	}

	print <<EOM;
	<td align="right">$countview<br><div style="margin-top: 4px;">
EOM

if($feed && !$ua) {
	print &strEncode("\t<img src=\"$imgurl/feed.gif\" border=\"0\" alt=\"FEEDアイコン\">\n");
	if($rss1patiofile) { print "\t<a href=\"$rss1patiourl\"><img src=\"$imgurl/RSS10.gif\" border=\"0\" alt=\"RSS1.0\"></a>\n"; }
	if($rss2patiofile) { print "\t<a href=\"$rss2patiourl\"><img src=\"$imgurl/RSS20.gif\" border=\"0\" alt=\"RSS2.0\"></a>\n"; }
	if($atompatiofile) { print "\t<a href=\"$atompatiourl\"><img src=\"$imgurl/ATOM10.gif\" border=\"0\" alt=\"ATOM1.0\"></a>\n"; }
}
	print <<EOM;
	</div></td></tr>
</table>
<table border="0" cellspacing="0" cellpadding="0" $width><tr>
  <td align="right" nowrap><div style="padding: 3px;">
EOM

	if (!$createonlyadmin) {
	$printString = <<EOM;
	 | <a href="$readshtml&mode=form">新規テーマで投稿</a>
EOM
print &strEncode($printString);
} else {
	$printString = <<EOM;
	 | スレッド作成制限中
EOM
print &strEncode($printString);
}

	if ($treeforum) {
	my $menu = defined($use_forum_menu) ? $use_forum_menu : 'Forum形式で表示';
	$printString = <<EOM;
	 | <a href="$forumshtml">$menu</a>
EOM
print &strEncode($printString);
}

	$printString = <<EOM;
	 | <a href="$home" target="_top">ホームに戻る</a>
	 | </font><a href="$notepage">留意事項</a>
	 | <a href="$bbsshtml&mode=find">ワード検索</a>
	 | <a href="$readshtml&mode=past">過去ログ</a> |
EOM
print &strEncode($printString);

	# 認証モードのとき
	if ($authkey) {
		print &strEncode(" <a href=\"$bbsshtml&mode=logoff\">ログオフ</a> |\n");
	}

	$printString = <<EOM;
 <a href="$admincgi">管理用</a> |</font></div></td>
</tr></table>
EOM
print &strEncode($printString);

#	ユーザ定義関数による表示があるときはここで実行する
	&user_func;
		
	# 閲覧専用モード

	if ( $ReadOnly ) {
	$printString = <<"EOM";
<table border="0" cellspacing="0" cellpadding="0" $width>
<tr><td>&nbsp;</td></tr>
<tr><td>
	<p align="left">$Oshirase</p>
</td></tr></table>
EOM
print &strEncode($printString);
	}

	$printString = <<EOM;
<form action="$script" method="POST">
<table border="0" cellspacing="0" cellpadding="0" $width>
<tr bgcolor="$col1">
<td align="left" bgcolor="$col1">
<div $bgclass style="padding: 3px; border: 1px solid $col1;">
<font color="$col6"><b>キーワード</b></font>
<input type=hidden name=mode value="find">
&nbsp;&nbsp;<input id="w220" type="text" name="word" value="">
<input type=submit value="検索実行">
<input type=hidden name=op value="AND">
<input type=hidden name=vw value="10">
<input type=hidden name=log value="0">
<input type=hidden name=s value="1">
<input type=hidden name=n value="1">
<input type=hidden name=c value="1">
</div>
</td>
</form>
</tr>
<tr><td bgcolor="$col2" align="center"><div style="padding: 3px; border: 1px solid $col1;">
<img src="$imgurl/foldnew.gif" alt="新規更新スレッド"> 新規更新スレッド &nbsp;&nbsp;
<img src="$imgurl/fold1.gif" alt="標準スレッド"> 標準スレッド &nbsp;&nbsp;
<img src="$imgurl/fold6.gif" alt="添付あり"> 添付あり &nbsp;&nbsp;
<img src="$imgurl/fold3.gif" alt="ロック中"> ロック中（書込不可）&nbsp;&nbsp;
<img src="$imgurl/fold4.gif" alt="FAQスレッド"> FAQ(優先)スレッド&nbsp;&nbsp;
<img src="$imgurl/fold5.gif" alt="アラーム"> アラーム（返信数$alarm件以上）&nbsp;&nbsp;
<img src="$imgurl/look.gif" alt="管理者メッセージ"> 管理者メッセージ
</div></td>
</tr>
</table>
<table border="0" cellspacing="0" cellpadding="6" $width>
<tr><td align="left">
<li> <img src=\"$imgurl/right_btn.gif\" alt="タイトル一覧"> をクリックするとスレッド内発言のタイトル一覧を表示します。
EOM
print &strEncode($printString);

# ツリー表示利用の手引きの記述(前の2行から後の5行)を追加
	if ($tree) {
		$printString = <<EOM;
<li> <img src=\"$imgurl/tree.gif\">または<img src=\"$imgurl/treerev2.gif\" alt=\"逆ツリー表示\">をクリックするとスレッド全体を
正順または逆順に${strong1}ツリー表示$strong2、<img src=\"$imgurl/upbutton1.gif\" alt=\"降順表示\"> はスレッド全体を新しい発言から降順に表示します。
EOM
print &strEncode($printString);
	}
	else {
		print &strEncode("<li> <img src=\"$imgurl/upbutton1.gif\" alt=\"降順表示\"> をクリックするとスレッド全体を新しい発言から降順に表示します。");
	}
	print <<EOM;
</td></tr></table>
EOM

# 新着記事一覧を表示する機能を追加に伴い、メニューインデックスのタイトルを表示 (2012/11/14 スガラボット修正)
	if ($newArticle) {
		# タイトル表示
		print "<table  border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width><tr><td nowrap>";
		print &strEncode("<tr><td align=\"left\" nowrap><b style=\"color:$t_color\">◆ トピックス(スレッド)別・投稿記事一覧 (タイトル･氏名の目次)</b></td></tr></table>\n");
		print "<p class=\"h4\"> </p>\n";
	}

	$printString = <<EOM;
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="4" $width>
<tr bgcolor="$col2">
  <td $bgclass align="left" bgcolor="$col1" $colspan>
	<font color="$col6"><b>スレッド一覧</b></font>
  </td>
</tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="20"><b>一覧</b></td>
  <td bgcolor="$col2" width="20"><b>閲覧</b></td>
EOM
print &strEncode($printString);
	if ($tree) {
		$printString = <<EOM;
  <td bgcolor="$col2" nowrap><b>ツリー<br>表示</b></td>
EOM
print &strEncode($printString);
	}
	$printString = <<EOM;
  <td bgcolor="$col2" width="70%" nowrap><b>トピックス</b></td>
  <td bgcolor="$col2" nowrap><b>作成者</b></td>
  <td bgcolor="$col2" nowrap><b>返信</b></td>
  <td bgcolor="$col2" nowrap><b>最終更新</b></td>
  <td bgcolor="$col2" nowrap><b>閲覧数</b></td>
EOM
print &strEncode($printString);

#  <td bgcolor="$col2" nowrap><b>最終更新</b></td>
	print <<EOM;
</tr>
EOM

	# 閲覧数要約ファイルを定義
	$countfile = "$datadir/viewcount.dat";
	# カウントファイルのフラグをクリア
	$cfile = 0;		

	# 各スレッドの閲覧数を要約したviewcountファイルをオープンして閲覧数を更新
	if(-e $countfile) {
		if(!open(CNT, "< $countfile"))  {&error("Open Error: $countfile."); }
		
		eval "flock(CNT, 2);";
		@cbuf = <CNT>;
		eval "flock(CNT, 8);";
		close(CNT);

		$cfile = 1;
		
		shift(@cbuf);
		$i = 0;
		foreach $cln (@cbuf) {
			chomp($cln);
			($tno[$i], $count[$i], undef) = split(/<>/, $cln);
			$tcount{$tno[$i]} = $count[$i];
			$i++;
		}
	}
	
	# スレッド表示
	if ($p eq "") { $p = 0; }
	$i = 0;
	open(IN,"$nowfile") || &error("Open Error: $nowfile");
#	$top = <IN>;
	$top = &lineDecode(IN);
#	while ( <IN> ) {
	while ( $_ = &lineDecode(IN) ) {
		$i++;
		# 新着記事を第1ページ目のスレッド一覧の下に表示する場合のページ数計算を導入 (2012/11/17 スガラボット修正)
		my $offset = $newArticle ? $menu3 : $menu1;
		my $offset1 = $p ? $offset : 0;
		my $multiple = $p ? ($p - 1) : 0;
		if ( $newArticle) {
			next if ($i < ($offset1 + $multiple * $menu1) + 1);
			next if ($i > ($offset + $p * $menu1));
		} else {
			next if ($i < $p * $menu1 + 1);
			next if ($i > $p * $menu1 + $menu1);
		}

		s/\n//;
		local($num,$sub,$res,$nam,$date,$na2,$key,$upl,$ressub,$restime) = split(/<>/);

		# 名前からトリップ表示を削除するかどうか (きりしまさんの掲示板を参考にして修正、2009/04/07 スガラボット)
		if ($patio_trip) {
			$nam =~ s/[◆◇].+//g;
			$na2 =~ s/[◆◇].+//g;
		}
		
		# もし閲覧数要約ファイル$countfileがなかったら従来通りno.datを読み込んで処理する
		if (!$tcount{$num}) {
			# 参照カウンタ読み込み
			open(NO,"$logdir/$num.dat");
			$data = <NO>;
			close(NO);
			($count[$i]) = split(/:/, $data);
			$tcount{$num} = $count[$i];
		}

		# アイコン定義
		if ($key eq '0' || $key eq '4') { $icon = 'fold3.gif'; }
		elsif ($key eq '3') { $icon = 'fold4.gif'; }
		elsif ($key eq '2') { $icon = 'look.gif'; }
		elsif ($res >= $alarm) { $icon = 'fold5.gif'; }
		elsif ($upl) { $icon = 'fold6.gif'; }
		elsif (time < $restime + $hot) { $icon = 'foldnew.gif'; }
		else { $icon = 'fold1.gif'; }

#		スレッド一覧からトリップを消したい場合有効にする
#		$nam =~ s/◆.+//g;
#		$na2 =~ s/◆.+//g;

		print "<tr bgcolor=\"$col1\"><th bgcolor=\"$col2\">\n";
		print "<a href=\"$patioshtml&view=thread&no=$num&tree=0\"><img src=\"$imgurl/right_btn.gif\" border=\"0\"></a></th>\n";
		print "<th bgcolor=\"$col2\"><a href=\"$readshtml&no=$num&tree=0\"><img src=\"$imgurl/$icon\" border=\"0\"></a></th>\n";
# ツリー表示のため以下の3行を追加
		if ($tree) {
			print "<td bgcolor=\"$col2\" align=\"center\"><a href=\"$readshtml&tree=1&no=$num\"><img src=\"$imgurl/tree.gif\" border=\"0\"></a>\n";
			print "<a href=\"$readshtml&tree=1&no=$num&l=rev\"><img src=\"$imgurl/treerev2.gif\" border=\"0\"></a></td>\n";
		}
		if (time >= $restime + $hot) { ($st1, $st2, $newdisp) = ''; }			#フラグをリセット
		else {
			$st1 = "<b>";
			$st2 = "</b>";
			$newdisp = $newmark;
		}
		print "<td align=\"left\" bgcolor=\"$col2\" width=\"70%\">\n";

# タイトルと名前に文字修飾機能追加 （2009/01/14 スガラボット修正)
		$sub = &$titlebb($sub);	
		$nam = &$titlebb($nam);	
		$ressub = &$titlebb($ressub);	
		$na2 = &$titlebb($na2);	
	
# ツリー表示のため以下の3行を追加
		if ($tree) {
			print &strEncode("<a href=\"$readshtml&tree=1&no=$num\">[$num] $st1$sub$st2</a> $newdisp\n");
		} else {
			print &strEncode("<a href=\"$readshtml&no=$num\">[$num] $st1$sub$st2</a> $newdisp\n");
		}
		if ($ressub) {
			# 最新レスをクリックしたときの表示を最新レスを先頭にツリーを逆順表示する
			print &strEncode("<br><font size=\"+1\">　</font><span class=s1>&nbsp;&nbsp;&nbsp;\n");
			print &strEncode("<a href=\"$readshtml&no=$num&l=new\"><img src=\"$imgurl/upbutton2.gif\" border=\"0\" alt=\"▲\"></a> \n");
			print &strEncode("<a href=\"$readshtml&no=$num&l=new\">$st1$ressub$st2</a> by $na2</span>\n");
		} else {
			print &strEncode("<br>　");
		}
		print "</td>";
		print &strEncode("<td align=\"left\" bgcolor=\"$col2\" nowrap>$nam</td>\n");
		print "<td bgcolor=\"$col2\" align=\"right\" nowrap class=\"num\">$res</td>\n";
		print "<td bgcolor=\"$col2\" align=\"right\" nowrap class=\"num\">$date</td>\n";
		print "<td bgcolor=\"$col2\" align=\"right\" nowrap class=\"num\">$tcount{$num}</td>\n";
		print "</td></tr>\n";
	}
	close(IN);

	print "</table>\n";

	# ページ移動ボタン表示
	my $page0 = $newArticle ? $menu3 : $menu1;
	if ($page0 < $i) {
		local($x,$y) = (1,0);
		print "<p><table $width><tr><td class=\"num\" align=\"left\"> Page: ";
		my $loop = 0;
		while ($i > 0) {
			if ($p == $y) {
				print "<b style=\"color:$pglog_col\">$x</b> |\n";
			} else {
				print "<a href=\"$patioshtml&p=$y\">$x</a> |\n";
			}
			$x++;
			$y++;
			$decrement = $loop ? $menu1 : $page0;
			$i -= $decrement;
			$loop++;
		}
		print "</td></tr></table>\n";
	}

# 新着記事一覧を表示する機能を追加 (2012/11/14 スガラボット修正)
	if ($newArticle && -e $feedlog && !$p ) {
		# feedlogを開いて上から順に新着記事表示数だけ抽出して記事を表示する
		my $FEED, @feed;
		open($FEED, "< $feedlog") || &error("Open Error: $feedlog");
		@feed = &arrayDecode($FEED);
		close($FEED);

		# タイトル表示
		print "<hr $width>";
		print "<table  border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width><tr><td nowrap>";
		print &strEncode("<tr><td align=\"left\" nowrap><b style=\"color:$t_color\">◆ 新着の投稿記事を新しいものから5個表示</b></td></tr></table>\n");
		print "<p class=\"h4\"> </p>\n";

		my @thread, @num, $end;
		$end = ( $newArticle >= $#feed ) ? $#feed : $newArticle;
		foreach my $n (1 .. $end) {
			($thread[$n], $num[$n]) = split(/<>/, $feed[$n]);
			&printArticle($thread[$n], $num[$n]);
			print "<p class=\"h10\"> </p>\n";
		}
	}

	# 著作権表示（削除不可）
	$printString = <<"EOM";
<br>
<!-- 著作権表示部・削除禁止 ($ver) -->
<span class="s1">
- <a href="http://www.kent-web.com/" target="_top">Web Patio</a> -
 <a href="http://kirishima.it/patio/" target="_top">きりしま式</a> -
 <a href="http://vmorita.com/bbs/patio/" target="_top">スガラボット版</a> -
 <a href="http://www.futomi.com/library/revocount.html" target="_top">RevoCounter</a> -
</span><br><br>
EOM
print &strEncode($printString);

	# Google AdSense
	&adsense_middle;

	print "</div>\n";

	&pr_footer;

	print "</div></body></html>\n";

	exit;
}

#-------------------------------------------------
#  掲示板全体メニューを表示
#-------------------------------------------------
sub threadview {
	local($alarm,$i,$data,$top,$count);
	local($st1,$st2,$newdisp);

# 検索語のハイライト表示のために追加 （2009/07/20 スガラボット追加)
our (@wd, $kijiop);
our $patioshtml0 = $patioshtml;
our $bbscgi0 = $bbscgi;

# スレッド閲覧ページからのダイナミックなRSSフィード購読機能を追加 （2009/10/27 スガラボット追加)
if ($in{'feed'} eq 'rss1' || $in{'feed'} eq 'rss2' || $in{'feed'} eq 'atom') {
	require $feedpl;
	my $max_feed = $t_rss{$in{'feed'}};
	&thread_feed($in{'feed'}, $in{'no'}, $max_feed);
	exit;
}

my ($keyword, $enwd);
if ($in{'hexwd'}) {
	my @hexword = split(/[\+\s]+/, $in{'hexwd'});
	$in{'hexwd'} =~ s/\s+/+/g;
	my @temp = @hexword;
	my $plus = '';
	foreach ( @temp ) {
		$_ = pack('H*', $_);
		$_ = &strDecode($_, $encode);
		push (@wd, $_);
		$keyword .= $plus . $_;
		$plus = ' ';
	}
	$in{'word'} = $keyword;

	$kijiop = $in{'kijiop'} ? "&kijiop=$in{'kijiop'}" : '';

# デバッグプリント
#	my $degubstr;
#	foreach (@wd) { $debugstr .= $_ . ', '; }
#	&error("Debug：:検索語の確認　\$charset=$charset, \$in{'hexwd'}=$in{'hexwd'}, \@wd=$debugstr, \$keyword=$keyword");

	# 次のページにリンクを張るときの検索語パラメータをURLエンコード
	$enwd = &strEncode($in{'word'});
	$enwd = &url_enc($in{'word'});	

	# ヒットしたときの閲覧ページへのリンクを定義
	my $linkparam0 = "hexwd=$in{'hexwd'}&vw=$in{'vw'}&op=$in{'op'}&log=$in{'log'}&s=$in{'s'}&n=$in{'n'}&c=$in{'c'}$kijiop";
	my $linkparam = '&' . $linkparam0;
	$readcgi = $readcgi . $linkparam;
	$readshtml = $readshtml . $linkparam;
	$bbscgi = $bbscgi . '&mode=find' . $linkparam;
	my $patioshtml1 = "$patioshtml&$linkparam0";
	$bbsshtml = $patioshtml1;

	# ヒットしたときの閲覧ページへのリンクを定義
#	if ($ua) {
#		$readshtml = $readcgi;
#	}

}

	# アラーム数定義
	$alarm = int ( $m_max * 0.9 );

	if ( $user_hdft ) {
		&header('', 'js', 1);
	} else {
		&header('', 'js', 0);
	}

# 本文タイトルを新規に追加した処理 (20080210守田修正)
	if ($body_title eq '') { $body_title=$title; }

# 各会議室にWebホームページがあればリンクを張る処理を追加 (20081009 スガラボット修正)
	@hpstat = stat("$roomdir/index.html");
	if ($hpstat[7] > 0) 
	{
		$hplink1 = "<a href=\"$room_url/index.html\">";
		$hplink2 = "&nbsp;&nbsp;←&lt;この掲示板のホームページへ&gt;</a>";
	}

# デバッグプリント
#	&error("Debug: room=$room_url, hpstat[7]=$hpstat[7], hpstatus=@hpstat<br>\n");

	$printString = <<"EOM";
<div align="center">
<table $width border="0" cellspacing="0" cellpadding="0">
<tr>
	<td align="left">$hplink1<b style="font-size:$t_size; color:$t_color">$body_title</b><b>$hplink2</b><br>
<small>$desc</small></td><td align="right">
EOM
print &strEncode($printString);

	print "<td>";
# Google AdSense
	&googleadsense;
	print "</td>";

	print <<"EOM";
</td>
EOM

	if ($authkey) {
		print &strEncode("<td align=\"right\">ようこそ、<b>${my_name}さん</b></td>\n");
	}

	print <<EOM;
	<td align="right"><div style="margin-top: 4px;">
EOM
if($feed && !$ua) {
	print &strEncode("\t<img src=\"$imgurl/feed.gif\" border=\"0\" alt=\"FEEDアイコン\">\n");
	if($t_rss{'rss1'}) { print "\t<a href=\"$patiocgi?view=thread&feed=rss1&no=$in{'no'}\"><img src=\"$imgurl/RSS10.gif\" border=\"0\" alt=\"RSS1.0\"\"></a>\n"; }
	if($t_rss{'rss2'}) { print "\t<a href=\"$patiocgi?view=thread&feed=rss2&no=$in{'no'}\"><img src=\"$imgurl/RSS20.gif\" border=\"0\" alt=\"RSS2.0\"\"></a>\n"; }
	if($t_rss{'atom'}) { print "\t<a href=\"$patiocgi?view=thread&feed=atom&no=$in{'no'}\"><img src=\"$imgurl/ATOM10.gif\" border=\"0\" alt=\"ATOM1.0\"\"></a>\n"; }
}
	print <<EOM;
	</div></td></tr>
</table>
<table border="0" cellspacing="0" cellpadding="0" $width><tr>
  <td align="right" nowrap><div style="padding: 3px;">
EOM

	# 検索トップに戻るを追加
	if ($in{'hexwd'}) {
	$printString = <<EOM;
	 | <a href="$bbscgi" target="_top">検索トップに戻る</a>
EOM
print &strEncode($printString);
	}

	if (!$createonlyadmin) {
	$printString = <<EOM;
	 | <a href="$readshtml&mode=form">新規テーマで投稿</a>
EOM
print &strEncode($printString);
} else {
	$printString = <<EOM;
	 | スレッド作成制限中
EOM
print &strEncode($printString);
}

	$printString = <<EOM;
	 | <a href="$bbscgi0" target="_top">トップページ</a>
	 | <a href="$home" target="_top">ホームに戻る</a>
	 | </font><a href="$notepage">留意事項</a>
	 | <a href="$bbsshtml&mode=find">ワード検索</a>
	 | <a href="$readshtml&mode=past">過去ログ</a> |
EOM
print &strEncode($printString);

	# 認証モードのとき
	if ($authkey) {
		print &strEncode(" <a href=\"$bbsshtml&mode=logoff\">ログオフ</a> |\n");
	}

	$printString = <<EOM;
 <a href="$admincgi">管理用</a> |</font></div></td>
</tr></table>
EOM
print &strEncode($printString);

	# 閲覧専用モード

	if ( $ReadOnly ) {
	$printString = <<"EOM";
<table border="0" cellspacing="0" cellpadding="0" $width>
<tr><td>&nbsp;</td></tr>
<tr><td>
	<p align="left">$Oshirase</p>
</td></tr></table>
EOM
print &strEncode($printString);
	}

	# スレッド読み込み
	open(IN, "$logdir/$in{'no'}.cgi") || &error("Open Error: $logdir/$in{'no'}.cgi");
#	@log = <IN>;
	my @log = &arrayDecode(IN);
    close(IN);

#	$top1 = $log[0];
	my $top1 = shift(@log);

	my ($no,$sub,$res,$key) = split(/<>/, $top1);

	my $tsub = $sub;
	$tsub = &$titlebb($tsub);
	$tsub = &highlight($tsub, \@wd) if (@wd && $in{'s'});

	# アイコン定義
	my $icon;
	if ($key eq '0' || $key eq '4') { $icon = 'fold3.gif'; }
	elsif ($key eq '3') { $icon = 'fold4.gif'; }
	elsif ($key eq '2') { $icon = 'look.gif'; }
	elsif ($res >= $alarm) { $icon = 'fold5.gif'; }
	elsif ($upl) { $icon = 'fold6.gif'; }
	elsif (time < $restime + $hot) { $icon = 'foldnew.gif'; }
	else { $icon = 'fold1.gif'; }

	# 検索ページトップむから起動されたときは、検索フォームを表示しない
	if (!$in{'hexwd'}) {
	$printString = <<EOM;
<form action="$script" method="POST">
<table border="0" cellspacing="0" cellpadding="0" $width>
<tr bgcolor="$col1">
<td align="left" bgcolor="$col1">
<div $bgclass style="padding: 3px; border: 1px solid $col1;">
<font color="$col6"><b>キーワード</b></font>
<input type=hidden name=mode value="find">
<input type=hidden name=view value="thread">
<input type=hidden name=no value="$in{'no'}">
&nbsp;&nbsp;<input id="w220" type="text" name="word" value="">
<input type=submit value="検索実行">
<input type=hidden name=op value="AND">
<input type=hidden name=vw value="10">
<input type=hidden name=log value="0">
<input type=hidden name=s value="1">
<input type=hidden name=n value="1">
<input type=hidden name=c value="1">
</div>
</td>
</form>
</tr>
</table>
EOM
print &strEncode($printString);
	}

	$printString = <<EOM;
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="6" $width>
<tr bgcolor="$col1">
<td $bgclass2 align="left" bgcolor="$col3" colspan="6">
<a href="$readshtml&mode=$mode&tree=0&no=$in{'no'}&l=all"><img src="$imgurl/$icon\" border="0"></a>
<b>スレッド$in{'no'}: $tsub</b>
</td></tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="20" align=center><b>No</b></td>
  <td bgcolor="$col2" width="70%" align=center><b>タイトル</b></td>
  <td bgcolor="$col2" align=center><b>作成者</b></td>
  <td bgcolor="$col2" align=center nowrap><b>返信先</b></td>
  <td bgcolor="$col2" align=center><b>最終更新</b></td>
</tr>
EOM
print &strEncode($printString);

	# スレッド一覧表示
	if ($p eq "") { $p = 0; }
	my $i = 0;

	# 各記事を展開
	my $line = 0;

	foreach my $buf ( @log ) {

		$i++;
		next if ($i < $p * $menu1 + 1);
		next if ($i > $p * $menu1 + $menu1);

		chomp($buf);

		my (@no, @sub, @nam, @com, @dat, @tim, @upl, @resto);
		($no[$line],$sub[$line],$nam[$line],undef,$com[$line],$dat[$line],undef,undef,undef,undef,
				undef,$tim[$line],$upl[1][$line],$upl[2][$line],$upl[3][$line],undef,undef,$resto[$line])  = split(/<>/, $buf);

		# 名前からトリップ表示を削除するかどうか (きりしまさんの掲示板を参考にして修正、2009/04/07 スガラボット)
		if ($patio_trip) {
			$nam[$line] =~ s/[◆◇].+//g;
		}

		# アイコン定義
		$icon;
		if (time < ($tim[$line] + $hot)) { $icon = 'filenew.gif'; }
		else { $icon = 'file.gif'; }

		# 添付ファイルのアイコン定義
		$res_icon = '';
		foreach my $k (1 .. 3) 
		{
			my($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl[$k][$line]);
			if ($ex) { $res_icon = "<img src=\"$imgurl/clipsls.gif\" border=\"0\"> "; last;}
		}

		# この記事に検索語が含まれるかをチェック
		my ($ktarget, $flg, $com_hit, $st1, $st2);
		$ktarget = $sub[$line] if ($in{'s'});
		$ktarget .= $nam[$line] if ($in{'n'});
		if ($in{'c'}) {
			$ktarget .= $com[$line];
			$ktarget .= $up[l][$line] . $upl[2][$line] . $upl[3][$line];
		}
		$flg = 0;
		foreach $wd (@wd) {
#			if (index($ktarget,$wd) >= 0) {
			if (&search($ktarget,$wd)) {
				$flg = 1;
				if ($in{'kijiop'} eq 'OR') { last; }
			} else {
				if ($in{'kijiop'} eq 'AND') { $flg = 0; last; }
			}
		}

		if ($flg) {
			$st1 = $strong1b;
			$st2 = $strong2b;
		}

		# タイトルと名前についても検索語をチェックしてそのレスを強調表示する
		if ($in{'c'}) {
			$ktarget = $com[$line];
			$ktarget .= $up[l][$line] . $upl[2][$line] . $upl[3][$line];

			foreach $wd (@wd) {
#				if (index($ktarget,$wd) >= 0) {
				if (&search($ktarget,$wd)) {
					$com_hit = " $strong1a<b>[本文で検索語ヒット]</b>$strong2a";
					last;
				}
			}
		}

		# タイトルと名前に文字修飾機能追加 （2009/01/12 スガラボット修正)
		$sub[$line] = &$titlebb($sub[$line]);
		$sub[$line] = &highlight($sub[$line], \@wd) if (@wd && $in{'s'});
		$nam[$line] = &$titlebb($nam[$line]);
		$nam[$line] = &highlight($nam[$line], \@wd) if (@wd && $in{'n'});
		

		print " <tr bgcolor=\"$col1\" class=\"num\"><td bgcolor=\"$col2\" align=\"right\">$no[$line]</td>\n";
		print " <td align=\"left\" bgcolor=\"$col2\"><a href=\"$readshtml&no=$in{'no'}&l=$no[$line]&tree=0&view=thread\"><img src=\"$imgurl/$icon\" border=\"0\"></a> \n";
		print &strEncode("$res_icon<a href=\"$readshtml&no=$in{'no'}&l=$no[$line]&tree=0&view=thread\"> $st1$sub[$line]$st2</a>$com_hit</td>\n");
		print &strEncode(" <td align=\"left\" bgcolor=\"$col2\" nowrap> $nam[$line]</td>\n");
		print " <td bgcolor=\"$col2\" align=\"right\" class=\"num\"> $resto[$line]</td>\n";
		print " <td bgcolor=\"$col2\" align=\"right\" nowrap class=\"num\"> $dat[$line]</td></tr>\n";

		$line++;
	}

	print "</table>\n";

	# ページ移動ボタン表示
	if ($menu1 < $i) {
		local($x,$y) = (1,0);
		print "<p><table $width><tr><td class=\"num\"> Page: ";
		while ($i > 0) {
			if ($p == $y) {
				print "<b style=\"color:$pglog_col\">$x</b> |\n";
			} else {
				print "<a href=\"$patioshtml&view=thread&no=$in{'no'}&p=$y\">$x</a> |\n";		# (2010/10/14 修正)Forum Patio No.51 スレッド 16-18 の記事で指摘のもの
			}
			$x++;
			$y++;
			$i -= $menu1;
		}
		print "</td></tr></table>\n";
	}

	# 著作権表示（削除不可）
	$printString = <<"EOM";
<br>
<!-- 著作権表示部・削除禁止 ($ver) -->
<span class="s1">
- <a href="http://www.kent-web.com/" target="_top">Web Patio</a> -
 <a href="http://kirishima.it/patio/" target="_top">きりしま式</a> -
 <a href="http://vmorita.com/bbs/patio/" target="_top">スガラボット版</a> -
 <a href="http://www.futomi.com/library/revocount.html" target="_top">RevoCounter</a> -
</span><br><br>
</div>
EOM
print &strEncode($printString);

	&pr_footer;

	print "</body></html>\n";

	exit;
}

#-------------------------------------------------
#  ログオフ
#-------------------------------------------------
sub logoff {
	unlink("$sesdir/$my_ckid.cgi");
	print "Set-Cookie: patio_member=;\n";

	&enter_disp;
}

#-------------------------------------------------
#  タイトルと名前にBBCode文字修飾機能を追加
#-------------------------------------------------
sub bbtitle {
	# BBCode を変換
	my $s = $_[0];
	if ($s !~ /\[(.*?)\]/) { return $s; }
	$s =~ s/([\x81-\x9F\xE0-\xFC].)/$1\0/g;
	$s =~ s/\[b\](.*?)\[\/b\]/<b>$1<\/b>/ig;
	$s =~ s/\[i\](.*?)\[\/i\]/<i>$1<\/i>/ig;
	$s =~ s/\[u\](.*?)\[\/u\]/<u>$1<\/u>/ig;
	$s =~ s/\[d\](.*?)\[\/d\]/<s>$1<\/s>/ig;
	$s =~ s/\[color=([A-Z]+|#[0-9A-F]{6})\](.*?)\[\/color\]/<font color="\L$1\E">$2<\/font>/ig;
	$s =~ s/\[size=([\+\-]?[1-7])\](.*?)\[\/size\]/<font size="$1">$2<\/font>/ig;
	$s =~ tr/\0//d;
	return $s;
}

#-------------------------------------------------
#  タイトルのBBCode文字修飾を削除するサブルーチン
#-------------------------------------------------
sub titlebbrm {
	# BBCode を変換
	my $s = $_[0];
	if ($s !~ /\[(.*?)\]/) { return $s; }
	$s =~ s/([\x81-\x9F\xE0-\xFC].)/$1\0/g;
	$s =~ s/\[b\](.*?)\[\/b\]/$1/ig;
	$s =~ s/\[i\](.*?)\[\/i\]/$1/ig;
	$s =~ s/\[u\](.*?)\[\/u\]/$1/ig;
	$s =~ s/\[d\](.*?)\[\/d\]/$1/ig;
	$s =~ s/\[color=([A-Z]+|#[0-9A-F]{6})\](.*?)\[\/color\]/$2/ig;
	$s =~ s/\[size=([\+\-]?[1-7])\](.*?)\[\/size\]/$2/ig;
	$s =~ tr/\0//d;
	return $s;
}

#-------------------------------------------------
#  時間取得
#-------------------------------------------------
sub time2date {
	my($time) = @_;
	my($min,$hour,$mday,$mon,$year) = (localtime($time))[1..5];

	# 日時のフォーマット
	my($date) = sprintf("%04d/%02d/%02d %02d:%02d",
				$year+1900,$mon+1,$mday,$hour,$min);
	return ($date);
}

