#!/usr/local/bin/perl
#┌─────────────────────────────────
#│ [ WebPatio ]
#│ patio.cgi - 2007/06/06
#│ Copyright (c) KentWeb
#│ webmaster@kent-web.com
#│ http://www.kent-web.com/
#└─────────────────────────────────

# きりしま式 K0.92相当
# 2013/02/14 v1.53 掲示板の記事を閲覧表示するときに UTF-8フラグが付いたまま文字列を出力し、"Wide character in print" が出力されるバグを修正
# 2013/02/14 v1.53 キーワード検索のハイライト処理で記事本文中のキーワードがハイライト表示されなくなっていたバグを修正
# 2013/02/14 v1.53 init.cgi で定義済の res_dsp(), res_dsp2() の二つのサブルーチンがこのスクリプトで二重定義されていたため削除した。
# 2010/12/17 ツリーインデックスでツリー逆順表示及びスレッド降順表示のアイコン位置を行の先頭に変更
# 2009/03/24 スレッド作成制限モードの追加・外部へのリンクに nofollow 追加。
# 2008/10/17 レス指定表示のバグ修正
# 2008/08/29 いったん一式アーカイブを更新
# 2008/04/15 メール送信フォームへのリンクのバグ修正
# 2008/01/09 過去ログのフラグになっているスレッドは、viewで呼び出しても過去ログとして表示
# 2007/10/27 レスの全部表示に取り組み
# 2007/06/10 3.2相当に修正
$kver = '_3.22_k0.92';
$sver = 'v1.53';
# 2012/11/15 patio/forum のインデックスページに新着記事を表示する機を実現するため、res_dsp, res_dsp2, auto_link, resize の各サブルーチンを read.cgi から init.cgiに移動した 
# 2012/02/12 UTF-8を連結した文字列 $print_str が一部 Wide_character されていたバグを修正 (3箇所)
# 2012/02/07 ユーザ定義ヘッダー対応のコラム背景画像クラスとユーザ定義フッターの印刷ルーチンを追加
# 2011/09/22 read.cgi で特定記事への返信をラジオボタンをクリックして行う場合の参照先記事番号のバグ修正と題名の引用をJavaScriptで選択できるよう修正
# 2010/11/30 過去ログ書庫アーカイブ閲覧機能を追加
# 2010/04/04 Image::magick を使用したときのリサイズ機能を修正
# 2010/02/12 携帯電話から閲覧時の記事表示数のバグを修正
# 2010/02/04 複数のGIF画像からなる投稿キーを Image::Magick を利用した投稿認証キーに変更
# 2009/08/01 返信ラジオボタンとJavaScript による投稿フォームジャンプなどを実装
# 2009/07/05 CGIスクリプトをUnicode記述に変更。HTML入出力とログファイルの文字コード(utf8,sjis,euc,jis)を設定可能
# 2009/05/12 スレッドテーマと新規投稿題名を別設定できるよう修正
# 			 $treeforum=0 (ツリー表示をしない) の時の表示方法を修正
# 2009/01/15 名前、タイトルと本文にBBCodeからHTMLに変換する機能を追加
# 2008/12/19 表示方法や記事指定方法などを整理
# 2008/12/09 携帯電話からのアクセス対応 (<table>タブの入れ子廃止、個別記事、範囲指定表示を改良 (2008/12/08 スガラボット)
# 2008/10/28 参照数を個々のin{'no'}.datだけではなくdata/viewcount.datファイルに記録することとした
# 2008/10/26 きりしま式のread_321k075.cgi に対応してスレッドの範囲指定修正他、20081026
# 2008/10/10 返信投稿にもファイルアップロード機能を追加してv1.00リリース
# 2008/03/20 過去ログにもツリー表示対応、ツリー表示から投稿したときはツリー表示に戻すようにした
# 2008/03/01 ツリー機能等追加の修正 (20080301 スガラボット)

#use strict;
#use warnings;
#use Time::Local;
use utf8;

# 外部ファイル取り込み
require './init.cgi';

# SSIによる複数会議室対応かどうか (20080315 スガラボット修正)
if (!$patioshtml) { $patioshtml = $patiocgi; }
if (!$forumshtml) { $forumshtml = $forumcgi; }
if (!$readshtml) { $readshtml = $readcgi; }
if (!$bbsshtml) { $bbsshtml = $bbscgi; }

# BBCode処理の変数関数を選択 (2009/01/14 スガラボット修正)
if ($bbcode) {
	$titlebb ="bbtitle";
	$combb = "bbcode2html";
} else {
	$titlebb = "titlebbrm";
	$combb = "bbcoderm";
}

&parse_form;
&axscheck;

# スレッド閲覧ページからのダイナミックなRSSフィード購読機能を追加 （2009/10/27 スガラボット追加)
if ($in{'feed'} eq 'rss1' || $in{'feed'} eq 'rss2' || $in{'feed'} eq 'atom') {
	require $feedpl;
	my $max_feed = $t_rss{$in{'feed'}};
	&thread_feed($in{'feed'}, $in{'no'}, $max_feed);
	exit;
}

# 検索語のハイライト表示のために追加 （2009/07/20 スガラボット追加)
our (@wd, $kijiop);
our $readshtml0 = $readshtml;
our $bbsshtml0 = $bbsshtml;
my ($keyword, $enwd);

if ($in{'hexwd'}) {
	my @hexword = split(/[\+\s]+/, $in{'hexwd'});
	$in{'hexwd'} =~ s/\s+/+/g;
	my @temp = @hexword;
	my $plus = '';
	foreach ( @temp ) {
		$_ = pack('H*', $_);
		$_ = &strDecode($_, $encode);
		push (@wd, $_);
		$keyword .= $plus . $_;
		$plus = ' ';
	}
	$in{'word'} = $keyword;

	$kijiop = $in{'kijiop'} ? "&kijiop=$in{'kijiop'}" : '';

# デバッグプリント
#	my $degubstr;
#	foreach (@wd) { $debugstr .= $_ . ', '; }
#	&error("Debug：:検索語の確認　\$charset=$charset, \$in{'hexwd'}=$in{'hexwd'}, \@wd=$debugstr, \$keyword=$keyword");

	# 次のページにリンクを張るときの検索語パラメータをURLエンコード
	$enwd = &strEncode($in{'word'});
	$enwd = &url_enc($in{'word'});	

	# ヒットしたときの閲覧ページへのリンクを定義
	my $linkparam0 = "hexwd=$in{'hexwd'}&vw=$in{'vw'}&op=$in{'op'}&log=$in{'log'}&s=$in{'s'}&n=$in{'n'}&c=$in{'c'}$kijiop";
	my $linkparam = '&' . $linkparam0;
	$readcgi = $readcgi . $linkparam;
	$readshtml = $readshtml . $linkparam;
	$bbscgi1 = $bbscgi . '&mode=find' . $linkparam;
	$patioshtml = "$bbsshtml&$linkparam0";
	$bbsshtml = "$bbsshtml&$linkparam0";

	# ヒットしたときの閲覧ページへのリンクを定義
#	if ($ua) {
#		$readshtml = $readcgi;
#	}

}

# 携帯電話からのアクセス時パラメータセット
if ($ua) { $width = "width=\"100%\""; }
else { $width = "width=\"95%\""; }

if ($mode eq "form") { &form; }
# のツリー表示機能を過去ログにも対応 (20080316 以下の1行を追加 by スガラボット)
elsif ($mode eq "past" && $in{'no'} && $tree == 1) { require $treeforum; &treeview('past'); }
elsif ($mode eq "past") { 
	if ($past_page_max_tno && -e $pastno_file && !$in{'delview'}) { &past_archive; }
	else { &past; }
}
elsif ($mode eq "view2") { &view2; }
elsif ($mode eq "mail") { &mailform; }
# トピックス毎のツリー表示機能を追加 (20080315 以下の1行を追加修正 by スガラボット)
elsif ($treeforum && ($mode eq "tree" || $tree == 1)) { require $treeforum; &treeview; }
&view;

#-------------------------------------------------
#  スレッド閲覧
#-------------------------------------------------
sub view {
#	local($no,$sub,$res,$key,$no2,$nam,$eml,$com,$dat,$ho,$pw,$url,$resub,$pno,$tmp);
	our($no,$sub,$res,$key,@no,@sub,@res,@key,@no2,@nam,@eml,@com,@dat,@ho,@pw,@url,@resub,@pno,@tmp,@s1,@s2);
	local($job) = @_;

	# アラームを定義
	our($alarm) = int ($m_max * 0.9);

	# スマイルアイコン定義
	if ($smile) {
		@s1 = split(/\s+/, $smile1);
		@s2 = split(/\s+/, $smile2);
	}

	# 汚染チェック
	$in{'no'} =~ s/\D//g;

	# 削除した退避ログを閲覧するモードを追加 （2009/03/27 スガラボット修正)
	if ($in{'delview'} == 1) {
		$logdir = "$delsave/log";
		$datadir = "$delsave/data";
		$upldir = "$delsave/upl";
		$uplurl = "$delsave_url/upl";
		$delview = '&delview=1';
		$job = "past";
	}

	# スレッド読み込み
	open(IN,"$logdir/$in{'no'}.cgi") || &error("Open Error: $in{'no'}.cgi");
#	$top1 = <IN>;
	$top1 = &lineDecode(IN);
	($no,$sub,$res,$key) = split(/<>/, $top1);

	if ($key eq '-1') {$job = "past";}

	# 過去ログ
	if ($job eq "past") {
		$bbsback = "mode=past";
		if (!$in{'delview'}) {
			$guid = "[<a href=\"$readshtml0&mode=past&tree=1\">過去ログ一覧</a>] <b>過去ログ閲覧</b>";
		} else {
			$guid = "[<a href=\"$readshtml0&mode=past&tree=1$delview\">消去退避ログ一覧</a>] <b>消去退避ログ閲覧</b>";
		}

	# 現行ログ
	} else {
		# 参照数カウント
		&viewcount;
		$bbsback = "";
		$guid = "[<a href=\"$readshtml0&mode=past&tree=1\">過去ログ</a>] <b>記事閲覧</b>";
	}

	# スレッド読み込み
#	@buf = <IN>;
	@buf = &arrayDecode(IN);
	local $line = 0;
	
	local (@no,@sub,@nam,@eml,@com,@dat,@ho,@pw,@url,@mvw,@myid,@tim,@upl,@idcrypt,@color,@resto);
	local (%lineno,@prnt,@chid,@prev,@next);
	foreach $buf (@buf) {
		chomp($buf);
	# 返信記事にもファイルアップロードを表示するように修正 (20080924 スガラボット修正)
		($no[$line],$sub[$line],$nam[$line],$eml[$line],$com[$line],$dat[$line],$ho[$line],$pw[$line],$url[$line],$mvw[$line],
				$myid[$line],$tim[$line],$upl[1][$line],$upl[2][$line],$upl[3][$line],$idcrypt[$line],$color[$line],$resto[$line])  = split(/<>/, $buf);
		$prnt[$line] = $resto[$line];

		# 飛び番を処理するために以下1行追加 （2009/11/20 スガラボット追加修正)
		$lineno{$no[$line]} = $line;

		$line++;
	}
	$num = $line;
	local $max_no = $no[$line - 1];

    close(IN);

	# スレッドタイトルとスレ親の題名を分離したことに因る処理追加→現行ログからスレッドタイトル読みだし （2009/05/02 スガラボット修正)
	our ($sub_dif, $sub0, $sub00);
	$sub0 = $sub;

	# スレッドタイトルとレス親の題名が異なる場合のフラグをセット
	if ($sub[0] ne $sub) {
		$sub_dif = 1;
	}

	# タイトルに文字修飾機能追加
	$sub = $sub00 = &$titlebb($sub);	

	$pno = $no;

	# タイトルにスレッド番号をつける
#	$sub="スレッド$in{'no'}: ".$sub;

	# アイコン定義
	if ($job ne "past" && $key eq '0') { $icon = 'fold3.gif'; }
	elsif ($job ne "past" && $key eq '4') { $icon = 'fold3.gif'; }
	elsif ($job ne "past" && $key eq '3') { $icon = 'fold4.gif'; }
	elsif ($job ne "past" && $key eq '2') { $icon = 'look.gif'; }
	elsif ($job ne "past" && $res >= $alarm) { $icon = 'fold5.gif'; }
#	elsif (time < $tim[0] + $hot) { $icon = 'foldnew.gif'; }
	else { $icon = 'fold1.gif'; }

	# ヘッダ
	$sub0 = &titlebbrm($sub0);
	if ($job eq "past") {
		if ( $user_hdft > 1 ) {
			&header($sub0, '', 1);
		} else {
			&header($sub0, '', 0);
		}
	} else {
		if ( $user_hdft > 1 ) {
			&header($sub0, 'js', 1);
		} else {
			&header($sub0, 'js', 0);
		}
	}
# デバッグプリント
#	&error("bbscgi=$bbscgi");

# Google AdSense
	&googleadsense;

	$printString = <<"EOM";
<div align="center">
<table border="0" cellspacing="0" cellpadding="0" $width><Tr>
<td width="20%" align="left"><b style="font-size:$t_size; color:$t_color">$forum_title</b></Td>
<td align="right" width="80%" valign="buttom">
[<a href="$home">ホームに戻る</a>]
EOM
print &strEncode($printString);

	if ($in{'view'} eq 'thread') {
	$printString = <<"EOM";
[<a href="$bbsshtml&view=thread&no=$in{'no'}">記事タイトル一覧に戻る</a>]
EOM
print &strEncode($printString);
	}

	if ($in{'hexwd'}) {
	$printString = <<"EOM";
[<a href="$bbsshtml&mode=find">検索トップに戻る</a>]
EOM
print &strEncode($printString);
	}

	$printString = <<"EOM";
[<a href="$bbsshtml">スレッド一覧</a>]
[<a href="$readshtml0&mode=form&tree=1">新規投稿</a>]
[<a href="$notepage">留意事項</a>]
[<a href="$bbsshtml&mode=find">ワード検索</a>]
EOM
print &strEncode($printString);

	# 認証モードのとき
	if ($authkey) {
		print &strEncode("[<a href=\"$bbsshtml&mode=logoff\">ログオフ</a>]\n");
	}

	$printString = <<EOM;
[<a href="$admincgi">管理用</a>]
$guid
</td></tr></table>
EOM
print &strEncode($printString);

#	print "<p>";
	print "<hr $width>\n";

	if ($key eq '0') {
		print "<table $width><tr><td align=\"left\">";
		print "<img src=\"$imgurl/alarm.gif\"> ";
		print &strEncode("このスレッドは<b>ロック</b>されています。");
		print &strEncode("記事の閲覧のみとなります。</td></tr></table>\n");

	} elsif ($key == 2) {
		print "<table $width><tr><td align=\"left\">";
		print "<img src=\"$imgurl/alarm.gif\"> ";
		print &strEncode("このスレッドは<b>管理者からのメッセージ</b>です。");
		print "</td></tr></table>\n";

	} elsif ($key eq '4') {
		print "<table $width><tr><td align=\"left\">";
		print "<img src=\"$imgurl/alarm.gif\"> ";
		print &strEncode("このスレッドは<b>管理者によりロック</b>されています。");
		print &strEncode("記事の閲覧のみとなります。</td></tr></table>\n");

	} elsif ($alarm <= $res) {
		print "<table $width><tr><td align=\"left\">";
		print "<img src=\"$imgurl/alarm.gif\"> ";
		print &strEncode("返信記事数が<b>$res</b>件あります。");
		print &strEncode("<b>$m_max</b>件を超えると書き込みができなくなります。");
		print "</td></tr></table>\n";
	}

# ツリー構造のリンクリストを作成するためトピックスのログファイルを一度全部読み込む。
	local $prnt[0] = 0;
	local $chid[0] = 0;

	local $no[0] = 0;

# list edit: 双方向リスト編集処理
#   prnt: 親ノード (parent node)
#   chid: 子ノード (child node)
#   next: 次ノード (兄弟リンクのnext node)
#   prev: 前ノード (兄弟リンクのprevious node)

# ツリー構造のインデックス・リストを作成
#	for ($line = 0; $line < $num; $line++) {
#		&lst_cre($line, $prnt[$line], $no[$line]);
#	}

######## デバッグ用にtree テーブルの表示
#	print "<div align=\"left\">line &nbsp;no,prnt,chid,next,prev<br>\n";
#	for ($line = 0; $line < $num; $line++) {
#	    printf("% 4d,% 4d,% 4d,% 4d,% 4d,% 4d, %50s<br>\n", $line, $no[$line],
#	        $prnt[$line], $chid[$line], $next[$line], $prev[$line], $sub[$line]);
#	}
#	print "<br>\n";
#
#	# デバッグ用にtree 行番号逆引きテーブル表示
#	$ln = $no[-1] + 1;
#	for ($line = 0; $line < $ln; $line++) {
#	    printf("%4d,%4d<br>\n", $line, $lineno[$line]);
#	}
#	print "</div>\n";

# 全部表示
#	print "p=$p l=$l from=$from to=$to";

# 全表示と逆順フラグをセット （2008/12/15 スガラボット修正)
	local $all = $in{'all'};
	local $rev = $in{'rev'};

	local ($from, $to);
	# 管理者メッセージの時は全部表示
	if ($key == 2) { $all = 1; }
#	if ($l eq '0') { $from = 0; $to = 0; }
	if ($l eq '' || $l eq '0-') { $l = "all"; $from = 0; }
	# 範囲指定に'-'がない場合をチェック
	my $flag;
	local ($fromno,$tono);
	if ($l =~ /\-/) { $flag = 1; }
	if (!$flag && ($l =~ /^\d+$/)) {
#		$from=$l; $to=$l; $only=1;
		$from=$lineno{$l}; $to=$lineno{$l}; $only=1;
	} else {
		# 範囲指定表示
		($fromno,$tono) = split(/\-/,$l);
		if (!$fromno) { $fromno = $no[0]; $from = 0; }
		if (!$tono) { $to = $line - 1; $tono = $no[$to], }
		if ($fromno > $tono) { my $tmp = $lineno{$tono}; $to = $lineno{$fromno}; $from = $tmp; }
		else { $from = $lineno{$fromno}; $to = $lineno{$tono}; }
	}
	
	# resパラメータで指定があったとき
#	if ($in{'res'} && !$from) { $from = $in{'res'}; $to =  $in{'res'}; }
	if ($in{'res'}) { $from = $lineno{$in{'res'}}; $to =  $lineno{$in{'res'}}; }

	if ($to eq ''){ $to = $num - 1; }
	if ($from eq ''){ $from = 0; }

	# 記事番号を行番号に変換する必要がある (2008/12/15 スガラボット修正)
#	$from = $lineno[$from];
#	$to = $lineno[$to];

	# "l=new"の時は前記事を逆順表示とする。（2009/11/13 スガラボット変更修正)
	if ($l eq "new") { 
		$l = 'all'; 
		$rev = 1;
	}

	# "l=all"の時はスレッド全体を投稿順に表示する。（2008/12/15 スガラボット修正)
	if ($l eq "all") { 
		$from = 0; 
		$to = $num - 1; 
	}

	# "l=rev"の時はスレッド全体を新しい記事から降順に表示する。（2008/12/15 スガラボット修正)
	if ($l eq "rev") { 
		$rev = 1;
		$from = 0; 
		$to = $num - 1; 
	}
	if ($p eq "") { $p = 1; }

# デバッグプリント
#	print &strEncode("all=$all, Page処理前: from=$from, to=$to, num=$num<br>\n");

	# ページ繰越ボタンの新しい定義 （2008/11/30 スガラボット修正)
	# 携帯からの閲覧時は、1ページの閲覧数を変更する （2009/11/13 スガラボット追加)
	if ( $ua ) { $t_max = $kt_max; }

	$dispnum = $to - $from + 1;
	our ($pglog, $pglogu);
	if ($p eq "") { $p = 1; }
	if ($dispnum > 0) {
		$end = $dispnum / $t_max;
		$pagecnt = ($end > 1) ? 1 : 0;
		if ($end > int($end)) { $end = int($end) + 1; }
	} else {
		$end=int($end);
	}
	
	if ($key != 2) {
		$pglog = &pagelink($end, $p);
	}

# デバッグプリント
#	print "\$fromno=$fromno, \$tono=$tono, \$lineno{\$fromno}=$lineno{$fromno}, \$lineno{\$tono}=$lineno{$tono}, dispnum=$dispnum, from=$from, to=$to<br>\n";

	# 携帯からの閲覧のときは$allフラグは0とする (2009/12/01 スガラボット追加修正)
	if ($ua) { $all = 0; }

	# 表示範囲を定義
	local $pgfrom;
	if ( $t_max == 1 ) {			# 1ページあたりの表示数が1記事のとき
		if (!$rev) {
			$from = $from + $p - 1;
			$to   = $from;
		} else {
			$from = $to - $p + 1;
			$to = $from;
		}
	} else {						# 1ページあたりの表示数が複数のとき
		if (!$all && !$rev) {
			$pgfrom = $to - ($t_max * $p) + 1;
			if ($from < $pgfrom) {
				$from = $pgfrom;
				$to   = $from + $t_max - 1;
			}
			else {
				if ($to > ($to - $t_max * ($p - 1))) {
					$to = $to - $t_max * ($p - 1);
				}
			}
		} elsif (!$all && $rev) {
			$from = $to - ($t_max * $p) + 1;
			$to = $from + $t_max - 1;
			if ($from < 0) {
				$from = 0;
			}
		}
	}

# デバッグプリント
#	print "l=$l, key=$key, all=$all, dispnum=$dispnum, Original: from=$from, to=$to<br>\n";
#	print &strEncode("all=$all, Page処理後: from=$from, to=$to, num=$num<br>\n");

	$spacer_h4 = "<img src=\"$imgurl/spacer_h4.gif\">";
	$t_write = 0;
	if (($num > 0) && ($from >= 0)) {

		# 表示タイトルの選択
		if ($l eq "rev") {
			$t_msg = "◆ スレッド全体を新しい記事から降順に表示";
		}
		elsif ($l eq "all") {
			$t_msg = "◆ スレッド全体を投稿順に表示";
		}
		elsif ($rev) {
			unless ($to == $from) { $plural = "新しいものから降順に"; }
			$t_msg = "◆ 選択された記事を${plural}表示";
		}
		else {
			unless ($to == $from) { $plural = "投稿順に"; }
			$t_msg = "◆ 選択された記事を${plural}表示";
		}

		print "<div align=\"center\">";
		print "<table  border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width><tr><td align=\"left\" nowrap>";
		print &strEncode("<b style=\"color:$t_color\"> $t_msg</b></td>\n");
		if ($pglogu) { print &strEncode("<td nowrap align=\"right\">$pglogu</td>\n"); }
		print "</tr><tr hight=\"4\"><td colspan=\"2\" $width>$spacer_h4</td></tr></table>\n";
	}

# デバッグプリント
#print $enwd . '<br>';
#print &strEncode($readcgi . '<br>');
		
	# 以下のform宣言文は各記事の「この発言に返信」のラジオボタンを有効にするために、form文から移動した （2009/07/31 スガラボット修正)

	if ($job ne "past" && ($key == 1 || $key == 3)) {
		# この記事に返信のJavaScriptを埋込み

		print <<EOM;
<script type="text/javascript">
<!--
function resnum(parts){
	f = parts.form;
	number = parts.value;
	f.resto.value = number;
	window.location='#form';
}
function restitle(str) {
	document.myFORM.sub.value = str;
	window.location='#form';
}
// -->
</script>
EOM

		if ($image_upl && !$ua) {
			print &strEncode(qq|<form action="$registcgi" method="post" name="myFORM" enctype="multipart/form-data">\n|);
		} else {
			print &strEncode(qq|<form action="$registcgi" method="post" name="myFORM">\n|);
		}
	}

	# スレッドテーマがレス親発言と異なるときの表示変更のための表示フラグリセット
	our $done = 0;
	our @res_sub;				# 返信のタイトルだけ引用参照するための変更 （2011/09/10 スガラボット修正)	

	# トップに返信のラジオボタンをクリックした時、タイトルへの参照を JavaScript に渡す処理を追加 （2011/10/15 スガラボット修正)
	&res_dsp2(0, '', 1);

	# 逆順表示を追加 (2008/12/15 スガラボット修正)
	if ($rev) { $i = $num - 1; } 
	else { $i = 0; }

	while ((0 <= $i) && ($i < $num)) {

# デバッグプリント
#		print "i=$i, rev=$rev, from=$from, to=$to, num=$num<br>\n";

		if (($i < $from) || ($i > $to)) {
# デバッグプリント
#			print &strEncode("Debug: nextでスキップ、i=$i, rev=$rev, from=$from, to=$to, num=$num<br>\n");

			# 逆順表示を追加 (2008/12/15 スガラボット修正)
			if ($rev) { $i--; }
			else { $i++; }
			next;
		}

		# 個別記事印刷サブルーチンをコール
		our ($resub, $rescom);
		&res_dsp($i);

		# 逆順表示を追加 (2008/12/15 スガラボット修正)
		if ($rev) { $i--; }
		else { $i++; }

	}	# whileブロックの終わり

	print "<p>\n";

	$pglog = &pagelink($end, $p);
	print "<table $width><tr><td class=\"num\" align=\"left\">";
	print &strEncode($pglog);

	&form2 if ($job ne "past" && ($key == 1 || $key == 3));

	print "</div>\n";

	&pr_footer;

	print "</body></html>\n";

	exit;
}

#-------------------------------------------------
#  個別記事閲覧
#-------------------------------------------------
sub view2 {
	# スマイルアイコン定義
	if ($smile) {
		@s1 = split(/\s+/, $smile1);
		@s2 = split(/\s+/, $smile2);
	}

# viewとのパラメータ互換性確保 (2008/12/12 スガラボット修正)
	if (!$in{'f'}) {
		$in{'f'} = $in{'no'};
		$in{'no'} = $l;
	}
	if (!$in{'no'}) { $in{'no'} = 0; }

	# 汚染チェック
	$in{'f'}  =~ s/\D//g;

	# 記事No認識
	if ($in{'no'} =~ /^\d+$/) { $ptn = 1; $start = $in{'no'}; }
	elsif ($in{'no'} =~ /^(\d+)\-$/) { $ptn = 2; $start = $1; }
	elsif ($in{'no'} =~ /^(\d+)\-(\d+)$/) { $ptn = 3; $start = $1; $end = $2; }
	# 記事Noが"-N"のパターンを追加 （2008/12/12 スガラボット修正)
	elsif ($in{'no'} =~ /^\-(\d+)$/) { $ptn = 4; $start = 0; $end = $1; }
	else { &error("記事Noが不正です"); }

	unless (-e "$logdir/$in{'f'}\.cgi") {
		 &error("スレッドが見当たりません");
	}

	if ( $user_hdft > 1 ) {
		&header($sub, '', 1);
	} else {
		&header($sub, '', 0);
	}
	print <<"EOM";
<div align="center">
EOM

	local($line, $flag, $top, $link, $prelink, $nextlink, $last_flg);
	open(IN,"$logdir/$in{'f'}.cgi");
	$line = 0;
#	$top = <IN>;
	$top = &lineDecode(IN);
	($tno,$tsub,$res,$key) = split(/<>/, $top);
	local $sub_dif;

	# アイコン定義
	if ($job ne "past" && $key eq '0') { $icon = 'fold3.gif'; }
	elsif ($job ne "past" && $key eq '4') { $icon = 'fold3.gif'; }
	elsif ($job ne "past" && $key eq '3') { $icon = 'fold4.gif'; }
	elsif ($job ne "past" && $key eq '2') { $icon = 'look.gif'; }
	elsif ($job ne "past" && $res >= $alarm) { $icon = 'fold5.gif'; }
#	elsif (time < $tim[0] + $hot) { $icon = 'foldnew.gif'; }
	else { $icon = 'fold1.gif'; }

	my $kijiCount = 0;
	while ( $_ = &lineDecode(IN) ) {
		# 行数カウントを追加 （2008/12/12 スガラボット修正)
		$line++;
		# 本文文字色指定機能及びレス指定発言追加、返信記事にも画像表示を追加
		($no,$sub,$nam,$eml,$com,$dat,$ho,$pw,$url,$mvw,$myid,$tim,$upl{1},$upl{2},$upl{3},$idcrypt,$color) = split(/<>/);

		# スレッドタイトルとスレ親の題名を分離したことに因る処理追加→現行ログからスレッドタイトル読みだし （2009/05/02 スガラボット修正)
		if ($line == 1 && $tsub ne $sub) {
			$sub_dif = 1;
			# タイトルに文字修飾機能追加
			$tsub = &$titlebb($tsub);	
		}

		if ($start == $no) { 
			$flag=1;
			print "<table bgcolor=\"$col1\" cellspacing=\"1\" cellpadding=\"5\" $width>\n";
		}
		# ループの途中抜けを廃止したため$last_flg処理を追加
		if (!$flag || $last_flg) { next; }

		# タイトルと名前に検索語のハイライト表示を追加 （2009/07/19 スガラボット修正)
		$sub = &highlight($sub, \@wd) if (@wd && $in{'s'});	
		$nam = &highlight($nam, \@wd) if (@wd && $in{'n'});	

		# タイトルと名前に文字修飾機能追加 （2009/01/12 スガラボット修正)
		$sub = &$titlebb($sub);	
		$nam = &$titlebb($nam);	

		# 「>」に色づけ
		$com =~ s/([\>]|^)(&gt;[^<]*)/$1<font color=$quotecol>$2<\/font>/g;
		# 「*」に色づけ
		$com =~ s/([\>]|^)(\*[^<]*)/$1<font color=$quotecol2>$2<\/font>/g;

		# BBCodeをHTMLに変換 （2009/01/11 スガラボット修正)
		$com = &$combb($com, $tim, $ex[1], $ex[2], $ex[3]);

		# 検索結果を表示する場合は検索語をハイライト（2009/07/19 スガラボット追加)
		$com = &highlight($com, \@wd) if (@wd && $in{'c'}) ;

		# スレッドテーマがレス親の題名と異なるときはスレッドテーマを表示（2009/105/02 スガラボット修正)
		if (!$kijiCount && $sub_dif) {
			print "<tr bgcolor=\"$col2\"><td align=\"left\" bgcolor=\"$col1\"><a href=\"$readcgi&mode=$mode&tree=0&no=$in{'no'}$delview\"><img src=\"$imgurl/$icon\" border=\"0\"></a>" . 
					"<a href=\"$readcgi&mode=$mode&tree=1&no=$in{'no'}&l=all$delview\"><img src=\"$imgurl/tree.gif\" border=\"0\"></a>";
			print &strEncode("<font color=\"$col6\"> <b>$tsub</b></font></td></tr>\n");
		}
		$kijiCount++;

		# 記事表示
		print "<tr bgcolor=\"$col1\"><td align=\"left\" bgcolor=\"$col3\" $width>";
		print "<a href=\"$readcgi&mode=$mode&no=$in{'f'}&l=$no\"><img src=\"$imgurl/file.gif\" border=\"0\"></a>";
		print &strEncode(" <b>$sub</b> ");
		print "<span class=num>( No.$no )</span></td></tr>\n";
		print "<tr bgcolor=\"$col1\"><td align=\"left\" bgcolor=\"$col2\">";
		print &strEncode("<dl><dt>日時： $dat<dt>名前： <b>$nam</b>");

		if ($eml && $mvw ne '0' && $show_mail==1) {
			print "&nbsp; &lt;<a href=\"mailto:$eml\" class=\"num\">$eml</a>&gt;\n";
		}

		# IDを表示
		if($idkey) { print &strEncode(" ID:$idcrypt"); }

		# メール送信フォームへのリンク
		if ($eml) {
			$printString = <<"EOM";
 <a href="$readcgi&mode=mail&job=form&f=$in{'no'}&no=$no"><img src="$imgurl/mail.gif" alt="メールを送信する" width="16" height="13" border="0"></a>
EOM
print &strEncode($printString);
		}

		if ($url) {
			print &strEncode("<dt>参照： <a href=\"$url\" target=\"_blank\" rel=\"nofollow\">$url</a>\n");
		}

		# 「>」に色づけ
		$com =~ s/([\>]|^)(&gt;[^<]*)/$1<font color=$quotecol>$2<\/font>/g;
		# 「*」に色づけ
		$com =~ s/([\>]|^)(\*[^<]*)/$1<font color=$quotecol2>$2<\/font>/g;

		# 本文印刷色の色指定機能追加 （20080210守田修正)
		if ($color) { $com = "<font color=\"$color\">" . $com . "</font>"; }

		$com = &auto_link($com, $in{'f'});

		# BBCodeをHTMLに変換 （2009/01/11 スガラボット修正)
		$com = &$combb($com, $tim, $ex[1], $ex[2], $ex[3]);

		# <br>のあとに改行コードを付加
		$com =~ s/<br>/<br>\n/g;

		# 返信記事にも画像表示を表示するよう以下40行を追加
		print &strEncode("<br><br>\n<dd>$com\n");

		local($dd_flg) = 0;

		foreach $n (1 .. 3) {
			# 記録されたアップロードファイル情報を抽出
			local($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl{$n});
			next if (!$ex);

			if (!$dd_flg && !$ua) {
			# PCブラウザの場合画像やダウンロードファイルを表示する領域をテープルとして処理
			print "<dd><table border=\"0\" cellspacing=\"10\" cellpadding=\"0\"><tr>";
			$dd_flg++;
			}
			if (!$ua) {
				print "<td align=\"center\" valign=\"top\">";
			} else {
				print "<dd>";
			}

			if (defined($imgex{$ex})) {
				local($w, $h, $thumb_use) = &resize($w, $h);
				print &strEncode("<b>$n. $filetitle</b><br><a href=\"$uplurl/$tim-$n$ex\" target=\"_blank\">\n");
				if (!$ua) {
					if ($thumb_use) { print "<img src=\"$uplurl/$tim-s$n$ex\" align=\"top\" border=\"0\" hspace=\"3\" vspace=\"5\">"; }
					else { print "<img src=\"$uplurl/$tim-$n$ex\" align=\"top\" border=\"0\" width=\"$w\" height=\"$h\" hspace=\"3\" vspace=\"5\">"; }
				} else {
					if ($thumb_use && !$kimg_noview) { print "<img src=\"$uplurl/$tim-t$n$ex\" align=\"top\" border=\"0\" hspace=\"3\" vspace=\"5\">"; }
					else { print "<img src=\"$imgurl/click.gif\" align=\"top\" border=\"0\" hspace=\"3\" vspace=\"5\">"; }
				}
				print &strEncode("<br>-クリックすると元画像を表示-</a>\n");
			} else {
				# ファイルダウンロードの場合は、リンクに埋込むファイル名をURLエンコードする。(20080218 以下の3行を追加)
				my $str = Unicode::Japanese->new($filename, $logchar);
				my $urlenc_name = $str->conv($charset);
				$urlenc_name =~ s/([^\w ])/'%' . unpack('H2', $1)/eg;
				$urlenc_name =~ tr/ /+/; 
    
				print &strEncode("<b>$n. $filetitle</b><br><a href=\"$downcgi&bfile=$tim-$n$ex&fn=$urlenc_name\">\n");
				print &strEncode("<img src=\"$imgurl/pc_20_01.gif\" align=\"top\" border=\"0\" hspace=\"3\" vspace=\"5\"><br>$filename</a>\n");
			}

			if (!$ua) {
				print "</td>\n";
			} else {
				print "</dd><br><br>\n";
			}
		}
		if ($dd_flg && !$ua) {
			print "</tr></table>";
		}
		print "</dl><br></td></tr>\n";

		# ページリンクを張る関係でループを最後まで廻すために途中でブレークしないよう修正
#		if (($ptn == 3 && $end == $no) || ($flag && $ptn == 1)) { last; }
		if (($ptn == 3 && $end == $no) || ($flag && $ptn == 1)) { $last_flg = 1; }
	}
	close(IN);
	# 行数はスレッドの元記事からカウントしたため記事番号の最大は一つ少ない番号
	print "</table>\n";

	$line--;

	if (!$flag) {
		print "<table bgcolor=\"$col1\" cellspacing=\"1\" cellpadding=\"5\">\n";
		print "<tr bgcolor=\"$col1\"><th bgcolor=\"$col2\">";
		print &strEncode("<font color=\"red\">記事が見当たりません</font></th></tr></table>\n");
	}

	# 前の記事へのリンク
	if ($in{'no'} >= 1) {
		$link = $in{'no'} - 1;
		$prelink = "&lt;<a href=\"$readshtml&mode=view2&f=$in{'f'}&no=$link\">前の記事を表示</a>&gt; &nbsp;";
	}
	# 次の記事へのリンク
	if ($in{'no'} < $line) {
		$link = $in{'no'} + 1;
		$nextlink = "&lt;<a href=\"$readshtml&mode=view2&f=$in{'f'}&no=$link\">次の記事を表示</a>&gt; &nbsp;";
	}

	$printString = <<"EOM";
<br>
<p>
<table $width><tr><td align="left">
$prelink
$nextlink
&lt;<a href="$bbscgi">スレッド一覧に戻る</a>&gt; &nbsp; 
&lt;<a href="$readshtml&no=$in{'f'}">このスレッドを全部表示</a>&gt;
</td></tr></table>
</div>
EOM
print &strEncode($printString);

	&pr_footer;

	print "</body></html>\n";

	exit;
}

#-------------------------------------------------
#  過去ログ閲覧
#-------------------------------------------------
sub past {

	# 削除した退避ログを閲覧するモードを追加 （2009/03/27 スガラボット修正)
	my $ttitle = '過去ログ';
	if ($in{'delview'} == 1) {
		$pastfile = "$delsave/data/index.log";
		$logdir = "$delsave/log";
		$datadir = "$delsave/data";
		$upldir = "$delsave/upl";
		$uplurl = "$delsave_url/upl";
		$delview = '&delview=1';
		$ttitle = '削除退避ログ';
	}

	# 記事閲覧
	if ($in{'no'}) { &view("past");	}

	if ( $user_hdft > 1 ) {
		&header('', '', 1);
	} else {
		&header('', '', 0);
	}
	$printString = <<"EOM";
<div align="center">
<table $width><tr><td align="right" nowrap>
<a href="$bbscgi">トップページ</a> &gt; $ttitle
</td></tr></table>
<table bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col3"><td align=\"left\" bgcolor="$col3" nowrap width="92%">
<img src="$imgurl/memo1.gif" align="middle">
&nbsp;<b>$ttitle</b></td>
</tr></table>
EOM
print &strEncode($printString);

# ツリー表示利用の手引きの記述(前の2行から後の5行)を追加 (20080301 スガラボット修正)
	if ($treeforum) {
		$printString = <<EOM;
<Table border=0 cellspacing=0 cellpadding=4 width="95%">
<Tr><Td align=\"left\">
<li> 「ツリー表示」欄の<img src=\"$imgurl/tree.gif\">をクリックするとトピックス毎に
Forum形式で記事の参照関係が$strong1ツリー表示$strong2されます
</Td></Tr></Table>
EOM
print &strEncode($printString);
	}
	else { print "<pr>"; }
	print <<EOM;
<table bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="16"><br></td>
EOM
	if ($treeforum) {
		$printString = <<EOM;
  <td bgcolor="$col2" nowrap><b><span style=\"font-size:9px\">ツリー<br>表示</b></span></td>
EOM
print &strEncode($printString);
	}
	$printString = <<EOM;
  <td bgcolor="$col2" width="80%"><b>スレッド</b></td>
  <td bgcolor="$col2" nowrap><b>投稿者</b></td>
  <td bgcolor="$col2" nowrap><b>返信数</b></td>
  <td bgcolor="$col2" nowrap><b>最終更新</b></td>
</tr>
EOM
print &strEncode($printString);

	# スレッド展開
	local($i) = 0;
	if ($p eq "") { $p = 0; }
	open(IN,"$pastfile") || &error("Open Error: $pastfile");
#	while (<IN>) {
	while ( $_ = &lineDecode(IN) ) {
		$i++;
		next if ($i < $p + 1);
		next if ($i > $p + $menu2);

		local($no,$sub,$res,$name,$date) = split(/<>/);

		# タイトルと名前に文字修飾機能追加 （2009/01/15 スガラボット修正)
		$sub = &$titlebb($sub);	
		$name = &$titlebb($name);	

		print "<tr bgcolor=\"$col2\"><td bgcolor=\"$col2\" width=\"16\">";
		print "<a href=\"$readcgi&tree=0&mode=past&no=$no$delview\"><img src=\"$imgurl/fold1.gif\" border=\"0\"></a></th>";
		# ツリー表示のため以下の3行を追加 (20080301 スガラボット修正)
		if ($treeforum) {
			print "<td bgcolor=\"$col2\" align=\"center\"><a href=\"$readshtml&mode=past&no=$no&tree=1$delview\"><img src=\"$imgurl/tree.gif\" border=\"0\"></a></td>";
		}
		print "<td align=\"left\" bgcolor=\"$col2\" width=\"80%\">";
		print &strEncode("<a href=\"$readcgi&mode=past&no=$no$delview\">$sub</a></td>");
		print &strEncode("<td align=\"left\" bgcolor=\"$col2\" nowrap>$name</td>");
		print &strEncode("<td align=\"left\" bgcolor=\"$col2\" align=\"right\" nowrap class=\"num\">$res</td>");
		print &strEncode("<td align=\"left\" bgcolor=\"$col2\" nowrap class=\"s1\">$date</td></tr>\n");
	}
	close(IN);

	if (!$i) {
		print "<tr><td bgcolor=\"$col2\">&nbsp;</td>";
# ツリー表示のため以下の3行を追加 (20080301 スガラボット修正)
		if ($treeforum) { print "<td bgcolor=\"$col2\"></td>"; }
		print &strEncode("<td align=\"left\" colspan=\"4\" bgcolor=\"$col2\">- 現在${ttitle}はありません -</td></tr>\n");
	}

	print "</table>\n";

	# ページ移動ボタン表示
	if ($p - $menu2 >= 0 || $p + $menu2 < $i) {
		local($x,$y) = (1,0);
		print "<p><table width=\"100%\"><tr><td class=\"num\"> Page: ";
		while ($i > 0) {
			if ($p == $y) {
				print "<b style=\"color:$pglog_col\">$x</b> |\n";
			} else {
				print "<a href=\"$readcgi&mode=past&p=$y\">$x</a> |\n";
			}
			$x++;
			$y += $menu2;
			$i -= $menu2;
		}
		print "</td></tr></table>\n";
	}

	print "</div>\n";

	&pr_footer;

	print "</body></html>\n";

	exit;
}


#-------------------------------------------------
#  ページ繰越ボタン
#-------------------------------------------------
sub pagelink {
	local($end,$p) = @_;
	local($pglog);

#	$pglog .= "<table $width><tr><td class=\"num\">";

	my $msg1 = "（全部表示中） \n";
	my $msg2 = "もどる";
	my $msg3 = "全部表示";
	my $msg4 = "逆順に表示";
	my $msg5 = "正順に表示";
	my $msg6 = " スレッド一覧";
	my $msg7 = " 新規スレッド作成";
	my $msg8 = " 検索トップに戻る";
	my $msg9 = "次の記事";
	my $msg10 = " 前の記事";
	my $msg11 = " 記事タイトル一覧に戻る";

	# 携帯からの閲覧時は"次の記事"、"前の記事"を先に表示する
	if ( $ua ) {
		if ($pagecnt) {
			if ($p > 1) {
				my $prev_page = $p - 1;
				$pglog .= "<a href=\"$readshtml&mode=$mode&no=$pno&p=$prev_page&l=$l&rev=$rev$delview\">$msg10</a>\n";
			}
			if ($p < $end) {
				my $next_page = $p + 1;
				$pglog .= "<a href=\"$readshtml&mode=$mode&no=$pno&p=$next_page&l=$l&rev=$rev$delview\">$msg9</a>\n";
			}
		}
	}
	else {
	# 全部表示
		if ($all == 1 ) {
			$pglog .= $msg1;
			$pglog .= " <a href=\"$readcgi&mode=$mode&no=$pno&l=$l&rev=$rev$delview\">$msg2</a>\n";
		} elsif ($pagecnt) {
			$pglog .= "Page: ";

			foreach (1 .. $end) {
				if ($p == $_) {
					$pglog .= "<b style=\"color:$pglog_col\">$_</b> |\n";
				} else {
					$pglog .= "<a href=\"$readcgi&mode=$mode&no=$pno&p=$_&l=$l&rev=$rev$delview\">$_</a> |\n";
				}
			}
				$pglog .= " &nbsp;<a href=\"$readcgi&mode=$mode&no=$pno&l=$l&all=1&rev=$rev$delview\">$msg3</a>\n";
		}
	}
#
	if (!$rev && !$only) { $pglog .= " &nbsp;<a href=\"$readcgi&mode=$mode&no=$pno&l=$l&all=$all&rev=1$delview\">$msg4</a>\n"; }
	if ($rev && !$only) { $pglog .= " &nbsp;<a href=\"$readcgi&mode=$mode&no=$pno&l=$l&all=$all&rev=0$delview\">$msg5</a>\n"; }

	if ($only) {
		if ($from > 0) { my $l_next = $no[$from-1]; $pglog .= " &nbsp;<a href=\"$readcgi&mode=$mode&view=thread&no=$pno&l=$l_next$delview\">$msg10</a>\n"; }
		my $max = $num - 1;
		if ($from < $max) { my $l_next = $no[$from+1]; $pglog .= " &nbsp;<a href=\"$readcgi&mode=$mode&view=thread&no=$pno&l=$l_next$delview\">$msg9</a>\n"; }
	}

	$pglogu = $pglog;

	if ($in{'view'} eq 'thread') {
		$pglog .= " &nbsp;<a href=\"$bbscgi&view=thread&no=$in{'no'}\">$msg11</a>\n";
	}
	
	if (!$createonlyadmin) {
		$pglog .= " &nbsp;<a href=\"$bbscgi\">$msg6</a>\n";
	}
	
	$pglog .= " &nbsp;<a href=\"$readcgi&mode=form\">$msg7</a>\n";
	$pglog .= " &nbsp;<a href=\"$bbscgi1\">$msg8</a>\n" if (@wd);
	$pglog .= "</td></tr></table>\n";
	$pglog;
}

#-------------------------------------------------
#  メールフォーム（ユーザー間）
#-------------------------------------------------
sub mailform {
	local($no,$sub,$nam,$eml,$com,$dat,$hos,$pw,$url,$mvw);
	local($myjob) = @_;


		# ロック開始
#		if ($lockkey) { &lock; }

#		@new=();
#		open(IN,"$logdir/$in{'f'}.cgi") || &error("Open Error: $in{'f'}.cgi");
#		$top = <IN>;
		
		# 連続投稿チェック
		open(IN,"+> $mailfile") || &error("Open Error: $mailfile");

		while (<IN>) {
			($hos2,$tim2) = split(/<>/);
			if ($host eq $hos2 && $mailwait > time - $tim2) {
				&error("連続送信はもうしばらく時間をおいて下さい");
			}
		}
		close(IN);

	# 該当ログチェック
	$flag=0;
	open(IN,"$logdir/$in{'f'}\.cgi");
#	$top = <IN>;
	$top = &lineDecode(IN);

	# ロックされているかチェック
#	&checklocked($top);

#	while (<IN>) {
	while ( $_ = &lineDecode(IN) ) {
		($no,$sub,$nam,$eml,$com,$dat,$hos,$pw,$url,$mvw) = split(/<>/);
		last if ($in{'no'} == $no);
	}
	close(IN);

	if ($eml eq "") {
#		$check = &decrypt($in{'pwd'}, $pw);
		&error("該当記事にはメールアドレスが入力されていません"); }
#	elsif ($mvw eq '0') {
#		&error("該当記事の投稿者はメールを受け付けていません");
#	}

	$eml =~ s/./\*/g;

	# 宛先、差出人とタイトルの BBCode を削除
	$nam = &titlebbrm($nam);
	$sub = &titlebbrm($sub);

#	if ($smile) { &header("", "js"); }
#	else { &header(); }

	# 本文のBBCodeを削除 （2009/01/14 スガラボット修正)
	$com = &bbcoderm($com);
	
	# 「>」つけ
	$com =~ s/([\>]|^)([^<]*)/$1&gt; $2/g;

	# クッキー取得
	local($cnam,$ceml,$cpwd,$curl,$cmvw) = &get_cookie;
	if ($curl eq "") { $curl = "http://"; }

	# 差出人の BBCode を削除
	$cnam = &titlebbrm($cnam);

	&header("メール送信フォーム");

	$printString = <<"EOM";
<div align="center">
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col3"><td align="left" bgcolor="$col3" nowrap width="92%">
<img src="$imgurl/mail.gif" align="top">
&nbsp; <b>メールフォーム</b></td>
<td align="right" bgcolor="$col3" nowrap>
<a href="javascript:history.back()">前画面に戻る</a></td>
</tr></table>
<p><div align="left" style="width:80%">
<ul><li>この記事の投稿者にメールを送信します。
<li><nobr>この掲示板では、迷惑メールを防止するために、投稿者のメールアドレスを表示せずにメールを送る機能を提供しています。</nobr>
<li>相手のメールアドレスは、相手から返信があるまでわかりません。（あなたの入力したアドレスは相手に知らされます）
</ul></div><p>
<form action="$registcgi" method="post" name="myFORM">
<input type=hidden name=mode value="mail">
<input type=hidden name=job value="send">
<input type=hidden name=f value="$in{'f'}">
<input type=hidden name=no value="$in{'no'}">
<table bgcolor="$col1" cellspacing=1 cellpadding=5 $width>
<tr bgcolor="$col2">
  <th bgcolor="$col2" nowrap>宛先</td>
  <td align="left"><input id="w330" type=text name=dummy size=30 value="$nam" maxlength=20 disabled></td>
</tr>
<tr bgcolor="$col2">
  <th bgcolor="$col2" nowrap>宛先アドレス</td>
  <td align="left"><input id="w330" type=text name=dummy size=30 value="$eml" disabled> （非表示）
</tr>
<tr bgcolor="$col2">
  <th bgcolor="$col2" nowrap>件名</td>
  <td><input id="w540" type=text name=sub size=$sublength value="Re:$sub" maxlength=$sublength></td>
</tr>
<tr bgcolor="$col2">
  <th align="left" bgcolor="$col2" nowrap>差出人</td>
  <td><input id="w330" type=text name=name size=30 value="$cnam" maxlength=20> （「名前#任意の文字列」でトリップ作成）</td>
</tr>
<tr bgcolor="$col2">
  <th bgcolor="$col2" nowrap>差出人アドレス</td>
  <td align="left"><input id="w330" type=text name=email size=30 value="$ceml"> （必須：同じ内容の控えが届きます）
EOM
print &strEncode($printString);

#######################
# CAPTCHA認証機能 を追加 オヤジサーバさんからのモジュールを使用
#######################
   # 投稿認証キー
   if ($captcha) {
	   require "$keyinitpl";
	   my $ciphertext = &en_key;

		$printString = <<EOM;
<tr bgcolor="$col2">
  <th bgcolor="$col2" width="80">投稿認証キー</th>
  <td align="left" bgcolor="$col2"><input id="w42" type="text" name="chk" maxlength=8 style="ime-mode:inactive" istyle="3" mode="alphabet">
    (投稿時 <img src="$authkeycgi?$ciphertext" alt="投稿認証キー" style=\"vertical-align:bottom;"> を入力してください。投稿認証キーは表示後<font color="red">${pcp_time}分間のみ有効</font>です。)
    <input type=hidden name=ciphertext value="$ciphertext"></td>
</tr>
EOM
print &strEncode($printString);
	}

	# 投稿キー
	if ($regist_key) {

		# キー生成
		require $regkeypl;
		local($str_plain,$str_crypt) = &pcp_makekey;

		# 入力フォーム
		print &strEncode(qq |<tr bgcolor="$col2"><th bgcolor="$col2" width="80">投稿キー</th>|);
		print &strEncode(qq |<td align="left" bgcolor="$col2"><input id="w42" type="text" name="regikey" size="6" style="ime-mode:inactive">\n|);
		print &strEncode(qq |（投稿時 <img src="$registkeycgi?$str_crypt" align="absmiddle" alt="投稿キー"> を入力してください）</td></tr>\n|);
		print &strEncode(qq |<input type="hidden" name="str_crypt" value="$str_crypt">\n|);
	}

	if ($url eq "") { $url = "http://"; }

	$printString = <<"EOM";
</select></td>
</tr>
<tr bgcolor="$col2">
  <th bgcolor="$col2">本文</td>
  <td align="left" bgcolor="$col2">
EOM
print &strEncode($printString);

# <tr bgcolor="$col2">
#   <td bgcolor="$col2" width=80>URL</td>
#   <td align="left" bgcolor="$col2"><input type=text name=url size=45 value="$url"></td>
# </tr>

	# アイコン

	$com =~ s/<br>/\r/g;
	$printString = <<"EOM";
元の文章（送信されません）<br>
<textarea id="w680" name=dummy cols=$cols rows=$rows wrap=soft disabled>$com</textarea><br>
メール本文（送信されます）<br>
<textarea id="w680" name=comment cols=$cols rows=$rows wrap=soft>

</textarea></td></tr>
<tr bgcolor="$col2">
  <th bgcolor="$col2"><br></td>
  <td align="left" bgcolor="$col2">
    <input type=submit value="メールを送信する"> ※メールは連続して送信できませんのでよく内容を確認してください。</td>
  </form></tr></table>
</form>
</div>
EOM
print &strEncode($printString);

	&pr_footer;

	$printString = <<"EOM";
</body>
</html>
EOM
print &strEncode($printString);
	exit;
}

#-------------------------------------------------
#  閲覧カウント更新
#-------------------------------------------------
sub viewcount {

	local($data, $id, $num, $ip);
	open(DAT,"+< $logdir/$in{'no'}.dat") || &error("Open Error: $in{'no'}.dat");
	eval "flock(DAT, 2);";
	$data = <DAT>;

	# IP相違であれば更新
	($count,$ip) = split(/:/, $data);
	if ($addr ne $ip) {
		$count++;
		seek(DAT, 0, 0);
		print DAT "$count:$addr";
		truncate(DAT, tell(DAT));
		eval "flock(DAT, 8);";
		close(DAT);

	# 各スレッドの閲覧数のみ要約したviewcountファイルをオープンして閲覧数を更新
		$countfile = "$datadir/viewcount.dat";
		if(-e $countfile) {
			if(!open(CNT, "+<$countfile")) {&error("Open Error: $countfile.");}
			eval "flock(CNT, 2);";
			
			@buf = <CNT>;
			chomp($buf[0]);
			$PreTotal = $buf[0];
			$PreTotal = 0 if($PreTotal eq '');

			$Total = $PreTotal + 1;

			$outbuf = $Total . "\n";
			
			my $i = 0;
			my $flag = 0;
			$Num = 0;
			$PreNum = 0;
			for (1 .. $#buf) {
#				$i++;
				chomp($buf[$_]);
				local($id, $num, $ip) = split(/<>/, $buf[$_]);
				
				if ($id eq $in{'no'} && $addr ne $ip) {
					$PreNum = $num;
					$Num = $PreNum + 1;
					$flag = 1;
					$outbuf .= $id . '<>' . $Num . '<>' . $addr . "\n";
				} else {
					$outbuf .= $id . '<>' . $num . '<>' . $ip . "\n";
				}
			}
			
			if (!$flag && $in{'no'}) { 
				$outbuf .= $in{'no'} . '<>1<>' . $addr . "\n";
			}

			seek(CNT, 0, 0);

			print CNT $outbuf;

			truncate(CNT, tell(CNT));
			eval "flock(CNT, 8);";
			close(CNT);
		}
	} else { 
		eval "flock(DAT, 8);";
		close(DAT);
	}

}

#-------------------------------------------------
#  過去ログ閲覧
#-------------------------------------------------
sub past_archive {

	# 記事閲覧
	if ($in{'no'}) { &view("past");	}

	if ($in{'bbs'} eq 'forum') { &past_forum; }

	&axscheck;
	if ($in{'find'} eq "検索実行") {
		require $findpl;
		$in{'log'} = '1';
		&find('patioview');
	}

	if ( $user_hdft > 1 ) {
		&header('', '', 1);
	} else {
		&header('', '', 0);
	}
	
	my $menu;
	if ($treeforum) {
		$menu = defined($use_forum_menu) ? $use_forum_menu : 'Forum形式で表示';
		$menu = " | <a href=\"$readshtml&bbs=forum&mode=past&pno=$in{'pno'}\">$menu</a>";
	}

	$printString = <<"EOM";
<div align="center">
<table $width><tr><td align="right" nowrap>
<a href="$bbscgi">トップページ</a>$menu | <b>過去ログ</b>
</td></tr></table>
<form action="$readcgi" method="POST">
<input type="hidden" name="mode" value="past">
<table bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col3"><td $bgclass2 align="left" bgcolor="$col3" nowrap width="92%">
<img src="$imgurl/memo1.gif" align="middle">
&nbsp;<b>過去ログ</b>&nbsp;&nbsp;書庫No.
<select name="pno">
EOM
print &strEncode($printString);

	my $PNO;
	open($PNO, "$datadir/pastno.dat") || &error("$datadir/pastno.dat が開けません!");
	my $buf = <$PNO>;
	close($PNO);

	my ($last_page, $tcount) = split(/<>/, $buf);
	$last_page = sprintf("%d", $last_page); 

	# 表示すべき書庫ページの設定
	my $page = ($in{'pno'}) ? $in{'pno'} : $last_page;
	my $start_page = $page;

	my $i = $last_page;
	while ( $i ) {
		print "\t<option value=\"$i\"";
		if ($page == $i) { print " selected"; }
		my $N = sprintf("%04d", $i);
		print ">P$N\n";
		$i--;
	}

	$printString = <<"EOM";
</select>
<input type="submit" name="select" value="選択">&nbsp;&nbsp;
キーワード:
<input id="w220" type="text" name="word" value="">
<input type="hidden" name="op" value="AND">
<input type="hidden" name="vw" value="10">
<input type="hidden" name="log" value="0">
<input type="hidden" name="s" value="1">
<input type="hidden" name="n" value="1">
<input type="hidden" name="c" value="1">
<input type="submit" name="find" value="検索実行">
</td></tr></table>
</form>
EOM
print &strEncode($printString);

# ツリー表示利用の手引きの記述(前の2行から後の5行)を追加 (20080301 スガラボット修正)
	if ($treeforum) {
		$printString = <<EOM;
<Table border=0 cellspacing=0 cellpadding=4 width="95%">
<Tr><Td align="left">
<li> 「ツリー表示」欄の<img src=\"$imgurl/tree.gif\">をクリックするとトピックス毎に
Forum形式で記事の参照関係が${strong1}ツリー表示${strong2}されます
</Td></Tr></Table>
EOM
print &strEncode($printString);
	}
	else { print "<pr>"; }

	$printString = <<EOM;
<table bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="20"><b>一覧</b></td>
  <td bgcolor="$col2" width="20"><b>閲覧</b></td>
EOM
print &strEncode($printString);
	if ($treeforum) {
		$printString = <<EOM;
  <td bgcolor="$col2" nowrap><b><span style=\"font-size:9px\">ツリー<br>表示</b></span></td>
EOM
print &strEncode($printString);
	}

	$printString = <<EOM;
  <td bgcolor="$col2" width="70%"><b>トピックス</b></td>
  <td bgcolor="$col2" nowrap><b>投稿者</b></td>
  <td bgcolor="$col2" nowrap><b>返信数</b></td>
  <td bgcolor="$col2" nowrap><b>最終更新</b></td>
</tr>
EOM
print &strEncode($printString);

	# 指定された書庫ページのスレッド展開
	$i = 0;
	my $k = 0;
	my $IN;
	my $N = sprintf("%04d", $page);
	
	if ($p eq "") { $p = 0; }
	open($IN,"$pastdir/P${N}.dat") || &error("Open Error: $pastdir/P${N}.dat");

	while ( $_ = &lineDecode($IN) ) {

		# <>で分割した先頭が数字でなければスキップ
#		my ($no0) = split(/<>/);
		local($no,$sub,$res,$name,$date) = split(/<>/);

		if ($no !~ /^\d+$/) { next; }

		$k++;
		# 最後のページでなかったら、表示すべき最後の $tcount 行になるまではファイル先頭から読み飛ばす
		if ($page != $last_page && $k <= $past_page_max_tno - $tcount) { next; }

		$i++;
		next if ($i < $p + 1);
		next if ($i > $p + $menu2);

		# タイトルと名前に文字修飾機能追加 （2009/01/15 スガラボット修正)
		$sub = &$titlebb($sub);	
		$name = &$titlebb($name);	

		print "<tr bgcolor=\"$col1\"><td bgcolor=\"$col2\">";
		print "<a href=\"$patioshtml&view=thread&mode=past&no=$no&tree=0\"><img src=\"$imgurl/right_btn.gif\" border=\"0\"></a></td>\n";
		print "<td bgcolor=\"$col2\" width=\"16\"><a href=\"$readcgi&tree=0&mode=past&no=$no$delview\"><img src=\"$imgurl/fold1.gif\" border=\"0\"></a></td>";

		# ツリー表示のため以下の3行を追加 (20080301 スガラボット修正)
		if ($treeforum) {
			print "<td bgcolor=\"$col2\" align=\"center\"><a href=\"$readshtml&mode=past&no=$no&tree=1$delview\"><img src=\"$imgurl/tree.gif\" border=\"0\"></a></td>";
		}
		print "<td align=\"left\" bgcolor=\"$col2\" width=\"80%\">";
		print &strEncode("<a href=\"$readcgi&mode=past&no=$no$delview\">[$no] $sub</a></td>");
		print &strEncode("<td align=\"left\" bgcolor=\"$col2\" nowrap>$name</td>");
		print &strEncode("<td align=\"left\" bgcolor=\"$col2\" align=\"right\" nowrap class=\"num\">$res</td>");
		print &strEncode("<td align=\"left\" bgcolor=\"$col2\" nowrap class=\"s1\">$date</td></tr>\n");
	}
	close($IN);

	if (!$i) {
		print "<tr><td bgcolor=\"$col2\">&nbsp;</td><td bgcolor=\"$col2\">&nbsp;</td>";
# ツリー表示のため以下の3行を追加 (20080301 スガラボット修正)
		if ($treeforum) { print "<td bgcolor=\"$col2\"></td>"; }
		print &strEncode("<td colspan=\"4\" bgcolor=\"$col2\">- 現在過去ログはありません -</td></tr>\n");
	}

	# 指定ページで最後の $tcount 個のスレッドを表示したあとは、その前のページを先頭からスレッドを $past_page_max_tno - $tcount 個表示する。
	if ($page > 1 && $i < $past_page_max_tno) {

		$page--;
		$N = sprintf("%04d", $page);
	
		open($IN,"$pastdir/P${N}.dat") || &error("Open Error: $pastdir/P${N}.dat");

		while ( $_ = &lineDecode($IN) ) {

			if ($i >= $past_page_max_tno) { last; }

			# <>で分割した先頭が数字でなければスキップ
			local($no,$sub,$res,$name,$date) = split(/<>/);

			if ($no !~ /^\d+$/) { next; }
    
			$i++;
			next if ($i < $p + 1);
			next if ($i > $p + $menu2);
    
			# タイトルと名前に文字修飾機能追加 （2009/01/15 スガラボット修正)
			$sub = &$titlebb($sub);	
			$name = &$titlebb($name);	
    
			print "<tr bgcolor=\"$col1\"><td bgcolor=\"$col2\">";
			print "<a href=\"$patioshtml&view=thread&mode=past&no=$no&tree=0\"><img src=\"$imgurl/right_btn.gif\" border=\"0\"></a></td>\n";
			print "<td bgcolor=\"$col2\" width=\"16\"><a href=\"$readcgi&tree=0&mode=past&no=$no$delview\"><img src=\"$imgurl/fold1.gif\" border=\"0\"></a></th>";

			# ツリー表示のため以下の3行を追加 (20080301 スガラボット修正)
			if ($treeforum) {
				print "<td bgcolor=\"$col2\" align=\"center\"><a href=\"$readshtml&mode=past&no=$no&tree=1$delview\"><img src=\"$imgurl/tree.gif\" border=\"0\"></a></td>";
			}
			print "<td align=\"left\" bgcolor=\"$col2\" width=\"80%\">";
			print &strEncode("<a href=\"$readcgi&mode=past&no=$no$delview\">[$no] $sub</a></td>");
			print &strEncode("<td align=\"left\" bgcolor=\"$col2\" nowrap>$name</td>");
			print &strEncode("<td align=\"left\" bgcolor=\"$col2\" align=\"right\" nowrap class=\"num\">$res</td>");
			print &strEncode("<td align=\"left\" bgcolor=\"$col2\" nowrap class=\"s1\">$date</td></tr>\n");
		}
		close($IN);
	}

	print "</table><br>\n";

	$readshtml = "$cgi_url/read.cgi?bbs=patio&mode=past&pno=$start_page";

	# ページ移動ボタン表示
	if ($p - $menu2 >= 0 || $p + $menu2 < $i) {
		local($x,$y) = (1,0);
		print "<hr $width><table $width><tr><td class=\"num\"> Page: ";
		while ($i > 0) {
			if ($p == $y) {
				print "<b style=\"color:$pglog_col\">$x</b> |\n";
			} else {
				print "<a href=\"$readshtml&p=$y\">$x</a> |\n";
			}
			$x++;
			$y += $menu2;
			$i -= $menu2;
		}
		print "</td></tr></table><hr $width>\n";
	}

	print "</div>\n";

	&pr_footer;

	print "</body></html>\n";
	exit;
}

#-------------------------------------------------
#  過去ログ・インデックス閲覧 Forum形式閲覧
#-------------------------------------------------
sub past_forum {

	&axscheck;
	if ($in{'find'} eq "検索実行") {
		require $findpl;
		$in{'log'} = '1';
		&find('forumview');
	}

	if ( $user_hdft > 1 ) {
		&header('', '', 1);
	} else {
		&header('', '', 0);
	}

	my $menu = defined($use_patio_menu) ? $use_patio_menu : 'Patio形式で表示';
	$menu = "| <a href=\"$readshtml&bbs=patio&mode=past&pno=$in{'pno'}\">$menu</a>";

	$printString = <<"EOM";
<div align="center">
<table $width><tr><td align="right" nowrap>
<a href="$bbscgi">トップページ</a>$menu | <b>過去ログ</b>
</td></tr></table>
<form action="$readcgi" method="POST">
<input type="hidden" name="mode" value="past">
<input type="hidden" name="bbs" value="forum">
<table bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col3"><td $bgclass2 align="left" bgcolor="$col3" nowrap width="92%">
<img src="$imgurl/memo1.gif" align="middle">
&nbsp;<b>過去ログ</b>&nbsp;&nbsp;書庫No.
<select name="pno">
EOM
print &strEncode($printString);

	my $PNO;
	open($PNO, "$datadir/pastno.dat") || &error("$datadir/pastno.dat が開けません!");
	my $buf = <$PNO>;
	close($PNO);

	my ($last_page, $tcount) = split(/<>/, $buf);
	$last_page = sprintf("%d", $last_page); 

	# 表示すべき書庫ページの設定
	my $page = ($in{'pno'}) ? $in{'pno'} : $last_page;
	my $start_page = $page;

	my $i = $last_page;
	while ( $i ) {
		print "\t<option value=\"$i\"";
		if ($page == $i) { print " selected"; }
		my $N = sprintf("%04d", $i);
		print ">P$N\n";
		$i--;
	}

	$printString = <<"EOM";
</select>
<input type="submit" name="select" value="選択">&nbsp;&nbsp;
キーワード:
<input id="w220" type="text" name="word" value="">
<input type="hidden" name="op" value="AND">
<input type="hidden" name="vw" value="10">
<input type="hidden" name="log" value="0">
<input type="hidden" name="s" value="1">
<input type="hidden" name="n" value="1">
<input type="hidden" name="c" value="1">
<input type="submit" name="find" value="検索実行">
</td></tr></table>
</form>
EOM
print &strEncode($printString);

# ファイルアップロードが許可された掲示板なら「投稿に添付」を表示する
	$tenpu = ($image_upl == 2)? "&nbsp;&nbsp;<img src=\"$imgurl/clipsls.gif\" alt=\"投稿に添付\"> 投稿に添付": '';

# 携帯電話からのアクセスの場合はツリー表示の説明を入れない (2008/12/08 スガラボット修正)
	if (!$ua) {
		$note_msg = "<LI>スレッド先頭部の <img src=\"$imgurl/tree.gif\"> または <img src=\"$imgurl/fold1.gif\"> をクリックするとスレッド内の全記事を表示します。(<img src=\"$imgurl/tree.gif\"> はツリー表示)\n" .
					"<LI>記事先頭の <font color=\"green\">▼ △</font>をクリックするとスレッド内の関連する発言をその発言から (<font color=\"green\">\n" .
					"▼</font>は下、<font color=\"green\">△</font>は上) へツリー表示します。<font size=\"+1\">　</font>" .
					"<LI>スレッド最終行の <img src=\"$imgurl/treerev2.gif\"> または最新発言の <img src=\"$imgurl/upbutton1.gif\"> をクリックするとスレッドの全記事を降順に表示します。(<img src=\"$imgurl/treerev2.gif\"> はツリー表示)\n";
	}
	else {
		$note_msg = "<LI>スレッド先頭部の <img src=\"$imgurl/fold1.gif\"> をクリックするとスレッド内の全記事を順に表示します。" . 
					"<LI>スレッド最新記事の <img src=\"$imgurl/upbutton1.gif\"> をクリックするとスレッド内の全記事を新しいものから降順に表示します。\n";
	}

	$printString = <<"EOM";
<Table border="0" cellspacing="5" cellpadding="0" $width>
<tr>
<td align="left" nowrap>$note_msg
</td></tr></table>
EOM
print &strEncode($printString);

	print "<Table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $width>\n";

	# 指定された書庫ページのスレッド展開
	$i = 0;
	my $k = 0;
	my $IN;
	my $N = sprintf("%04d", $page);
	
	if ($p eq "") { $p = 0; }
	open($IN,"$pastdir/P${N}.dat") || &error("Open Error: $pastdir/P${N}.dat");

	while ( $_ = &lineDecode($IN) ) {

		local($no,$sub,$res,$name,$date) = split(/<>/);

		# <>で分割した先頭が数字ならスキップ
		if ($no =~ /^\d+$/) { 
			$k++;
			# 最後のページでなかったら、表示すべき最後の $tcount 行になるまではファイル先頭から読み飛ばす
			if ($page != $last_page && $k > $past_page_max_tno - $tcount) { $i++; }
			if ($page == $last_page) { $i++; }
			next;
		}

		# 最後のページでなかったら、表示すべき最後の $tcount 行になるまではファイル先頭から読み飛ばす
		if ($page != $last_page && $k <= $past_page_max_tno - $tcount) { next; }

		next if ($i < $p * $fmenu2 + 1);
		next if ($i > $p * $fmenu2 + $fmenu2);

		print &strEncode($_);

	}
	close($IN);

	# 指定ページで最後の $tcount 個のスレッドを表示したあとは、その前のページを先頭からスレッドを $past_page_max_tno - $tcount 個表示する。
	if ($page > 1 && $i < $past_page_max_tno) {

		$page--;
		$N = sprintf("%04d", $page);

		open($IN,"$pastdir/P${N}.dat") || &error("Open Error: $pastdir/P${N}.dat");

		while ( $_ = &lineDecode($IN) ) {

			local($no,$sub,$res,$name,$date) = split(/<>/);

			# <>で分割した先頭が数字ならスキップ
			if ($no =~ /^\d+$/) { 
				# 既にスレッド表示が規定数に達していればループ終了
				if ($i >= $past_page_max_tno) { last; }
				$i++;
				next; 
			}

			next if ($i < $p * $fmenu2 + 1);
			next if ($i > $p * $fmenu2 + $fmenu2);

			print &strEncode($_);

		}
		close($IN);

	}

	if (!$i) {
		print &strEncode("<tr><td bgcolor=\"$col2\">- 現在過去ログはありません -</td></tr>\n");
	}

	print "</table><br>\n";

	$readshtml = "$cgi_url/read.cgi?bbs=forum&mode=past&pno=$start_page";

	my $j = $i;
	# ページ移動ボタン表示
	if ($fmenu2 < $j) {
		local($x,$y) = (1,0);
		print "<hr $width><table $width><tr><td class=\"num\"> Page: ";
# デバッグプリント
#		print "Debug: fmenu1=$fmenu1, j=$j <br>\n";
		
		while ($j > 0) {
			if ($p == $y) {
				print "<b style=\"color:$pglog_col\">$x</b> |\n";
			} else {
				print "<a href=\"$readshtml&p=$y\">$x</a> |\n";
			}
			$x++;
			$y++;
			$j -= $fmenu2;
		}
		print "</td></tr></table>\n";
	}

	print "<hr $width>";

	print "</div>\n";
	&pr_footer;
	print "</body></html>\n";
	exit;
}

1;

