#!/usr/local/bin/perl
#┌─────────────────────────────────
#│ [ Forum Patio ]
#│ regist.cgi - 2014/09/24
#│ 以下の掲示板のモジュールを許可を得て再配布
#│ Copyright (c) KentWeb
#│ webmaster@kent-web.com
#│ http://www.kent-web.com/
#│ 
#│ きりしま式 Web Patio
#│ http://kirishima.it/patio/
#└─────────────────────────────────
#
# きりしま式 K0.92相当
# 2009/04/01 FAQモード追加修正
# 2009/03/24 スレッド作成制限モードの追加
# 2009/03/24 禁止語フィルタにURL欄も適用
# 2009/03/24 3.22相当に修正
# 2008/02/27 スレッド分割機能を装備（厳密には指定レス以降をコピーして新規スレッド作成）
# 2008/01/15 レスお知らせメールのルーチン組み込み
# 2008/01/09 過去ログに落ちてても書き込みができるセキュリティ上の問題に対処
# 2007/06/25 レスを削除してレス数が0になるときに、レスタイトルが親記事のタイトルになるのを修正
# 2007/06/10 3.2相当に修正
# 2007/05/01 ユーザーの記事削除時にレス数調整。レスが0になるときの表示修正
# 2007/04/06 スレッドトップの記事から、管理者パスで直接スレッド削除ができるフォームを設置
# 2007/03/06 2ch互換トリップ
#
# スガラボット ツリー表示 v1.14 (きりしま式k0.8に対応)
$kver = '_3.22_k0.92';
$sver = 'v1.54';
# 2014/09/24 v1.54 新規記事の投稿時、プレビュー画面で「投稿を取りやめる」ボタンを押すと「掲示板に戻る」、「スレッドをみる」などのボタンを押すと
#                 「◆ 新着の投稿記事を新しいものから5個表示」の下で ".cgiの読み込みに失敗しました"と赤でエラー表示されるバグを修正しました。
# 2012/12/08 v1.52 アップロードされたファイルのパーミッションを "0644" に変更。またプレビューでアップされたファイルのサムネールがある場合これも upl ディレクトリにムーブするように修正
# 2012/12/08 v1.52 regist.cgi で使用していた res_disp3 サブルーチンを廃止して res_disp2 に統合した。
#            これに伴い init.cgi の中の res_dsp2 のローカル変数 $l をグローバル変数 $ix に変更した。
# 2012/11/10 大きなファイル(約100MB以上)をアップロードするときサーバのRAMにコピーしていたためサーバの容量制限でエラーになることがあったため、コピーをやめてムーブに変更した
# 2012/02/07 ユーザ定義ヘッダー対応のコラム背景画像クラスとユーザ定義フッターの印刷ルーチンを追加
# 2010/12/22 記事集政治のパスワード修正方法を変更
# 2010/04/12 v1.36 現行スレッド数が規定数に達したときの新規スレッド投稿で､現行ログの最下位スレッドの過去ログに移動処理を修正
# 2009/10/15 如水さんのWebPatio+ (http://jyosui.xrea.jp/feed.html) 静的RSS機能を一部修正して追加インストール
# 2009/07/05 CGIスクリプトをUnicode記述に変更。HTML入出力とログファイルの文字コード(utf8,sjis,euc,jis)を設定可能
# 2009/05/12 スレッドテーマと新規投稿題名を別設定できるよう修正
# 2009/01/27 修正･削除フォームの画面でBBCode表示を修正
# 2009/01/06 スレッド元発言のロック機能が効かなかったバグを修正
# 2009/01/14 名前、タイトルと本文にBBCodeからHTMLへの変換機能追加に伴い、通知メールの題名と名前からBBCodeを削除
# 2008/10/29 新規に v1.03として配布
# 投稿時の最大容量チェックをinit.cgiのparse_form()から移動 (20081014 スガラボット修正)
# きりしま式 K0.7に対応してスレッド分割機能を取り込み 993-1019行を挿入(20080321)
# ツリー表示、Hi-Hoのssendmail対応のためスガラボットが書き直し (20080220)

#use strict;
#use warnings;
#use Time::Local;
use utf8;

# 外部ファイル取り込み
require './init.cgi';

# SSIによる複数会議室対応かどうか (20080315 スガラボット修正)
if (!$patioshtml) { $patioshtml = $patiocgi; }
if (!$forumshtml) { $forumshtml = $forumcgi; }
if (!$readshtml) { $readshtml = $readcgi; }
if (!$bbsshtml) { $bbsshtml = $bbscgi; }

# BBCode処理の変数関数を選択 (2009/01/14 スガラボット修正)
if ($bbcode) {
	$titlebb ="bbtitle";
	$combb = "bbcode2html";
} else {
	$titlebb = "titlebbrm";
	$combb = "bbcoderm";
}

&parse_form;
&axscheck;

our $admin_flag;

# 携帯電話からのアクセス時パラメータセット
if ($ua) { $width = "width=\"100%\""; }
else { $width = "width=\"95%\""; }

if ($mode eq "regist") { &regist; }
elsif ($mode eq "del") { &delete; }
elsif ($mode eq "mente") { &mente; }
elsif ($mode eq "edit_log") {
	require $editlog;
	&edit_log;
}
elsif ($mode eq "mail") { &mailsend; }
#&error("不明な処理です");
&error("不明な処理です$in{'mode'}");

#-------------------------------------------------
#  記事投稿処理
#-------------------------------------------------
sub regist {
#	our ($sub,$key,$flg,$i,@top);
	our ($sub,$key,$flg,$i,@top,$reg_no,$reg_upl);		#2009/10/15 スガラボット修正
	our $completeMessage = 'ご投稿ありがとうございました';

## デバッグプリント準備
our $tempbuf;

	# 最大記事数に達したとき出す管理者メールのアラームフラグ追加
	our $noticeflag;

	# 権限チェック
	if ($authkey && $my_rank < 2) {
		&error("投稿の権限がありません$my_rank");
	}

	# POST限定
	if ($postonly && !$postflag) { &error("不正なアクセスです"); }

	# 最大容量チェック ⇒ 会議室別の最大容量設定を可能とするため場所をinit.cgiから
	# regist.cgi,admin.cgiなどのアプリCGIに移動 (20081015 スガラボット修正)
	if ($ENV{'CONTENT_LENGTH'} > $maxdata) {
		local($maxd) = int( $maxdata / 1024 ) . "KB";
		&error("容量サイズオーバーです : $maxdまで");
	}

	# チェック
	if ($no_wd) { &no_wd; }
	if ($jp_wd) { &jp_wd; }
#	if ($urlnum > 0) { &urlnum; }
# URLチェックはゼロから行うように変更 (20080214 守田修正)
	if ($urlnum >= 0) { &urlnum; }

	# コメント文字数チェック
	if (length($i_com) > $max_msg*2) {
		&error("文字数オーバーです。<br>全角$max_msg文字以内で記述してください");
	}

	# 汚染チェック
	$in{'res'} =~ s/\D//g;

	# 投稿内容チェック
	if ($i_com eq "") { &error("コメントの内容がありません"); }
	if ($i_nam eq "") {
		if ($in_name) { &error("名前は記入必須です"); }
		else { $i_nam = '名無しのゴンベエ'; }
	}
	if ($in_mail == 1 && $in{'email'} eq "") { &error("E-mailは記入必須です"); }
	if ($in_mail == 2 && $in{'email'} ne "") { &error("E-mailは入力禁止です"); }
	if ($in_mail == 3 && $in{'email'} ne "") { &error("E-mailは入力禁止です"); }
	if ($in{'email'} && $in{'email'} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,6}$/) {
		&error("E-mailの入力内容が不正です");
	}
	if ($i_sub eq "") { &error("タイトルは記入必須です"); }
	if ($i_sub =~ /^(\x81\x40|\s)+$/) { &error("タイトルは正しく記入してください"); }
	if ($i_nam =~ /^(\x81\x40|\s)+$/) { &error("名前は正しく記入してください"); }
	if ($i_com =~ /^(\x81\x40|\s|<br>)+$/) { &error("コメントは正しく記入してください"); }
	if ($in_pwd && $in{'pwd'} eq "") { &error("パスワードは入力必須です"); }
	if (length($in{'pwd'}) > 8) { &error("パスワードは8文字以内にして下さい"); }
	if ($in{'url'} eq "http://") { $in{'url'} = ""; }

	# 投稿認証キーチェック	（2010/01/29 スガラボット追加修正)
	if ($captcha) {
		our $keylen;
		require $keyinitpl;

		if ($in{'chk'} !~ /^\d{$keylen}$/) {
			&error("投稿キーが入力不備です。<p>投稿フォームに戻って再読込み後、指定の${keylen}桁の数字を入力してください");
		}

		local($chk) = &key_chk($in{'chk'}, $in{'ciphertext'});
		if ($chk == 0) {
			&error("投稿キーが制限時間を超過しました。<p>投稿フォームに戻って再読込み後、指定の数字を再入力してください");
		} elsif ($chk == -1) {
			&error("投稿キーが不正です。<p>投稿フォームに戻って再読込み後、指定の数字を入力してください");
		}
	}

	# 投稿キーチェック
	if ($regist_key) {
		require $regkeypl;

		if ($in{'regikey'} !~ /^\d{4}$/) {
			&error("投稿キーが入力不備です。<p>投稿フォームに戻って再読込み後、指定の数字を入力してください");
		}

		# 投稿キーチェック
		# -1 : キー不一致
		#  0 : 制限時間オーバー
		#  1 : キー一致
		local($chk) = &registkey_chk($in{'regikey'}, $in{'str_crypt'});
		if ($chk == 0) {
			&error("投稿キーが制限時間を超過しました。<p>投稿フォームに戻って再読込み後、指定の数字を再入力してください");
		} elsif ($chk == -1) {
			&error("投稿キーが不正です。<p>投稿フォームに戻って再読込み後、指定の数字を入力してください");
		}
	}

	# トリップ
	$i_nam2 = &trip($i_nam);

	# パスワード暗号化
	if ($in{'pwd'} eq "") { $pwd = ""; }
	else { $pwd = &encrypt($in{'pwd'}); }

	# IDを作成
	if($idkey) { &makeid; }
	else { $idcrypt = "";}

	# job 変数を定義
	our $job = $in{'job'};

	# ファイルアップロード処理を親スレッドから移動 (20080924 スガラボット修正)
	local($upl_flg, %ex, %w ,%h, %filename, %filetitle);
	if ($image_upl && $job ne 'quit' && ($in{'upfile1'} || $in{'upfile2'} || $in{'upfile3'})) {
		require $upload;
		($ex{1},$w{1},$h{1},$filename{1},$filetitle{1},$ex{2},$w{2},$h{2},$filename{2},
				$filetitle{2},$ex{3},$w{3},$h{3},$filename{3},$filetitle{3}) = &upload($time);
			# 画像アップのときはフラグを立てる
		if ($ex{1} || $ex{2} || $ex{3}) { $upl_flg = $time; }
	}

	# ログ の$upl{$j} タイプに変換
	our %upl;
	foreach my $j (1 .. 3) {
		$upl{$j} = "$ex{$j},$w{$j},$h{$j},$filename{$j},$filetitle{$j}";
	}

	# プレビュー画面からの送信された job を解釈
	if ($in{'submit'} eq $prevButton) { $job = 'preview'; }
	elsif ($in{'submit'} eq $quitButton) { $job = 'quit'; }

	# 投稿取り止めの場合
	if ($in{'time'} && $job eq 'quit') {
		$in{'del1'} = $in{'del2'} = $in{'del3'} = 1;
		&preUpfile($in{'time'}, $job);
		$completeMessage = '投稿を中止しました';
	}

	# 新規投稿
	elsif ($in{'res'} eq "") {

		# 管理者スレ立てチェック
		if ($createonlyadmin && $pass ne $in{'pwd'}) {
			&error("スレッドの作成は管理者のみに制限されています");
		}

		# indexファイル
		local($i, $flg, $top, @new, @tmp, @top, @faq);
		open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
		eval "flock(DAT, 2);";
#		$top = <DAT>;
		$top = &lineDecode(DAT);

		# 連続投稿IPチェック
		local($no,$ho,$t) = split(/<>/, $top);
		if ($host eq $ho && $wait > time - $t) {
			close(DAT);
			&error("連続投稿はもうしばらく時間をおいて下さい");
		}
		$new = $no + 1;

		# index展開
		while( $_ = &lineDecode(DAT) ) {
			local($sub,$key) = (split(/<>/))[1,6];

			$i++;
			if ($sub eq $in{'sub'}) { $flg++; last; }
			elsif ($key == 2) { push(@top,$_); next; }
			elsif ($key == 3) { push(@faq,$_); next; }

			if ($i >= $i_max) { push(@tmp,$_); }
			else { push(@new,$_); }
		}

		# スレッド名重複チェック
		if ($flg) {
			close(DAT);
			&error("<b>「$in{'sub'}」</b>は既存スレッドと重複しています。<br>別のスレッド名を指定してください");
		}

		# アップロードファイルの処理
		my $tim0 = $in{'time'};			# プレビュー投稿したときのタイムスタンプ
		if ($tim0) {
			# 今回のアップロードと preview でアップロードされたファイルを処理するサブルーチンコール
			&preUpfile($tim0, $job);
		}
		
		# プレビューのときは index ファイルを操作しない
		if ($job eq 'preview') {
			close(DAT);

			# 新規スレッドフラグをセット
			our $newthread = 1;

			# temp フォルダーの確認 (無ければ作成する)
#			unless (-e "$logdir/temp") { mkdir("$logdir/temp", 0747); }
			&clearDir("$logdir/temp");

			# 暫定ログファイル作成
			open(OUT,">$logdir/temp/$time.cgi") || &error("Write Error: ./temp/$time.cgi");
			print OUT &strEncode("$new<>$in{'tsub'}<>0<>1<>\n", $logchar);
			print OUT &strEncode("0<>$in{'sub'}<>$i_nam2<>$in{'email'}<>$i_com<>$date<>$host<>$pwd<>$in{'url'}<>$in{'mvw'}<>$my_id<>$time<>$upl{1}<>$upl{2}<>$upl{3}<>$idcrypt<>$in{'color'}<><>\n", $logchar);
			close(OUT);

			# temp フォルダーの確認 (無ければ作成する)
#			unless (-e "$upldir/temp") { mkdir("$upldir/temp", 0747); }
			&clearDir("$upldir/temp");

			# アップロードされたファイルを temp フォルダに移動
			foreach my $j (1 .. 3) {
				if ( $ex{$j} ) {
					rename("$upldir/$time-$j$ex{$j}", "$upldir/temp/$time-$j$ex{$j}");
				}
			}

			&preview;
		} 

#		local ($tsub, $ressub);
		our $ressub;
		# 新規投稿の場合はスレッドタイトルと投稿の題名比較
		# スレッドタイトルとレス親の題名を分離したことに因る処理を追加 （2009/05/01 スガラボット修正)
		if ($in{'tsub'} && $i_sub ne $in{'tsub'}) { $tsub = $in{'tsub'}; $ressub = $i_sub; }
		else { $tsub = $i_sub; $ressub = ''; }

		# 現行index更新
		unshift(@new,"$new<>$tsub<>0<>$i_nam2<>$date<>$i_nam2<>1<>$upl_flg<>$ressub<>$time<>\n");
		unshift(@new,@faq) if (@faq > 0);
		unshift(@new,@top) if (@top > 0);
		unshift(@new,"$new<>$host<>$time<>\n");
		seek(DAT, 0, 0);
		print DAT &arrayEncode(\@new, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# 過去ログに落ちるスレッドのフラグを変更
		@tmp2 = @tmp;

		while (@tmp2) {
#			local($pastno) = split(/<>/, $tmp2);
#			if ($pastno == '') { last; }
#			# スレッド読み込み
#			open(DAT,"+< $logdir/$pastno.cgi") || &error("Open Error: $pastno.cgi");
#			eval "flock(DAT, 2);";
##			local(@file) = <DAT>;
#			our @file = &arrayDecode(DAT);
#
#			# 先頭ファイルを抽出・分解
#			$top = shift(@file);
#			local($no,$sub,$res,undef) = split(/<>/, $top);
#
#			# フラグ変更・スレッド更新
#			unshift(@file,"$no<>$sub<>$res<>-1<>\n");
#
#			seek(DAT, 0, 0);
##			print DAT @file;
#			print DAT &arrayEncode(\@file, $logchar);
#			truncate(DAT, tell(DAT));
#			close(DAT);

			# 過去ログ書庫に廻るスレッド処理 (2010/11/26 スガラボット追加修正)
			
			&add_pastlog(pop(@tmp2));
		}

#		&add_pastlog( \@tmp2 );
		
		# 過去index更新
		if (@tmp > 0) {

			# 削除時に削除退避ログディレクトリに移動する設定の時はディレクトリ環境を整備
			local @deldat;
			if ($logdelete) {
				if (!opendir(DIR, $delsave)) {
					mkdir($delsave, 0707);
					mkdir("$delsave/data", 0707);
					mkdir("$delsave/log", 0707);
					mkdir("$delsave/upl", 0707);
					unless (-e "$delsave/data/index.log") {
						open(DATA, ">$delsave/data/index.log");
						close(DATA);
					}
				}
			}
				
			$i = @tmp;
			open(DAT,"+< $pastfile") || &error("Open Error: $pastfile");
			eval "flock(DAT, 2);";
			while( $_ = &lineDecode(DAT) ) {
				$i++;
				if ($i > $p_max) {
					local($delno) = split(/<>/);

					open(IN,"$logdir/$delno.cgi");
#					my $top = <IN>;
					my $top = &lineDecode(IN);

#					my $log = <IN>;
#					my $log = &lineDecode(IN);
					# 返信投稿にもファイルアップロードを許可する場合もあるので全投稿をチェックするように変更 （2010/04/12 スガラボット修正)
					while ( my $log = &lineDecode(IN) ) {
#					close(IN);
						local($no,$sub,$nam,$eml,$com,$dat,$ho,$pw,$url,$mvw,$myid,$tim,$upl{1},$upl{2},$upl{3}) = split(/<>/, $log);
						foreach my $j (1 .. 3) {
							next if (!$upl{$j});
							my ($ex,$w,$h) = split(/,/, $upl{$j});
							if (-e "$upldir/$tim-$j$ex") {
								# 削除の場合
								if (!$logdelete) {
									unlink("$upldir/$tim-$j$ex");
								}
								# スレッド移動の場合
								else {
									rename("$upldir/$tim-$j$ex", "$delsave/upl/$tim-$j$ex");
								}
							}
						}
					close(IN);
					}

					# スレッド移動の場合 以下5行と8行目は新規追加 （2009/03/26 スガラボット修正)
					if ($logdelete) {
						rename("$logdir/$delno.cgi", "$delsave/log/$delno.cgi");
						rename("$logdir/$delno.dat", "$delsave/log/$delno.dat");
						push(@deldat,$_);
					} else {
						unlink("$logdir/$delno.cgi");
						unlink("$logdir/$delno.dat");
					}
				} else {
					push(@tmp,$_);
				}
			}
			seek(DAT, 0, 0);
#			print DAT @tmp;
			print DAT &arrayEncode(\@tmp, $logchar);
			truncate(DAT, tell(DAT));
			close(DAT);

			# 削除ログ移動先のindex更新 （2009/03/26 スガラボット修正)
			if ($logdelete) {
				open(DATA, "+>$delsave/data/index.log");
				while( $_ = &lineDecode(DATA) ) {
					push(@deldat, $_);
				}
				seek(DATA, 0, 0);
#				print DATA @deldat;
				print DATA &arrayEncode(\@deldat, $logchar);
				truncate(DATA, tell(DATA));
				close(DATA);
			}
		}

		# スレッド更新
		open(OUT,">$logdir/$new.cgi") || &error("Write Error: $new.cgi");
		print OUT &strEncode("$new<>$tsub<>0<>1<>\n", $logchar);
#		print OUT &strEncode("0<>$in{'sub'}<>$i_nam2<>$in{'email'}<>$i_com<>$date<>$host<>$pwd<>$in{'url'}<>$in{'mvw'}<>$my_id<>$time<>$ex{1},$w{1},$h{1},$filename{1},$filetitle{1}<>$ex{2},$w{2},$h{2},$filename{2},$filetitle{2}<>$ex{3},$w{3},$h{3},$filename{3},$filetitle{3}<>$idcrypt<>$in{'color'}<><>\n", $logchar);
		print OUT &strEncode("0<>$in{'sub'}<>$i_nam2<>$in{'email'}<>$i_com<>$date<>$host<>$pwd<>$in{'url'}<>$in{'mvw'}<>$my_id<>$time<>$upl{1}<>$upl{2}<>$upl{3}<>$idcrypt<>$in{'color'}<><>\n", $logchar);
		close(OUT);

		# 参照ファイル生成
		open(NO,">$logdir/$new.dat") || &error("Write Error: $new.dat");
		print NO "0:";
		close(NO);

		# パーミッション変更
		chmod(0666, "$logdir/$new.cgi");
		chmod(0666, "$logdir/$new.dat");

#		# プレビュー有りなら添付ファイル削除
#		if ($preview) {
#			$in{'del1'} = $in{'del2'} = $in{'del3'} = 1;
#			&preUpfile($in{'time'}, 'quit');
#		}

		# メール送信
		&sendmail if ($mailing);

		# RSS/Atom (2009/10/15 以下2行を追加: スガラボット)
		$feed++;
		if ($upl_flg) { $reg_upl = $upl_flg; }

	# 返信投稿
	} else {

		our ($tsub, $ressub);

		# 参照ファイル
		local($data);
		open(IN,"$logdir/$in{'res'}.dat");
		$data = <IN>;
		close(IN);

		($count) = split(/:/, $data);

		# 連続投稿チェック
		local($top);
		open(IN,"$nowfile") || &error("Open Error: $nowfile");
		$top = <IN>;
		close(IN);

		local($no,$hos2,$tim2) = split(/<>/, $top);
		if ($host eq $hos2 && $wait > time - $tim2) {
			&error("連続投稿はもうしばらく時間をおいて下さい");
		}

		# スレッド読み込み
		open(DAT,"+< $logdir/$in{'res'}.cgi") || &error("Open Error: $in{'res'}.cgi");
		eval "flock(DAT, 2);";
#		local(@file) = <DAT>;
		our(@file) = &arrayDecode(DAT);

		# 先頭ファイルを抽出・分解
		$top = shift(@file);
		our($no,$sub,$res,$key) = split(/<>/, $top);

		# RSS機能追加のため、スレッドタイトルがあれば抽出 (2009/10/19 以下7行を追加修正)
		my $top2;
		our $ressub0;				# FEED で $ressub0 が反映されないため変数をグローバルに修正
		$top2 = shift(@file);
		unshift(@file, $top2);
		
		(undef, $ressub0) = split(/<>/, $top2);
		if ($sub ne $ressub0) { $tsub = $sub; }
		else { $tsub = ''; }

		# ロックチェック
		if ($key eq '0' || $key eq '2') {
			close(DAT);
			&error("このスレッドはロック中のため返信できません");
		}

		# 過去ログチェック
		if ($key eq '-1') {
			close(DAT);
			&error("過去ログのスレッドには返信できません");
		}

		# 末尾投稿を分解、重複チェック
		local($no2,$sb2,$na2,$em2,$co2) = split(/<>/, $file[$#file]);
		if ($i_nam2 eq $na2 && $i_com eq $co2) { &error("重複投稿は禁止です"); }

		# 採番
		our $newno = $no2 + 1;

		# 記事数チェック
#		if ($m_max < $res+1) { &error("最大記事数をオーバーしたため投稿できません"); }
		if ($m_max < $#file+1) { &error("最大記事数をオーバーしたため投稿できません"); }
#		elsif ($m_max == $res+1) { $maxflag = 1; }
		elsif ($m_max == $#file+1) { $maxflag = 1; }
		# ちょうど最大記事数に達したときは管理者へのメールにアラーム追加
		elsif ($m_max == $#file+2) { $noticeflag = 1; }
		else { $maxflag = 0; }

		# 特定発言への返信であれば参照している発言が登録されるこの発言の番号より若番であることをチェック (20080220 守田修正)
		# restor のラジオボタンを追加したことによる処理
		if ($res_no && $res_no >= $newno) {  &error("レス指定返信はこれ以前の発言にしか投稿できません"); }

		# アップロードファイルの処理
		my $tim0 = $in{'time'};			# プレビュー投稿したときのタイムスタンプ
		if ($tim0) {
			# 今回のアップロードと preview でアップロードされたファイルを処理するサブルーチンコール
			&preUpfile($tim0, $job);
		}

		# プレビューのときは 暫定ログファイル作成 (ファイル名は{$time}.cgi)
		if ($job eq 'preview') {
			close(DAT);
#			$new = $time;

			# temp フォルダーの確認 (無ければ作成する)
#			unless (-e "$logdir/temp") { mkdir("$logdir/temp", 0747); }
			&clearDir("$logdir/temp");

			# 暫定ログファィル作成
			open(OUT,">$logdir/temp/$time.cgi") || &error("Write Error: ./temp/$time.cgi");
			print OUT &strEncode("$in{'res'}<>$sub<>0<>1<>\n", $logchar);
			print OUT &strEncode("$newno<>$in{'sub'}<>$i_nam2<>$in{'email'}<>$i_com<>$date<>$host<>$pwd<>$in{'url'}<>$in{'mvw'}<>$my_id<>$time<>$upl{1}<>$upl{2}<>$upl{3}<>$idcrypt<>$in{'color'}<>$res_no<>\n", $logchar);
			close(OUT);

			# temp フォルダーの確認 (無ければ作成する)
#			unless (-e "$upldir/temp") { mkdir("$upldir/temp", 0747); }
			&clearDir("$upldir/temp");

			# アップロードされたファイルを temp フォルダに移動
			foreach my $j (1 .. 3) {
				if ( $ex{$j} ) {
					rename("$upldir/$time-$j$ex{$j}", "$upldir/temp/$time-$j$ex{$j}");
				}
			}

			&preview;
		} 

		# IDを作成
		if($idkey) { &makeid; }
		else { $idcrypt = "";}

		# 画像アップのときはフラグを立てる (プレビュー機能追加により185行目からここに移動)
		if ($ex{1} || $ex{2} || $ex{3}) { $upl_flg = $time; }

		# スレッド更新
		$res++;
		unshift(@file,"$no<>$sub<>$res<>$key<>\n");
#		if (($res_no) && ($res_no =~ /[0-9]/) && ($res_no < $newno)) { $resto = $res_no; } 
		if (($res_no) && ($res_no =~ /^[0-9]+$/) && ($res_no < $newno)) { $resto = $res_no; } 
#		push(@file,"$newno<>$in{'sub'}<>$i_nam2<>$in{'email'}<>$i_com<>$date<>$host<>$pwd<>$in{'url'}<>$in{'mvw'}<>$my_id<>$time<>$ex{1},$w{1},$h{1},$filename{1},$filetitle{1}<>$ex{2},$w{2},$h{2},$filename{2},$filetitle{2}<>$ex{3},$w{3},$h{3},$filename{3},$filetitle{3}<>$idcrypt<>$in{'color'}<>$resto<>\n");
		push(@file, "$newno<>$in{'sub'}<>$i_nam2<>$in{'email'}<>$i_com<>$date<>$host<>$pwd<>$in{'url'}<>$in{'mvw'}<>$my_id<>$time<>$upl{1}<>$upl{2}<>$upl{3}<>$idcrypt<>$in{'color'}<>$resto<>\n");

		seek(DAT, 0, 0);
#		print DAT @file;
		print DAT &arrayEncode(\@file, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		## 規定記事数オーバのとき ##
		if ($maxflag) {

			# 過去ログindex読み込み
			open(BAK,"+< $pastfile") || &error("Open Error: $pastfile");
			eval "flock(BAK, 2);";
#			local(@file) = <BAK>;
			my (@file) = &arrayDecode(BAK);

			# 現行ログindexから該当スレッド抜き出し
			local($top, @new);
			open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
			eval "flock(DAT, 2);";
#			$top = <DAT>;
			$top = &lineDecode(DAT);
#			while(<DAT>) {
			while( $_ = &lineDecode(DAT) ) {
				s/\n//;
				local($no,$sub,$re,$nam,$d,$na2,$key,$upl) = split(/<>/);

				if ($in{'res'} == $no) {
					$re++;
#					unshift(@file,"$no<>$sub<>$re<>$nam<>$date<>$na2<>1<>$upl<>$in{'sub'}<>$time<>\n");
#					unshift(@file,"$no<>$sub<>$re<>$nam<>$date<>$i_nam2<>1<>$upl<>$in{'sub'}<>$time<>\n");
					# 過去ログに移すとき、$key 値を -1 にするように変更 (2009/08/05 スガラボット修正)
					unshift(@file,"$no<>$sub<>$re<>$nam<>$date<>$i_nam2<>-1<>$upl<>$in{'sub'}<>$time<>\n");
					next;
				}
				push(@new,"$_\n");
			}

			# 現行ログindex更新
			unshift(@new,$top);
			seek(DAT, 0, 0);
#			print DAT @new;
			print DAT &arrayEncode(\@new, $logchar);
			truncate(DAT, tell(DAT));
			close(DAT);

			# 過去ログindex更新
			seek(BAK, 0, 0);
#			print BAK @file;
			print BAK &arrayEncode(\@file, $logchar);
			truncate(BAK, tell(BAK));
			close(BAK);

		## ソートあり ##
		} elsif ($in{'sort'} == 1) {

			# indexファイル更新
			# FAQモード追加のため以下1行修正 （2009/03/27 スガラボット修正)
			local($flg, $top, @new, @top, @faq);
			open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
			eval "flock(DAT, 2);";
#			$top = <DAT>;
			$top = &lineDecode(DAT);
			while( $_ = &lineDecode(DAT) ) {
				s/\n//;
				local($no,$sub,$re,$nam,$da,$na2,$key,$upl) = split(/<>/);

				if ($key == 2) {
					push(@top,"$_\n");
					next;
				}
				# FAQモードで以下9行追加 (2009/03/27 スガラボット修正)
				if (($key == 3) && ($in{'res'} != $no)) {
					push(@faq,"$_\n");
					next;
				}
				if (($key == 3) && ($in{'res'} == $no)) {
					$flg = 1;
					$new = "$in{'res'}<>$sub<>$res<>$nam<>$date<>$i_nam2<>$key<>$upl<>$in{'sub'}<>$time<>\n";
					unshift(@faq, $new);
					next;
				}
				if (($key != 3) && ($in{'res'} == $no)) {
					$flg = 1;
					$new = "$in{'res'}<>$sub<>$res<>$nam<>$date<>$i_nam2<>$key<>$upl<>$in{'sub'}<>$time<>\n";
					unshift(@new,$new);
					next;
				}
				push(@new,"$_\n");
			}

			if (!$flg) {
				&error("該当のスレッドがindexファイルに見当たりません");
			}

			local($no2,$host2,$time2) = split(/<>/, $top);

			# FAQモードで1行削除し1行追加 （2009/03/27 スガラボット修正)
			unshift(@new,@faq) if (@faq > 0);
			unshift(@new,@top) if (@top > 0);
			unshift(@new,"$no2<>$host<>$time<>\n");
			seek(DAT, 0, 0);
#			print DAT @new;
			print DAT &arrayEncode(\@new, $logchar);
			truncate(DAT, tell(DAT));
			close(DAT);

		## ソートなし ##
		} else {

			# indexファイル更新
			local($flg, $top, @new);
			open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
			eval "flock(DAT, 2);";
#			$top = <DAT>;
			$top = &lineDecode(DAT);
			while( $_ = &lineDecode(DAT) ) {
				s/\n//;
				local($no,$sub,$re,$nam,$da,$na2,$key,$upl) = split(/<>/);
				if ($in{'res'} == $no) {
					$flg = 1;
#					$_ = "$in{'res'}<>$sub<>$res<>$nam<>$date<>$i_nam2<>1<>$upl<>$in{'sub'}<>$time<>";
					# ソート無しのとき、$key 値が "1" の通常スレッドに戻ってしまうバグ修正 （2009/08/05 スガラボット修正)
					$_ = "$in{'res'}<>$sub<>$res<>$nam<>$date<>$i_nam2<>$key<>$upl<>$in{'sub'}<>$time<>";
				}
				push(@new,"$_\n");
			}

			if (!$flg) {
				&error("該当のスレッドがindexファイルに見当たりません");
			}

			local($no2,$host2,$time2) = split(/<>/, $top);

			unshift(@new,"$no2<>$host<>$time<>\n");
			seek(DAT, 0, 0);
#			print DAT @new;
			print DAT &arrayEncode(\@new, $logchar);
			truncate(DAT, tell(DAT));
			close(DAT);
		}

#		# プレビュー有りなら添付ファイル削除
#		if ($preview) {
#			$in{'del1'} = $in{'del2'} = $in{'del3'} = 1;
#			&preUpfile($in{'time'}, 'quit');
#		}

		# メール送信
		&sendmail if ($mailing == 2);
		
		# レスお知らせメール送信
		&sendnotify if ($mailnotify != 0);

		# RSS/Atom (2009/10/15 スガラボット修正)
		$reg_no = $no;
		if ($upl_flg) { $reg_upl = $upl_flg; }
	}

	# RSS/Atom (2009/10/15 以下の4行を追加: スガラボット)
	if(($feed >= 2) && ($completeMessage ne '投稿を中止しました')) {
		require $feedpl;
		&feed("reg");
	}

	# クッキーを格納
	if ($in{'cook'} eq "on") {
		&set_cookie($i_nam,$in{'email'},$in{'pwd'},$in{'url'},$in{'mvw'},$in{'color'});
	}

## デバッグプリント
#&error("Debug：ここまで来たぞ！");

	# 完了メッセージ
	&header;
	$md = 'view';
	if ($in{'res'} eq "") { $no = $new; }
	else { $no = $in{'res'}; }

	$printString = <<EOM;
<br><br><div align="center">
<Table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" width="400">
<tr bgcolor="$col2">
  <td bgcolor="$col2" nowrap align="center" height="60">
	<h3 style="font-size:15px"><b>$completeMessage</b></h3>
  </td>
</tr>
</table>
<p>
EOM
print &strEncode($printString);

	# 過去ログ繰り越しの場合
	if ($maxflag) {
		print &strEncode("ただし１スレッド当りの最大記事数を超えたため、<br>\n");
		print &strEncode("このスレッドは <a href=\"$readcgi&mode=past\">過去ログ</a> ");
		print &strEncode("へ移動しました。\n");
		$md = 'past';
	}

	# 戻りフォーム
	$printString = <<"EOM";
<table><tr><td valign="top">
<form action="$bbscgi">
<input type="submit" value="掲示板へ戻る">
</form></td>
EOM
	if ($completeMessage ne '投稿を中止しました') {
		$printString .= <<"EOM";
<td width="15"></td>
<td valign="top">
<form action="$readcgi" method="post">
<input type="hidden" name="mode" value="$md">
<input type="hidden" name="no" value="$no">
<input type="submit" value="スレッドを見る">
</form></td>
EOM
	}
	$printString .= <<"EOM";
</tr>
</table>
</div>
EOM
	print &strEncode($printString);

	&pr_footer;

	$printString = <<"EOM";
</body>
</html>
EOM
print &strEncode($printString);
	exit;
}

#----------------------------------------------------
# プレビュー確認送信フォーム
#----------------------------------------------------

sub editform {

	if ($image_upl && !$ua) {
		print qq|<form action="$registcgi" method="post" name="myFORM" enctype="multipart/form-data">\n|;
	} else {
		print qq|<form action="$registcgi" method="post" name="myFORM">\n|;
	}

	# Forum形式一覧表示のフラグをチェックするよう以下三行追加 (20080926 スガラボット修正)
	if ($in{'forum'} == "1") {
		print "<input type=\"hidden\" name=\"forum\" value=\"1\">";
	}

	$printString = <<"EOM";
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col3"><td $bgclass2 align="left" colspan="2" bgcolor="$col3" nowrap>
<img src="$imgurl/pen.gif" align="middle">&nbsp; <b>投稿原稿の確認・修正フォーム</b></td>
</tr>
EOM
print &strEncode($printString);

	print <<EOM;
<input type="hidden" name="time" value="$time">
<input type="hidden" name="mode" value="regist">
<input type="hidden" name="f" value="$in{'f'}">
<input type="hidden" name="forum" value="$in{'forum'}">
<input type="hidden" name="res" value="$in{'res'}">
<input type="hidden" name="sort" value="$in{'sort'}">
<input type="hidden" name="cook" value="$in{'cook'}">
EOM

	# 投稿認証キー機能	（2010/01/29 スガラボット追加修正)
	if ($captcha) {
		print <<EOM;
<<input type="hidden" name="chk" value="$in{'chk'}">
<input type="hidden" name="ciphertext" value="$in{'ciphertext'}">
EOM
	}

	if ($regist_key) {
		print <<EOM;
<input type="hidden" name="regikey" value="$in{'regikey'}">
<input type="hidden" name="str_crypt" value="$in{'str_crypt'}">
EOM
	}

	# スレッドタイトルとすれ親の題名を分離したことにより処理 （2009/05/01 スガラボット修正)
	if (!$in{'res'} && ($thread_theme || $admin_flag || $in{'mode'} eq 'admin')) {
		print &strEncode("<tr bgcolor=\"$col2\"><th bgcolor=\"$col2\" nowrap>スレッドテーマ</th>");
		print &strEncode("<td align=\"left\"><input id=\"w420\" type=\"text\" name=\"tsub\" value=\"$in{'tsub'}\" maxlength=\"$sublength\">");
		print &strEncode("&nbsp; (空欄にすると次の題名と同じ内容になります)</td></tr>");
	}

	$printString = <<EOM;
<tr bgcolor="$col2">
  <th bgcolor="$col2" nowrap>題名</th>
  <td align="left"><input id="w540" type="text" name="sub" value="$in{'sub'}" maxlength="$sublength">
</tr>
EOM
print &strEncode($printString);

	# 特定レスへの返信機能を追加する (20080218 守田修正)
	if ($no && $in{'res'}) {
		$printString = <<"EOM";
<tr bgcolor="$col2">
  <th bgcolor="$col2" width="90">レス指定返信</th><td align="left">
EOM
print &strEncode($printString);

		print "<b>(No.";
		print &strEncode("<input id=\"w35\" type=\"text\" name=\"resto\" value=\"$res_no\" maxlength=\"3\" value=\"\" istyle=\"4\" mode=\"numeric\">");
		print &strEncode(")</b>の発言に対して返信する &nbsp;&nbsp;(空欄にするとスレッドの元テーマに対する発言になります)");
		print "</td></tr>";
	}

	$printString = <<"EOM";
<tr bgcolor="$col2">
  <th bgcolor="$col2" nowrap>名前</th>
  <td align="left"><input id="w330" type="text" name="name" value="$i_nam" maxlength="60"></td>
</tr>
EOM
print &strEncode($printString);

	if ($in_mail == 2) {
	} else {

	print <<"EOM";
<tr bgcolor="$col2">
  <th bgcolor="$col2" nowrap>E-Mail</th>
  <td align="left"><input id="#330" type="text" name="email" value="$eml" style="ime-mode:inactive" istyle="3" mode="alphabet">
EOM

	if ($show_mail) {
		print "  <select name=\"mvw\">\n";
		if ($cmvw eq "") { $cmvw = 0; }
		@mvw = ('非表示','表示');
		foreach (0,1) {
			if ($mvw == $_) {
				print &strEncode("<option value=\"$_\" selected>$mvw[$_]\n");
			} else {
				print &strEncode("<option value=\"$_\">$mvw[$_]\n");
			}
		}
		print "</select>\n";
	} else {
		print &strEncode("  <input type=\"hidden\" name=\"mvw\" value=\"0\"> 入力すると <img src=\"$imgurl/mail.gif\" alt=\"メールを送信する\" width=\"16\" height=\"13\" border=\"0\"> からメールを受け取れます（アドレス非表\示）\n");
	}
	if ($in_mail == 3) {
		print &strEncode(" 迷惑投稿防止のため何か入れると投稿できません\n");

	} elsif ($in_mail == 1) {
		print &strEncode(" （必須）\n");
	}
	print <<EOM;
</td>
</tr>
EOM

	}
	if ($url eq "") { $url = "http://"; }

	print <<"EOM";
<tr bgcolor="$col2">
  <th bgcolor="$col2">URL</th>
  <td align="left" bgcolor="$col2"><input id="w330" type="text" name="url" value="$url" style="ime-mode:inactive" istyle="3" mode="alphabet"></td>
</tr>
EOM

# デバッグプリント
#	print &strEncode("<tr><th>image_upl=</th><td>$image_upl</td></tr>");

	# 親記事は添付フォーム ⇒ 返信記事にもファイルアップロードを許可したためファイル修正条件を以下の3行に変更 (20080926 スガラボット修正)
	local ($file_ipl) = 0;
	if (($upl{1} ne ',,,,') || ($upl{2} ne ',,,,') || ($upl{3} ne ',,,,') && !$ua) {$file_upl = 1;}
	if (($image_upl && !$in{'no'}) || ($image_upl == 2) || $file_upl) {
		print &strEncode("<tr bgcolor=\"$col2\"><th bgcolor=\"$col2\" width=\"90\">添付ファイル</th>");
		print "<td align=\"left\" bgcolor=\"$col2\">\n";
		print &strEncode("(新しいファイルを指定すると前のファイルを上書きして更新。ファイルが空欄なら標題のみ修正)<br>\n");

print <<EOM;
<script type="text/javascript">
function sample(oId){
	var obj = document.getElementById(oId);
	var stO = obj.innerHTML;
	obj.innerHTML = stO;
}
</script>
EOM

		foreach my $i (1 .. 3) {
#			local($ex) = split(/,/, $upl{$i});
			# 添付ファイルの名前と標題を表示するように以下の3行を修正・追加 (20080215 守田修正)
			local($ex,$w,$h,$filename,$filetitle) = split(/,/, $upl{$i});
#			print "<input id=\"w330\" type=\"file\" name=\"upfile$i\" value=\"$filename\" size=\"$f_size\" istyle=\"3\" mode=\"alphabet\">\n";
			print "<span id=\"FL$i\"><input id=\"w330\" type=\"file\" name=\"upfile$i\" size=\"$f_size\" istyle=\"3\" mode=\"alphabet\"></span>";
			print &strEncode("<input type=\"button\" value=\"←クリア\" onclick=\"sample(\'FL$i\')\">");
			print &strEncode(" &nbsp;&nbsp; 標題: <input id=\"w300\" type=\"text\" name=\"ftitle$i\" value=\"$filetitle\" maxlength=\"30\">\n");
			if ($ex) {
				print &strEncode("&nbsp;[<a href=\"$uplurl/$tim-$i$ex\" target=\"_blank\">確認</a>]\n");
				print &strEncode("<input type=\"checkbox\" name=\"del$i\" value=\"1\">添付ファイル削除\n");
			}
			print "<br>\n";
		}

		print "</td></tr>\n";
	}

	$printString = <<EOM;
<tr bgcolor="$col2">
  <th bgcolor="$col2">パスワード</th>
  <td align="left" bgcolor="$col2">
  <input id="w115" type="password" name="pwd" value="$in{'pwd'}" maxlength="8" style="ime-mode:inactive" istyle="3" mode="alphabet">
   記事メンテ時に使用 (入力しておくと後から発言を修正・削除できます)
  </td>
</tr>
EOM
print &strEncode($printString);

	# 投稿できる最大文字数を表示 (スガラボット修正分)
	$printString = <<EOM;
<tr bgcolor="$col2">
  <td bgcolor="$col2" align="center"><b>記事本文</b><br><span class=s2><br>(全角$max_msg字まで)</span></td>
  <td align="left" bgcolor="$col2">
EOM
print &strEncode($printString);

	# アイコン
	if ($smile) {
		@s1 = split(/\s+/, $smile1);
		@s2 = split(/\s+/, $smile2);
		foreach (0 .. $#s1) {
			print "<a href=\"javascript:MyFace('$s2[$_]')\">";
			print "<img src=\"$imgurl/$s1[$_]\" border=0></a>\n";
		}
# コメント内にURLの記載を許可しないときは注意書きを表示する。
		if ($urlnum == 0) {
			print &strEncode("<font color='red'>　(ご注意: このパティオではスパム対策のため発言にURLの書き込みを禁止しています)</font>");
		}
		print "<br>\n";
	}

	$com =~ s/<br>/\n/g;

	# 本文印刷色の色指定機能追加 （20080210守田修正)
	if ($color) { print &strEncode("<font color=\"$color\">■■■元の記事本文はこの色で印刷されていました■</font><br>\n"); }
	else { $color = "#000000"; }

	$printString = <<"EOM";
<textarea id="w680" name="comment" cols="$cols" rows="$rows" wrap="soft">$com</textarea><br>
<b>文字色</b>
EOM
print &strEncode($printString);

	@colors = split(/,/, $char_color);
	foreach $c (@colors) {
		$checked = "";
		if ($c eq $color) { $checked = "checked"; }
		print &strEncode("<input type=\"radio\" name=\"color\" value=\"$c\" $checked><font color=\"$c\">■</font>\n");
	}

	$printString = <<"EOM";
</td></tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2"><br></td>
  <td align="left" bgcolor="$col2">
    <input type="submit" name="submit" value="この内容で投稿する">
    <input type="submit" name="submit" value="$prevButton">
    <input type="submit" name="submit" value="$quitButton">
  </td>
</tr></table>
</form></div>
EOM
print &strEncode($printString);

	&pr_footer;

	$printString = <<"EOM";
</body>
</html>
EOM
print &strEncode($printString);

	exit;
}

#-------------------------------------------------
#  記事削除
#-------------------------------------------------
sub delete {
	# 汚染チェック
	$in{'f'}  =~ s/\D//g;
	$in{'no'} =~ s/\D//g;

	# 削除処理
	if ($in{'job'} eq "del") {
		if ($in{'pwd'} eq '') { &error("パスワードの入力モレです"); }

		# スレッドより削除記事抽出
		local($flg,$top,$check,$last_nam,$last_dat,@new);
		open(DAT,"+< $logdir/$in{'f'}.cgi") || &error("Open Error: $in{'f'}.cgi");
		eval "flock(DAT, 2);";
#		$top = <DAT>;
		$top = &lineDecode(DAT);

		for ($line = 0; $buf = <DAT>; $line++) {
			chomp($buf);
# 一般記事にもファイルロードを許可するため以下の二行を修正 （2008/09/24 スガラボット修正)
#			($no[$line],$sub[$line],$nam[$line],$eml[$line],$com[$line],$dat[$line],$ho[$line],$pw[$line],$url[$line],$mvw[$line],
#					$myid[$line],$tim[$line],undef,undef,undef,$idcrypt[$line],$color[$line],$resto[$line])  = split(/<>/, $buf);
			($no[$line],$sub[$line],$nam[$line],$eml[$line],$com[$line],$dat[$line],$ho[$line],$pw[$line],$url[$line],$mvw[$line],
					$myid[$line],$tim[$line],$upl[1][$line],$upl[2][$line],$upl[3][$line],$idcrypt[$line],$color[$line],$resto[$line])  = split(/<>/, $buf);
			$prnt[$line] = $resto[$line];
		}
		$num = $line;

#		close(IN);

# ツリー構造のインデックス・リストを作成
		for ($line = 0; $line < $num; $line++) {
			&lst_cre($line, $prnt[$line], $no[$line]);
		}

# もし削除しようとする発言に返信した子ノードがあれば削除禁止 （20080220 守田修正)
		$idx = $in{'no'};
		if ($idx && $chid[$lineno[$idx]] != 0) { &error("返信がついている記事は削除できません"); }

# 兄弟ノードがある発言の削除要求がある場合は削除しない記事のノードリンクを繋ぐ
#		if ($idx && $next[$lineno[$idx]] ne $lineno[$idx]) {
#			$next[$prev[$lineno[$idx]]] = $next[$idx];
#			$prev[$next[$lineno[$idx]]] = $prev[$idx];
#		}

		seek(DAT, 0, 0);
#		$top = <DAT>;
		$top = &lineDecode(DAT);
		$i=-1;
#		while(<DAT>) {
		while( $_ = &lineDecode(DAT) ) {
			local($no,$sub,$nam,$eml,$com,$dat,$ho,$pw,$url,$mvw,$myid,$tim,$upl{1},$upl{2},$upl{3}) = split(/<>/);

			if ($in{'no'} == $no) {
				$flg = 1;

				# パス照合
				$check = &decrypt($in{'pwd'}, $pw);

				# スレッドヘッダのレス個数を調整
				local($num,$sub2,$res,$key) = split(/<>/, $top);
				$res--;
				$top = "$num<>$sub2<>$res<>$key<>\n";

				# 画像削除
				foreach $i (1 .. 3) {
					next if (!$upl{$i});

					local($ex) = split(/,/, $upl{$i});
					if (-e "$upldir/$tim-$i$ex") {
						unlink("$upldir/$tim-$i$ex");
					}
				}

				$i++;
				# スキップ
				next;
			}
			push(@new,$_);

			# 最終記事の投稿者と時間・タイトルを覚えておく
			$last_nam = $nam;
			$last_dat = $dat;
			$last_sub = $sub;
		}

		if (!$flg) { &error("該当記事が見当たりません"); }
		if (!$check) { &error("パスワードが違います"); }

		# レス個数補正
		local($num,$sub2,$res,$key) = split(/<>/, $top);
		$top = "$num<>$sub2<>$i<>$key<>\n";

		# スレッド更新
		unshift(@new,$top);
		seek(DAT, 0, 0);
#		print DAT @new;
		print DAT &arrayEncode(\@new, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# index展開
		@new = ();
		local($top, @sort, @top, @faq);
		open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
		eval "flock(DAT, 2);";
#		$top = <DAT>;
		$top = &lineDecode(DAT);
		
#		while(<DAT>) {
		while( $_ = &lineDecode(DAT) ) {
			s/\n//;
			local($no,$sub,$res,$nam,$da,$na2,$key,$upl,$ressub,$restime) = split(/<>/);
			chomp ($ressub);
			chomp ($restime);

			if ($key == 2) {
				push(@top,"$_\n");
				next;
			}
			if ($key == 3 && $in{'f'} != $no) {
				push(@faq,"$_\n");
				next;
			}
			if ($key == 3 && $in{'f'} == $no) {
				# indexのレス個数を調整し、最終投稿者と時間を置換
# レス数はカウントし直して使う
#				$res--;
				$na2 = $last_nam;
				$dat = $last_dat;
				if ($i< 1) { $last_sub =""; }
				$_ = "$no<>$sub<>$i<>$nam<>$da<>$na2<>$key<>$upl<>$last_sub<>$dat<>";
				push(@faq,"$_\n");
				next;
			}
			if ($in{'f'} == $no) {
				# indexのレス個数を調整し、最終投稿者と時間を置換
# レス数はカウントし直して使う
#				$res--;
				$na2 = $last_nam;
				$dat = $last_dat;
				if ($i< 1) { $last_sub =""; }
				$_ = "$no<>$sub<>$i<>$nam<>$da<>$na2<>$key<>$upl<>$last_sub<>$dat<>";
			}
			push(@new,"$_\n");

			# ソート用配列
			$dat =~ s/\D//g;
			push(@sort,$dat);
		}

		# 投稿順にソート
		@new = @new[sort {$sort[$b] <=> $sort[$a]} 0 .. $#sort];

		# index更新
		unshift(@new,@faq) if (@faq > 0);
		unshift(@new,@top) if (@top > 0);
		unshift(@new,$top);
		seek(DAT, 0, 0);
#		print DAT @new;
		print DAT &arrayEncode(\@new, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# RSS/Atom (2009/10/15 以下4行を追加: スガラボット)
		if($feed == 2) {
			require $feedpl;
			&feed("del");
		}

		# 完了メッセージ
		&header;
		print "<div align=\"center\">\n";
		print &strEncode("<b>記事は正常に削除されました。</b><p>\n");
		print "<form action=\"$bbscgi\">\n";
		print &strEncode("<input type=\"submit\" value=\"掲示板へ戻る\"></form>\n");
		print "</div>\n";
		&pr_footer;
		print "</body></html>\n";
		exit;
	}

	# 該当ログチェック
	local($flg,$top,$no,$sub,$nam,$eml,$com,$dat,$ho,$pw);
	open(IN,"$logdir/$in{'f'}.cgi");
#	$top = <IN>;
	$top = &lineDecode(IN);
#	while(<IN>) {
	while($_ = &lineDecode(IN) ) {
		($no,$sub,$nam,$eml,$com,$dat,$ho,$pw) = split(/<>/);

		last if ($in{'no'} == $no);
	}
	close(IN);

	if ($pw eq "") {
		&error("該当記事はパスワードが設定されていないため<br>削除することはできません");
	}

	&header;
	$printString = <<"EOM";
<div align="center">
<Table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col3"><td $bgclass2 align="left" bgcolor="$col3" nowrap width="92%">
<img src="$imgurl/trash.gif" align="top">
&nbsp; <b>記事削除フォーム</b></td>
<td align="right" bgcolor="$col3" nowrap>
<a href="javascript:history.back()">前画面に戻る</a></td>
</tr></table>
<P>
<form action="$registcgi" method="post">
<input type="hidden" name="mode" value="del">
<input type="hidden" name="job" value="del">
<input type="hidden" name="f" value="$in{'f'}">
<input type="hidden" name="no" value="$in{'no'}">
<Table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="80" nowrap>削除記事</td>
  <td>記事： No.<b>$in{'no'}</b><br>件名： <b>$sub</b><br>名前： <b>$nam</b>
  </td>
</tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="80" nowrap>パスワード</td>
  <td><input type="password" name="pwd" size="8" maxlength="8">
	<input type="submit" value="記事を削除">
  </td></form>
</tr>
</table>
</div>
EOM
print &strEncode($printString);

	&pr_footer;

	$printString = <<"EOM";
</body>
</html>
EOM
print &strEncode($printString);
	exit;
}

#-------------------------------------------------
#  メンテ処理
#-------------------------------------------------
sub mente {
	# 汚染チェック
	$in{'f'}  =~ s/\D//g;
	$in{'no'} =~ s/\D//g;

	# 記事修正
	if ($in{'job'} eq "edit") {
		if ($in{'pwd'} eq '') { &error("パスワードの入力モレです"); }

		require $editlog;
		&edit_log("user");

	# 削除処理
	} elsif ($in{'job'} eq "del") {

		if ($in{'pwd'} eq '') { &error("パスワードの入力モレです"); }

		# スレッドより削除記事抽出
		local($flg, $top, @new, $lrtime);
		open(DAT,"+< $logdir/$in{'f'}.cgi") || &error("Open Error: $in{'f'}.cgi");
		eval "flock(DAT, 2);";

#		$buf = <DAT>;
		$buf = &lineDecode(DAT);
#		for ($line = 0; $buf = <DAT>; $line++) {
		for ($line = 0; $buf = &lineDecode(DAT); $line++) {
			chomp($buf);
# 返信記事にもファイルアップロードを許可するため修正 (20080924 スガラボット修正)
			($no[$line],$sub[$line],$nam[$line],$eml[$line],$com[$line],$dat[$line],$ho[$line],$pw[$line],$url[$line],$mvw[$line],
					$myid[$line],$tim[$line],$upl[1][$line],$upl[2][$line],$upl[3][$line],$idcrypt[$line],$color[$line],$resto[$line])  = split(/<>/, $buf);
			$prnt[$line] = $resto[$line];
		}
		$num = $line;

#		close(IN);

# ツリー構造のインデックス・リストを作成
		for ($line = 0; $line < $num; $line++) {
			&lst_cre($line, $prnt[$line], $no[$line]);
		}

# もし削除しようとする発言に返信した子ノードがあれば削除禁止 （20080220 守田修正)
		$idx = $in{'no'};

######## デバッグ用にtree テーブルの表示
#		&header;
#		print "li,;no,prnt,chid,next,prev<br>\n";
#		for ($line = 0; $line < $num; $line++) {
#		    printf("% 4d,% 4d,% 4d,% 4d,% 4d,% 4d, %50s<br>\n", $line, $no[$line],
#		        $prnt[$line], $chid[$line], $next[$line], $prev[$line], $sub[$line]);
#		}
#		print "<br>\n";
#		# デバッグ用にtree 行番号逆引きテーブル表示
#		$ln = $no[-1] + 1;
#		for ($line = 0; $line < $ln; $line++) {
#		    printf("%4d,%4d<br>\n", $line, $lineno[$line]);
#		}
#		print "\n";
#		print "Debug: no=$idx, chid=$chid[$lineno[$idx]]<br>\n";

		if ($idx && $chid[$lineno[$idx]] != 0) { &error("返信がついている記事は削除できません"); }

#		&error("debug: idx=$idx, chid=$chid[$lineno[$idx]]<br>");

		seek(DAT, 0, 0);
#		$top = <DAT>;
		$top = &lineDecode(DAT);
#		while(<DAT>) {
		while( $_ = &lineDecode(DAT) ) {
			local($no,$sub,$nam,$eml,$com,$dat,$ho,$pw,$url,$mvw,$myid,$tim,$upl{1},$upl{2},$upl{3},$idcrypt,$color,$resto) = split(/<>/);

#			# スレッド内で一番最後に更新された記事の時刻を覚える	← (※1)この処理は削除するレスについては行わないようにスキップの後に移す。(20080428 スガラボット)
#			if ($tim ne 0 && $tim > $lrtime) { $lrtime = $tim; }

			if ($in{'no'} == $no) {
				$flg = 1;

				# 管理パスワードで削除
				if ($in{'pwd'} ne $pass) {
				# パス照合
				$check = &decrypt($in{'pwd'}, $pw);
				}

				# スレッドヘッダのレス個数を調整
				($num,$sub2,$res,$key) = split(/<>/, $top);
				$res--;
				$top = "$num<>$sub2<>$res<>$key<>\n";

				# 添付削除
				foreach $i (1 .. 3) {
					next if (!$upl{$i});

					local($ex) = split(/,/, $upl{$i});
					if (-e "$upldir/$tim-$i$ex") {
						unlink("$upldir/$tim-$i$ex");
					}
				}

				# スキップ
				next;
			}

			# スレッド内で一番最後に更新された記事の時刻を覚える  ← 上(※1)の処理をここに移動した。(20080428 スガラボット)
			if ($tim ne 0 && $tim > $lrtime) { $lrtime = $tim; }

			push(@new,$_);

			# 最終記事の投稿者と時間を覚えておく
			$last_nam = $nam;
			$last_dat = $dat;
			# タイトルも
			$last_sub = $sub;
		}

		if (!$flg) { &error("該当記事が見当たりません"); }
#		if (!$check) { &error("パスワードが違います"); }
		if (!$check && $in{'pwd'} ne $pass ) { &error("パスワードが違います"); }

		# スレッド更新
		unshift(@new,$top);
		seek(DAT, 0, 0);
#		print DAT @new;
		print DAT &arrayEncode(\@new, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# index展開
		@new = (); @sort = (); @top = (); @faq = ();

		open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
		eval "flock(DAT, 2);";
#		$top = <DAT>;
		$top = &lineDecode(DAT);
#		while(<DAT>) {
		while( $_ = &lineDecode(DAT) ) {
			s/\n//;
			local($no,$sub,$res,$nam,$dat,$na2,$key,$upl) = split(/<>/);

			if ($key == 2) {
				push(@top,"$_\n");
				next;
			}
			if ($key == 3 && $in{'f'} != $no) {
				push(@faq,"$_\n");
				next;
			}
			if ($key == 3 && $in{'f'} == $no) {
				# indexのレス個数を調整し、最終投稿者と時間を置換
				$res--;
				$na2 = $last_nam;
				$dat = $last_dat;
# レスがない場合は、レスのタイトルを空欄に
				if ($res<1) {$last_sub="";}
				$_ = "$no<>$sub<>$res<>$nam<>$dat<>$na2<>$key<>$upl<>$last_sub<>$lrtime<>";
				push(@faq,"$_\n");
				next;
			}
			if ($in{'f'} == $no) {
				# indexのレス個数を調整し、最終投稿者と時間を置換
				$res--;
				$na2 = $last_nam;
				$dat = $last_dat;
# レスがない場合は、レスのタイトルを空欄に
				if ($res<1) {$last_sub="";}
# レスのタイムスタンプが0のときは空欄に	(20080428 スガラボット修正)
				if (!$lrtime) {$lrtime = "";}
				$_ = "$no<>$sub<>$res<>$nam<>$dat<>$na2<>$key<>$upl<>$last_sub<>$lrtime<>";
			}
			# スレッド元発言を削除するときはこの行を保存しないよう修正 (2009 スガラボット修正)
#			push(@new,"$_\n");
			push(@new,"$_\n") if ($res >= 0);

			# ソート用配列
			$dat =~ s/\D//g;
			push(@sort,$dat);
		}

		# 投稿順にソート
		@new = @new[sort {$sort[$b] <=> $sort[$a]} 0..$#sort];

		# index更新
		unshift(@new,@faq) if (@faq > 0);
		unshift(@new,@top) if (@top > 0);
		unshift(@new,$top);
		seek(DAT, 0, 0);
#		print DAT @new;
		print DAT &arrayEncode(\@new, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# RSS/Atom （2009/10/15 以下4行追加: スガラボット)
		if($feed == 2) {
			require $feedpl;
			&feed("del");
		}

		# 完了メッセージ
		&header;
		print "<div align=\"center\">\n";
		print &strEncode("<b>記事は正常に削除されました。</b><p>\n");
		print "<form action=\"$bbscgi\">\n";
		print &strEncode("<input type=\"submit\" value=\"掲示板へ戻る\"></form>\n");
		print "</div>\n";
		&pr_footer;
		print "</body></html>\n";
		exit;

	# ロック処理
	} elsif ($in{'job'} eq "lock") {

		if ($in{'pwd'} eq '') { &error("パスワードの入力モレです"); }

		local($top);
		open(DAT,"+< $logdir/$in{'f'}.cgi") || &error("Open Error: $in{'f'}.cgi");
		eval "flock(DAT, 2);";
#		local(@file) = <DAT>;
		our(@file) = &arrayDecode(DAT);

		$top = shift(@file);

		# パスワードチェック
		local($no,$sb,$na,$em,$com,$da,$ho,$pw) = split(/<>/, $file[0]);

# 管理者ロック
		if ($in{'pwd'} eq $pass) {} 
		elsif (!&decrypt($in{'pwd'}, $pw)) { &error("パスワードが違います"); }

		# 更新
		local($num,$sub,$res,$key) = split(/<>/, $top);

		if ($in{'pwd'} eq $pass && $key == 4) { $key = 1;} 
		elsif ($in{'pwd'} eq $pass ) { $key = 4; }
		elsif ($in{'pwd'} ne $pass && $key == 4) { &error("管理者ロックされています"); }
		elsif ($key == 1) { $key = 0; }
		elsif ($key == 0) { $key = 1; }

		unshift(@file,"$num<>$sub<>$res<>$key<>\n");
		seek(DAT, 0, 0);
#		print DAT @file;
		print DAT &arrayEncode(\@file, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# index展開
		@new = ();
		open(DAT,"+< $nowfile") || &error("Open Error: $nowfile");
		eval "flock(DAT, 2);";
#		$top = <DAT>;
		$top = &lineDecode(DAT);
#		while(<DAT>) {
		while( $_ = &lineDecode(DAT) ) {
			s/\n//;
			local($no,$sub,$res,$nam,$da,$na2,$key2,$upl,$ressub,$restime) = split(/<>/);

			if ($in{'f'} == $no) {
				$_ = "$no<>$sub<>$res<>$nam<>$da<>$na2<>$key<>$upl<>$ressub<>$restime<>";
			}
			push(@new,"$_\n");
		}

		# index更新
		unshift(@new,$top);
		seek(DAT, 0, 0);
#		print DAT @new;
		print DAT &arrayEncode(\@new, $logchar);
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		&header;
		print "<div align=\"center\">\n";

		if ($key == 4) {
			print &strEncode("<b>スレッドは管理者によりロックされました。</b>\n");
		} elsif ($key == 1) {
			print &strEncode("<b>スレッドはロック解除されました。</b>\n");
		} else {
			print &strEncode("<b>スレッドはロックされました。</b>\n");
		}

		print "<form action=\"$bbscgi\">\n";
		print &strEncode("<input type=\"submit\" value=\"掲示板へ戻る\"></form>\n");
		print "</div>\n";
		&pr_footer;
		print "</body></html>\n";
		exit;
	}

# BBCode処理の変数関数を選択 (2009/01/27 スガラボット修正)
	if ($bbcode) { $titlebb ="bbtitle"; } 
	else { $titlebb = "titlebbrm"; }

	# 該当ログチェック
	$flg = 0;
	open(IN,"$logdir/$in{'f'}.cgi");
#	$top = <IN>;
	$top = &lineDecode(IN);
#	while (<IN>) {
	while ( $_ = &lineDecode(IN) ) {
		($no,$sub,$name,$email,$com,$date,$host,$pw) = split(/<>/);

		last if ($in{'no'} == $no);
	}
	close(IN);

	# 管理者による変更ができるように無効化
#	if ($pw eq "") {
#		&error("該当記事はパスワードが設定されていません");
#	}

# タイトルと名前に文字修飾機能追加 （2009/01/27 スガラボット修正)
	$sub = &$titlebb($sub);	
	$name = &$titlebb($name);	

	($num,$sub2,$res,$key) = split(/<>/, $top);

	&header;
	$printString = <<"EOM";
<div align="center">
<Table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col3"><td $bgclass2 align="left" bgcolor="$col3" nowrap width="92%">
<img src="$imgurl/mente.gif" align="top">
&nbsp; <b>メンテフォーム</b></td>
<td $bgclass2 align="right" bgcolor="$col3" nowrap>
<a href="javascript:history.back()">前画面に戻る</a></td>
</tr></table>
<P>
<form action="$registcgi" method="post">
<input type="hidden" name="mode" value="mente">
<input type="hidden" name="f" value="$in{'f'}">
<input type="hidden" name="no" value="$in{'no'}">
<Table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="75" nowrap>対象スレッド</td>
  <td align="left">件名： <b>$sub</b><br>名前： <b>$name</b>
  </td>
</tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="75" nowrap>処理選択</td>
  <td align="left"><select name="job">
	<option value="edit" selected>記事を修正
EOM
print &strEncode($printString);

	if (!$in{'no'}) {
		if ($key == 1) {
			print &strEncode("<option value=\"lock\">スレッドをロック\n");
		} elsif ($key == 0) {
			print &strEncode("<option value=\"lock\">ロックを解除\n");
		}
	} 
# スレッド元発言でもレスが付いていなければ投稿者によって削除可能とする。（2009/01/16 スガラボット修正)
#	else {
		print &strEncode("<option value=\"del\">記事を削除\n");
#	}

	$printString = <<"EOM";
	</select>
  </td>
</tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="75" nowrap>パスワード</td>
  <td align="left"><input type="password" name="pwd" size="10" maxlength="8">
	<input type="submit" value="送信する">
  </td></form>
</tr>
</table>
</Td></Tr></Table>
EOM
print &strEncode($printString);

	$printString = <<"EOM";
<P>
<form action="$admincgi" method="post">
<input type="hidden" name="mode" value="admin">
<input type="hidden" name="logfile" value="1">
<input type="hidden" name="no" value="$in{'f'}">
<input type="hidden" name="no2" value="$in{'no'}">
<input type="hidden" name="action" value="view">
<input type="hidden" name="job" value="split">
<Table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="75" nowrap>管理者モード</td>
  <td align="left">このレスでスレッド分割
  </td>
</tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="75" nowrap>管理パスワード</td>
  <td align="left"><input type="password" name="pass" size="10" maxlength="8">
	<input type="submit" value="スレッド分割（管理者のみ）">
  </td></form>
</tr>
</table>
EOM
print &strEncode($printString);

	if ($in{'no'} eq "") {
	$printString = <<"EOM";
<P>
<form action="$admincgi" method="post">
<input type="hidden" name="mode" value="admin">
<input type="hidden" name="logfile" value="1">
<input type="hidden" name="action" value="del">
<input type="hidden" name="no" value="$in{'f'}">
<Table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="75" nowrap>管理者モード</td>
  <td align="left">スレッド削除
  </td>
</tr>
<tr bgcolor="$col2">
  <td bgcolor="$col2" width="75" nowrap>管理パスワード</td>
  <td align="left"><input type="password" name="pass" size="10" maxlength="8">
	<input type="submit" value="スレッド削除（管理者のみ）">
  </td></form>
</tr>
</table>
</Td></Tr></Table>
EOM
print &strEncode($printString);
	}

	print <<"EOM";
</div>
EOM

	&pr_footer;

	print <<"EOM";
</body>
</html>
EOM
	exit;
}

#-------------------------------------------------
#  クッキー発行
#-------------------------------------------------
sub set_cookie {
	local(@cook) = @_;
	local($gmt, $cook, @t, @m, @w);

	@t = gmtime(time + 60*24*60*60);
	@m = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	@w = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');

	# 国際標準時を定義
	$gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
			$w[$t[6]], $t[3], $m[$t[4]], $t[5]+1900, $t[2], $t[1], $t[0]);

	# 保存データをURLエンコード
#	foreach (@cook) {
#		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
#		$cook .= "$_<>";
#	}
	foreach my $item(@cook) {
		$item = &strEncode($item);
		$item =~ s/([^\w\=\& ])/'%' . unpack("H2", $1)/eg;
		$item =~ tr/ /+/;
		$cook .= "$item<>";
	}

	# 格納
#	print "Set-Cookie: WEB_PATIO=$cook; expires=$gmt\n";
	print "Set-Cookie: WEB_PATIO=$cook; expires=$gmt; Path=$room_url\n";
}

#-------------------------------------------------
#  メール送信
#-------------------------------------------------
sub sendmail {
	local($msub, $mbody, $mcom, $email);
#	local($msub, $mbody, $email);			# FEED機能追加により$mcomはグローバル変数に変更 （2009/10/20 スガラボット修正)

	# タイトルと名前のBBCodeを削除 （2009/01/14 スガラボット修正)
	$i_sub = &titlebbrm($i_sub);
	$i_nam2 = &titlebbrm($i_nam2);

	# メールタイトルを定義
	$msub = "$title： $i_sub";

	# 本文の改行・タグを復元
	$mcom = $i_com;

	# 本文のBBCodeを削除 （2009/01/14 スガラボット修正)
	$mcom = &bbcoderm($mcom);
	
	$mcom =~ s/<br>/\n/g;
	$mcom =~ s/&lt;/＜/g;
	$mcom =~ s/&gt;/＞/g;
	$mcom =~ s/&quot;/”/g;
	$mcom =~ s/&amp;/＆/g;
	
	if ($in{'res'} eq "") { $no = $new; $resno = ''; }
	else { $resno = "No.$newno "; }
	
	# 新規投稿により最大記事数に達したときは管理者にアラームメーセージを追加
	my $notice = '';
	if ($noticeflag) { $notice = " ***** サーバ通報：この投稿により [スレッド $no] の記事数が許容規定数に達しました！！ *****\n"; }

$mbody = <<EOM;
--------------------------------------------------------
${title}の
[スレッド $no] に以下の投稿がありましたのでお知らせします。
$notice
タイトル：$resno$i_sub
投稿日時：$date
ホスト名：$host
ブラウザ：$ENV{'HTTP_USER_AGENT'}

おなまえ：$i_nam2
Ｅメール：$in{'email'}
タイトル：$i_sub
ＵＲＬ  ：$in{'url'}

送信されたデータの本文
--------------------------------------------------------
$mcom

スレッドを見る
$fullscript&no=$no
--------------------------------------------------------
(ご注意: このメールは自動送信です。この通知メールの発アドレス宛てには返信しないで下さい。)
EOM

# Hi-HOのssendmailに合わせて題名のエンコードを'euc'に変更方を変更 スガラボット修正分
#	if ($hi_ho) { &jcode'convert(*msub,'euc'); }
	if ($hi_ho) { $msub = Unicode::Japanese->new($msub)->euc; }
	# 題名をBASE64化
	else 		{ $msub = &base64($msub); }

	# メールアドレスがない場合は管理者アドレスに置き換え
#	if ($in{'email'} eq "") { $email = $mailto; }
#	else { $email = $in{'email'}; }

# 管理者への新規スレッド投稿通知の差出人はサーバアドレスとする。KENTオリジナルではこうなってた筈。(20080212 守田修正)
	if ($sender eq "") { $email = $in{'email'}; }
	else { $email = $sender; }

# 複数の管理人がいたときは一通ずつ送信する。(20080222 守田修正)

	# 複数アドレスがセットされていないときは従来の宛先を使用する
	if (!@mailto2) { $mailto2[0] = $mailto; }

	# 1通ずつ送信する
	foreach (@mailto2) {

		# sendmail送信
		if ($hi_ho) {
# Hi-HOのssendmailに合わせて$sendmailの呼び方を変更 スガラボット修正分
			open(MAIL,"| $sendmail -s \"$msub\" -f \"$email\" $_") || &error("送信失敗");
		}
		else {
			open(MAIL,"| $sendmail -t -i") || &error("送信失敗");
			print MAIL "To: $_\n";
			print MAIL "From: $email\n";
			print MAIL "Subject: $msub\n";
			print MAIL "MIME-Version: 1.0\n";
			print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
			print MAIL "Content-Transfer-Encoding: 7bit\n";
			print MAIL "X-Mailer: perl$]\n\n";
		}
		foreach ( split(/\n/, $mbody) ) {
#			&jcode'convert(*_, 'jis', 'sjis');
			my $str = Unicode::Japanese->new($_)->jis;
			print MAIL $str, "\n";
		}
		close(MAIL);	
	}

}

#-------------------------------------------------
#  レスお知らせ送信
#-------------------------------------------------
sub sendnotify {
	local($msub,$mbody,$mcom,$email,$no,$sub,@maillist,$eml,$top,$top2,$flg,@maillist2);
#	local($msub,$mbody,$email,$no,$sub,@maillist,$eml,$top,$top2,$flg,@maillist2);			# FEED機能追加により$mcomはグローバル変数に変更 （2009/10/20 スガラボット修正)

	# スレッド解体
	# スレッド読み込み
	open(IN,"$logdir/$in{'res'}.cgi") || &error("Open Error: $in{'res'}.cgi");
	my @file = &arrayDecode(IN);
	close(IN);

	# 先頭ファイルを抽出、分解
	$top = shift(@file);
	($no,$sub,undef,undef) = split(/<>/, $top);
	
	# スレ主のメールアドレスを抽出
	# トップ記事
	$top2 = shift(@file);
	(undef,undef,undef,$eml,undef,undef,undef,undef,undef,undef,undef,undef,undef) = split(/<>/, $top2);
	if ($eml ne "") {
		foreach ( split(/,/, $refuseaddr) ) {
			if (index("$eml",$_) >= 0) {
				$flg = 1; last;
			}
		}
		if ($flg == 0){
			push(@maillist,$eml);
		}
	}

	# レス記事 (スレッドに返信した人全員に通知メールを出す場合)
	if ($mailnotify==2 && $#file >= 0) {

		foreach ( @file ){
		# print $value, "\n";
			(undef,undef,undef,$eml,undef,undef,undef,undef,undef,undef,undef,undef,undef) = split(/<>/);
			if ($eml ne "") {
				$flg = 0;
				foreach ( split(/,/, $refuseaddr) ) {
					if (index("$eml",$_) >= 0) {
						$flg = 1; last;
					}
				}
				if ($flg == 0){
					push(@maillist,$eml);
				}
			}
		}
	}

	# レス指定返信の場合でスレ主と返信先に通知メールを出す場合 (20080222 以下18行を守田追加)
	if ($mailnotify==3 && $#file >= 0) {

		foreach ( @file ){
		# print $value, "\n";
			local($no,undef,undef,$eml,undef,undef,undef,undef,undef,undef,undef,undef,undef) = split(/<>/);
			if ($eml ne "" && $no == $resto) {
				$flg = 0;
				foreach ( split(/,/, $refuseaddr) ) {
					if (index("$eml",$_) >= 0) {
						$flg = 1; last;
					}
				}
				if ($flg == 0){
					push(@maillist,$eml);
				}
			}
		}
	}

	# メールアドレスの重複の削除
	my %uniq = map {$_ => 1} @maillist;
	my @maillist2 = keys %uniq;

#	my %count;
#	@maillist = grep {!$count{$_}++} @maillist;

#	print "@maillist";
	
	# メールタイトルを定義
	# タイトルと名前のBBCodeを削除 （2009/01/14 スガラボット修正)
	$sub = &titlebbrm($sub);
	$msub = "$title： [$no] $sub";
	
	# 本文の改行・タグを復元
	$mcom = $i_com;

	# 本文のBBCodeを削除 （2009/01/14 スガラボット修正)
	$mcom = &bbcoderm($mcom);

	$mcom =~ s/<br>/\n/g;
	$mcom =~ s/&lt;/＜/g;
	$mcom =~ s/&gt;/＞/g;
	$mcom =~ s/&quot;/”/g;
	$mcom =~ s/&amp;/＆/g;

$mbody = <<EOM;
--------------------------------------------------------
${title}の
"[スレッド $no] $sub" に新しいレスがありましたのでお知らせします。

タイトル：$resno$i_sub
日時　　：$date
おなまえ：$i_nam2

送信されたデータの本文
--------------------------------------------------------
$mcom

--------------------------------------------------------
スレッドを見る
$fullscript&no=$no&l=rev
(ご注意: このメールは自動送信です。この通知メールの発アドレス宛てには返信しないで下さい。)
EOM

# 使えそうな変数
# $sub
# $new
# $newno
# $fullscript 新設
#	本文はあえて掲載しないというテもアリ。
#	ホスト名：$host
#	ブラウザ：$ENV{'HTTP_USER_AGENT'}
#	Ｅメール：$in{'email'}
#	ＵＲＬ  ：$in{'url'}
#	$mcom

# レスお知らせメールの差出人はサーバアドレスとする。(20080222 守田修正)
#	if ($sender eq "") { $email = $in{'email'}; }
#	else { 
		$email = $sender; 
#	}

# Hi-HOのssendmailに合わせて題名のエンコードを'euc'に変更方を変更 スガラボット修正分
#	if ($hi_ho) { &jcode'convert(*msub,'euc'); }
	if ($hi_ho) { $msub = Unicode::Japanese->new($msub)->euc; }
	# 題名をBASE64化
	else 		{ $msub = &base64($msub); }

#	$notifybcc = "@maillist2";
	
	# 1通ずつ送信する
	foreach (@maillist2) {

		# sendmail送信
		if ($hi_ho) {
# Hi-HOのssendmailに合わせて$sendmailの呼び方を変更 スガラボット修正分
			open(MAIL,"| $sendmail -s \"$msub\" -f \"$email\" $_") || &error("送信失敗");
		}
		else {
			open(MAIL,"| $sendmail -t -i") || &error("送信失敗");
			print MAIL "To: $_\n";
			print MAIL "From: $email\n";
			print MAIL "Subject: $msub\n";
			print MAIL "MIME-Version: 1.0\n";
			print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
			print MAIL "Content-Transfer-Encoding: 7bit\n";
			print MAIL "X-Mailer: perl$]\n\n";
		}
		foreach ( split(/\n/, $mbody) ) {
#			&jcode'convert(*_, 'jis', 'sjis');
			my $str = Unicode::Japanese->new($_)->jis;
			print MAIL $str, "\n";
		}
		close(MAIL);	
	}

}

#-------------------------------------------------
#  BASE64変換
#-------------------------------------------------
#	とほほのWWW入門で公開されているルーチンを
#	参考にしました。( http://tohoho.wakusei.ne.jp/ )
sub base64_try {
	local($sub) = @_;
#	&jcode'convert(*sub, 'jis', 'sjis');
	$sub = Unicode::Japanese->new($sub)->conv('jis', 'base64');
	chomp($sub);
	$sub = "=?iso-2022-jp?B?" . $sub . "?=";
	return $sub;
}
sub base64{
	local($sub) = @_;
#	&jcode'convert(*sub, 'jis', 'sjis');
	$sub = Unicode::Japanese->new($sub)->jis;

	$sub =~ s/\x1b\x28\x42/\x1b\x28\x4a/g;
	$sub = "=?iso-2022-jp?B?" . &b64enc($sub) . "?=";
	$sub;
}
sub b64enc {
	local($ch)="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	local($x, $y, $z, $i);
	$x = unpack("B*", $_[0]);
	for ($i=0; $y=substr($x,$i,6); $i+=6) {
		$z .= substr($ch, ord(pack("B*", "00" . $y)), 1);
		if (length($y) == 2) {
			$z .= "==";
		} elsif (length($y) == 4) {
			$z .= "=";
		}
	}
	$z;
}

#---------------------------------------
#  トリップ機能
#---------------------------------------
sub trip {
	my($name) = @_;

	$name =~ s/◆/◇/g;

#	if ($i_nam =~ /#/) {	# 強調表示調整用 }
	# BBCodeの使用により名前の文字修飾で色コードが入ったときの対応 （2009/06/11 スガラボット修正)
	if ($name =~ /(?<!\[color=)#/) {
		$name =~ s/(\[color=)#/$1＃/ig;
		my($handle,$trip) = split(/#/, $name, 2);
		$handle =~ s/(\[color=)＃/$1#/ig;

#		local($enc) = crypt($trip, $trip_key) || crypt ($trip, '$1$' . $trip_key);
#		$enc =~ s/^..//;

# 2ch互換トリップ
		my($trip_key) = substr(substr($trip,0,8).'H.', 1, 2);
		$trip_key =~ s/[^\.-z]/\./go;
		$trip_key =~ tr/:;<=>?@[\\]^_`/ABCDEFGabcdef/;
#		my($enc) = substr(crypt($trip, $trip_key), -10);
		my $enc;
		eval { $enc = substr(crypt($trip, $trip_key), -10); };
		if ($@) { 
			&error("$@<br>トリップ部分の文字列は半角英数字(記号を含む)にして下さい!!"); 
		}

		return "$handle◆$enc";
	} else {
		return $name;
	}
}

#-------------------------------------------------
#  禁止ワードチェック
#-------------------------------------------------
sub no_wd {
	local($flg);
	foreach ( split(/,/, $no_wd) ) {
		# 禁止ワードチェックにURL欄も追加 （2009/03/24 きりしま式k0.8修正)
		if (index("$i_nam $i_sub $i_com $in{'url'}",$_) >= 0) {
			$flg = 1; last;
		}
	}
	if ($flg) { &error("禁止ワードが含まれています"); }
}

#-------------------------------------------------
#  日本語チェック
#-------------------------------------------------
sub jp_wd {
#	my($sub, $com, $mat1, $mat2, $code1, $code2);
	my($sub, $com, $code1, $code2);
	$sub = $i_sub;
	$com = $i_com;

	my $inst = Unicode::Japanese->new;

	if ($sub) {
#		($mat1, $code1) = &jcode'getcode(*sub);
		$code1 = $inst->getcode($sub);
		
	}
#	($mat2, $code2) = &jcode'getcode(*com);
	$code2 = $inst->getcode($com);
#	print "\$code1=$code1, \$code2=$code2<br>";
	if ($code1 ne 'utf8' && $code2 ne 'utf8') {
		&error("題名又はコメントに日本語が含まれていません");
	}
}

#-------------------------------------------------
#  URL個数チェック
#-------------------------------------------------
sub urlnum {
	local($com) = $i_com;
	local($num) = ($com =~ s|(https?://)|$1|ig);
	if ($num > $urlnum) {
		&error("コメント中のURLアドレスは最大$urlnum個までです。(0個の場合URLは記述出来ません。)");
	}
}


#-------------------------------------------------
#  メール送信（ユーザー間）
#-------------------------------------------------
sub mailsend {
#	local($msub,$mbody,$mcom,$email);
	local($no,$sub,$nam,$eml,$com,$dat,$hos,$pw,$url,$mvw);
	local($myjob) = @_;

	# チェック
	if ($no_wd) { &no_wd; }
	if ($jp_wd) { &jp_wd; }
	if ($urlnum >= 0) { &urlnum; }

	# 汚染チェック
	$in{'f'}  =~ s/\D//g;
	$in{'no'} =~ s/\D//g;

		# ロック開始
		if ($lockkey) { &lock; }

		# 連続投稿チェック
		open(IN,"$mailfile") || &error("Open Error: $mailfile");

		while (<IN>) {
			($hos2,$tim2) = split(/<>/);
			if ($host eq $hos2 && $mailwait > time - $tim2) {
				&error("連続送信はもうしばらく時間をおいて下さい");
			}
		}
		close(IN);

		# 投稿内容チェック
		if ($i_com eq "") { &error("コメントの内容がありません"); }
		if ($i_nam eq "") {
			if ($in_name) { &error("名前は記入必須です"); }
			else { $i_nam = '名無しのゴンベエ'; }
		}
		if ($in{'email'} eq "") { &error("返信用E-mailは記入必須です"); }
#		if ($in_mail>1 && $in{'email'} ne "") { &error("E-mailは記入禁止です"); }
		if ($in{'email'} && $in{'email'} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,6}$/)
			{ &error("E-mailの入力内容が不正です"); }
		if ($i_sub eq "")
			{ &error("タイトルは記入必須です"); }
		if ($i_sub =~ /^(\x81\x40|\s)+$/)
			{ &error("タイトルは正しく記入してください"); }
		if ($i_nam =~ /^(\x81\x40|\s)+$/)
			{ &error("名前は正しく記入してください"); }
		if ($i_com =~ /^(\x81\x40|\s|<br>)+$/)
			{ &error("コメントは正しく記入してください"); }
		if ($in{'url'} eq "http://") { $in{'url'} = ""; }

	# 投稿認証キーチェック	（2010/01/29 スガラボット追加修正)
	if ($captcha) {
		require $keyinitpl;

		if ($in{'chk'} !~ /^\d{4}$/) {
			&error("投稿キーが入力不備です。<p>投稿フォームに戻って再読込み後、指定の数字を入力してください");
		}

		local($chk) = &key_chk($in{'chk'}, $in{'ciphertext'});
		if ($chk == 0) {
			&error("投稿キーが制限時間を超過しました。<p>投稿フォームに戻って再読込み後、指定の数字を再入力してください");
		} elsif ($chk == -1) {
			&error("投稿キーが不正です。<p>投稿フォームに戻って再読込み後、指定の数字を入力してください");
		}
	}

	# 投稿キーチェック
	if ($regist_key) {
		require $regkeypl;

		if ($in{'regikey'} !~ /^\d{4}$/) {
			&error("投稿キーが入力不備です。<p>投稿フォームに戻って再読込み後、指定の数字を入力してください");
		}

		# 投稿キーチェック
		# -1 : キー不一致
		#  0 : 制限時間オーバー
		#  1 : キー一致
		local($chk) = &registkey_chk($in{'regikey'}, $in{'str_crypt'});
		if ($chk == 0) {
			&error("投稿キーが制限時間を超過しました。<p>投稿フォームに戻って再読込み後、指定の数字を再入力してください");
		} elsif ($chk == -1) {
			&error("投稿キーが不正です。<p>投稿フォームに戻って再読込み後、指定の数字を入力してください");
		}
	}

		# メールログ更新
		@new="";
		$flag=1;
		
		open(IN, "+> $mailfile") || &error("Open Error: $mailfile");

		while (<IN>) {
			($hos2,$tim2) = split(/<>/);
			if ($host eq $hos2) {
				$_ = "$host<>$time<>\n";
				$flag=0;
				unshift(@new,$_);
			} else {
				push(@new,$_);
			}
		}
#		close(IN);

		if ($flag) {
			unshift(@new,"$host<>$time<>\n");
		}

#		open(OUT,">$mailfile") || &error("Write Error: $mailfile");
#		print OUT @new;
#		close(OUT);
		seek(IN, 0, 0);
		print IN @new;
		truncate(IN, tell(IN));
		close(IN);

	# トリップ処理
	$i_nam2 = &trip($i_nam);
	
		# ロック開始
#		if ($lockkey) { &lock; }

#		@new=();
#		open(IN,"$logdir/$in{'f'}.cgi") || &error("Open Error: $in{'f'}.cgi");
#		$top = <IN>;
		

	# 該当ログチェック
	$flag=0;
	open(IN,"$logdir/$in{'f'}\.cgi");
#	$top = <IN>;
	$top = &lineDecode(IN);

	# ロックされているかチェック
#	&checklocked($top);

#	while (<IN>) {
	while ( $_ = &lineDecode(IN) ) {
		($no,$sub,$nam,$eml,$com,$dat,$hos,$pw,$url,$mvw) = split(/<>/);
		last if ($in{'no'} == $no);
	}
	close(IN);

	# ロック解除
	&unlock if ($lockkey);

	if ($eml eq "") {
#		$check = &decrypt($in{'pwd'}, $pw);
		&error("メールアドレスが入力されていません"); }
#	elsif ($mvw eq '0') {
#		&error("該当記事の投稿者はメールを受け付けていません");
#	}

	# メールタイトルを定義
	$msub = "$i_sub";

	# 本文の改行・タグを復元
	$mcom = $i_com;

	# 宛先、差出人とタイトルの BBCode を削除
	$nam = &titlebbrm($nam);
	$i_nam2 = &titlebbrm($i_nam2);
	$i_sub = &titlebbrm($i_sub);
	$sub = &titlebbrm($sub);


	# 本文のBBCodeを削除 （2009/01/14 スガラボット修正)
	$mcom = &bbcoderm($mcom);
	
	$mcom =~ s/<br>/\n/g;
	$mcom =~ s/&lt;/</g;
	$mcom =~ s/&gt;/>/g;
	$mcom =~ s/&quot;/"/g;
	$mcom =~ s/&amp;/&/g;

	if ($in{'res'} eq ""){$in{'res'}=$new;}
	
$mbody = <<EOM;
${title} から送信されたメールをお届けしました。
該当記事のURL: $fullscript&mode=view&no=$in{'f'}&l=$in{'no'}-

差出人のホスト名 (IPアドレス)：$host
差出人 (From): "$i_nam2" <$in{'email'}> さんから
宛先 (To):     "$nam" さんへ <あなたのメールアドレスは伏せてあります>

"$i_nam2"さんからのメール本文:
------------------------------------------------------------------------
$mcom
EOM

# Hi-HOのssendmailに合わせて題名のエンコードを'euc'に変更方を変更 スガラボット修正分
#	if ($hi_ho) { &jcode'convert(*msub,'euc'); }
	if ($hi_ho) { $msub = Unicode::Japanese->new($msub)->euc; }
	# 題名をBASE64化
	else 		{ 
		$msub = &base64($msub);
		$namb64 = &base64($nam);
		$i_nam2b64 = &base64($i_nam2);
	}

#	$nam = &base64($nam);
#	$i_nam2 = &base64($i_nam2);
	
	# sendmail送信
	if ($hi_ho) {
# Hi-HOのssendmailに合わせて$sendmailの呼び方を変更 スガラボット修正分
	open(MAIL,"| $sendmail -s \"$msub\" -f \"$in{'email'}\" $eml") || &error("送信失敗");
	}
	else {
		open(MAIL,"| $sendmail -t") || &error("送信失敗");
		print MAIL "To: \"$namb64\" <$eml>\n";
#		print MAIL "To: \"$i_nam2b64\" <$in{'email'}>\n";
#		print MAIL "From: \"$i_nam2\" <$in{'email'}>\n";
		print MAIL "From: \"$i_nam2b64\" <$in{'email'}>\n";
		print MAIL "Subject: $msub\n";
		print MAIL "MIME-Version: 1.0\n";
		print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
		print MAIL "Content-Transfer-Encoding: 7bit\n";
		print MAIL "X-Mailer: $ver\n\n";
	}
	foreach ( split(/\n/, $mbody) ) {
#		&jcode'convert(*_, 'jis', 'sjis');
		my $str = Unicode::Japanese->new($_)->jis;
		print MAIL $str, "\n";
	}
	close(MAIL);

$mbody = <<EOM;
$title からあなたが送信したメールの控えです。
該当記事のURL: $fullscript&mode=view&no=$in{'f'}&l=$in{'no'}-

あなたのホスト名 (IPアドレス)：$host
差出人 (From): "$i_nam2" <$in{'email'}> から
宛先 (To):     "$nam" さんへ <宛先のメールアドレスは伏せています>

あなたが送信したメール本文:
------------------------------------------------------------------------
$mcom
EOM

	# 控え送信
	# メール送信者への控えの差出人はサーバアドレスとする。(20081217 守田修正)
	if ($sender eq "") { $email = $in{'email'}; }
	else { $email = $sender; }

	if ($hi_ho) {
# Hi-HOのssendmailに合わせて$sendmailの呼び方を変更 スガラボット修正分
		open(MAIL,"| $sendmail -s \"$msub\" -f \"$in{'email'}\" $in{'email'}") || &error("送信失敗");
	}
	else {
		open(MAIL,"| $sendmail -t") || &error("送信失敗");
#		print MAIL "To: \"$nam\" <$eml>\n";
		print MAIL "To: \"$i_nam2b64\" <$in{'email'}>\n";
#		print MAIL "From: \"$i_nam2\" <$in{'email'}>\n";
		print MAIL "From: $email\n";
		print MAIL "Subject: $msub\n";
		print MAIL "MIME-Version: 1.0\n";
		print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
		print MAIL "Content-Transfer-Encoding: 7bit\n";
		print MAIL "X-Mailer: perl$]\n\n";
	}
	foreach ( split(/\n/, $mbody) ) {
#		&jcode'convert(*_, 'jis', 'sjis');
		my $str = Unicode::Japanese->new($_)->jis;
		print MAIL $str, "\n";
	}
	close(MAIL);

	# 完了メッセージ
	&header;
#	$md = 'view';
#	if ($in{'res'} eq "") { $no = $new; }
#	else { $no = $in{'res'}; }

	$printString = <<EOM;
<br><br><div align="center">
<Table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" width="400">
<tr bgcolor="$col2">
  <td bgcolor="$col2" nowrap align="center" height=60>
	<h3 style="font-size:15px">メールを送信しました</h3>
  </td>
</tr>
</table>
<p>
EOM
print &strEncode($printString);

	# 戻りフォーム
	$printString = <<"EOM";
<table><tr><td valign=top>
<form action="$bbscgi">
<input type=submit value="掲示板へ戻る">
</form></td><td width=15></td>
<td valign=top>
<form action="$readcgi" method="post">
<input type=hidden name=mode value="view">
<input type=hidden name=no value="$in{'f'}">
<input type=submit value="スレッドへ戻る">
</form></td>
</tr>
</table>
</div>
EOM
print &strEncode($printString);

	&pr_footer;

	$printString = <<"EOM";
</body>
</html>
EOM
print &strEncode($printString);
	exit;
}

#-------------------------------------------------
#  プレビュー時のアップロードファイルを投稿に反映
#-------------------------------------------------
sub preUpfile {

	my ($tim0, $job) = @_;

	# 投稿中止でなければ前のプレビュー投稿時の暫定ファイルをオープン
	my (%pupl, $TMP);
	if ($job ne 'quit') {
		open($TMP,"+< $logdir/temp/$tim0.cgi") || &error("Open Error: $logdir/temp/$tim0.cgi");
		my $top = &lineDecode($TMP);
		my $preLog = &lineDecode($TMP);
		(undef,undef,undef,undef,undef,undef,undef,undef,undef,undef,undef,undef,$pupl{1},$pupl{2},$pupl{3}) = split(/<>/, $preLog);
		close($TMP);
	}

## デバッグプリント
#&error("Debug：tempFile=$logdir/temp/$tim0.cgi, &nbsp;\$pupl{1}=$pupl{1}, \$pupl{2}=$pupl{2}, \$pupl{3}=$pupl{3}");

	# 前のプレビュー投稿時の暫定ファイルを削除
#	unlink("$logdir/temp/$tim0.cgi");			# デバッグが終了して落ち着くまで削除しない

	my (%pex, %pw, %ph, %pfn, %pft);
	foreach my $j (1 .. 3) {

		# アップロード時のファイル情報を抽出
		($pex{$j}, $pw{$j}, $ph{$j}, $pfn{$j}, $pft{$j}) = split(/,/, $pupl{$j});

		my $delete = "del" . $j;
		# 新しいファイルがアップされたときは旧ファイルを消す
		if ( $ex{$j} ) {
			$upl{$j} = "$ex{$j},$w{$j},$h{$j},$filename{$j},$filetitle{$j}";
			if (-e "$upldir/temp/$tim0-$j$pex{$j}") {
				unlink("$upldir/temp/$tim0-$j$pex{$j}") if ($job eq 'quit');
			}
			$upl_flg = $time;
		}
		# ファイル削除がチェックされていたとき
		elsif ( $in{$delete} ) {
			$upl{$j} = ',,,,';
			if (-e "$upldir/temp/$tim0-$j$pex{$j}") {
				unlink("$upldir/temp/$tim0-$j$pex{$j}") if ($job eq 'quit');
			}
		}
		# プレビューでアップロードされたファイルがあって標題のみ変更のとき
		elsif ( $pex{$j} ) {
			# 旧ファイルの識別名とファイルの標題を変更する
			my $filetitle = $in{"ftitle$j"};
			$upl{$j} = "$pex{$j},$pw{$j},$ph{$j},$pfn{$j},$filetitle";

#			# 前回アップロードされたファイルをリネーム
#			if ($job eq 'preview') {
#				rename("$upldir/temp/$tim0-$j$pex{$j}", "$upldir/temp/$time-$j$pex{$j}");
#			} else {
#				rename("$upldir/temp/$tim0-$j$pex{$j}", "$upldir/$time-$j$pex{$j}");
#			}

			# 前回アップロードされたファイルを一旦読み込む
			# 大きなファイルを読み込むとサーバエラーになることがあるので、コピーをやめてムーブに変更 (12/09/23 スガラボット修正)
#			open($TMP, "$upldir/temp/$tim0-$j$pex{$j}");
#			binmode ( $TMP );
#			binmode ( STDOUT );
#			my ( $fsize ) = -s $TMP;
#
#			my $buf;
#			read ( $TMP, $buf, $fsize );
#			close($TMP);

			# 前回のファイル内容を今回のタイムスタンプのファイルにコピー (→ コピーでは無くムーブに変更 120923)
			# プレビューのときにサムネイルも作成されていたらそれもムーブするように変更 (2012/12/08 スガラボット修正)
			my ($newfile, $newfile1, $newfile2);
			if ($job eq 'preview') { 
				$newfile = "$upldir/temp/$time-$j$pex{$j}";
				if ( -e "$upldir/temp/$tim0-s$j$pex{$j}" ) { $newfile1 = "$upldir/temp/$time-s$j$pex{$j}"; }
				if ( -e "$upldir/temp/$tim0-t$j$pex{$j}" ) { $newfile2 = "$upldir/temp/$time-t$j$pex{$j}"; }
			 }
			else {
				$newfile = "$upldir/$time-$j$pex{$j}";
				if ( -e "$upldir/temp/$tim0-s$j$pex{$j}" ) { $newfile1 = "$upldir/$time-s$j$pex{$j}"; }
				if ( -e "$upldir/temp/$tim0-t$j$pex{$j}" ) { $newfile2 = "$upldir/$time-t$j$pex{$j}"; }
				if ($pex{$j}) { $upl_flg = $time; }
			}

#			open (OUT, "> $newfile");
#			syswrite ( OUT, $buf, $fsize );
#			close(OUT);
			# ファイル書き込みでは無くムーブに変更 (12/09/23 スガラボット修正)
			move("$upldir/temp/$tim0-$j$pex{$j}", $newfile);
			# パーミッション変更
			chmod(0644, $newfile);
			# サムネイルファイルがあればそれもムーブする
			if ( $newfile1 ) { move("$upldir/temp/$tim0-s$j$pex{$j}", $newfile1); chmod(0644, $newfile1); }
			if ( $newfile2 ) { move("$upldir/temp/$tim0-t$j$pex{$j}", $newfile2); chmod(0644, $newfile2); }
		}
	}
}

#-------------------------------------------------
#  プレビュー画面表示
#-------------------------------------------------
sub preview {

	# スマイルアイコン定義
	our (@s1,@s2);
	if ($smile) {
		@s1 = split(/\s+/, $smile1);
		@s2 = split(/\s+/, $smile2);
	}

	# ヘッダ
	if ($smile) { &header('投稿プレビュー', 'js'); }
	else { &header('投稿プレビュー'); }

	my $printString = <<"EOM";
<div align="center">
<table border="0" cellspacing="0" cellpadding="0" $width><tr>
 <td align="right" nowrap>
	&gt; 投稿プレビュー
 </td>
</tr></table>
<img src=\"$imgurl/spacer_h4.gif\">
<table border="0" bgcolor="$col1" cellspacing="1" cellpadding="5" $width>
<tr bgcolor="$col3"><td bgcolor="$col3" colspan=\"2\" nowrap width="92%">
&nbsp; <b>投稿データ確認用プレビュー画面</b></td></tr></table>
<Table border=\"0\" cellspacing=\"5\" cellpadding=\"0\" $width>
<tr><td align="center">$previewnotice
</td></tr></table>
EOM
print &strEncode($printString);

## デバッグプリント
# print $tempbuf;

	# 原稿を開く
	open(DAT,"+< $logdir/temp/$time.cgi") || &error("Open Error: 投稿原稿保存ファイル");
	my $top = &lineDecode(DAT);
	my $buf = &lineDecode(DAT);
	close(DAT);

	our ($tno, $sub) = split(/<>/, $top);

	chomp($buf);

	our (@no,@nam,@eml,@com,@dat,@hos,@pw,@url,@mvw,@myid,@tim,@upl,@color,@resto);
	our ($no,$nam,$eml,$com,$dat,$hos,$pw,$url,$mvw,$myid,$tim,%fupl,$color,$resto);
	# 原稿内容展開
	($no[0],$sub[0],$nam[0],$eml[0],$com[0],$dat[0],$ho[0],$pw[0],$url[0],$mvw[0],
		$myid[0],$tim[0],$upl[1][0],$upl[2][0],$upl[3][0],$idcrypt[0],$color[0],$resto[0])  = split(/<>/, $buf);
	($no,undef,$nam,$eml,$com,$dat,$hos,$pw,$url,$mvw,$myid,$tim,$fupl{1},$fupl{2},$fupl{3},undef,$color,$resto) = split(/<>/, $buf);

	# スレッドタイトルとレス親の題名が異なる場合のフラグをセット
	if ($sub[0] ne $sub) {
		$sub_dif = 1;
	}

	if ($newthread) { $no[0] = '0'; $in{'no'} = " Maybe $tno"; }
	else { $no[0] = " Maybe $no[0]"; }

	$uplurl = "$uplurl/temp";
	$upldir = "$upldir/temp";
	$icon = 'foldnew.gif';

	&res_dsp(0);

	print "<p>";

	$tsub = $sub;
	$sub = $sub[0];
	$upl{1} = $fupl{1}; $upl{2} = $fupl{2}; $upl{3} = $fupl{3};

	&editform;

}

#-------------------------------------------------
#  リンク処理
#-------------------------------------------------
sub clearDir {
	my($dir) = @_;

	# temp フォルダーの確認 (無ければ作成する)
	unless (-e $dir) { mkdir($dir, 0747); }

	# ディレクトリ内のファイル取得
	my $DIR;
	opendir($DIR, $dir);
	my (@file) = readdir($DIR);
	closedir($DIR);

	# 各ファィルをスキャン
	foreach $f (@file) {
		# ディレクトリはスキップ
		if ($f eq '.' || $f eq '..') { next; }

		# ファイル情報を取得
		my @status = stat("$dir/$f");
		my $lastup = $status[9];

## デバッグプリント情報
# $tempbuf .= "Debug : file=$dir$f, \$lastup=$lastup, ";

		# ファイル更新時刻が投稿キー許容時間より前ならファイル削除
		if ($lastup && $lastup < ($time - $pcp_time * 60)) {

#			# デバッグの目途が付くまでファイル削除は当面やめておくことにする
#			unlink("$dir/$f");

# $tempbuf .= "DELETED !!!";
		}
# $tempbuf .= "<br>";
	}
}

#-------------------------------------------------
#  リンク処理
#-------------------------------------------------
sub auto_link {
	local($msg, $f) = @_;

	$msg =~ s/([^=^\"]|^)(http[s]?\:[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%\,]+)/$1<a href=\"$2\" target=\"$target\" rel=\"nofollow\">$2<\/a>/g;
#	$msg =~ s/([^=^\"]|^)(https\:[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%\,]+)/$1<a href=\"$2\" target=\"$target\">$2<\/a>/g;
# レスNo指定（表示系未実装））
#	$msg =~ s/&gt;&gt;(\d)([\d\-]*)/<a href=\"$script?mode=view2&f=$f&no=$1$2\" target=\"_blank\">&gt;&gt;$1$2<\/a>/gi;
# 他スレッド参照 by あらら
	$msg =~ s/&gt;&gt;\[(\d+)\](-?)([\d]?)([\d\-]*)([^<&]*)/<a href=\"$readcgi&mode=view&no=$1&l=$3$4\" target=\"_blank\">&gt;&gt;[$1]$2$3$4$5<\/a>/gi;
# 他スレッド参照（スレッドを参照するのみの簡易版・表示系が未実装のため）
#	$msg =~ s/&gt;&gt;\[(\d+)\]([^<&]*)/<a href=\"$readcgi&no=$1\" target=\"$target\">&gt;&gt;[$1]$2<\/a>$3/gi;
# bctpリンク （BitComet用）
#	$msg =~ s/([^=^\"]|^)(bctp\:[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%\,]+)/$1<a href=\"$2\" target=\"$target\">$2<\/a>/g;
# bcリンク （BitComet 0.87以降用）
#	$msg =~ s/([^=^\"]|^)(bc\:[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%\,]+)/$1<a href=\"$2\" target=\"$target\">$2<\/a>/g;

#	$msg =~ s/&gt;&gt;(\d)([\d\-]*)/<a href=\"$readcgi&mode=view2&f=$f&no=$1$2\" target=\"$target\">&gt;&gt;$1$2<\/a>/gi;
	$msg =~ s/&gt;&gt;(\d|\-)([\d\-]*)/<a href=\"$readcgi&mode=view&no=$f&l=$1$2\" target=\"$target\">&gt;&gt;$1$2<\/a>/gi;

	# スマイル画像変換
	if ($smile) {
		local($tmp);
		foreach (0 .. $#s1) {
			$tmp = $s2[$_];
			$tmp =~ s/([\+\*\.\?\^\$\[\-\]\|\(\)\\])/\\$1/g;
			$msg =~ s/$tmp/ <img src=\"$imgurl\/$s1[$_]\">/g;
		}
	}
	$msg;
}

#---------------------------------------------------------
#  過去ログ書庫インデックスに項目を追加 （2010/11/26 追加)
#---------------------------------------------------------
sub add_pastlog {

#	my ($ref) = @_;
#	my @tmp2 = @{ $ref };
	my ($tmp2) = @_;

	require $pastlog;

	# 過去ログ書庫ページのカウントファイルを開く
	my $COUNT;
	open($COUNT, "+< $pastno_file") || open($COUNT, "+> $pastno_file") || &error("Open Error: $pastno_file");

	my $buf = <$COUNT>;
	my ($page, $num) = split(/<>/, $buf);
	# $page も $num も最小数は 1
	$page = $page ? $page : 1;
	$num = $num ? $num : 1;

	# もし $pastdir がなければ作成する
	unless(-e $pastdir) {
		mkdir($pastdir, '707');
	}

	my ($past_page_dir, $N);

	# もし最新過去ログ書庫ページのスレッド数が規定数に達していたら新しいページを作成する
	if ($num >= $past_page_max_tno) {
		$page++;
		$num = 1;

		$N = sprintf("%04d", $page);
		$past_page_dir = "$pastdir/plog${N}";
		# 過去ログ書庫ディレクトリの作成
		if ($copy_logfiles) {
			unless (-e $past_page_dir) {
			mkdir($past_page_dir, '706');
			mkdir("$past_page_dir/upl", '706');
			}
		}
	} else {
		$N = sprintf("%04d", $page);
		$past_page_dir = "$pastdir/plog${N}";
		$num++;
	}

	seek($COUNT, 0, 0);
	print $COUNT "$N<>$num<>\n";
	truncate($COUNT, tell($COUNT));
	close($COUNT);

	# 過去ログインデックスファイルを開く (無ければ作成する)
	my $past_index = "$pastdir/P${N}.dat";
	open($INDEX_P, "+< $past_index") || open($INDEX_P, "+> $past_index") || &error("Open Error: $past_index");
	my @past_tp = &arrayDecode($INDEX_P);

	# スレッドのツリー式インデックスを作成する
	local $print_string = '';
	local @upl_files = ();
	# Forum 表示リンクのパラメータセット
	$readshtml = "$cgi_url/read.cgi?bbs=forum&mode=past";
	# ツリー形式インデックス作成

	my $num = &create_pindex($tmp2);

	# Patio 表示リンクのパラメータセット
	$readshtml = "$cgi_url/read.cgi?bbs=patio&mode=past";
	unshift(@past_tp, $tmp2.$print_string);


	# 過去ログインデックスファイルを書き込む
	seek($INDEX_P, 0, 0);
	print $INDEX_P &arrayEncode(\@past_tp, $logchar);
	truncate($INDEX_P, tell($INDEX_P));
	close($INDEX_P);

	if ($copy_logfiles) {
		use File::Copy;

		# 過去ログに移動するスレッドのlog/datファイルとアップロードファイルをコピーする
		copy("$logdir/$num.cgi", "$past_page_dir/$num.cgi");
		copy("$logdir/$num.dat", "$past_page_dir/$num.dat");

		while ( @upl_files ) {
			my $file = shift(@upl_files);
			copy("$upldir/$file",  "$past_page_dir/upl/$file");
		}
	}
}

1;
