#
#  officeio.cgi: 今日のステータスや出勤・帰宅時間をWEB上に表示するCGI
#        今日のステータスは翌日には自動的にクリアされます。
#        過去の情報も指定した日数分は保存しますが、過去の情報は変更できません。
#        メンバーの追加・削除、データファイルの管理ができるメンテナンス・モードつき。
#
#     Ver.1.00(02.07.03) つくりました。
#     Ver.1.01(02.07.07) データファイル初期設定機能を追加しました。
#     Ver.1.02(02.07.20) ファイルが１つしかないときのグループ選択のバグと
#                        メンテナンスモードの移動時のバグを修正。
#
#-----------------------------------------------------------------------------
#	Salon da Musica の練習予定表のためのスガラボット修正版 Ver.1.04
#	・練習日の決定として'◎'及び'中止'が登録された時にメンバーに対するメール通知を出す拡張
#	  Ver.1.05	(2010/10/16):	スガラボット修正

#	以下の2行はメール送信のテスト用設定
	my $mailTest = 0;
	if ($mailTest) { @mailto2 = ('viola@vmorita.com'); }

	#use strict;
	#use warnings;
	#use Time::Local;
	use utf8;

    #親パス
    $htmPath = "$bbsurl";    #[もどる]でジャンプするパス

    #ファイルとディレクトリ
    #  セキュリティを考え、初期値は使わず、推測されにくい文字列にしましょう。
    use lib './lib';              #jcode.pl、cgi-lib.pl、kabalib.plがあるパス
    $fileExt = 'dat';              #データ・ファイル用のファイル拡張子
    $dataDir = "$datadir";             #データ・ファイル用ディレクトリ。

    #動作設定
    $Title = "サロン・ダ・ムジカ 出欠予定\表";         #ページのタイトル
    $remdays = 5 ;                #過去何日分記録するか？
    $maxdays = 19;                #今日から以後何日表示するか？
    $page = 10;                     #１ページに表示する日数。7～8日位が適当。
    $enTeam = 0 ;                  #チームを表示するときは1、いらないときは0
    $mentKey = 'musica01';         #メンテナンス・キー、不要なら''にするかコメントアウト。

    #ステータス種類
    @statList = ( '○', '×', '△', 'Ｌ', '-', '◎', '◎ 仙川', '◎代官山', '中止' );

    #色指定
	$strong1 = "<font color=\"FF1493\"><strong>"; $strong2 = "</strong></font>";
    $clrText      = '#003399'; #文字色(群青)
    $clrNormalday = '#FFFFCC'; #平日の色(淡い黄色)
    $clrSunday    = '#FFC0CB'; #日曜日の色(ピンク)
    $clrSaturday  = '#87CEFA'; #土曜日の色(ライトスカイブルー)
    $clrBG        = '#FFFFF0'; #背景(アイボリー)
    $clrFormBG    = '#FFFFFF'; #フォーム部の背景色(白)
    $clrMsgBG     = '#FFFF99'; #エラーメッセージの背景色(レモンイエロー)
    $clrLTitle    = '#F0E68C'; #行タイトルの色(柿)
    $clrLine1     = '#F0FFF0'; #奇数行の背景(ハニーデュー)
    $clrLine0     = '#FFFFFF'; #偶数行の背景(白)
    $clrCTitle    = '#F5DEB3'; #列タイトルの色(麦)
    $clrCLine1    = '#CCFFCC'; #列タイトルの奇数行の背景(淡い緑)
    $clrCLine0    = '#FFFFE0'; #列タイトル偶数行の背景(ライトイエロー)
    $clrLpink     = '#FFEEF1'; #サロン・ダ・ムジカ集合日の背景(淡いピンク)

# 設定はここまで
#---------------------------------------------------------------------------------

# 参照ファイルの設定
use File::Path;
#require './lib/jcode.pl';
require './lib/kabalib.pl';
#require './lib/cgi-lib.pl';
#use Unicode::Japanese;
#use Unicode::Japanese qw(unijp);

use File::Basename;                        # プログラム名
$Program = basename($0);
# 漢字コード
if (!$charset) { $charset = 'utf8'; }
if (!$logchar) { $logchar = 'utf8'; }
#$htmlcode = 'shift-jis';                   # 漢字コード
$htmlcode = &htmlchar($charset);

$Encoding = 'sjis';
@wdays= ('日', '月', '火', '水', '木', '金', '土');

# 引数の読み込み
#&ReadParse;
#while ( ( $key, $value ) = each %in ) {
##    &jcode'convert(*value, $Encoding);
#	$value = &strDecode($value, $encode);
#    $value =~ s/&/&amp;/g ;
#    $value =~ s/</&lt;/g ;
#    $value =~ s/>/&gt;/g ;
#    $value =~ s/"/&quot;/g ;
#    $in{$key} = $value;
#}

# テスト用の引数
#$in{'myfile'} = 'sales';
#$in{'mode'} = 'ment';
#$in{'action'} = 'update';
#$in{'myname'} = '佐藤';
#$in{'myteam'} = '営業１係';
#$in{'date'} = '2002/6/15';
#$in{'dir'} = 'back';
#$in{'stat'} = 3 ;
#$in{'memo'} = '電話不可';
#$in{'debug'} = 1;

# 引数を変数に保存する
$myfile = $in{'myfile'};
$mode = $in{'mode'};
$act = $in{'action'};
$myname = $in{'myname'};
$myteam = $in{'myteam'};
$date = $in{'date'};
$base = $in{'base'};
$stat = $in{'stat'};
$memo = $in{'memo'};
$num = $in{'num'};
$myam = $in{'myam'};
$mypm = $in{'mypm'};
$refnum = $in{'refnum'};
$group = $in{'group'};
$pass = $in{'pass'};
$direction = $in{'direction'};
$debug = $in{'debug'};


#	デバッグ用に入力パラメータを表示
#	&header; &error("Debug: myfile=$myfile, mode=$mode, action=$act, myname=$myname, date=$date, myam=$myam <br>\n");


if ($debug) { 
    $dbgfile = 'debug.log';
    open( DBG, ">$dbgfile" ) || &webmsg( "デバッグ・ファイルが開けません\n" );
    print DBG &strEncode("引数の一覧は、\n", $logchar);
    while ( ($key,$value) = each %in ) { print DBG &strEncode("    キーは${key}、値は${value}。\n", ${logchar}); }
    print DBG &strEncode("です。\n", $logchar);
}
# メイン・プログラム

# クッキーを読み込む
*cookies = &get_cookie;
my( $cookieFile ) = $cookies{'myfile'};
my( $cookieName ) = $cookies{'myname'};
if ($debug) {
    print DBG &strEncode("クッキーのmyfileは$cookieFile\n", $logchar);
    print DBG &strEncode("クッキーのmynameは$cookieName\n", $logchar);
}

#引数にmyfileとmynameとmyteamがなければクッキーからgetする
#if (( $myfile eq '' ) and ( $cookieFile eq '' )) { $myfile = 'sales' } #見本用
if ( $myfile eq '' ) { $myfile = $cookieFile }
if ( $myname eq '' ) { $myname = $cookieName }

#現在日を入手
( $year, $month, $day ) = &getDate();  #現在日を入手
$today = $year. '/'. $month. '/'. $day ;
if ($debug) { print DBG &strEncode("今日todayは${today}\n", $logchar); }

#ここでメイン・プログラムは終わり。


# データファイルから情報を読み込む
# <IN> 0ならnameとteamのみ、1なら全部
# <OUT> 存在するデータファイルの数
#
sub readdata {

    if ($debug) { print DBG &strEncode("---サブルーチン：readdata---\n", $logchar) }
    my($mode) = @_;
    my($x, $y, $i, $dummy, $str, $memName, $memTeam, $memStat, $memMemo );
    my($todayTime, $startTime, $tempTime, $avlDays );
    my($fDate, $fIn, $fOut, $fTime, $length, $width, $yy, $mm, $dd, $datafile );
    my($filename, $corename, $ext, $fileCnt );
    if ($debug) { print DBG &strEncode("    modeは${mode}。\n", $logchar) }

    #データファイルを数えておく
    opendir( DIR, "$dataDir" );
    $fileCnt = 0;
    while ( $filename = readdir DIR ) {
        if ( $filename =~ /.$fileExt/ ) { $fileCnt++ }
    }
    if ($debug) { print DBG &strEncode("    データファイルの数は${fileCnt}。\n", $logchar) }

    #データ・ファイルをreadしてみる
    $datafile = "$dataDir/$myfile.$fileExt";
    if ($debug) { print DBG &strEncode("    データファイルは${datafile}。\n", $logchar) }
    if ( open( FILE, "$datafile" ) eq '' ) {
        &webmsg( "データファイルがありません。",
            "$Program?action=grList", "データファイルを選ぶ" );
    }

    #modeが0でなければ有効期間分のTIMEを準備する
    if ( $mode ) {
        $todayTime = &reversetime( $year, $month, $day );
#        $startTime = $todayTime - $remdays*24*60*60;
        $startTime = $todayTime - $remdays*7*24*60*60;
        $avlDays = $maxdays + $remdays;

#	今日の曜日を数字で取得
	$wday = &getweek($year, $month, $day);
#	&weberror("Debug: weekday=$wday<br>\n");

#	今日の曜日から次の土曜日までの日数を取得
	$offset = 6 - $wday;

        $y = 4; $length = $avlDays+4;
#        $ref[$y]->[0] = $startTime; $y++;
#	開始日を範囲内の1番目の土曜日に設定
        $ref[$y]->[0] = $startTime + $offset*60*60*24; $y++;

        while ( $y <= $length ) {
            $tempTime = $ref[$y-1][0];
#            $tempTime = $tempTime+60*60*24;
#	候補日を土曜日のみに限定
            $tempTime = $tempTime + 7*60*60*24;
            $ref[$y]->[0] = $tempTime ;
            $y++;
        }
    }

    #ファイルの内容をGET
    $i=0; $x=0;
    while( $_ = &lineDecode(FILE) ) {
        chomp $_;
        if ( $i==0 ) {
            if ($_ =~ /^update=/ ) {
                ( $dummy, $update ) = split( /=/, $_ );
                if ($debug) { print DBG &strEncode("    最終更新日は${update}。\n", $logchar) }
            }
            else {
                &webmsg( "データ・ファイルの先頭に最終更新日がありません。\n" );
            }
        }
        elsif ( $i==1 ) {
            if ($_ =~ /^group=/ ) {
                ( $dummy, $grpName ) = split( /=/, $_ );
                if ($debug) { print DBG &strEncode("    グループ名は${grpName}。\n", $logchar) }
            }
            else {
                &webmsg( "データ・ファイルの２行目に部署名がありません。\n" );
            }
        }
        else {
            if ( $_ =~ /^name=/ ) {
                if ($debug) { print DBG"    name=があった「${_}」\n" }
                $x++;
                ( $dummy, $str ) = split( /=/, $_ );
                ( $memName, $memTeam, $memStat, $memMemo ) = split( />/, $str );
                $ref[0]->[$x] = $memName ;
                $ref[1]->[$x] = $memTeam ;
                if ( $update eq $today ) {
                    $ref[2]->[$x] = $memStat;
                    $ref[3]->[$x] = $memMemo ;
                }
                else {
                    $ref[2]->[$x] = '-' ;
                    $ref[3]->[$x] = '-' ;
                }
            }
            else {
                if (( $mode ) and ( $_ =~ /^  / )) {
                    $_ =~ s/^  // ;
                    ( $fDate, $fIn, $fOut ) = split( />/, $_ );
                    $fTime = &reversetime( split( /\//, $fDate ) );
                    for( $y=4; $y<=$length; $y++ ) {
                        if ( $ref[$y][0] == $fTime ) {
                            $ref[$y]->[$x] = "$fIn>$fOut";
                        }
                    }
                }
            }
        }
        $i++;
    }

    if ($debug) {
        $width = @{$ref[0]};
        $length = @ref;
        print DBG &strEncode("    widthは$width。\n", $logchar);
        for ( $y=0; $y<$length; $y++ ) {
            print DBG &strEncode("    ", $logchar);
            printf DBG "%24s", $ref[$y][0] ;
            for ( $x=1; $x<$width; $x++ ) { printf DBG "%12s", $ref[$y][$x] }
            print DBG "\n";
        }
    }
    return $fileCnt;
}

#出欠表示板の標準画面を表示する
# <IN> 0なら入力フォームなし、1ならフォームあり。
# <OUT> なし
sub display {

    if ($debug) { print DBG &strEncode("---サブルーチン：display---\n", $logchar) }
    my( $enForm ) = @_;
    my( $x, $y, $beginTime, $endTime, $beginDate, $endDate, $todayTime, $i, $span );
    my( $yy, $mm, $dd, $byy, $bmm, $bdd, $width, $length, $wday, $toggle, $am, $pm, $enBack, $enForword );
    my( $result, $remine, $tt, $range, $delta, $enName );

    $width = @{$ref[0]}; $length = @ref;


######## 以下8行はデバッグ用のin変数とサーバのENV変数確認処理
	my $param;
	foreach $key ( keys( %in ) ) {
	    $param .= "key = $key : ";
	    $param .= "value = $in{$key} \n "
	} 
	
#	print "Content-type: text/html\n\n";
#	&weberror ("<div align=\"left\">Debug: in{key}= <br>$param<br> base=$base<br>\n</div>");



    #widthが１以下ならメンバーが一人もいないのでメッセージを出す
    if ( $width <= 1 ) {
        &webmsg( "メンバーが登録されていません。", "$Program?mode=ment&myfile=$myfile", "メンバー登録" );
    }

    #デフォルトで表示すべき名前があるかを確かめる
    $enName = 0;
    for ( $x=1; $x<$width; $x++ ) {
        if ( $ref[0][$x] eq $myname ) { $enName = 1 }
    }

    #表示すべき範囲を確定する
    $enBack = 1; $enForword = 1;
    if ( $direction eq 'back' ) {
        ( $yy, $mm, $dd ) = &caldays( split( /\//, $base ), ( 0 - $page*7 ) );
        $beginTime = &reversetime( $yy, $mm, $dd );
        if ( $beginTime <= $ref[4][0] ) {
            $enBack = 0;
            $delta = ( $ref[4][0] - $beginTime );
            $range = $page - $delta/(7*24*60*60);
            $beginTime = $ref[4][0];
            ( $yy, $mm, $dd ) = &correcttime( $beginTime );
        }
        else { $range = $page; }
        $beginDate = "$yy/$mm/$dd";
        ( $yy, $mm, $dd ) = &caldays( split( /\//, $base ), -7 );
        $endDate = "$yy/$mm/$dd";
        $endTime = &reversetime( $yy, $mm, $dd );
    }
    elsif ( $direction eq 'forword' ) {
        ( $yy, $mm, $dd ) = &caldays( split( /\//, $base ), 7 );
        $beginDate = "$yy/$mm/$dd";
        $beginTime = &reversetime( $yy, $mm, $dd );
        ( $yy, $mm, $dd ) = &caldays( split( /\//, $base ), $page*7  );
        $endTime = &reversetime( $yy, $mm, $dd );
        if ( $endTime >= $ref[($length-1)][0] ) {
            $enForword = 0;
            $delta = ( $endTime - $ref[($length-1)][0] );
            $range = $page - $delta / (7*24*60*60);
			$endTime = $ref[($length-1)][0];
            ( $yy, $mm, $dd ) = &correcttime( $endTime );
        }
        else { $range = $page }
        $endDate = "$yy/$mm/$dd";
    }
    else {
#        $beginDate = $today;
#        $beginTime = &reversetime( $year, $month, $day );
        ( $byy, $bmm, $bdd ) = &caldays( $year, $month, $day, $offset );
        $beginDate = "$byy/$bmm/$bdd";
        $beginTime = &reversetime( $byy, $bmm, $bdd );
        $nweekafter = ($page-1) * 7;
#        ( $yy, $mm, $dd ) = &caldays( $year, $month, $day, ($page-1) );
        ( $yy, $mm, $dd ) = &caldays( $byy, $bmm, $bdd, $nweekafter );
        $endDate = "$yy/$mm/$dd";
        $endTime = &reversetime( $yy, $mm, $dd );
        $range = $page;
    }
    if ($debug) { print DBG &strEncode("    表示範囲は$beginDate($beginTime)から$endDate($endTime)まで${range}日間。\n", $logchar) }

#    $todayTime = &reversetime( $year, $month, $day );
    $todayTime = &reversetime( $byy, $bmm, $bdd );

#	&weberror ("Debug: beginDate=$beginDate, endDate=$endDate\n");

    #ここからブラウザへ出力
    #引数が1で今日より後の時にフォームを表示する
    if (( $enForm ) and ( $endTime >= $todayTime )) {
        print "<SCRIPT LANGUAGE=\"JavaScript\">\n";
        print "<!--\n";
        print "function chk1( str ) {\n";
        print "    n = str.length;\n";
        print "    if ( n>10 ) {\n";
        print &strEncode("        alert(\"10文字以内にしてください。\");\n");
        print "    }\n";
        print "}\n\n";
        print "function chk2( str ) {\n";
        print "    n = str.length;\n";
        print "    if ( n>6 ) {\n";
        print &strEncode("        alert(\"6文字以内にしてください。\");\n");
        print "    }\n";
        print "}\n\n";
        print "function argChk() {\n";
        print &strEncode("    n = document.form.myname.selectedIndex;\n");
        print "    if ( document.form.myname[n].value == '' ) {\n";
        print &strEncode("        alert( \"名前を選んでください。\" );\n");
        print "        return(0);\n";
        print "    }\n";
        print "    if ((document.form.myam.value != '') || (document.form.mypm.value != '')) {\n";
        print "        flag = 0;\n";
        print "        len = document.form.date.length;\n";
        print "        for ( i=0; i<len; i++ ) {\n";
        print "            if ( document.form.date[i].checked ) { flag = 1 }\n";
        print "        }\n";
        print "        if ( flag == 0 ) {\n";
        print &strEncode("            alert(\"日付をチェックしてください。\");\n");
        print "            return(0);\n";
        print "        }\n";
        print "    }\n";
        print "    document.form.submit();\n";
        print "}\n";
        print "//-->\n";
        print "</SCRIPT>\n";
    }

    print "<CENTER>\n";
    print "<font size=-2 color=\"$clrText\"><p>\n";
#	グループ名表示をスキップ (20080502 守田修正)
#    print &strEncode("<P>－$grpName－</P>\n");

    #ヘッダー行を表示する
    $span = $range * 2 ;
    print "<TABLE BORDER=1>\n";
    print "  <TR BGCOLOR=\"$clrLTitle\">\n";
    print &strEncode("    <TH ROWSPAN=2 BGCOLOR=\"$clrCTitle\">お名前</TH>\n");
    if ($enTeam) { print &strEncode("    <TH ROWSPAN=2 BGCOLOR=\"$clrCTitle\">チーム</TH>\n") }
#	今日の情報は出力しない (20080502 守田修正)
#    print &strEncode("    <TH COLSPAN=2 BGCOLOR=\"$clrCTitle\">今日の情報</TH>\n");
    print &strEncode("    <TH COLSPAN=$span>練習候補日</TH>\n");
#    print "  </TR>\n";
    print "  <TR BGCOLOR=\"$clrLTitle\">\n";
#    print &strEncode("    <TH BGCOLOR=\"$clrCTitle\">状態</TH>\n");
#    print &strEncode("    <TH BGCOLOR=\"$clrCTitle\">メモ</TH>\n");


#	集合日(メンバーリストの最初のエントリーを集合日とする)を予め読んで、実施日を$go[$j]に入れておく (20080508 守田修正)
	my @go;
	my $j = 0;
    for ( $y=4; $y<$length; $y++ ) {
        if (( $ref[$y][0] >= $beginTime ) and ( $ref[$y][0] <= $endTime )) {
            ( $am, $pm ) = split( />/, $ref[$y][1] );
            if ( $am =~ /◎/ ) { $go[$j] = 1; }
            else {  $go[$j] = 0; }
			$j++;
		}
	}

#    for ( $i=$beginTime; $i<=$endTime; $i=$i+24*60*60 ) {
#	表に候補日のコラム・タイトルを印刷する (実施日はピンク色に着色する)
    $j = 0;
    for ( $i=$beginTime; $i<=$endTime; $i=$i+7*24*60*60 ) {
        ( $yy, $mm, $dd ) = &correcttime( $i );
        $wday = &getweek( $yy, $mm, $dd );
#	実施日なら背景をピンクにする
       if ( $go[$j] == 1 ) {
            print &strEncode("    <TH BGCOLOR=\"$clrSunday\">$mm/$dd($wdays[$wday])</TH>\n");
       }
#        elsif ( $wday == 6 ) {
#            print &strEncode("    <TH BGCOLOR=\"$clrSaturday\">$mm/$dd($wdays[$wday])</TH>\n");
#        }
        else {
            print &strEncode("    <TH BGCOLOR=\"$clrNormalday\">$mm/$dd($wdays[$wday])</TH>\n");
        }
        $j++;
    }
    print "  </TR>\n";

    #	配列の内容を表示する (メンバーの出欠予定はメンバーエントリーの2校目以降 20080508 守田修正)
    $toggle = 0;
    for ( $x=2; $x<$width; $x++ ) {
        if ( $toggle ) {
            print "  <TR BGCOLOR=\"$clrLine1\">\n";
            print &strEncode("    <TH BGCOLOR=\"$clrCLine1\" align=\"center\">$ref[0][$x]</TH>\n");
            if ( $enTeam ) {
                if ( $ref[1][$x] eq '' ) { print "    <TD BGCOLOR=\"$clrCLine1\">-</TD>\n" }
                else                     { print &strEncode("    <TD BGCOLOR=\"$clrCLine1\">$ref[1][$x]</TD>\n") }
            }
#            if ( $ref[2][$x] eq '' ) { print "    <TD BGCOLOR=\"$clrCLine1\">-</TD>\n" }
#            else                     { print &strEncode("    <TD BGCOLOR=\"$clrCLine1\">$ref[2][$x]</TD>\n") }
#            if ( $ref[3][$x] eq '' ) { print "    <TD BGCOLOR=\"$clrCLine1\">-</TD>\n" }
#            else                     { print &strEncode("    <TD BGCOLOR=\"$clrCLine1\">$ref[3][$x]</TD>\n") }
            $toggle = 0; 
        }
        else {
            print "  <TR BGCOLOR=\"$clrLine0\">\n";
            print &strEncode("    <TH BGCOLOR=\"$clrCLine0\" align=\"center\">$ref[0][$x]</TH>\n");
            if ( $enTeam ) {
                if ( $ref[1][$x] eq '' ) { print "    <TD BGCOLOR=\"$clrCLine0\">-</TD>\n" }
                else                     { print &strEncode("    <TD BGCOLOR=\"$clrCLine0\">$ref[1][$x]</TD>\n") }
            }
#            if ( $ref[2][$x] eq '' ) { print "    <TD BGCOLOR=\"$clrCLine0\">-</TD>\n" }
#            else                     { print &strEncode("    <TD BGCOLOR=\"$clrCLine0\">$ref[2][$x]</TD>\n") }
#            if ( $ref[3][$x] eq '' ) { print "    <TD BGCOLOR=\"$clrCLine0\">-</TD>\n" }
#            else                     { print &strEncode("    <TD BGCOLOR=\"$clrCLine0\">$ref[3][$x]</TD>\n") }
            $toggle = 1;
        }

        $j = 0;
        for ( $y=4; $y<$length; $y++ ) {
            if (( $ref[$y][0] >= $beginTime ) and ( $ref[$y][0] <= $endTime )) {
                ( $am, $pm ) = split( />/, $ref[$y][$x] );
                if ( $am eq '' ) { $am = '-' }
#                if ( $pm eq '' ) { $pm = '-' }

#                if ( $ref[$y][0] == $todayTime ) {
#                    if ( $pm eq '=' ) 
#                    { print &strEncode("    <TD ALIGN=\"center\"><B>$am</B></TD>\n") }
#                    else { print &strEncode("    <TD><B>$am</B></TD><TD><B>$pm</B></TD>\n") }
#                }
#                else {
#                    if ( $pm eq '=' ) 
                if ( $go[$j] == 1 ) {
                	print &strEncode("    <TD ALIGN=\"center\" BGCOLOR=\"$clrLpink\">$am</TD>\n");
                }
                else {
					print &strEncode("    <TD ALIGN=\"center\">$am</TD>\n");
				}
				$j++;
#                    else { print &strEncode("    <TD>$am</TD><TD>$pm</TD>\n") }
#                }
            }
        }
		print "    </TR>\n";
    }

#	最後に集合日の行を印刷する
    print "  <TR BGCOLOR=\"$clrLine1\">\n";
    print &strEncode("    <TH BGCOLOR=\"$clrCTitle\">$ref[0][1]</TH>\n");
    $j = 0; 
    for ( $y=4; $y<$length; $y++ ) {
        if (( $ref[$y][0] >= $beginTime ) and ( $ref[$y][0] <= $endTime )) {
            ( $am, $pm ) = split( />/, $ref[$y][1] );
            if ( $am =~ /◎/ ) { 
#            	$am = "<font color=\"red\"><b>◎</b></font>"; 
            	$am = "<span style=\"font-size:large; color:green; font-weight:bold\">" . $am . "</span>"; 
				print &strEncode("    <TD  BGCOLOR=\"$clrLpink\" ALIGN=\"center\">$am</TD>\n");
            }
            elsif ( $am eq '中止' ) { 
            	$am = "<span style=\"color:red; font-weight:bold\">中止</span>"; 
				print &strEncode("    <TD  BGCOLOR=\"$clrLpink\" ALIGN=\"center\">$am</TD>\n");
            }
            else { 
            	$am = '&nbsp;';
				print &strEncode("    <TD  BGCOLOR=\"$clrNormalday\" ALIGN=\"center\">$am</TD>\n");
			}
        }
    }
	print "    </TR>\n";

    print "</TABLE>\n";

    #引数が1で今日より後の時にフォームを表示する
    if (( $enForm ) and ( $endTime >= $todayTime )) {
#		print "<FORM METHOD=\"get\" ACTION=\"$room_url/schedule.cgi\" NAME=\"form\">\n";
#	｢送信｣ボタンで起動するCGIをschedule.cgiからpatio.cgiに変更 (20080519 守田修正)
		print "<FORM METHOD=\"post\" ACTION=\"$cgi_url/patio.cgi?room=salon\" NAME=\"form\">\n";
#		print "<FORM METHOD=\"get\" ACTION=\"$cgi_url/patio.cgi?room=salon\" NAME=\"form\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"update\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"myfile\" VALUE=\"$myfile\">\n";
        if ( $base ne '' ) { print "<INPUT TYPE=\"hidden\" NAME=\"base\" VALUE=\"$base\">\n" }
        if ( $direction ne '' ) { print &strEncode("<INPUT TYPE=\"hidden\" NAME=\"direction\" VALUE=\"$direction\">\n") }

        print "    <TABLE>\n";
        $result = int( $range / 10 );
        $remain = $range % 2;
        if ( $remain != 0 ) { $result++ }
        $tt = $beginTime;
        $count = 0;
		if ($range >= 10) { $column = 10; }
		else { $column = $remain; }
        for ( $i=0; $i<$result; $i++ ) {
	        print "<TR>\n";
	        for ( $j=0; $i<$column; $j++ ) {
	            ( $yy, $mm, $dd ) = &correcttime( $tt );
	            $wday = &getweek( $yy, $mm, $dd );
	            print &strEncode("<TD><INPUT TYPE=\"checkbox\" NAME=\"date\" VALUE=\"$yy/$mm/$dd\">$mm/$dd($wdays[$wday])</TD>\n");
	            $tt = $tt+7*24*60*60;
	            $count++;
	            if ($count == $range ) { last; }
	        }
	        print "</TR>\n";
            if ($count == $range ) { last; }
        }





print &strEncode("      <TR><TD colspan=\"4\">${strong1}日付をチェックし、名前とステータスを選択して送信！$strong2</TD>\n");
# 出勤/帰宅を見込みに変更 (20080502 守田修正)
#        print "      <TD>\n";
#        print &strEncode("        出勤：<INPUT TYPE=\"text\" SIZE=6 NAME=\"myam\" onChange=\"chk2(this.value)\">\n");
#        print "        <BR>\n";
#        print &strEncode("        帰宅：<INPUT TYPE=\"text\" SIZE=6 NAME=\"mypm\" onChange=\"chk2(this.value)\">\n");
#        print "      </TD>\n";

        print &strEncode("      <TD colspan=\"2\" align=\"right\">名前：\n");
        print "      <SELECT NAME=\"myname\">\n";
        if ( $enName == 0 ) { print &strEncode("        <OPTION VALUE=\"\" SELECTED>選んで下さい</OPTION>\n") }
        for ( $x=1; $x<$width; $x++ ) {
            if ( $myname eq $ref[0][$x] ) {
                print &strEncode("        <OPTION VALUE=\"$ref[0][$x]\" SELECTED>$ref[0][$x]</OPTION>\n");
            }
            else {
                print &strEncode("        <OPTION VALUE=\"$ref[0][$x]\">$ref[0][$x]</OPTION>\n");
            }
        }
        print "      </SELECT></TD>\n";


        print &strEncode("      <TD colspan=\"2\" align=\"center\">ステータス：\n");
        print "      <SELECT NAME=\"myam\">\n";
        print &strEncode("        <OPTION VALUE=\"\" SELECTED>選択</OPTION>\n");
        foreach ( @statList ) {
            print &strEncode("        <OPTION VALUE=\"$_\">$_</OPTION>\n");
        }
        print "      </SELECT></TD>\n";
        
#        print "    </TR></TABLE>\n";
#        print "  <TD WIDTH=25></TD>\n";
        print "  <TD align=\"right\">\n";
        print &strEncode("    <INPUT TYPE=\"reset\" VALUE=\"リセット\">\n");
        print "    </TD>\n";
        print &strEncode("    <TD align=\"right\"><INPUT TYPE=\"submit\" VALUE=\"送信\">\n");
        print "  </TD></TR>\n";
        print "</TABLE></FORM></font>\n";
    }


    #ボタンやリンクを表示する
#    print "<TABLE WIDTH=\"100%\">\n";
#    print "  <TR>\n";
#    print "    <TD ALIGN=\"left\">";
#    if ( $enBack ) {
#        print &strEncode("<A HREF=\"$Program?base=$beginDate&direction=back&myfile=$myfile\">&lt;&lt;以前へ</A></TD>\n");
#    }
#    else {
#        print "&nbsp;</TD>\n";
#    }
#    print "    <TD ALIGN=\"right\">";
#    if ( $enForword ) {
#        print &strEncode("<A HREF=\"$Program?base=$endDate&direction=forword&myfile=$myfile\">先へ&gt;&gt;</A></TD>\n");
#    }
#    else {
#        print "&nbsp;</TD>\n";
#    }
#    print "  </TR>\n";
#    print "</TABLE>\n";
    
}

#データを更新する
# <IN> なし
# <OUT> なし
sub update {

    if ($debug) { print DBG &strEncode("---サブルーチン：update---\n", $logchar) }
    my( $x, $y, $targetTime, $i, @targets, $width, $length, $flag, $am0, $pm0 );
    my( $datafile );

    $width = @{$ref[0]};
    $length = @ref;

    if ($debug) { print DBG &strEncode("    refの幅widthは${width}。\n", $logchar) }

    #対象になるメンバーをチェックする
    $flag = 0;
    for ( $i=1; $i<$width; $i++ ) {
        if ( $myname eq $ref[0][$i] ) { $flag=1; $x=$i; last; }
    }
    if ( $flag == 0 ) {
        &webmsg( "${myname}さんは登録されていません。", "$Program" );
    }

    #今日の状態を更新
    if ( $stat ne '' ) {
        $ref[2]->[$x] = $stat ;
    }

    #メモを書き込む
    if ( $memo ne '' ) {
        $ref[3]->[$x] = $memo ;
    }

    #出勤＆帰宅を書き込む
    if ( $date ne '' ) {
        @targets = split( /\0/, $date );
        foreach ( @targets ) {
            if ($debug) { print DBG &strEncode("    targetは$_。\n", $logchar) }
            $targetTime = &reversetime( split( /\//, $_ ));
            for ( $y=4; $y<$length; $y++ ) {
                if ( $targetTime == $ref[$y][0] ) {
                    ( $am0, $pm0 ) = split( />/, $ref[$y][$x] );
                    if ($debug) { print DBG &strEncode("    am0は${am0}、pm0は${pm0}。\n", $logchar) }
                    if ( $myam ne '' ) {
#                        if ( $pm0 eq '=' ) { $pm0 = $am0 }
                        $am0 = $myam;
                        if ( $myname eq '開 催 日' && ( $myam =~ /◎/ || $myam eq '中止' || $myam eq '-' )) {
                        	&sendmail( $_, $myam );
                        }
                    }
                    if ( $mypm ne '' ) { 
                    	$pm0 = $mypm;
                        if ( $pm0 eq '=' ) { $pm0 = $am0 }
                    }
                    if ($debug) { print DBG &strEncode("    am0は${am0}、pm0は${pm0}。\n", $logchar) }
                    $ref[$y]->[$x] = "$am0>$pm0";
                    last;
                }
            }
        }
    }

    #クッキーを送信
#	｢送信｣ボタンで起動するCGIを修正したことによりクッキー処理をヘッダー送出の前に変更
#    &setFile;
#    &setName;

    #ファイルに書き出す
    $datafile = "$dataDir/$myfile.$fileExt";
    if ( &lockopen( FILE, ">$datafile" ) eq '' ) {
        &webmsg( "データファイルが作成できません。" );
    }
    print FILE &strEncode("update=$today\n", $logchar);
    print FILE &strEncode("group=$grpName\n", $logchar);

    if ($debug) { print DBG &strEncode("    refの幅widthは${width}。\n", $logchar) }

    for ( $x=1; $x<$width; $x++ ) {
        print FILE &strEncode("name=$ref[0][$x]>$ref[1][$x]>$ref[2][$x]>$ref[3][$x]\n", $logchar);
        for ( $y=4; $y<$length; $y++ ) {
            ( $yy, $mm, $dd ) = &correcttime( $ref[$y][0] );
            print FILE &strEncode("  $yy/$mm/$dd>$ref[$y][$x]\n", $logchar);
        }
    }
    &lockclose( FL, $datafile );
    
}

#ブラウザにメッセージと戻るボタンを表示する
#   <IN>  メッセージ、[ もどり先 、 リンク文字列 ]
#   <OUT> なし
sub webmsg {

    my( $msg, $path, $label ) = @_;
    $msg =~ s/\n/<BR>\n/g;
    if ( $debug ) { &lockclose( DBG, "$dbgfile" ) }

    #戻り先の指定がなければ$Programに戻る
    if ( $path eq '' ) { $path = $htmPath }

    #リンク文字列の指定がなければ「もどる」にリンクする
    if ( $label eq '' ) { $label = "もどる" }

    print "Content-Type: text/html\n\n";
    print "<HTML>\n";
    print "<HEAD>\n";
    print "  <META http-equiv=\"Content-Type\" content=\"text/html; charset=$htmlcode\">\n";
    print &strEncode("  <TITLE>$Title エラー!</TITLE>\n");
    print "</HEAD>\n";
    print "<BODY BGCOLOR=$clrMsgBG TEXT=\"$clrText\">\n";
    print "<CENTER>\n";
    print &strEncode("<BR><BR><H3>$Title エラー！</H3>\n");
    print "<BR><BR><BR>\n";
    print &strEncode("<H4>$msg</H4>\n");
    print "<BR><BR>\n";
    print &strEncode("<P><A HREF=\"$path\">[$label]</P>\n");
    print "</CENTER>\n";
    &printFooter;

    if ( $debug ) { &lockclose( DBG, "$dbgfile" ) }
    exit(0);
}

#-------------------------------------------------
#  メール送信
#-------------------------------------------------
sub sendmail {

	my ($targetDate, $event) = @_;

	local($msub, $mbody, $mcom, $email);
#	local($msub, $mbody, $email);			# FEED機能追加により$mcomはグローバル変数に変更 （2009/10/20 スガラボット修正)

	# タイトルと名前のBBCodeを削除 （2009/01/14 スガラボット修正)
	$i_sub = "Salon da Musica 練習･開催日のお知らせ";
	$i_nam2 = "サロン・ダ・ムジカ Web 掲示板";

	# メールタイトルを定義
	$msub = "$title： $i_sub";

	# 実施内容の表示
	if ( $event =~ /◎/ ) { $event = $event . " (実施します)"; }
	if ( $event eq '中止' ) { $event = "中止します"; }
	if ( $event eq '-' ) { $event = "解除 (以前の登録がリセットされました)"; }

	# 本文の定義
	$mcom = "サロン・ダ・ムジカ メンバー各位:\n\n";
	$mcom .= "先程、掲示板の練習開催日欄に以下の内容が書き込まれました。\n";
	$mcom .= "開催日: $targetDate\n";
	$mcom .= "内　容: $event\n\n";
	$mcom .= "このメールはWebサーバが自動的に送信したものです。掲示板の内容については以下のURLからご確認下さい。\n";
	$mcom .= "http://vmorita.com/bbs/salon/forum.shtml\n";

$mbody = <<EOM;
$mcom

--------------------------------------------------------
(ご注意: このメールは自動送信です。この通知メールの発アドレス宛てには返信しないで下さい。)
EOM

# Hi-HOのssendmailに合わせて題名のエンコードを'euc'に変更方を変更 スガラボット修正分
#	if ($hi_ho) { &jcode'convert(*msub,'euc'); }
	if ($hi_ho) { $msub = Unicode::Japanese->new($msub)->euc; }
	# 題名をBASE64化
	else 		{ $msub = &base64($msub); }

	# メールアドレスがない場合は管理者アドレスに置き換え
#	if ($in{'email'} eq "") { $email = $mailto; }
#	else { $email = $in{'email'}; }

	$email = $sender;

# 複数の管理人がいたときは一通ずつ送信する。(20080222 守田修正)

	# 複数アドレスがセットされていないときは従来の宛先を使用する
	if (!@mailto2) { $mailto2[0] = $mailto; }

	# 1通ずつ送信する
	foreach (@mailto2) {

		# sendmail送信
		if ($hi_ho) {
# Hi-HOのssendmailに合わせて$sendmailの呼び方を変更 スガラボット修正分
			open(MAIL,"| $sendmail -s \"$msub\" -f \"$email\" $_") || &error("送信失敗");
		}
		else {
			open(MAIL,"| $sendmail -t -i") || &error("送信失敗");
			print MAIL "To: $_\n";
			print MAIL "From: $email\n";
			print MAIL "Subject: $msub\n";
			print MAIL "MIME-Version: 1.0\n";
			print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
			print MAIL "Content-Transfer-Encoding: 7bit\n";
			print MAIL "X-Mailer: perl$]\n\n";
		}
		foreach ( split(/\n/, $mbody) ) {
#			&jcode'convert(*_, 'jis', 'sjis');
			my $str = Unicode::Japanese->new($_)->jis;
			print MAIL $str, "\n";
		}
		close(MAIL);	
	}

}

#-------------------------------------------------
#  BASE64変換
#-------------------------------------------------
#	とほほのWWW入門で公開されているルーチンを
#	参考にしました。( http://tohoho.wakusei.ne.jp/ )
sub base64_try {
	local($sub) = @_;
#	&jcode'convert(*sub, 'jis', 'sjis');
	$sub = Unicode::Japanese->new($sub)->conv('jis', 'base64');
	chomp($sub);
	$sub = "=?iso-2022-jp?B?" . $sub . "?=";
	return $sub;
}
sub base64{
	local($sub) = @_;
#	&jcode'convert(*sub, 'jis', 'sjis');
	$sub = Unicode::Japanese->new($sub)->jis;

	$sub =~ s/\x1b\x28\x42/\x1b\x28\x4a/g;
	$sub = "=?iso-2022-jp?B?" . &b64enc($sub) . "?=";
	$sub;
}
sub b64enc {
	local($ch)="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	local($x, $y, $z, $i);
	$x = unpack("B*", $_[0]);
	for ($i=0; $y=substr($x,$i,6); $i+=6) {
		$z .= substr($ch, ord(pack("B*", "00" . $y)), 1);
		if (length($y) == 2) {
			$z .= "==";
		} elsif (length($y) == 4) {
			$z .= "=";
		}
	}
	$z;
}

#HTMLのフッターをprintする。
#   <IN>  なし
#   <OUT> なし
sub printFooter {

    print <<END_OF_VIEW;
<P ALIGN="right">
$_
</P></BODY></HTML>
END_OF_VIEW

}

1;
