=pod
┌─────────────────────────────────
│ Forum Patio v1.55m
│ serverconf.cgi - 2022/0813
│ Copyright Sugarabotto
│ viola@vmorita.com
│ http://vmorita.com/bbs/patio/
│
│ (このスクリプトは以下のオリジナルの拡張版です)
│ Web Patio v3.22
│ init.cgi - 2009/07/04
│ Copyright (c) KentWeb
│ webmaster@kent-web.com
│ http://www.kent-web.com/
└─────────────────────────────────

 サーバのディレクトリ構成をinit.cgiから切り離して別設定ファイルとして独立 （2009/04/02 スガラボット)

 掲示板スクリプトをサーバにインストールするときは、最低限以下の行でコメントアウトしていない項目について、ご利用環境・要件に従った値を設定して下さい。
 設定後このファイル名を ”serverconf.cgi " に変更して保存し、サーバにアップして下さい。
 この設定ファイルで設定した環境に固有の設定値は、後のバージョンアップ時に init.cgi を配布されたファイルで上書きしても変更されないので安心してバージョンアップできます。

━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━
=cut

use utf8;

#-------------------------------------------------
#  ◎掲示板の固有設定【1】(サーバのディレクトリ構成とドメイン及びルートURLの設定)
#	 ・ご利用のサーバに合わせて必ず以下の項目を設定して下さい。
#-------------------------------------------------

	# ユーザHTMLのルートディレクトリ 【サーバルートのフルパス】
	#$root_dir = '/var/www/html';					# dnf(yum)でインストールしたアパッチのドキュメントルート
	#$root_dir = '/usr/local/apache2/htdocs';		# アパッチHTTPDのデフォルト
	#$root_dir = 'D:/Web/vmorita_sakura';			# WindowsのDドライブテスト用
	$root_dir = '/home/USER-ID/www';				# さくらレンタルサーバの場合
	#$root_dir = "$ENV{'HOME'}/html";				# Hi-Hoの場合HTMLのルート

	# サーバがhi-hoのとき=1
	$hi_ho = 0;
	#$root_dir = "$ENV{'HOME'}/html"; $hi_ho = 1; 	# Hi-Hoの場合HTMLのルート

	# 複数会議室を設置するするときのBBSホームディレクトリ名
	$bbs_dir = 'bbs';

	# CGI実行ディレクトリ (.cgiファイルの場所) 【サーバのフルパス】
	$cgi_dir = "$root_dir/cgi-bin";					# 一般の場合 (さくらレンタルサーバを含む)
	#$cgi_dir = "$ENV{'HOME'}/cgi-bin";				# Hi-Hoの場合
	#$cgi_dir = '/usr/local/apache2/cgi-bin';		# アパッチcgiスクリプトのデフォールト

	# ホームページのルートディレクトリ 【/から始まるURLサーバルート】
	$home_root = '/';								# URLルート直下の時 (Hi-hoを含む)
	#$home_root = '/USER-ID';						# ユーザ別のサブディレクトリがトップページとなるレンタルサーバの場合

	# CGIファイルのURLディレクトリ【/から始まるURLディレクトリ】
	$cgi_url = ($home_root eq '/')? '/cgi-bin' : "$home_root/cgi-bin";		# さくらインターネットなど一般の場合はこっち (2014/09/23 スガラボット修正)
	#$cgi_url = "/cgi-bin/user/USER-ID";			# Hi-Hoの場合
	#$cgi_url = "/xxxxxxxx/cgi-bin";				# 任意のディレクトリの場合はこっち

	# ユーザのURLドメイン 【最後の/を省略したURLドメインのフルパス】
	#$url_root = 'https://10.2.255.4';				# スガラボットのテスト環境 (IPアドレス直指定)
	#$url_root = 'https://localhost';				# 実験用PCなどブラウザと同じCPU内のサーバ
	$url_root = 'https://www.example.com';			# 公開するサーバのURLルート
	#$url_root = 'https://vmorita.com';				# スガラボットの独自ドメイン
	#$url_root = 'https://USER-ID.sakura.ne.jp';		# さくらインターネットの場合
	#$url_root = 'https://www.xxx.hi-ho.ne.jp/USER-ID';	# Hi-Hoの場合

	# 会議室ディレクトリが省略された場合のメイン会議室名 (適宜変更のこと)
	$def_room = "room1";

sub bbsconf {		# オリジナルの init.cgi と表示を合わせるため敢えてインデントしない

#-------------------------------------------------
#  ◎掲示板の固有設定【2】(設定【1】以外の項目)
#		・init.cgi の掲示板固有設定の【2】「始め」から「終わり」の部分でデフォールト値以外の設定をしたい時は
#		  init.cgi を直接変更するのではなく、その項目を全て以下にコピーしてから希望の設定値に変更し、
#		  このファイルの名前を serverconf.cgi に変更して、init.cgi と同じディレクトリに配置して下さい。
#-------------------------------------------------
#「始め」
#=====================

# 書き込み禁止モード (0=通常動作 1=書き込み禁止)
our $ReadOnly = 0;

# 全会議室書き込み禁止モード (0=通常動作 1=書き込み禁止)
our $ReadOnlyAll = 0;

# 書き込み禁止モード中に表示するお知らせ
our $Oshirase = 'メンテナンス中につき、書き込み禁止モードで動作しています。';

# 管理パスワード（英数字で8文字以内）
our $pass = 'abcd1234';

# 会員専用掲示板としてアクセス制限をする
# 0=no 1=yes
our $authkey = 0;

# ログイン有効期間（分）
our $authtime = 60;

# 画像アップを許可する（親記事のみ）
# 0=no 1=yes
#$image_upl = 1;
# 画像アップの許可はスガラボットの項目で追加修正した （2008/09/26 スガラボット)

# トリップ機能（ハンドル偽造防止）のための変換キー
# →　英数字で2文字
our $trip_key = 'ab';

# タイトル (ヘッダータイトルと本文タイトルを分離 ⇒ 20080210スガラボット修正)
# 複数の各会議室毎にroomNini.cgiにて設定が必要
our $title = "Forum Patio 掲示板 room1";

# タイトルの文字色
our $t_color = "#531B08";

# 掲示板の説明
our $desc = "<font color=\"$t_color\">ビオラやバイオリンまたは室内楽愛好の方はご自由に書き込み下さい</font>";

# タイトルサイズ
our $t_size = '14pt';

# 本文文字サイズ
#our $b_size = '10pt';
#our $b_size = '10.5pt';
our $b_size = '11pt';

# 本文文字フォント
#our $b_face = '"メイリオ", "MS UI Gothic", Osaka, "ＭＳ Ｐゴシック"';
#our $b_face = '"ヒラギノ", "メイリオ", "MS UI Gothic", Osaka, "ＭＳ Ｐゴシック"';
our $b_face = '"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro","Meiryo UI","メイリオ",Meiryo,"ＭＳ Ｐゴシック", "MS UI Gothic",Osaka,sans-serif';

# 壁紙 (添付の壁紙は楽譜です。適宜変更してご使用下さい)
#our $bg = '';
#our $bg = "$imgurl/k-onpu303.gif";
our $bg = "$imgurl/music_bg.gif";

# 背景色
our $bc = "#F0F0F0";

# 文字色
our $tx = "#000000";

# リンク色
our $lk = "#0000FF";
our $vl = "#800080";
our $al = "#DD0000";

# アクセス制限（半角スペースで区切る）
#  → 拒否するホスト名又はIPアドレスを記述（アスタリスク可）
#  → 記述例 $deny = '*.anonymizer.com 211.154.120.*';
our $deny = '';

# 記事の更新は method=POST 限定 (0=no 1=yes)
# （セキュリティ対策）
our $postonly = 1;

# 連続投稿の禁止時間（秒）
our $wait = 30;

# 禁止ワード
# → 投稿時禁止するワードをコンマで区切る　以下はきりしま式のサンプル掲示板で設定した禁止ワードの一覧
#    ２つ目以降のリストは「,」で区切ってから始めること。
#   （例）$deny_word = 'アダルト,出会い,カップル';
#    迷惑書き込みに多い「http」を指定するとかなり効果があると思われます
# $no_wd = '';

# アダルト系禁止ワード
# $no_wd = '●万,M男,SEX,アダルト系,エステ,エッチ,えっち,エロ,オカネ,おッぱい,おっぱい,オナニー,おまんこ,セ●レ,セックス,セックヌ,セフレ,セレブ,てぃんこ,ドウテイ,ニート,レイプ,愛人,愛欲請負人,臼奨鍬咎巷望,悦び,悦楽,奥さん,快感,顔射,激安,交際,工□,高級,社長令嬢,謝礼,熟女,出会,出会い,出会い系,出張ホスト,初体験,人妻,性感,成熟,中出し,調教,童貞,肉棒,濡れて,卑猥,不倫,風俗,癒されたい,誘唹字,羅王,乱交,裏バイト,輪姦,涙血菰砿,疼';
our $no_wd = '●万,M男,SEX,アダルト系,エッチ,えっち,エロ,オカネ,おッぱい,おっぱい,オナニー,おまんこ,セ●レ,セックス,セックヌ,セフレ,てぃんこ,ドウテイ,ニート,レイプ,愛人,愛欲請負人,臼奨鍬咎巷望,悦楽,奥さん,顔射,激安,工□令嬢,謝礼,熟女,出張ホスト,人妻,性感,中出し,童貞,肉棒て,卑猥,風俗,誘唹字,羅王,乱交,裏バイト,輪姦,涙血菰砿,疼';

# 英語系禁止ワード ※簡単な英語でコメントする英語の迷惑投稿対策です。URLで引っかかる可能性もあります
# $no_wd = $no_wd.',good,best,guestbook,Interesting,Hammm';

# 英語コードの「'」対策 ※英語コードの文字化けで引っかからない単語
# $no_wd = $no_wd.',’,that卒s';

# その他の言語系禁止ワード ※日本人が使わないと思われる単語
$no_wd = $no_wd.',Сиськи';

# URL系禁止ワード
# $no_wd = $no_wd.'282814,007ihost,100webspace,101freehost,115navi,117-ero,11-nioi,12gbfree,1g8sr4,1stbenefits,247ihost,2www.org,4infovision,59d,81f,ac.be,adsenseru.info,adult,ai.aisite-hosii,aiai-honey,alive-iine,all-thetime-you,a-lot-of-deai,anal,angelfire,av-lovemania,azcafe,best-7-couple,bigtits.1gb.ua,bikerboyz,bitdom,bitxcl2.blog48.fc2,blogspot,bocaroyale.com ,born-again-christian.info,bravehost,buddyprofile,casino,c-cock,chocolateladytreats,christianskitscripts,chwweb,cialis,clearmethods,cloud.prohosting,cnn,cossackbrothers,cute-lala,dartmouth,deai,deai-megami,denise-milani,denvereruv,diazepam,diet,digmun.info,diorer,disabledsg,division7,d-ota,dp-117,dragonball.z-mode,dtiblog,eastpapuan.ling.su.se,ed.gov,ee-ro,ekanpo,ekanpou,ero2.biz,eromeimei,erorin,eters,ettina-anoko,ewqe-r.info,excellent3,fansfc,fatfreehost,fd532,firelily,fm7.biz,f-mama,forumforfree,freehyperspace,freephpwebhosting,freespirits,freeweb7,freewebs,freshgirls.1gb.ua,friscomountainrentals,from-today-we,garl-navi,gatech.edu,georgiatemple,get-loud-da,giftsbygrove,gomang-usa,googleweb953,gregory.free-site-host,g-sf,guestbook,gyaku-h,hamburg.de,harborsupply,hips,h-no1,home.planet.nl,home.wanadoo.nl,hostaim,hostpresso,hotelcorona,href,huizengahergt,hydrastore,iikamone,iikannkei,imasugu-aeru,insurance,ireteiiyo,irisembroidery.homestead,iwanttowheelie.co.,jackie-guerrido,jj-i,joolo,kane-kane-kudasai,kikennna-koi-koi,kiss-kiss-girls,kmcbaskets,koi-kami,koi-suppot,konnano-hazimete,ldskfhha.0buckhost,leslies,lifestyle-072,likecureslike,lingamesjp,loan,lolicolle,lord,lover-good,lvyahoo,madara28,map4,masserspuds,mens-laugh-last,metacritic,minnieerecting,mistress2,mixy-7,morpca,mortgage,myfreewebhost,naked,narod.ru,natu.ero-natu,ngkeun.my2gig,nikoniko-club,nikoniko-club.comuntouchable-man,norato,nrg-search,nude,nuki-navi,nurenure-okusan.nurenure-okusan,nwkaj.free-site-host,ocean-acros,oernyu.freehostplace,ona.ona-m,onenight-in-paris,onny,otonano.pooo3,otona-spot,pacaeromodel,paimomi,paipai,pajdsk.iifree,pasxcl,peach-push,pemisi.ypu,petal-lip,pharmacy,pjcollectors,planetsti.info,pluto.no,poker,pokerprince,porn,ppp-sereb,prnewsmedia.tyrilolsen,projector-beijing,puccol.twsgv,quest.pooo3,ranchocicadaretreat,reachtranslation,republika,retgrs,ripway,robinsfcu,room-in-girl,saigomade,saikou.etti-saikou,s-auction,s-beauty,sefure-annai,sekkutyu,sex,sex.sex-maniax,sex.sex-o,sex-sexs,s-fr,sha-la-la-baby,sharonpaper,sheffield-mfg,shigajet,sinclair.awesomewebspace,singbarbershop,siski,sky-hart,slave-sm,sm-ero,smplay,snao.z-mode,sodenoshita,spa-guy,sukisuki-gal,swell.swell-up,tatu-yo,tc.umn.e,tchjs.,touchpoint.za,truly-it-coco,tulane.edu,tyfo,ublib.buffalo.edu,uiowa.edu,ullohn,unc.twsgv,untouchable-man,usdil,viagra,vicodin.envy.nu,wananchi,warp-station,welcome.twsgv,westerbraehighlandlodges,white.prohosting,wiiwi,woman-line,wwwa.accuweather,wydi,x07.jp,xn--cck0cya3lp32zbqo.biz,xn--ick7bf6125cybm,xn--n8j890gcxag5af4d,xn--vus757,xyevdrom,yattane-sex,ynglingsailing,youmenipip,z-night,zz84';
# フリーWeb系禁止ワード ※ユーザーの悪意のないページがはじかれる可能性があります
#                         メジャー系でないフリーWebの場合は、URL系禁止ワードに含まれているかもしれません
# $no_wd = $no_wd.',tripod,usearea';

# 日本語チェック（投稿時日本語が含まれていなければ拒否する）
# 0=No  1=Yes
our $jp_wd = 1;

# URL個数チェック
# → 投稿コメント中に含まれるURL個数の最大値 (オリジナルは"0"のとき無制限) → 後でスガラボットにより定義変更(0のときは禁止、-1の時は制限無し)
our $urlnum = 0;

# 名前入力必須 (0=no 1=yes)
our $in_name = 1;

# E-Mail入力必須 (0=no 1=yes)
# E-Mail入力必須 (0=no 1=yes 2=入力欄非表示・入力禁止 3=入力禁止)
# ここを2や3にするとレスお知らせメール機能が利用できません。
our $in_mail = 0;

## E-Mail表示 (0=非表示 1=表示) ※ここを表示にしても、ユーザーが非表示を選ぶと表示されません
our $show_mail = 0;

# 削除キー入力必須 (0=no 1=yes)
our $in_pwd = 0;

# 現行ログ最大スレッド数
# → これを超えると過去ログへ移動
our $i_max = 100;

# 過去ログ最大スレッド数
# → これを超えると自動削除
our $p_max = 1000;

# 1スレッド当りの「表示」記事数
our $t_max = 10;

# 1スレッド当りの「最大」記事数
# → これを超えると過去ログへ廻ります
# → 残り90%でアラームを表示します
our $m_max = 100;

# 現行ログ初期メニューのスレッド表示数
our $menu1 = 20;

# 過去ログ初期メニューのスレッド表示数
our $menu2 = 20;

# 色指定（順に、濃色、薄色、中間色、濃色の中の文字タイトル色）
our $col1 = "#8080C0";
our $col2 = "#FFFFFF";
our $col3 = "#DCDCED";
our $col6 = "#FFFF00";

# 繰越ページ数の当該ページの色
our $pglog_col = "#DD0000";

# コメント入力文字数（全角換算）
our $max_msg = 5000;

# スマイルアイコンの使用 (0=no 1=yes)
our $smile = 1;

# スマイルアイコンの定義 (スペースで区切る)
# → ただし、この設定箇所は変更しないほうが無難
# → 顔文字に半角カナや2バイト文字は使用厳禁（正規表現上の制約）
our $smile1 = 'smile01.gif smile02.gif smile03.gif smile04.gif smile05.gif smile06.gif smile07.gif';
our $smile2 = '(^^) (^_^) (+_+) (^o^) (^^;) (^_-) (;_;)';

# メール送信
# 0 : しない
# 1 : スレッド生成時
# 2 : 投稿記事すべて
our $mailing = 2;

# メール送信先
our $mailto = 'someone@example.com';

# メール送信時の差出人
# 空欄 : メールアドレスの入力があればそのアドレス
# メールアドレスを指定 : つねに指定したメールアドレスから送信
our $sender = 'patio-admin@USER-ID.sakura.ne.jp';

# メール送信先（ＢＣＣ）
our $bccto = '';

# sendmailパス
# 通常はこれ
#$sendmail = '/usr/lib/sendmail';
#$sendmail = './form-to-mail-lib/ssendmail';	# Hi-Hoの時など
# さくらインターネットはこっち
our $sendmail = '/usr/sbin/sendmail';

# ホスト取得方法
# 0 : gethostbyaddr関数を使わない
# 1 : gethostbyaddr関数を使う
our $gethostbyaddr = 1;

# アクセス制限（半角スペースで区切る、アスタリスク可）
#  → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
our $deny_host = '';

#  → 拒否IPアドレスを記述（前方一致）【例】210.12.345.*
our $deny_addr = '';

# １回当りの最大投稿サイズ (bytes)
# → 例 : 102400 = 100KB
our $maxdata = 5120000;			# 5MB としてある

# アップ画像の最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
our $img_max_w = 200;	# 横幅
our $img_max_h = 200;	# 縦幅

## --- <以下は「投稿キー」機能（スパム対策）を使用する場合の設定です> --- ##
#
# 投稿キーの使用（スパム対策）
# → 0=no 1=yes
#our $regist_key = 1;
our $regist_key = 0;

# 投稿キー画像生成ファイル【URLパス】
#$registkeycgi =  "$cgi_url/registkey.cgi";

# 投稿キー暗号用パスワード（英数字で８文字）
our $pcp_passwd = 'patio123';

# 投稿キー許容時間（分単位）
#   投稿フォームを表示させてから、実際に送信ボタンが押される
#   までの可能時間を分単位で指定
our $pcp_time = 360;

# 投稿キー画像の大きさ（10ポ or 12ポ）
# 10pt → 10
# 12pt → 12
our $regkey_pt = 10;

# 投稿キー画像の文字色
# → $textと合わせると違和感がない。目立たせる場合は #dd0000 など。
our $moji_col = '#dd0000';

# 投稿キー画像の背景色
# → $bcと合わせると違和感がない
our $back_col = '#F0F0F0';

#-------------------------------------------------
#  ◎これ以下は きりしま式 の設定項目です。
#-------------------------------------------------

# 新着表示時間
# 単位：秒
# $hot = 43200; # 12時間
# $hot = 72000; # 20時間
our $hot = 259200; # 72時間

# NEWの表示内容（HTML可）
our $newmark = " <font color=\"#FF0000\"><b>new!</b></font>";
# $newicon = ""; ブランクにすれば無効と同じ

# 新着レスのアイコン
#our $newfile = "filenew.gif";

# 色指定・注意色
our $col4 = "#FF0000";

# 投稿画面のコメント欄の行数
our $rows = 15;

# 投稿画面のコメント欄の桁数
#$cols = 72;
our $cols = 80;

# 新規スレッド作成時のコメント欄の行数
our $newrows = 20;

# レスのデフォルトタイトルの設定
our $ourrestitle = 0;
# 0 : 空欄
# 1 : 「Re: 元のタイトル」
# スレッド一覧にレスのタイトルが入るので 0 : 空欄 を推奨

# リンクの際のターゲット
our $target="_blank";

# 引用部分の色
our $quotecol="#6495ED";

# 引用部分の色(2)
our $quotecol2="#FF6600";

# ID機能の利用
# 0 : ID機能を利用しない
# 1 : ID機能を利用する
our $idkey = 1;

# タイトルの文字数
our $sublength = 80;

# 同一IPからのメール送信可能間隔（秒）
our $mailwait = 30;

# レスがあったときにお知らせ 0=しない 1=スレ立てた人のみ 2=コメントした人も含め全員 3=スレ主とレス先
our $mailnotify = 3;

# お知らせの送信元として使用するアドレス (各会議室毎に上書き設定も可)
our $notifyaddr = 'patio-admin@example.com';

# お知らせの配信を拒否しているアドレス（,で区切って複数指定）
# この文字列にマッチした場合は配信されません（文字列なので注意））
our $refuseaddr = '';

# 管理人が記事を編集した場合、書き込みをした本人が編集できないようにパスワードをクリアする
# 0 : パスワードを維持する
# 1 : パスワードをクリアする（本人編集不可）
our $clearpass = 0;

# スレッド作成には、管理パスワードの入力を必須にする
# 有効にすると、実質的に管理者しかスレッドを立てることができなくなります。
# 0 : 無効にする
# 1 : 管理パスワードの入力を必須にする
our $createonlyadmin = 0;

# スレッド作成時の注意書き（コメント欄の前に表示されます）
#our $createnotice = "";
our $createnotice = "新規テーマでの投稿時は、既に同一テーマのスレッドがないか検索して下さいね。";

# スレッド作成時のテンプレート（コメント欄に初期表示されます）
#our $createtemplate ="";
our $createtemplate ="テンプレート展開: \n行末の改行コードとして\\nを使用すると\n複数行も対応できます。";

#-------------------------------------------------
#  ◎これ以下は スガラボット版の設定項目です。
#-------------------------------------------------

# URL個数チェック
# 投稿コメント中に含まれるURL個数の最大値 (オリジナルは"0"のとき無制限) をスガラボットにより定義変更(0のときは禁止、-1の時は制限無し)
if ($urlnum == 0) { $urlnum = -1; }
# URLの書込みを禁止するときは以下の行をコメントアウトする。
$urlnum = -1;

# プロバイダがHi-Hoのときはsendmailなどの一部処理を差し換える必要があり、そのための制御変数を定義
#$hi_ho = 0;
#$hi_ho = 1;

# アップロードを許可するファイルタイプ
our $file_type = "jpg,jpe,gif,png,txt,pdf,doc,dot,xls,xlt,ppt,pot,zip,lzh,tar,gz,tar.gz,tar.bz2,bz,cgi,pl,php,java,c,h,html,htm,shtml,dat,bz2,cab,wav,mp3";

# レス指定返信による記事の背景色を新たに定義
#our $res_color = "#FFFCB7";	# 薄い黄色
our $res_color = "#FFFFFA";	# 薄い黄色
#our $res_color = "#FFFCD0";	# 薄い緑色

# ツリー表示をする(=ファイル名)かしない(=0)か。するときは外部ファイルを定義 (新規に同梱済）
our $treeforum = './lib/tree.pl';

# ツリー表示｢Forum｣ページタイトル (文字列または画像へのリンク)
our $forum_title = "<img src=\"$imgurl/Forum_Patio_y.gif\" style='border-style: none;' alt=\"[Forum Patio]\">";

# トップページのタイトル表示をロゴや画像へのリンク表示したいときに設定
our $body_title = "<img src=\"$imgurl/Forum_Patio_y.gif\" style='border-style: none;' alt=\"[Forum Patio]\">";

# ツリー表示するとき、パラメータで指定されたノードと一致したときの強調表示のスタイル
#our $strong1 = "<font color=\"FF1493\"><strong>";
#our $strong2 = "</strong></font>";
our $strong1 = "<b style=\"color:red\">";
our $strong2 = "</b>";
#our $strong1 = "<span style=\"background:#FFDDDD\"><strong>";
#our $strong2 = "</strong></span>";

# 検索結果を表示するとき、パラメータで指定されたノードと一致したときの強調表示のスタイル (文字に背景色を付ける)
#our $strong1a = "<span style=\"background:yellow\"><strong>";
#our $strong2a = "</strong></span>";
our $strong1a = "<span style=\"background:#FFFF77\"><strong>";
our $strong2a = "</strong></span>";
our $strong1b = "<span style=\"background:#88FFFF\"><strong>";
our $strong2b = "</strong></span>";
our $strong1c = "<span style=\"background:#005555\"><strong>";
our $strong2c = "</strong></span>";

# 文字色指定に使える色を定義する (24色カラーコードを","で繋げたリスト)
our $char_color = "#000000,#800000,#DF0000,#2F4F4F,#006400,#008040,#0000FF,#C100C1,#FF80C0,#FF8040,#000080,#483D8B,#808000";

# 文字色指定する場合のデフォールト色 (上の中から指定した色のラジオボタンがチェックされる)
our $default_color = "#000000";

# メール送信先 (複数の管理人を置いたときに設定する ()の中に''で1囲んだメールアドレスを , で区切って列挙
#our @mailto2 = ('viola@vmorita.com', 'viola-morita@fol.hi-ho.ne.jp');

# 本文の行間設定 (オリジナルだと少し詰まりすぎに感じたので追加)
#our $l_height = '';
our $l_height = 'line-height: 1.3;';

# 管理機能でスレッド分割のとき分割後の旧スレッドに記事を (0の時は残す。1の時は消去する。2の時は親スレッドへの返信として残す) 
our $split_del = 1;

# 画像アップを許可する (20080926 スガラボットが返信も追加修正)
# 共通設定はここで行うが 各会議室のiniファイルで個別設定も可能
# 0=no, 1=yes（親記事のみ）, 2=yes（親記事と返信も）
our $image_upl = 2;

# Forum形式トップページで現行ログ初期メニューのスレッド表示数
our $fmenu1 = 10;

# Forum形式トップページで過去ログ初期メニューのスレッド表示数
our $fmenu2 = 10;

# 返信フォームで特定発言を参照したとき、題名と本文に参照した記事の内容を引用するか(=1)、しないか(=0)
our $ftitlecom = 1;

# ラジオボタンで特定発言に返信する時、題名欄に参照した記事の内容を引用するか(=1)、しないか(=0)
our $reftitle = 1;
our $res_script;			# 元発言のタイトルを引用参照するための変更 （2011/10/13 スガラボット修正)
our @res_sub;				# 元発言のタイトルを引用参照するための変更 （2011/10/13 スガラボット修正)

# BBCode使用の可否: 投稿記事のBBCodeをHTMLタグに変換するか(1)、しないか(0) (2009/01/04 v1.13にて追加)
our $bbcode = 1;
# BBCodeからHTMLへのタグ変換を無効にする時の記事中、及び返信フォームの引用中にBBCodeをそのまま表示する(0)か、隠す(1)か
our $bbhide = 0;

# 管理者が削除したスレッドの取り扱い方法
# ログファィルとアップロードデータを全て削除するとき(0), 別の削除ディレクトリに移動するとき(1)
our $logdelete = 1;		# この行を0か1に設定する

# patioのトップページの名前からトリップ表示を削除するかどうか (そのまま表示=0、削除=1)
our $patio_trip = 1;

# 新規投稿フォームで一般ゲストにスレッドテーマの設定を許可するかどうか。許可しない=0、許可する=1
our $thread_theme = 1;

# HTML入出力文字コード (「sjis」→Shift_JIS,「euc」→euc-jp,「utf8」→utf-8,「jis」→iso-2022-jp)(必須)
our $charset = 'utf8';

# ログファイル文字コード (「sjis」Shift_JIS「utf8」utf-8)(必須)
our $logchar = 'utf8';

# 投稿時プレビューをするかしないか (0=no 1=yes)
our $preview = 1;

# プレビュー画面での注意書き（プレビュー画面のタイトル欄に表示されます）
# our $createnotice = "";
our $previewnotice = "*** 送信データを登録するために、必ず画面下の三つのボタンボタンのうち一つをクリックして下さい！ ***";

### プレビュー画面でのsubmitボタンメッセージ
# 投稿プレビュー後、再度プレビューするメッセージ
our $prevButton = '修正内容を再度プレビュー';
# 投稿プレビュー後、投稿取りやめメッセージ
our $quitButton = '投稿を取り止める';

# ツリー形式の閲覧画面でスレッド・タイトルのツリー表示メニューの表示位置
# (0=単独記事表示のときは下/複数なら上に表示)、(1=下に表示)、(2=上に表示)
our $tree_menu = 0;

# 携帯電話からの閲覧時、1ページに表示する記事の数 (0=PC時の$t_maxと同じ、n>0 → n個の記事)
our $kt_max = 1;

# 閲覧時に画像を縮小表示するときサムネイル画像を作成するかどうか (0=作成しない)、(1=表示する)
our $thumbnail = 1;

# 携帯電話からの閲覧時添付画像の縮小画面を表示しないようにする設定 (0=表示する)、(1=表示しない)
our $kimg_noview = 0;

# 携帯電話で画像をサムネイル表示するときの表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
our $img_thm_w = 96;	# 横幅
our $img_thm_h = 96;	# 縦幅
our $quality = 100;		# 描画品質

## --- <以下は「投稿認証キー」機能（スパム対策）を使用する場合の設定です> --- ##
#
# 投稿認証キーの使用（スパム対策）
# → 0=no 1=yes
our $captcha = 1;

############## RSS配信する場合の設定項目 ###########

# RSS/Atomフィード
# 使用する場合はwpfeed.plを開いて設定を行う必要があります
# 0 = 出力しない
# 1 = 親記事のみ
# 2 = レス含む
our $feed = 2;

# 出力させるファイルの定義、(='1' 出力する、='' 空なら出力しない)
# Forum Patio では各形式への対応を示すため全部出力しているが、フォーマットは異なっていても内容的には同一であるため
# patio 用と forum 用に RSS1.4、RSS2.0、ATOM1.4 のどれか一ずつあれば十分と思われる。
our $rss1patiofile = '1';		# Patio目次ページの RSS1.0 ファイル
our $rss2patiofile = '1';		# Patio目次ページの RSS2.0 ファイル
our $atompatiofile = '1';		# Patio目次ページの ATOM1.0 ファイル
our $rss1forumfile = '1';		# Forum目次ページの RSS1.0 ファイル
our $rss2forumfile = '1';		# Forum目次ページの RSS2.0 ファイル
our $atomforumfile = '1';		# Forum目次ページの ATOM1.0 ファイル
our ($rss1readurl, $rss2readurl, $atomreadurl);

# FEEDタイトルはroomini.cgiを読み取り後にセットすることに修正 (2013/04/17 スガラボット修正)

# 簡単な説明
our $feed_des = '新規投稿のお知らせ';

# コメントの頭から文字分までを<description>,<summary>に出力する。
# 0にすると全文を出力する。
our $len = 250;

# 画像がアップロードされている場合<description>,<summary>の最初にこの文字列が付与される
our $mark = "【画像・添付ファイル有り】";

# FEEDに出力する最大件数
our $feed_num = 10;

# feed.log の最大件数
our $log_length = 1000;

# スレッド閲覧ページにFeedを置くとき、スレッド毎に出力するRSS1.0/RSS2.0/ATOM1.0 の最大件数 (0にすると出力しない)
our $t_rss_num = 5;
our %t_rss;
$t_rss{'rss1'} = $t_rss_num;
$t_rss{'rss2'} = $t_rss_num;
$t_rss{'atom'} = $t_rss_num;

### RSS1.0 ###
# 出力する文字コード
# sjis→Shift_JIS
# euc→EUC_JP
# utf8→UTF_8
# jis→iso-2022-jp
our $rss1_code = 'utf8';

### RSS2.0 ###
# 出力する文字コード（の意味は$rss1_codeと同じ）
our $rss2_code = 'utf8';

### Atom1.0 ###
# 出力する文字コード（意味は$rss1_codeと同じ）
our $atom_code = 'utf8';

# DNS名
our $dns = $url_root;

############## RSS配信する場合、設定以上 ###########

####### v1.40 からの追加設定項目 ###########
#
# youtubeの画像埋め込み関連のHTMLタグの投稿を許可するかどうか (=1 許可、=0 禁止)
# この項目は http://www.yabukogi.net/index.html フジイさんの拡張内容を取り入れさせて頂きました。
our $youtube_tag = 1;

# Patioインデックスページ冒頭の「Forum形式で表示」となっていたリンクメニューの表記方法
#our $use_forum_menu = 'Forum形式で表示';
our $use_forum_menu = 'ツリー形式で表示';

# Forumインデックスページ冒頭の「Patio形式で表示」となっていたリンクメニューの表記方法
#our $use_patio_menu = 'Patio形式で表示';
our $use_patio_menu = 'トピックス単位で表示';

# read.cgi によるスレッド一覧ページで添付画像(ファイル)の表示を記事より先に表示する設定 (=1 記事より先に表示、=0 従来通り下に表示)
our $picture_up = 0;

# ブラウザのキャッシュコントロール制御 (=1 有効、=0 無効・フォーム入力後に他ページ閲覧後ブラウザの戻るボタンで戻ったとき入力値を保存するときは"1"に設定する)
our $html_cache = 1;
#our $html_cache = 0;

####### v1.40 からの追加設定項目 ###########
#
# クッキーの有効期限を設定
our $cookie_expires = 30;			# 一般のクッキー
our $cookei_WebPatio = 90;			# 投稿フォームの名前など

#---------------------
#  Google AdSense
#---------------------
# Google AdSenseのコードを表示させるルーチンを有効にするか設定します。
# コードは sub googleadsense で記述します。
# 0 : 無効にする
# 1 : 有効にする
our $adsenseenable = 0;

# Google AdSenseを有効にした場合表示する場所の設定
# 0 : ページトップの直下に表示
# 1 : スレッド一覧表示の下 (forum.cgi と read.cgi では新規/返信投稿フォームの上でページ中段) に表示
our $adsensemiddle = 0;

# Google AdSenseのコードを設定。
our $adsense_code = '';
# 有効にするときは上の行をコメントアウトし、次の行のコメントを外して、後ろのEOMまでの間にGoogle AdSenseのコードを貼ります。(以下のコードはきりしま式の例)
#our $adsense_code = << "EOM;
#<script type="text/javascript"><!--
#google_ad_client = "pub-3076372101026415";
#google_ad_width = 468;
#google_ad_height = 60;
#google_ad_format = "468x60_as";
#google_ad_type = "text";
#//2007-09-22: きりしま式WebPatio
#google_ad_channel = "8139079326";
#google_color_border = "CCCCCC";
#google_color_bg = "FFFFFF";
#google_color_link = "0000FF";
#google_color_text = "000000";
#google_color_url = "008000";
#google_ui_features = "rc:6";
#//-->
#</script>
#<script type="text/javascript"
#  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
#</script>
#EOM

#-------------------------------------------
# 過去ログ書庫管理 (v1.40 にて追記した機能)
#-------------------------------------------

# 過去ログ書庫を複数のサブディレクトリに分けてページ分けし、閲覧しやすくする設定
# 過去ログサブディレクトリの最大値 (=0, =1ならこれまで通り過去ログはページ、=nなら最大nページ)
#our $max_past_page = 100;								# 当面､最大ページ数は処理しない

# 過去ログ1ページあたりの最大スレッド数 ($i_max とは独立に設定可能だが、同一書庫ページ内でのページ送り制御は原則として行わないものとする) 
our $past_page_max_tno = $i_max;			# 現行ログと同じスレッド数とする場合。
#our $past_page_max_tno = 10;				# 別途定義する場合

# 過去ログのあるページからスレッドを削除した時、不足分を後のページから前のページに繰り上げるか否か (=0: 繰り上げない、=1: 繰り上げる)
#our $borrow_over = 0;		# 繰り上げ処理は後日別途開発 → 過去ログ削除したあとは過去ログ書庫アーカイブを再構築する方向検討

# 作成した過去ログアーカイブにオリジナルのログ・ファイルとアップロードファイルをコピーするかどうか (=0: コピーしない、=1: コピーする)
our $copy_logfiles = 0;

# 過去ログ書庫アーカイブ・再構築の際、現行ログのスレッド数が$i_max より少なくても過去ログから現行ログへ自動復帰させるか否か (=0: させない、=1: させる)
our $plog_restore = 0;

# 過去ログ書庫アーカイブ・再構築の際 、現行ログのスレッド数が$i_max より多い時、超過したスレッドを過去ログに落とすか (=0: 落とさないない、=1: 落とす)
our $move2plog = 1;

# 現状の過去ログ書庫ページ数を記録するファイルの定義
#our $pastno_file = "$datadir/pastno.dat";				# あとで $datadir が定義された後に定義する

# 過去ログディレクトリ
#our $pastdir = "$cgi_dir/past";						# あとで $datadir が定義された後に定義する

# 過去ログのURL
#our $pasturl = "$cgi_url/past";						# あとで $datadir が定義された後に定義する

# 過去ログ nページのインデックスファイル名 000n はゼロ左詰4桁整数(備忘録)
our $past_index = "";			#"$pastdir/pindex000n.dat";

# 過去ログ nページ目のログディレクトリ名 (備忘録)
our $past_page_dir = "";			#"$pastdir/plog000n";

# 過去ログ nページ目のアップロードファイルディレクトリ (備忘録)
our $past_page_upldir = "";			#"$pastdir/plog000n/upl";

# 過去ログ nページ目のアップロードファイルURL (備忘録)
our $past_page_uplurl = "";			#"$pasturl/plog000n/upl";

#-------------------------------------------
# ユーザ定義のヘッダー、フッター、CSS機能関連 (v1.43 にて追記した機能)
#-------------------------------------------

# 表の見出し行にカスタムな背景色や背景画像をユーザ定義のCSSで定義する場合 (定義する時は、次項目の $header1 でそれに相当するクラスかIDを定義して追加すること)
#our $bgclass = 'class="color4"';
our $bgclass = '';
#our $bgclass2 = 'class="color2"';
our $bgclass2 = '';

########### ヘッダー関連
#
# ユーザ定義のCSS定義などを<html> ～ </html> タグ内に定義する場合 (空でなければ全てのページで出力される)
#
our $header1 = '';
# 有効にするときは上の行をコメントアウトし、次の行からEOMの頭ののコメント"#"を外して、後ろのEOMまでの間にコードを貼ります。(以下のコードは一例)
#our $template_url = ($home_root eq '/') ? "/$bbs_dir/template" : "$home_root/$bbs_dir/template";
#$header1 = << 'EOM';
#<meta name="robots" content="all" />
#<meta name="description" content="歴史戦略シミュレーションゲーム「戦国史」の総合情報ポータルサイトです。攻略情報、交流掲示板、wiki、アップローダなど完備。定期的にコンテストを行っています。" />
#<meta name="keywords" content="シナリオ,攻略,wiki,リプレイ,戦国時代,第二次,世界,三国志,信長,ツクール" />
#<link rel="stylesheet" href="./bbs.css" type="text/css" />
#<link rel="stylesheet" href="http://sengokushi.net/css/mail-style.css" type="text/css" />
#<link rel="stylesheet" href="http://sengokushi.net/css/header-style.css" type="text/css" />
#<link rel="stylesheet" href="http://sengokushi.net/css/footer-style.css" type="text/css" />
#
#<script type="text/javascript" src="http://www.google.com/jsapi?key=ABQIAAAAu2dbXp5D-GJL8OYd3QAzpBQw3CTGOsDSHAWQUJ2YBFDVDlpyRBTrdbJ-soIuh6oDnC-fn_suSQRP8Q"></script>
#<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4/jquery.min.js"></script>
#<script type="text/javascript" src="http://sengokushi.net/js/hoverIntent.js"></script>
#<script type="text/javascript" src="http://sengokushi.net/js/jquery.dropdown.js"></script>
#
#<style type="text/css">
#<!--
#.hr1        { border-color:#4D4552; border-style:solid;}  /* 直線ライン色 */
#
#a:link    {text-decoration:underline;color:#000088;text-decoration: none;}  /*テキストリンクの色*/
#a:visited {text-decoration:underline;color:#000088;text-decoration: none;}  /*訪問済みのリンクの色*/ 
#a:active  {text-decoration:underline;color:#7777ff;text-decoration: none;}   /*クリック時のリンクの色*/
#a:hover   {text-decoration:underline;color:#7777ff;}  /*マウスの上にカーソルがあるときのリンクの色*/
#
#.color1     {background-color:#A9A9A9;}   /*画面内外枠線の色*/
#.color2     {background-color:#613A1E;background-image: url(http://sengokushi.net/images/bg_cl.png);}   /*画面内赤部分の背景色*/
#.color3     {background-color:#E6DED3;background-image: url(http://sengokushi.net/images/bg_g.png);}   /*画面内黄色部分の背景色*/
#.color4     {background-color:#824c28;background-image: url(http://sengokushi.net/images/bg_c.png);}   /*画面内左セルの薄い赤*/
#.color5     {background-color:#f3f1e9;background-image: url(http://sengokushi.net/images/bg_b.png);}   /*画面内右セルの薄い赤*/
#.color6     {background-color:#ffffff;}   /*画面内右セルの薄い赤*/
#
#.topbar     {background-color:#E6DED3;background-image: url(http://sengokushi.net/images/bg_g.png);font-size:14px;}
#
#.title1     {font-size:24px;color:#ad3116;font-family:Verdana;font-weight:bold;line-height:150%;}       /* タイトル文字フォントサイズ,色*/
#.text1 {font-size:14px;color:#000066;font-weight:bold;line-height:150%;}   /*赤い太文字*/
#
#-->
#</style>
#
#<script type="text/javascript">
#	$(function(){
#		$("#header").load("./template/topheader.html");
#		$("#middle").load("./template/middlefooter.html");
#		$("#footer").load("./template/topfooter.html");
#	})
#</script>
#
#<title>戦国史同盟掲示板 - 戦国史同盟</title>
#<Script Language="JavaScript">
#<!--
#function MyFace(Smile) {
#myComment = document.myFORM.comment.value;
#document.myFORM.comment.value = myComment + Smile;
#}//-->
#</script>
#EOM

# ユーザ定義の $header1 内で<body>タグ内の要素が定義されている時は次の $user_body_tag を "1" にセットすること
#our $user_body_tag = 1;
our $user_body_tag = 0;
# ユーザ定義の $header1 内で<title>タグ内の要素が定義されている時は次の $user_title_tag を "1" にセットすること
#our $user_title_tag = 1;
our $user_title_tag = 0;

#
# 画面上部に表示するユーザ定義のヘッダーを定義する場合 (<body>タグの直後、本体部CGIスクリプトが表示するコンテンツの上に表示するユーザ定義のコンテンツ)
#
our $header2 =  '';
# 有効にするときは上の行をコメントアウトし、次の行からEOMの頭のコメント"#"を外して、後ろのEOMまでの間にコードを貼ります。(以下のコードは一例)
#our $header2 = << 'EOM';
#<!--テンプレート-->
#<div id="header"><img src="http://sengokushi.net/images/loadinfo.gif"></div>
#<!--テンプレート-->
#
#<div id="container">
#
#<!--センターエリア1ここから-->
#<div id="topmain">
#
#<div id="mainwrapper">
#
#<h1><a href="./">連絡・報告掲示板</a>　<small><a href="http://sengokushi.net/bbs1/">同盟板</a>｜<a href="http://sengokushi.net/bbs4/">制作質問</a>｜<a href="http://sengokushi.net/bbs2/">サンプル改造</a></small></h1>
#
#ここに掲示板の説明文等を書きます。
#
#</div>
#
#</div>
#
#<div style="clear: both;"> </div>
#
#</div>
#
#<div id="container">
#
#<!--センターエリア1ここから-->
#
#ここまでヘッダーです。
#
#<hr>
#
#ここから中身です。
#
#EOM
our $hd2_done = 0;		# ユーザ定義ヘッダ $header2 出力済み記憶フラグ

# 追加した $header1 のCSS定義によっては背景画像の上に白地の本体部を定義するなど、全てのページで最低限のヘッダーが必要な場合が有る。その定義をここに記述する。
#our $header0 = "<div id=\"container\">\n";
our $header0 = "";
################################################


################# フッター関連
#
# 画面下部に表示するユーザ定義のフッターを定義する場合 (</body>タグの直前、本体部CGIスクリプトが表示するコンテンツの下に表示するユーザ定義のコンテンツ)
#
our $footer = "";
# 有効にするときは上の行をコメントアウトし、次の行からEOMまで行頭のコメント"#"を外して、後ろのEOMまでの間にコードを貼ります。(以下のコードは一例)
#$footer = << "EOM";
#
#ここまで中身です。
#
#<hr>
#
#ここからフッターです。
#
#</div>
#
#<div style="clear: both;"> </div>
#
#<!--ミドルフッターエリア-->
#<div id="middle"><img src="http://sengokushi.net/images/loadinfo.gif"></div>
#
#<!--フッターエリア-->
#
#<div id="footer"><img src="http://sengokushi.net/images/loadinfo.gif"></div>
#<!--フッターエリアここまで-->
#<SCRIPT TYPE="text/javascript" SRC="http://rranking2.ziyu.net/rank.php?sengokushi"></SCRIPT>
#
#<script type="text/javascript" language="javascript" src="http://sengokushi.net/js/script.js"></script>
#EOM

# $header0 を定義した場合に全てのページ必要なフッターの定義をここに記述する。
#our $footer0 = "</div>\n";
our $footer0 = "";
################################################

# ユーザ定義のヘッダー($header2)･フッター($footer)を表示するページ種類の定義
# ( =0 の時は無し、 =1 の時はトップページ(paciot.cgiとforum.cgi)のみ、=2 の時はトップページとスレッド閲覧ページ(read.cgi)、=3 の時は全て)
#our $user_hdft = 2;
our $user_hdft = 0;

# ユーザカスタム CSS などでページ表示幅の最大値がある場合、ツリー表示の目次で記事タイトルの長さを詰めて長さを短縮する場合、"ツリーインデント" + "題名" + "名前" の長さの再偉大値
# ( =0 の時は短縮しない、ページ枠の幅が 730px で フォントサイズが 14pt の時は 76 程度が良い、ページ枠の幅が変わる時は適宜調整すること)
our $max_chars = 0;
#our $max_chars = 76;

#################
#-------------------------------------------
# ユーザ定義のトップページ上部にユーザ定義関数による表示を行うときは以下に関数等は定義する
#-------------------------------------------
################# ユーザ定義関数による表示を行う場合
#

# ユーザ定義関数を実施するかしないか、( =0 しない、=1 する)
#our $func_activate = 1
# 会議室毎に実施の要否を設定するときは、init.cgi (serverconf.cgi) はゼロにしておき、各会議室で設定する。
our $func_activate = 0;
sub user_func { ; }
#sub user_func {
#
#	# 会議室設定によって実施しないときはリターンする
#	if ( !$func_activate ) { return; }
#
##	Salon da Musica会議室用スペシャル設定 (スレッド一覧に練習一覧を表示)
#
#	our $act = 'select';
#
#	my $salon_title = "Forum サロンオフ会 出欠予定表";
#	print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" $main::width>\n";
#	print "<tr bgcolor=\"$col1\"><td bgcolor=\"$col1\" align=\"center\"><div style=\"border: 2px solid $col1;\">\n";
#	print &strEncode("<font color=\"$col6\" size=\"+1\"><b>&nbsp;$salon_title</b></font></div></td></tr></table>\n");
#	&display(1);
#}

################# ユーザ設定関数に伴うクッキー送出機能を定義する場合
#
our $CookieFlag;
sub user_cookie { ; }
#sub user_cookie {
##	Salon da Musica の掲示板で処理がアップデートならクッキー送出処理を追加 (20080519 守田修正)
#
#	# 会議室設定によって実施しないときはリターンする
#	if ( !$func_activate ) { return; }
#
#	our $act;
#	our $myname;
#	require './schdl.cgi';		
#
#	our $myfile = 'salon';
#	our $dataCnt = &readdata(1);
#	$CookieFlag = 1;
#
##	｢送信｣釦押下時の起動CGI変更に伴い以下の4行を修正 (20080519 守田修正)
#	if ( $act eq 'update' ) { &update; }
##	&AddCookie('myfile', $myfile);
#	if ( $myname ) { &AddCookie('myname', $myname); }
#}

################# ユーザ設定カウンター関連
#
# スガラボット特製カウンタ表示用CGI
#sub view_count {
#	our $ID = $main::room;
#	my $count = "$cgi_dir/viewcount.cgi";
#
#	require $count;
#
#	$countview = "<img src=\"$cgi_url/countview.cgi?id=$ID&PreNumber=$PreNumber&Number=$Number\">";
#
#	# カウンタ用のクッキーを送出
#	if ( $CookieFlag ) {
#		my($now) = time;
#		&AddCookie("Revocount$ID", $now);
#	}
#}

####### v1.51 からの追加設定項目 ###########
#-------------------------------------------
# patio/forum のインデックスページに新着記事を表示する場合(簡易掲示板向け)
#-------------------------------------------
############################################
#

# 新着記事をスレッド一覧の下に表示す場合、その記事数を定義 (2012/11/14 スガラボット修正)
our $newArticle = 5;
# fosum指揮一覧ページに新着記事表示を行う場合、スレッド一覧の最初のページに表示するスレッド数
our $menu3 = 5;
# fosum指揮一覧ページに新着記事表示を行う場合、スレッド一覧の最初のページに表示するスレッド数
our $fmenu3 = 5;

#=====================
#	【２終わり】
#=====================

################################ 設定項目はここまで ##############################

# 留意事項ページ【URLパス】
#$notepage = "$home_root/$bbs_dir/note.html";
# BBCodeを使用可とした会議室の留意事項を追加
#if ($bbcode) { $notepage = "$home_root/$bbs_dir/note_bb.html"; }

# 各会議室毎に異なる留意事項を書くときは下のコメントを外す
#$notepage = "$home_root/$bbs_dir/$room/$room" . "note.html";
#if ($bbcode) { $notepage = "$home_root/$bbs_dir/note_bb.html"; }

############################################################

}

1;

