##########################################################
# viescount.cgi v1.50
# Copyright(C): Sugarabotto
# リリース: 2012/07/18
# http://vmorita.com/bbs/patio/
# 
# この掲示板のビューカウンタは futomi's CGI Cafe さんの RevoCounter CGI の改造版です
# オリジナル; RevoCounter Ver 1.4
# Copyright(C) futomi 2001 - 2009
# http://www.futomi.com/library/revocount.html
# CGI利用規程：http://www.futomi.com/library/kitei.html
# (この CGI は futmi's CGI Cafe さんの許可を得て再配布しています)
##########################################################

use utf8;

require './revoconfig.cgi';
#use CGI;
#$query = new CGI;
#$ID = $query->param('id');
#$BaseBmpFile = $query->param('base');
#$ImodeFlag = $query->param('imode');


## URLガード
#if($UrlGuardFlag) {
#	unless( ($ENV{'HTTP_REFERER'} =~ /^$YourSiteUrl/) ) {
#		&error("指定外のサイトからは利用できません。");
#	}
#}

# カウントデータファイルの指定
if($ID) {
	unless($ID =~ /^\w+$/) {
		&error("IDには、半角アルファベットもしくは数字で指定してください : $ID");
	}
}
$CountDataFile = './data/count.dat';

if($CookieFlag) {
	%Cookie = &GetCookie;
	$LastAccess = $Cookie{"Revocount$ID"};
#	$LastAccess = $Cookie{"Revocount"};
} else {
	$LastAccess = 0;
}

#($PreNumber, $Number) = &Count($CountDataFile, $LastAccess, $GuardTime);
our ($PreNumber, $Number) = &Count($CountDataFile, $LastAccess, $GuardTime, $ID);

#exit;


sub GetCookie {
	my(@CookieList) = split(/\; /, $ENV{'HTTP_COOKIE'});
	my(%Cookie) = ();
	my($key, $CookieName, $CookieValue);
	for $key (@CookieList) {
		($CookieName, $CookieValue) = split(/=/, $key);
		$CookieValue =~ s/\+/ /g;
		$CookieValue =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;

		# クッキーのユニコード化に対応 (2012/07/15 スガラボット修正)
		$CookieValue = Unicode::Japanese->new($CookieValue, 'utf8')->getu;
		$Cookie{$CookieName} = $CookieValue;
	}
	return %Cookie;
}

sub Count {
	my($CountDataFile, $LastAccess, $GuardTime, $ID) = @_;
	local ($PreTotal, $Total, $PreNum, $Num, $buf, $outbuf);

	if(-e $CountDataFile) {
		if(!open(CNT, "+<$CountDataFile")) {&error("データファイル $CountDataFile をオープンできませんでした。");}
	} else {
		if(!open(CNT, ">$CountDataFile")) {&error("データファイル $CountDataFile を作成できませんでした。「data」ディレクトリがあるかどうか確認してください。");}
	}
	if(!&LockFile(CNT)) {&error("$CountDataFileをロックできませんでした。");}

	$buf = <CNT>;
	chomp($buf);
	$PreTotal = $buf;
	$PreTotal = 0 if($PreTotal eq '');

	my($now) = time;
	if($now < $LastAccess + $GuardTime*3600) {
		$add = 0;
	} else {
		$add = 1;
	}
	
	$Total = $PreTotal + $add;

	$outbuf = $Total . "\n";
	
	my $i = 0;
	my $flag = 0;
	$Num = 0;
	$PreNum = 0;
	while ($buf = <CNT>) {
		$i++;
		chomp($buf);
		local($id, $num) = split(/<>/, $buf);
		
		if ($id eq $ID) {
			$PreNum = $num;
			$Num = $PreNum + $add;
			$flag = 1;
			$outbuf .= $id . '<>' . $Num . "\n";
		} else {
			$outbuf .= $id . '<>' . $num . "\n";
		}
	}
	
	if (!$flag && $ID) { 
		$outbuf .= $ID . '<>' . $add . "\n";
	}

	seek(CNT, 0, 0);

	print CNT $outbuf;
	
	&UnlockFile(CNT);
	close(CNT);
	
	if ($ID) { return ($PreNum, $Num); }
	return ($PreTotal, $Total);
}

sub LockFile {
	local(*FILE) = @_;
	my($retry) = 3;
	my($lockresult);
	while($retry-- > 0) {
		$lockresult = eval("flock(FILE, 2)");
		if($@) {
			$retry = -1;
			last;
		}
		if(!$lockresult) {
			sleep(2);
		} else {
			last;
		}
	}
	if($retry > 0) {
		return 1;
	} else {
		return 0;
	}
}

sub UnlockFile {
	local(*FILE) = @_;
	flock(FILE, 8);
}


1;

